#include "simint/boys/boys.h"
#include "simint/ostei/gen/ostei_generated.h"
#include "simint/vectorization/vectorization.h"
#include <math.h>
#include <string.h>


int ostei_f_d_i_i(struct simint_multi_shellpair const P,
                  struct simint_multi_shellpair const Q,
                  double screen_tol,
                  double * const restrict work,
                  double * const restrict INT__f_d_i_i)
{

    SIMINT_ASSUME_ALIGN_DBL(work);
    SIMINT_ASSUME_ALIGN_DBL(INT__f_d_i_i);
    int ab, cd, abcd;
    int istart, jstart;
    int iprimcd, nprim_icd, icd;
    const int check_screen = (screen_tol > 0.0);
    int i, j;
    int n;
    int not_screened;
    int real_abcd;
    int iket;
    int ibra;

    // partition workspace
    double * const INT__f_s_i_s = work + (SIMINT_NSHELL_SIMD * 0);
    double * const INT__f_s_k_s = work + (SIMINT_NSHELL_SIMD * 280);
    double * const INT__f_s_l_s = work + (SIMINT_NSHELL_SIMD * 640);
    double * const INT__f_s_m_s = work + (SIMINT_NSHELL_SIMD * 1090);
    double * const INT__f_s_n_s = work + (SIMINT_NSHELL_SIMD * 1640);
    double * const INT__f_s_o_s = work + (SIMINT_NSHELL_SIMD * 2300);
    double * const INT__f_s_q_s = work + (SIMINT_NSHELL_SIMD * 3080);
    double * const INT__g_s_i_s = work + (SIMINT_NSHELL_SIMD * 3990);
    double * const INT__g_s_k_s = work + (SIMINT_NSHELL_SIMD * 4410);
    double * const INT__g_s_l_s = work + (SIMINT_NSHELL_SIMD * 4950);
    double * const INT__g_s_m_s = work + (SIMINT_NSHELL_SIMD * 5625);
    double * const INT__g_s_n_s = work + (SIMINT_NSHELL_SIMD * 6450);
    double * const INT__g_s_o_s = work + (SIMINT_NSHELL_SIMD * 7440);
    double * const INT__g_s_q_s = work + (SIMINT_NSHELL_SIMD * 8610);
    double * const INT__h_s_i_s = work + (SIMINT_NSHELL_SIMD * 9975);
    double * const INT__h_s_k_s = work + (SIMINT_NSHELL_SIMD * 10563);
    double * const INT__h_s_l_s = work + (SIMINT_NSHELL_SIMD * 11319);
    double * const INT__h_s_m_s = work + (SIMINT_NSHELL_SIMD * 12264);
    double * const INT__h_s_n_s = work + (SIMINT_NSHELL_SIMD * 13419);
    double * const INT__h_s_o_s = work + (SIMINT_NSHELL_SIMD * 14805);
    double * const INT__h_s_q_s = work + (SIMINT_NSHELL_SIMD * 16443);
    SIMINT_DBLTYPE * const primwork = (SIMINT_DBLTYPE *)(work + SIMINT_NSHELL_SIMD*18354);
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_s_s = primwork + 0;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_p_s = primwork + 18;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_d_s = primwork + 69;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_f_s = primwork + 165;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_g_s = primwork + 315;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_h_s = primwork + 525;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_i_s = primwork + 798;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_k_s = primwork + 1134;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_l_s = primwork + 1530;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_m_s = primwork + 1980;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_n_s = primwork + 2475;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_o_s = primwork + 3003;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_q_s = primwork + 3549;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_d_s = primwork + 4095;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_f_s = primwork + 4185;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_g_s = primwork + 4335;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_h_s = primwork + 4560;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_i_s = primwork + 4875;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_k_s = primwork + 5295;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_l_s = primwork + 5835;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_m_s = primwork + 6510;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_n_s = primwork + 7335;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_o_s = primwork + 8325;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_q_s = primwork + 9495;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_f_s = primwork + 10860;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_g_s = primwork + 11100;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_h_s = primwork + 11460;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_i_s = primwork + 11964;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_k_s = primwork + 12636;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_l_s = primwork + 13500;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_m_s = primwork + 14580;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_n_s = primwork + 15900;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_o_s = primwork + 17484;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_q_s = primwork + 19356;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_g_s = primwork + 21540;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_h_s = primwork + 21990;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_i_s = primwork + 22620;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_k_s = primwork + 23460;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_l_s = primwork + 24540;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_m_s = primwork + 25890;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_n_s = primwork + 27540;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_o_s = primwork + 29520;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_q_s = primwork + 31860;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_h_s = primwork + 34590;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_i_s = primwork + 35220;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_k_s = primwork + 36060;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_l_s = primwork + 37140;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_m_s = primwork + 38490;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_n_s = primwork + 40140;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_o_s = primwork + 42120;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_q_s = primwork + 44460;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_i_s = primwork + 47190;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_k_s = primwork + 47778;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_l_s = primwork + 48534;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_m_s = primwork + 49479;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_n_s = primwork + 50634;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_o_s = primwork + 52020;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_q_s = primwork + 53658;
    double * const hrrwork = (double *)(primwork + 55569);
    double * const HRR_INT__f_p_i_s = hrrwork + 0;
    double * const HRR_INT__f_p_k_s = hrrwork + 840;
    double * const HRR_INT__f_p_l_s = hrrwork + 1920;
    double * const HRR_INT__f_p_m_s = hrrwork + 3270;
    double * const HRR_INT__f_p_n_s = hrrwork + 4920;
    double * const HRR_INT__f_p_o_s = hrrwork + 6900;
    double * const HRR_INT__f_p_q_s = hrrwork + 9240;
    double * const HRR_INT__f_d_i_s = hrrwork + 11970;
    double * const HRR_INT__f_d_i_p = hrrwork + 13650;
    double * const HRR_INT__f_d_i_d = hrrwork + 18690;
    double * const HRR_INT__f_d_i_f = hrrwork + 28770;
    double * const HRR_INT__f_d_i_g = hrrwork + 45570;
    double * const HRR_INT__f_d_i_h = hrrwork + 70770;
    double * const HRR_INT__f_d_k_s = hrrwork + 106050;
    double * const HRR_INT__f_d_k_p = hrrwork + 108210;
    double * const HRR_INT__f_d_k_d = hrrwork + 114690;
    double * const HRR_INT__f_d_k_f = hrrwork + 127650;
    double * const HRR_INT__f_d_k_g = hrrwork + 149250;
    double * const HRR_INT__f_d_k_h = hrrwork + 181650;
    double * const HRR_INT__f_d_l_s = hrrwork + 227010;
    double * const HRR_INT__f_d_l_p = hrrwork + 229710;
    double * const HRR_INT__f_d_l_d = hrrwork + 237810;
    double * const HRR_INT__f_d_l_f = hrrwork + 254010;
    double * const HRR_INT__f_d_l_g = hrrwork + 281010;
    double * const HRR_INT__f_d_m_s = hrrwork + 321510;
    double * const HRR_INT__f_d_m_p = hrrwork + 324810;
    double * const HRR_INT__f_d_m_d = hrrwork + 334710;
    double * const HRR_INT__f_d_m_f = hrrwork + 354510;
    double * const HRR_INT__f_d_n_s = hrrwork + 387510;
    double * const HRR_INT__f_d_n_p = hrrwork + 391470;
    double * const HRR_INT__f_d_n_d = hrrwork + 403350;
    double * const HRR_INT__f_d_o_s = hrrwork + 427110;
    double * const HRR_INT__f_d_o_p = hrrwork + 431790;
    double * const HRR_INT__f_d_q_s = hrrwork + 445830;
    double * const HRR_INT__g_p_i_s = hrrwork + 451290;
    double * const HRR_INT__g_p_k_s = hrrwork + 452550;
    double * const HRR_INT__g_p_l_s = hrrwork + 454170;
    double * const HRR_INT__g_p_m_s = hrrwork + 456195;
    double * const HRR_INT__g_p_n_s = hrrwork + 458670;
    double * const HRR_INT__g_p_o_s = hrrwork + 461640;
    double * const HRR_INT__g_p_q_s = hrrwork + 465150;


    // Create constants
    const SIMINT_DBLTYPE const_1 = SIMINT_DBLSET1(1);
    const SIMINT_DBLTYPE const_10 = SIMINT_DBLSET1(10);
    const SIMINT_DBLTYPE const_11 = SIMINT_DBLSET1(11);
    const SIMINT_DBLTYPE const_12 = SIMINT_DBLSET1(12);
    const SIMINT_DBLTYPE const_2 = SIMINT_DBLSET1(2);
    const SIMINT_DBLTYPE const_3 = SIMINT_DBLSET1(3);
    const SIMINT_DBLTYPE const_4 = SIMINT_DBLSET1(4);
    const SIMINT_DBLTYPE const_5 = SIMINT_DBLSET1(5);
    const SIMINT_DBLTYPE const_6 = SIMINT_DBLSET1(6);
    const SIMINT_DBLTYPE const_7 = SIMINT_DBLSET1(7);
    const SIMINT_DBLTYPE const_8 = SIMINT_DBLSET1(8);
    const SIMINT_DBLTYPE const_9 = SIMINT_DBLSET1(9);
    const SIMINT_DBLTYPE one_half = SIMINT_DBLSET1(0.5);


    ////////////////////////////////////////
    // Loop over shells and primitives
    ////////////////////////////////////////

    real_abcd = 0;
    istart = 0;
    for(ab = 0; ab < P.nshell12_clip; ++ab)
    {
        const int iend = istart + P.nprim12[ab];

        cd = 0;
        jstart = 0;

        for(cd = 0; cd < Q.nshell12_clip; cd += SIMINT_NSHELL_SIMD)
        {
            const int nshellbatch = ((cd + SIMINT_NSHELL_SIMD) > Q.nshell12_clip) ? Q.nshell12_clip - cd : SIMINT_NSHELL_SIMD;
            int jend = jstart;
            for(i = 0; i < nshellbatch; i++)
                jend += Q.nprim12[cd+i];

            // Clear the beginning of the workspace (where we are accumulating integrals)
            memset(work, 0, SIMINT_NSHELL_SIMD * 18354 * sizeof(double));
            abcd = 0;


            for(i = istart; i < iend; ++i)
            {
                SIMINT_DBLTYPE bra_screen_max;  // only used if check_screen

                if(check_screen)
                {
                    // Skip this whole thing if always insignificant
                    if((P.screen[i] * Q.screen_max) < screen_tol)
                        continue;
                    bra_screen_max = SIMINT_DBLSET1(P.screen[i]);
                }

                icd = 0;
                iprimcd = 0;
                nprim_icd = Q.nprim12[cd];
                double * restrict PRIM_PTR_INT__f_s_i_s = INT__f_s_i_s + abcd * 280;
                double * restrict PRIM_PTR_INT__f_s_k_s = INT__f_s_k_s + abcd * 360;
                double * restrict PRIM_PTR_INT__f_s_l_s = INT__f_s_l_s + abcd * 450;
                double * restrict PRIM_PTR_INT__f_s_m_s = INT__f_s_m_s + abcd * 550;
                double * restrict PRIM_PTR_INT__f_s_n_s = INT__f_s_n_s + abcd * 660;
                double * restrict PRIM_PTR_INT__f_s_o_s = INT__f_s_o_s + abcd * 780;
                double * restrict PRIM_PTR_INT__f_s_q_s = INT__f_s_q_s + abcd * 910;
                double * restrict PRIM_PTR_INT__g_s_i_s = INT__g_s_i_s + abcd * 420;
                double * restrict PRIM_PTR_INT__g_s_k_s = INT__g_s_k_s + abcd * 540;
                double * restrict PRIM_PTR_INT__g_s_l_s = INT__g_s_l_s + abcd * 675;
                double * restrict PRIM_PTR_INT__g_s_m_s = INT__g_s_m_s + abcd * 825;
                double * restrict PRIM_PTR_INT__g_s_n_s = INT__g_s_n_s + abcd * 990;
                double * restrict PRIM_PTR_INT__g_s_o_s = INT__g_s_o_s + abcd * 1170;
                double * restrict PRIM_PTR_INT__g_s_q_s = INT__g_s_q_s + abcd * 1365;
                double * restrict PRIM_PTR_INT__h_s_i_s = INT__h_s_i_s + abcd * 588;
                double * restrict PRIM_PTR_INT__h_s_k_s = INT__h_s_k_s + abcd * 756;
                double * restrict PRIM_PTR_INT__h_s_l_s = INT__h_s_l_s + abcd * 945;
                double * restrict PRIM_PTR_INT__h_s_m_s = INT__h_s_m_s + abcd * 1155;
                double * restrict PRIM_PTR_INT__h_s_n_s = INT__h_s_n_s + abcd * 1386;
                double * restrict PRIM_PTR_INT__h_s_o_s = INT__h_s_o_s + abcd * 1638;
                double * restrict PRIM_PTR_INT__h_s_q_s = INT__h_s_q_s + abcd * 1911;



                // Load these one per loop over i
                const SIMINT_DBLTYPE P_alpha = SIMINT_DBLSET1(P.alpha[i]);
                const SIMINT_DBLTYPE P_prefac = SIMINT_DBLSET1(P.prefac[i]);
                const SIMINT_DBLTYPE Pxyz[3] = { SIMINT_DBLSET1(P.x[i]), SIMINT_DBLSET1(P.y[i]), SIMINT_DBLSET1(P.z[i]) };

                const SIMINT_DBLTYPE P_PA[3] = { SIMINT_DBLSET1(P.PA_x[i]), SIMINT_DBLSET1(P.PA_y[i]), SIMINT_DBLSET1(P.PA_z[i]) };

                for(j = jstart; j < jend; j += SIMINT_SIMD_LEN)
                {
                    // calculate the shell offsets
                    // these are the offset from the shell pointed to by cd
                    // for each element
                    int shelloffsets[SIMINT_SIMD_LEN] = {0};
                    int lastoffset = 0;
                    const int nlane = ( ((j + SIMINT_SIMD_LEN) < jend) ? SIMINT_SIMD_LEN : (jend - j));

                    if((iprimcd + SIMINT_SIMD_LEN) >= nprim_icd)
                    {
                        // Handle if the first element of the vector is a new shell
                        if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                        {
                            nprim_icd += Q.nprim12[cd + (++icd)];
                            PRIM_PTR_INT__f_s_i_s += 280;
                            PRIM_PTR_INT__f_s_k_s += 360;
                            PRIM_PTR_INT__f_s_l_s += 450;
                            PRIM_PTR_INT__f_s_m_s += 550;
                            PRIM_PTR_INT__f_s_n_s += 660;
                            PRIM_PTR_INT__f_s_o_s += 780;
                            PRIM_PTR_INT__f_s_q_s += 910;
                            PRIM_PTR_INT__g_s_i_s += 420;
                            PRIM_PTR_INT__g_s_k_s += 540;
                            PRIM_PTR_INT__g_s_l_s += 675;
                            PRIM_PTR_INT__g_s_m_s += 825;
                            PRIM_PTR_INT__g_s_n_s += 990;
                            PRIM_PTR_INT__g_s_o_s += 1170;
                            PRIM_PTR_INT__g_s_q_s += 1365;
                            PRIM_PTR_INT__h_s_i_s += 588;
                            PRIM_PTR_INT__h_s_k_s += 756;
                            PRIM_PTR_INT__h_s_l_s += 945;
                            PRIM_PTR_INT__h_s_m_s += 1155;
                            PRIM_PTR_INT__h_s_n_s += 1386;
                            PRIM_PTR_INT__h_s_o_s += 1638;
                            PRIM_PTR_INT__h_s_q_s += 1911;
                        }
                        iprimcd++;
                        for(n = 1; n < SIMINT_SIMD_LEN; ++n)
                        {
                            if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                            {
                                shelloffsets[n] = shelloffsets[n-1] + 1;
                                lastoffset++;
                                nprim_icd += Q.nprim12[cd + (++icd)];
                            }
                            else
                                shelloffsets[n] = shelloffsets[n-1];
                            iprimcd++;
                        }
                    }
                    else
                        iprimcd += SIMINT_SIMD_LEN;

                    // Do we have to compute this vector (or has it been screened out)?
                    // (not_screened != 0 means we have to do this vector)
                    if(check_screen)
                    {
                        const double vmax = vector_max(SIMINT_MUL(bra_screen_max, SIMINT_DBLLOAD(Q.screen, j)));
                        if(vmax < screen_tol)
                        {
                            PRIM_PTR_INT__f_s_i_s += lastoffset*280;
                            PRIM_PTR_INT__f_s_k_s += lastoffset*360;
                            PRIM_PTR_INT__f_s_l_s += lastoffset*450;
                            PRIM_PTR_INT__f_s_m_s += lastoffset*550;
                            PRIM_PTR_INT__f_s_n_s += lastoffset*660;
                            PRIM_PTR_INT__f_s_o_s += lastoffset*780;
                            PRIM_PTR_INT__f_s_q_s += lastoffset*910;
                            PRIM_PTR_INT__g_s_i_s += lastoffset*420;
                            PRIM_PTR_INT__g_s_k_s += lastoffset*540;
                            PRIM_PTR_INT__g_s_l_s += lastoffset*675;
                            PRIM_PTR_INT__g_s_m_s += lastoffset*825;
                            PRIM_PTR_INT__g_s_n_s += lastoffset*990;
                            PRIM_PTR_INT__g_s_o_s += lastoffset*1170;
                            PRIM_PTR_INT__g_s_q_s += lastoffset*1365;
                            PRIM_PTR_INT__h_s_i_s += lastoffset*588;
                            PRIM_PTR_INT__h_s_k_s += lastoffset*756;
                            PRIM_PTR_INT__h_s_l_s += lastoffset*945;
                            PRIM_PTR_INT__h_s_m_s += lastoffset*1155;
                            PRIM_PTR_INT__h_s_n_s += lastoffset*1386;
                            PRIM_PTR_INT__h_s_o_s += lastoffset*1638;
                            PRIM_PTR_INT__h_s_q_s += lastoffset*1911;
                            continue;
                        }
                    }

                    const SIMINT_DBLTYPE Q_alpha = SIMINT_DBLLOAD(Q.alpha, j);
                    const SIMINT_DBLTYPE PQalpha_mul = SIMINT_MUL(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE PQalpha_sum = SIMINT_ADD(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE one_over_PQalpha_sum = SIMINT_DIV(const_1, PQalpha_sum);


                    /* construct R2 = (Px - Qx)**2 + (Py - Qy)**2 + (Pz -Qz)**2 */
                    SIMINT_DBLTYPE PQ[3];
                    PQ[0] = SIMINT_SUB(Pxyz[0], SIMINT_DBLLOAD(Q.x, j));
                    PQ[1] = SIMINT_SUB(Pxyz[1], SIMINT_DBLLOAD(Q.y, j));
                    PQ[2] = SIMINT_SUB(Pxyz[2], SIMINT_DBLLOAD(Q.z, j));
                    SIMINT_DBLTYPE R2 = SIMINT_MUL(PQ[0], PQ[0]);
                    R2 = SIMINT_FMADD(PQ[1], PQ[1], R2);
                    R2 = SIMINT_FMADD(PQ[2], PQ[2], R2);

                    const SIMINT_DBLTYPE alpha = SIMINT_MUL(PQalpha_mul, one_over_PQalpha_sum); // alpha from MEST
                    const SIMINT_DBLTYPE one_over_p = SIMINT_DIV(const_1, P_alpha);
                    const SIMINT_DBLTYPE one_over_q = SIMINT_DIV(const_1, Q_alpha);
                    const SIMINT_DBLTYPE one_over_2p = SIMINT_MUL(one_half, one_over_p);
                    const SIMINT_DBLTYPE one_over_2q = SIMINT_MUL(one_half, one_over_q);
                    const SIMINT_DBLTYPE one_over_2pq = SIMINT_MUL(one_half, one_over_PQalpha_sum);
                    const SIMINT_DBLTYPE Q_PA[3] = { SIMINT_DBLLOAD(Q.PA_x, j), SIMINT_DBLLOAD(Q.PA_y, j), SIMINT_DBLLOAD(Q.PA_z, j) };

                    // NOTE: Minus sign!
                    const SIMINT_DBLTYPE a_over_p = SIMINT_MUL(SIMINT_NEG(alpha), one_over_p);
                    SIMINT_DBLTYPE aop_PQ[3];
                    aop_PQ[0] = SIMINT_MUL(a_over_p, PQ[0]);
                    aop_PQ[1] = SIMINT_MUL(a_over_p, PQ[1]);
                    aop_PQ[2] = SIMINT_MUL(a_over_p, PQ[2]);

                    SIMINT_DBLTYPE a_over_q = SIMINT_MUL(alpha, one_over_q);
                    SIMINT_DBLTYPE aoq_PQ[3];
                    aoq_PQ[0] = SIMINT_MUL(a_over_q, PQ[0]);
                    aoq_PQ[1] = SIMINT_MUL(a_over_q, PQ[1]);
                    aoq_PQ[2] = SIMINT_MUL(a_over_q, PQ[2]);
                    // Put a minus sign here so we don't have to in RR routines
                    a_over_q = SIMINT_NEG(a_over_q);


                    //////////////////////////////////////////////
                    // Fjt function section
                    // Maximum v value: 17
                    //////////////////////////////////////////////
                    // The parameter to the Fjt function
                    const SIMINT_DBLTYPE F_x = SIMINT_MUL(R2, alpha);


                    const SIMINT_DBLTYPE Q_prefac = mask_load(nlane, Q.prefac + j);


                    boys_F_split(PRIM_INT__s_s_s_s, F_x, 17);
                    SIMINT_DBLTYPE prefac = SIMINT_SQRT(one_over_PQalpha_sum);
                    prefac = SIMINT_MUL(SIMINT_MUL(P_prefac, Q_prefac), prefac);
                    for(n = 0; n <= 17; n++)
                        PRIM_INT__s_s_s_s[n] = SIMINT_MUL(PRIM_INT__s_s_s_s[n], prefac);

                    //////////////////////////////////////////////
                    // Primitive integrals: Vertical recurrance
                    //////////////////////////////////////////////

                    const SIMINT_DBLTYPE vrr_const_1_over_2p = one_over_2p;
                    const SIMINT_DBLTYPE vrr_const_2_over_2p = SIMINT_MUL(const_2, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_3_over_2p = SIMINT_MUL(const_3, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_4_over_2p = SIMINT_MUL(const_4, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_1_over_2q = one_over_2q;
                    const SIMINT_DBLTYPE vrr_const_2_over_2q = SIMINT_MUL(const_2, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_3_over_2q = SIMINT_MUL(const_3, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_4_over_2q = SIMINT_MUL(const_4, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_5_over_2q = SIMINT_MUL(const_5, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_6_over_2q = SIMINT_MUL(const_6, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_7_over_2q = SIMINT_MUL(const_7, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_8_over_2q = SIMINT_MUL(const_8, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_9_over_2q = SIMINT_MUL(const_9, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_10_over_2q = SIMINT_MUL(const_10, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_11_over_2q = SIMINT_MUL(const_11, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_1_over_2pq = one_over_2pq;
                    const SIMINT_DBLTYPE vrr_const_2_over_2pq = SIMINT_MUL(const_2, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_3_over_2pq = SIMINT_MUL(const_3, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_4_over_2pq = SIMINT_MUL(const_4, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_5_over_2pq = SIMINT_MUL(const_5, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_6_over_2pq = SIMINT_MUL(const_6, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_7_over_2pq = SIMINT_MUL(const_7, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_8_over_2pq = SIMINT_MUL(const_8, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_9_over_2pq = SIMINT_MUL(const_9, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_10_over_2pq = SIMINT_MUL(const_10, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_11_over_2pq = SIMINT_MUL(const_11, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_12_over_2pq = SIMINT_MUL(const_12, one_over_2pq);



                    // Forming PRIM_INT__s_s_p_s[17 * 3];
                    for(n = 0; n < 17; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__s_s_p_s[n * 3 + 0] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__s_s_p_s[n * 3 + 0] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_p_s[n * 3 + 0]);

                        PRIM_INT__s_s_p_s[n * 3 + 1] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__s_s_p_s[n * 3 + 1] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_p_s[n * 3 + 1]);

                        PRIM_INT__s_s_p_s[n * 3 + 2] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__s_s_p_s[n * 3 + 2] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_p_s[n * 3 + 2]);

                    }



                    // Forming PRIM_INT__s_s_d_s[16 * 6];
                    for(n = 0; n < 16; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__s_s_d_s[n * 6 + 0] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_p_s[n * 3 + 0]);
                        PRIM_INT__s_s_d_s[n * 6 + 0] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_p_s[(n+1) * 3 + 0], PRIM_INT__s_s_d_s[n * 6 + 0]);
                        PRIM_INT__s_s_d_s[n * 6 + 0] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__s_s_d_s[n * 6 + 0]);

                        PRIM_INT__s_s_d_s[n * 6 + 1] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_p_s[n * 3 + 0]);
                        PRIM_INT__s_s_d_s[n * 6 + 1] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_p_s[(n+1) * 3 + 0], PRIM_INT__s_s_d_s[n * 6 + 1]);

                        PRIM_INT__s_s_d_s[n * 6 + 2] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_p_s[n * 3 + 0]);
                        PRIM_INT__s_s_d_s[n * 6 + 2] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_p_s[(n+1) * 3 + 0], PRIM_INT__s_s_d_s[n * 6 + 2]);

                        PRIM_INT__s_s_d_s[n * 6 + 3] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_p_s[n * 3 + 1]);
                        PRIM_INT__s_s_d_s[n * 6 + 3] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_p_s[(n+1) * 3 + 1], PRIM_INT__s_s_d_s[n * 6 + 3]);
                        PRIM_INT__s_s_d_s[n * 6 + 3] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__s_s_d_s[n * 6 + 3]);

                        PRIM_INT__s_s_d_s[n * 6 + 4] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_p_s[n * 3 + 1]);
                        PRIM_INT__s_s_d_s[n * 6 + 4] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_p_s[(n+1) * 3 + 1], PRIM_INT__s_s_d_s[n * 6 + 4]);

                        PRIM_INT__s_s_d_s[n * 6 + 5] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_p_s[n * 3 + 2]);
                        PRIM_INT__s_s_d_s[n * 6 + 5] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_p_s[(n+1) * 3 + 2], PRIM_INT__s_s_d_s[n * 6 + 5]);
                        PRIM_INT__s_s_d_s[n * 6 + 5] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__s_s_d_s[n * 6 + 5]);

                    }



                    // Forming PRIM_INT__s_s_f_s[15 * 10];
                    for(n = 0; n < 15; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__s_s_f_s[n * 10 + 0] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_d_s[n * 6 + 0]);
                        PRIM_INT__s_s_f_s[n * 10 + 0] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__s_s_f_s[n * 10 + 0] = SIMINT_FMADD( vrr_const_2_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_p_s[(n+1) * 3 + 0], PRIM_INT__s_s_p_s[n * 3 + 0]), PRIM_INT__s_s_f_s[n * 10 + 0]);

                        PRIM_INT__s_s_f_s[n * 10 + 1] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_d_s[n * 6 + 0]);
                        PRIM_INT__s_s_f_s[n * 10 + 1] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_f_s[n * 10 + 1]);

                        PRIM_INT__s_s_f_s[n * 10 + 2] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_d_s[n * 6 + 0]);
                        PRIM_INT__s_s_f_s[n * 10 + 2] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_f_s[n * 10 + 2]);

                        PRIM_INT__s_s_f_s[n * 10 + 3] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_d_s[n * 6 + 3]);
                        PRIM_INT__s_s_f_s[n * 10 + 3] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__s_s_f_s[n * 10 + 3]);

                        PRIM_INT__s_s_f_s[n * 10 + 4] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_d_s[n * 6 + 1]);
                        PRIM_INT__s_s_f_s[n * 10 + 4] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_d_s[(n+1) * 6 + 1], PRIM_INT__s_s_f_s[n * 10 + 4]);

                        PRIM_INT__s_s_f_s[n * 10 + 5] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_d_s[n * 6 + 5]);
                        PRIM_INT__s_s_f_s[n * 10 + 5] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__s_s_f_s[n * 10 + 5]);

                        PRIM_INT__s_s_f_s[n * 10 + 6] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_d_s[n * 6 + 3]);
                        PRIM_INT__s_s_f_s[n * 10 + 6] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__s_s_f_s[n * 10 + 6] = SIMINT_FMADD( vrr_const_2_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_p_s[(n+1) * 3 + 1], PRIM_INT__s_s_p_s[n * 3 + 1]), PRIM_INT__s_s_f_s[n * 10 + 6]);

                        PRIM_INT__s_s_f_s[n * 10 + 7] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_d_s[n * 6 + 3]);
                        PRIM_INT__s_s_f_s[n * 10 + 7] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__s_s_f_s[n * 10 + 7]);

                        PRIM_INT__s_s_f_s[n * 10 + 8] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_d_s[n * 6 + 5]);
                        PRIM_INT__s_s_f_s[n * 10 + 8] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__s_s_f_s[n * 10 + 8]);

                        PRIM_INT__s_s_f_s[n * 10 + 9] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_d_s[n * 6 + 5]);
                        PRIM_INT__s_s_f_s[n * 10 + 9] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__s_s_f_s[n * 10 + 9] = SIMINT_FMADD( vrr_const_2_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_p_s[(n+1) * 3 + 2], PRIM_INT__s_s_p_s[n * 3 + 2]), PRIM_INT__s_s_f_s[n * 10 + 9]);

                    }



                    // Forming PRIM_INT__s_s_g_s[14 * 15];
                    for(n = 0; n < 14; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__s_s_g_s[n * 15 + 0] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__s_s_g_s[n * 15 + 0] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 0], PRIM_INT__s_s_g_s[n * 15 + 0]);
                        PRIM_INT__s_s_g_s[n * 15 + 0] = SIMINT_FMADD( vrr_const_3_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_d_s[n * 6 + 0]), PRIM_INT__s_s_g_s[n * 15 + 0]);

                        PRIM_INT__s_s_g_s[n * 15 + 1] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__s_s_g_s[n * 15 + 1] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 0], PRIM_INT__s_s_g_s[n * 15 + 1]);

                        PRIM_INT__s_s_g_s[n * 15 + 2] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__s_s_g_s[n * 15 + 2] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 0], PRIM_INT__s_s_g_s[n * 15 + 2]);

                        PRIM_INT__s_s_g_s[n * 15 + 3] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_f_s[n * 10 + 1]);
                        PRIM_INT__s_s_g_s[n * 15 + 3] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 1], PRIM_INT__s_s_g_s[n * 15 + 3]);
                        PRIM_INT__s_s_g_s[n * 15 + 3] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_d_s[n * 6 + 0]), PRIM_INT__s_s_g_s[n * 15 + 3]);

                        PRIM_INT__s_s_g_s[n * 15 + 4] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_f_s[n * 10 + 1]);
                        PRIM_INT__s_s_g_s[n * 15 + 4] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 1], PRIM_INT__s_s_g_s[n * 15 + 4]);

                        PRIM_INT__s_s_g_s[n * 15 + 5] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_f_s[n * 10 + 2]);
                        PRIM_INT__s_s_g_s[n * 15 + 5] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 2], PRIM_INT__s_s_g_s[n * 15 + 5]);
                        PRIM_INT__s_s_g_s[n * 15 + 5] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_d_s[n * 6 + 0]), PRIM_INT__s_s_g_s[n * 15 + 5]);

                        PRIM_INT__s_s_g_s[n * 15 + 6] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__s_s_g_s[n * 15 + 6] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 6], PRIM_INT__s_s_g_s[n * 15 + 6]);

                        PRIM_INT__s_s_g_s[n * 15 + 7] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_f_s[n * 10 + 3]);
                        PRIM_INT__s_s_g_s[n * 15 + 7] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 3], PRIM_INT__s_s_g_s[n * 15 + 7]);

                        PRIM_INT__s_s_g_s[n * 15 + 8] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_f_s[n * 10 + 5]);
                        PRIM_INT__s_s_g_s[n * 15 + 8] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 5], PRIM_INT__s_s_g_s[n * 15 + 8]);

                        PRIM_INT__s_s_g_s[n * 15 + 9] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__s_s_g_s[n * 15 + 9] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 9], PRIM_INT__s_s_g_s[n * 15 + 9]);

                        PRIM_INT__s_s_g_s[n * 15 + 10] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__s_s_g_s[n * 15 + 10] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 6], PRIM_INT__s_s_g_s[n * 15 + 10]);
                        PRIM_INT__s_s_g_s[n * 15 + 10] = SIMINT_FMADD( vrr_const_3_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__s_s_d_s[n * 6 + 3]), PRIM_INT__s_s_g_s[n * 15 + 10]);

                        PRIM_INT__s_s_g_s[n * 15 + 11] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__s_s_g_s[n * 15 + 11] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 6], PRIM_INT__s_s_g_s[n * 15 + 11]);

                        PRIM_INT__s_s_g_s[n * 15 + 12] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_f_s[n * 10 + 7]);
                        PRIM_INT__s_s_g_s[n * 15 + 12] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 7], PRIM_INT__s_s_g_s[n * 15 + 12]);
                        PRIM_INT__s_s_g_s[n * 15 + 12] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__s_s_d_s[n * 6 + 3]), PRIM_INT__s_s_g_s[n * 15 + 12]);

                        PRIM_INT__s_s_g_s[n * 15 + 13] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__s_s_g_s[n * 15 + 13] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 9], PRIM_INT__s_s_g_s[n * 15 + 13]);

                        PRIM_INT__s_s_g_s[n * 15 + 14] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__s_s_g_s[n * 15 + 14] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 9], PRIM_INT__s_s_g_s[n * 15 + 14]);
                        PRIM_INT__s_s_g_s[n * 15 + 14] = SIMINT_FMADD( vrr_const_3_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__s_s_d_s[n * 6 + 5]), PRIM_INT__s_s_g_s[n * 15 + 14]);

                    }


                    VRR_K_s_s_h_s(
                            PRIM_INT__s_s_h_s,
                            PRIM_INT__s_s_g_s,
                            PRIM_INT__s_s_f_s,
                            Q_PA,
                            a_over_q,
                            aoq_PQ,
                            one_over_2q,
                            13);


                    VRR_K_s_s_i_s(
                            PRIM_INT__s_s_i_s,
                            PRIM_INT__s_s_h_s,
                            PRIM_INT__s_s_g_s,
                            Q_PA,
                            a_over_q,
                            aoq_PQ,
                            one_over_2q,
                            12);


                    VRR_I_p_s_i_s(
                            PRIM_INT__p_s_i_s,
                            PRIM_INT__s_s_i_s,
                            PRIM_INT__s_s_h_s,
                            P_PA,
                            aop_PQ,
                            one_over_2pq,
                            5);


                    VRR_I_p_s_h_s(
                            PRIM_INT__p_s_h_s,
                            PRIM_INT__s_s_h_s,
                            PRIM_INT__s_s_g_s,
                            P_PA,
                            aop_PQ,
                            one_over_2pq,
                            5);


                    ostei_general_vrr_I(2, 0, 6, 0, 4,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__p_s_i_s, PRIM_INT__s_s_i_s, NULL, PRIM_INT__p_s_h_s, NULL, PRIM_INT__d_s_i_s);


                    VRR_I_p_s_g_s(
                            PRIM_INT__p_s_g_s,
                            PRIM_INT__s_s_g_s,
                            PRIM_INT__s_s_f_s,
                            P_PA,
                            aop_PQ,
                            one_over_2pq,
                            5);


                    VRR_I_d_s_h_s(
                            PRIM_INT__d_s_h_s,
                            PRIM_INT__p_s_h_s,
                            PRIM_INT__s_s_h_s,
                            PRIM_INT__p_s_g_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            one_over_2pq,
                            4);


                    ostei_general_vrr_I(3, 0, 6, 0, 3,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__d_s_i_s, PRIM_INT__p_s_i_s, NULL, PRIM_INT__d_s_h_s, NULL, PRIM_INT__f_s_i_s);


                    VRR_K_s_s_k_s(
                            PRIM_INT__s_s_k_s,
                            PRIM_INT__s_s_i_s,
                            PRIM_INT__s_s_h_s,
                            Q_PA,
                            a_over_q,
                            aoq_PQ,
                            one_over_2q,
                            11);


                    ostei_general_vrr_I(1, 0, 7, 0, 5,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_k_s, NULL, NULL, PRIM_INT__s_s_i_s, NULL, PRIM_INT__p_s_k_s);


                    ostei_general_vrr_I(2, 0, 7, 0, 4,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__p_s_k_s, PRIM_INT__s_s_k_s, NULL, PRIM_INT__p_s_i_s, NULL, PRIM_INT__d_s_k_s);


                    ostei_general_vrr_I(3, 0, 7, 0, 3,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__d_s_k_s, PRIM_INT__p_s_k_s, NULL, PRIM_INT__d_s_i_s, NULL, PRIM_INT__f_s_k_s);



                    // Forming PRIM_INT__p_s_f_s[5 * 30];
                    for(n = 0; n < 5; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__p_s_f_s[n * 30 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__p_s_f_s[n * 30 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 0], PRIM_INT__p_s_f_s[n * 30 + 0]);
                        PRIM_INT__p_s_f_s[n * 30 + 0] = SIMINT_FMADD( vrr_const_3_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__p_s_f_s[n * 30 + 0]);

                        PRIM_INT__p_s_f_s[n * 30 + 1] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_f_s[n * 10 + 1]);
                        PRIM_INT__p_s_f_s[n * 30 + 1] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 1], PRIM_INT__p_s_f_s[n * 30 + 1]);
                        PRIM_INT__p_s_f_s[n * 30 + 1] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 1], PRIM_INT__p_s_f_s[n * 30 + 1]);

                        PRIM_INT__p_s_f_s[n * 30 + 2] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_f_s[n * 10 + 2]);
                        PRIM_INT__p_s_f_s[n * 30 + 2] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 2], PRIM_INT__p_s_f_s[n * 30 + 2]);
                        PRIM_INT__p_s_f_s[n * 30 + 2] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 2], PRIM_INT__p_s_f_s[n * 30 + 2]);

                        PRIM_INT__p_s_f_s[n * 30 + 3] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_f_s[n * 10 + 3]);
                        PRIM_INT__p_s_f_s[n * 30 + 3] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 3], PRIM_INT__p_s_f_s[n * 30 + 3]);
                        PRIM_INT__p_s_f_s[n * 30 + 3] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__p_s_f_s[n * 30 + 3]);

                        PRIM_INT__p_s_f_s[n * 30 + 4] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_f_s[n * 10 + 4]);
                        PRIM_INT__p_s_f_s[n * 30 + 4] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 4], PRIM_INT__p_s_f_s[n * 30 + 4]);
                        PRIM_INT__p_s_f_s[n * 30 + 4] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 4], PRIM_INT__p_s_f_s[n * 30 + 4]);

                        PRIM_INT__p_s_f_s[n * 30 + 5] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_f_s[n * 10 + 5]);
                        PRIM_INT__p_s_f_s[n * 30 + 5] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 5], PRIM_INT__p_s_f_s[n * 30 + 5]);
                        PRIM_INT__p_s_f_s[n * 30 + 5] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__p_s_f_s[n * 30 + 5]);

                        PRIM_INT__p_s_f_s[n * 30 + 6] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__p_s_f_s[n * 30 + 6] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 6], PRIM_INT__p_s_f_s[n * 30 + 6]);

                        PRIM_INT__p_s_f_s[n * 30 + 7] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_f_s[n * 10 + 7]);
                        PRIM_INT__p_s_f_s[n * 30 + 7] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 7], PRIM_INT__p_s_f_s[n * 30 + 7]);

                        PRIM_INT__p_s_f_s[n * 30 + 8] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_f_s[n * 10 + 8]);
                        PRIM_INT__p_s_f_s[n * 30 + 8] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 8], PRIM_INT__p_s_f_s[n * 30 + 8]);

                        PRIM_INT__p_s_f_s[n * 30 + 9] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__p_s_f_s[n * 30 + 9] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 9], PRIM_INT__p_s_f_s[n * 30 + 9]);

                        PRIM_INT__p_s_f_s[n * 30 + 10] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__p_s_f_s[n * 30 + 10] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 0], PRIM_INT__p_s_f_s[n * 30 + 10]);

                        PRIM_INT__p_s_f_s[n * 30 + 11] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_f_s[n * 10 + 1]);
                        PRIM_INT__p_s_f_s[n * 30 + 11] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 1], PRIM_INT__p_s_f_s[n * 30 + 11]);
                        PRIM_INT__p_s_f_s[n * 30 + 11] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__p_s_f_s[n * 30 + 11]);

                        PRIM_INT__p_s_f_s[n * 30 + 12] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_f_s[n * 10 + 2]);
                        PRIM_INT__p_s_f_s[n * 30 + 12] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 2], PRIM_INT__p_s_f_s[n * 30 + 12]);

                        PRIM_INT__p_s_f_s[n * 30 + 13] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_f_s[n * 10 + 3]);
                        PRIM_INT__p_s_f_s[n * 30 + 13] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 3], PRIM_INT__p_s_f_s[n * 30 + 13]);
                        PRIM_INT__p_s_f_s[n * 30 + 13] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 1], PRIM_INT__p_s_f_s[n * 30 + 13]);

                        PRIM_INT__p_s_f_s[n * 30 + 14] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_f_s[n * 10 + 4]);
                        PRIM_INT__p_s_f_s[n * 30 + 14] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 4], PRIM_INT__p_s_f_s[n * 30 + 14]);
                        PRIM_INT__p_s_f_s[n * 30 + 14] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 2], PRIM_INT__p_s_f_s[n * 30 + 14]);

                        PRIM_INT__p_s_f_s[n * 30 + 15] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_f_s[n * 10 + 5]);
                        PRIM_INT__p_s_f_s[n * 30 + 15] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 5], PRIM_INT__p_s_f_s[n * 30 + 15]);

                        PRIM_INT__p_s_f_s[n * 30 + 16] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__p_s_f_s[n * 30 + 16] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 6], PRIM_INT__p_s_f_s[n * 30 + 16]);
                        PRIM_INT__p_s_f_s[n * 30 + 16] = SIMINT_FMADD( vrr_const_3_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__p_s_f_s[n * 30 + 16]);

                        PRIM_INT__p_s_f_s[n * 30 + 17] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_f_s[n * 10 + 7]);
                        PRIM_INT__p_s_f_s[n * 30 + 17] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 7], PRIM_INT__p_s_f_s[n * 30 + 17]);
                        PRIM_INT__p_s_f_s[n * 30 + 17] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 4], PRIM_INT__p_s_f_s[n * 30 + 17]);

                        PRIM_INT__p_s_f_s[n * 30 + 18] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_f_s[n * 10 + 8]);
                        PRIM_INT__p_s_f_s[n * 30 + 18] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 8], PRIM_INT__p_s_f_s[n * 30 + 18]);
                        PRIM_INT__p_s_f_s[n * 30 + 18] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__p_s_f_s[n * 30 + 18]);

                        PRIM_INT__p_s_f_s[n * 30 + 19] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__p_s_f_s[n * 30 + 19] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 9], PRIM_INT__p_s_f_s[n * 30 + 19]);

                        PRIM_INT__p_s_f_s[n * 30 + 20] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__p_s_f_s[n * 30 + 20] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 0], PRIM_INT__p_s_f_s[n * 30 + 20]);

                        PRIM_INT__p_s_f_s[n * 30 + 21] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_f_s[n * 10 + 1]);
                        PRIM_INT__p_s_f_s[n * 30 + 21] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 1], PRIM_INT__p_s_f_s[n * 30 + 21]);

                        PRIM_INT__p_s_f_s[n * 30 + 22] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_f_s[n * 10 + 2]);
                        PRIM_INT__p_s_f_s[n * 30 + 22] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 2], PRIM_INT__p_s_f_s[n * 30 + 22]);
                        PRIM_INT__p_s_f_s[n * 30 + 22] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__p_s_f_s[n * 30 + 22]);

                        PRIM_INT__p_s_f_s[n * 30 + 23] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_f_s[n * 10 + 3]);
                        PRIM_INT__p_s_f_s[n * 30 + 23] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 3], PRIM_INT__p_s_f_s[n * 30 + 23]);

                        PRIM_INT__p_s_f_s[n * 30 + 24] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_f_s[n * 10 + 4]);
                        PRIM_INT__p_s_f_s[n * 30 + 24] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 4], PRIM_INT__p_s_f_s[n * 30 + 24]);
                        PRIM_INT__p_s_f_s[n * 30 + 24] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 1], PRIM_INT__p_s_f_s[n * 30 + 24]);

                        PRIM_INT__p_s_f_s[n * 30 + 25] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_f_s[n * 10 + 5]);
                        PRIM_INT__p_s_f_s[n * 30 + 25] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 5], PRIM_INT__p_s_f_s[n * 30 + 25]);
                        PRIM_INT__p_s_f_s[n * 30 + 25] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 2], PRIM_INT__p_s_f_s[n * 30 + 25]);

                        PRIM_INT__p_s_f_s[n * 30 + 26] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__p_s_f_s[n * 30 + 26] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 6], PRIM_INT__p_s_f_s[n * 30 + 26]);

                        PRIM_INT__p_s_f_s[n * 30 + 27] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_f_s[n * 10 + 7]);
                        PRIM_INT__p_s_f_s[n * 30 + 27] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 7], PRIM_INT__p_s_f_s[n * 30 + 27]);
                        PRIM_INT__p_s_f_s[n * 30 + 27] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__p_s_f_s[n * 30 + 27]);

                        PRIM_INT__p_s_f_s[n * 30 + 28] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_f_s[n * 10 + 8]);
                        PRIM_INT__p_s_f_s[n * 30 + 28] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 8], PRIM_INT__p_s_f_s[n * 30 + 28]);
                        PRIM_INT__p_s_f_s[n * 30 + 28] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 4], PRIM_INT__p_s_f_s[n * 30 + 28]);

                        PRIM_INT__p_s_f_s[n * 30 + 29] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__p_s_f_s[n * 30 + 29] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 9], PRIM_INT__p_s_f_s[n * 30 + 29]);
                        PRIM_INT__p_s_f_s[n * 30 + 29] = SIMINT_FMADD( vrr_const_3_over_2pq, PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__p_s_f_s[n * 30 + 29]);

                    }


                    VRR_I_d_s_g_s(
                            PRIM_INT__d_s_g_s,
                            PRIM_INT__p_s_g_s,
                            PRIM_INT__s_s_g_s,
                            PRIM_INT__p_s_f_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            one_over_2pq,
                            4);


                    ostei_general_vrr_I(3, 0, 5, 0, 3,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__d_s_h_s, PRIM_INT__p_s_h_s, NULL, PRIM_INT__d_s_g_s, NULL, PRIM_INT__f_s_h_s);


                    ostei_general_vrr_I(4, 0, 6, 0, 2,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__f_s_i_s, PRIM_INT__d_s_i_s, NULL, PRIM_INT__f_s_h_s, NULL, PRIM_INT__g_s_i_s);


                    ostei_general_vrr1_K(8, 10,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_k_s, PRIM_INT__s_s_i_s, PRIM_INT__s_s_l_s);


                    ostei_general_vrr_I(1, 0, 8, 0, 5,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_l_s, NULL, NULL, PRIM_INT__s_s_k_s, NULL, PRIM_INT__p_s_l_s);


                    ostei_general_vrr_I(2, 0, 8, 0, 4,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__p_s_l_s, PRIM_INT__s_s_l_s, NULL, PRIM_INT__p_s_k_s, NULL, PRIM_INT__d_s_l_s);


                    ostei_general_vrr_I(3, 0, 8, 0, 3,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__d_s_l_s, PRIM_INT__p_s_l_s, NULL, PRIM_INT__d_s_k_s, NULL, PRIM_INT__f_s_l_s);


                    ostei_general_vrr_I(4, 0, 7, 0, 2,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__f_s_k_s, PRIM_INT__d_s_k_s, NULL, PRIM_INT__f_s_i_s, NULL, PRIM_INT__g_s_k_s);



                    // Forming PRIM_INT__p_s_d_s[5 * 18];
                    for(n = 0; n < 5; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__p_s_d_s[n * 18 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_d_s[n * 6 + 0]);
                        PRIM_INT__p_s_d_s[n * 18 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__p_s_d_s[n * 18 + 0]);
                        PRIM_INT__p_s_d_s[n * 18 + 0] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__s_s_p_s[(n+1) * 3 + 0], PRIM_INT__p_s_d_s[n * 18 + 0]);

                        PRIM_INT__p_s_d_s[n * 18 + 1] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_d_s[n * 6 + 1]);
                        PRIM_INT__p_s_d_s[n * 18 + 1] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_d_s[(n+1) * 6 + 1], PRIM_INT__p_s_d_s[n * 18 + 1]);
                        PRIM_INT__p_s_d_s[n * 18 + 1] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_p_s[(n+1) * 3 + 1], PRIM_INT__p_s_d_s[n * 18 + 1]);

                        PRIM_INT__p_s_d_s[n * 18 + 2] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_d_s[n * 6 + 2]);
                        PRIM_INT__p_s_d_s[n * 18 + 2] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_d_s[(n+1) * 6 + 2], PRIM_INT__p_s_d_s[n * 18 + 2]);
                        PRIM_INT__p_s_d_s[n * 18 + 2] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_p_s[(n+1) * 3 + 2], PRIM_INT__p_s_d_s[n * 18 + 2]);

                        PRIM_INT__p_s_d_s[n * 18 + 3] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_d_s[n * 6 + 3]);
                        PRIM_INT__p_s_d_s[n * 18 + 3] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__p_s_d_s[n * 18 + 3]);

                        PRIM_INT__p_s_d_s[n * 18 + 4] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_d_s[n * 6 + 4]);
                        PRIM_INT__p_s_d_s[n * 18 + 4] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_d_s[(n+1) * 6 + 4], PRIM_INT__p_s_d_s[n * 18 + 4]);

                        PRIM_INT__p_s_d_s[n * 18 + 5] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_d_s[n * 6 + 5]);
                        PRIM_INT__p_s_d_s[n * 18 + 5] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__p_s_d_s[n * 18 + 5]);

                        PRIM_INT__p_s_d_s[n * 18 + 6] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_d_s[n * 6 + 0]);
                        PRIM_INT__p_s_d_s[n * 18 + 6] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__p_s_d_s[n * 18 + 6]);

                        PRIM_INT__p_s_d_s[n * 18 + 7] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_d_s[n * 6 + 1]);
                        PRIM_INT__p_s_d_s[n * 18 + 7] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_d_s[(n+1) * 6 + 1], PRIM_INT__p_s_d_s[n * 18 + 7]);
                        PRIM_INT__p_s_d_s[n * 18 + 7] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_p_s[(n+1) * 3 + 0], PRIM_INT__p_s_d_s[n * 18 + 7]);

                        PRIM_INT__p_s_d_s[n * 18 + 8] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_d_s[n * 6 + 2]);
                        PRIM_INT__p_s_d_s[n * 18 + 8] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_d_s[(n+1) * 6 + 2], PRIM_INT__p_s_d_s[n * 18 + 8]);

                        PRIM_INT__p_s_d_s[n * 18 + 9] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_d_s[n * 6 + 3]);
                        PRIM_INT__p_s_d_s[n * 18 + 9] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__p_s_d_s[n * 18 + 9]);
                        PRIM_INT__p_s_d_s[n * 18 + 9] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__s_s_p_s[(n+1) * 3 + 1], PRIM_INT__p_s_d_s[n * 18 + 9]);

                        PRIM_INT__p_s_d_s[n * 18 + 10] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_d_s[n * 6 + 4]);
                        PRIM_INT__p_s_d_s[n * 18 + 10] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_d_s[(n+1) * 6 + 4], PRIM_INT__p_s_d_s[n * 18 + 10]);
                        PRIM_INT__p_s_d_s[n * 18 + 10] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_p_s[(n+1) * 3 + 2], PRIM_INT__p_s_d_s[n * 18 + 10]);

                        PRIM_INT__p_s_d_s[n * 18 + 11] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_d_s[n * 6 + 5]);
                        PRIM_INT__p_s_d_s[n * 18 + 11] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__p_s_d_s[n * 18 + 11]);

                        PRIM_INT__p_s_d_s[n * 18 + 12] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_d_s[n * 6 + 0]);
                        PRIM_INT__p_s_d_s[n * 18 + 12] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__p_s_d_s[n * 18 + 12]);

                        PRIM_INT__p_s_d_s[n * 18 + 13] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_d_s[n * 6 + 1]);
                        PRIM_INT__p_s_d_s[n * 18 + 13] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_d_s[(n+1) * 6 + 1], PRIM_INT__p_s_d_s[n * 18 + 13]);

                        PRIM_INT__p_s_d_s[n * 18 + 14] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_d_s[n * 6 + 2]);
                        PRIM_INT__p_s_d_s[n * 18 + 14] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_d_s[(n+1) * 6 + 2], PRIM_INT__p_s_d_s[n * 18 + 14]);
                        PRIM_INT__p_s_d_s[n * 18 + 14] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_p_s[(n+1) * 3 + 0], PRIM_INT__p_s_d_s[n * 18 + 14]);

                        PRIM_INT__p_s_d_s[n * 18 + 15] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_d_s[n * 6 + 3]);
                        PRIM_INT__p_s_d_s[n * 18 + 15] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__p_s_d_s[n * 18 + 15]);

                        PRIM_INT__p_s_d_s[n * 18 + 16] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_d_s[n * 6 + 4]);
                        PRIM_INT__p_s_d_s[n * 18 + 16] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_d_s[(n+1) * 6 + 4], PRIM_INT__p_s_d_s[n * 18 + 16]);
                        PRIM_INT__p_s_d_s[n * 18 + 16] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__s_s_p_s[(n+1) * 3 + 1], PRIM_INT__p_s_d_s[n * 18 + 16]);

                        PRIM_INT__p_s_d_s[n * 18 + 17] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_d_s[n * 6 + 5]);
                        PRIM_INT__p_s_d_s[n * 18 + 17] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__p_s_d_s[n * 18 + 17]);
                        PRIM_INT__p_s_d_s[n * 18 + 17] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__s_s_p_s[(n+1) * 3 + 2], PRIM_INT__p_s_d_s[n * 18 + 17]);

                    }


                    VRR_I_d_s_f_s(
                            PRIM_INT__d_s_f_s,
                            PRIM_INT__p_s_f_s,
                            PRIM_INT__s_s_f_s,
                            PRIM_INT__p_s_d_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            one_over_2pq,
                            4);


                    VRR_I_f_s_g_s(
                            PRIM_INT__f_s_g_s,
                            PRIM_INT__d_s_g_s,
                            PRIM_INT__p_s_g_s,
                            PRIM_INT__d_s_f_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            one_over_2pq,
                            3);


                    ostei_general_vrr_I(4, 0, 5, 0, 2,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__f_s_h_s, PRIM_INT__d_s_h_s, NULL, PRIM_INT__f_s_g_s, NULL, PRIM_INT__g_s_h_s);


                    ostei_general_vrr_I(5, 0, 6, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__g_s_i_s, PRIM_INT__f_s_i_s, NULL, PRIM_INT__g_s_h_s, NULL, PRIM_INT__h_s_i_s);


                    ostei_general_vrr1_K(9, 9,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_l_s, PRIM_INT__s_s_k_s, PRIM_INT__s_s_m_s);


                    ostei_general_vrr_I(1, 0, 9, 0, 5,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_m_s, NULL, NULL, PRIM_INT__s_s_l_s, NULL, PRIM_INT__p_s_m_s);


                    ostei_general_vrr_I(2, 0, 9, 0, 4,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__p_s_m_s, PRIM_INT__s_s_m_s, NULL, PRIM_INT__p_s_l_s, NULL, PRIM_INT__d_s_m_s);


                    ostei_general_vrr_I(3, 0, 9, 0, 3,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__d_s_m_s, PRIM_INT__p_s_m_s, NULL, PRIM_INT__d_s_l_s, NULL, PRIM_INT__f_s_m_s);


                    ostei_general_vrr_I(4, 0, 8, 0, 2,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__f_s_l_s, PRIM_INT__d_s_l_s, NULL, PRIM_INT__f_s_k_s, NULL, PRIM_INT__g_s_l_s);


                    ostei_general_vrr_I(5, 0, 7, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__g_s_k_s, PRIM_INT__f_s_k_s, NULL, PRIM_INT__g_s_i_s, NULL, PRIM_INT__h_s_k_s);


                    ostei_general_vrr1_K(10, 8,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_m_s, PRIM_INT__s_s_l_s, PRIM_INT__s_s_n_s);


                    ostei_general_vrr_I(1, 0, 10, 0, 5,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_n_s, NULL, NULL, PRIM_INT__s_s_m_s, NULL, PRIM_INT__p_s_n_s);


                    ostei_general_vrr_I(2, 0, 10, 0, 4,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__p_s_n_s, PRIM_INT__s_s_n_s, NULL, PRIM_INT__p_s_m_s, NULL, PRIM_INT__d_s_n_s);


                    ostei_general_vrr_I(3, 0, 10, 0, 3,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__d_s_n_s, PRIM_INT__p_s_n_s, NULL, PRIM_INT__d_s_m_s, NULL, PRIM_INT__f_s_n_s);


                    ostei_general_vrr_I(4, 0, 9, 0, 2,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__f_s_m_s, PRIM_INT__d_s_m_s, NULL, PRIM_INT__f_s_l_s, NULL, PRIM_INT__g_s_m_s);


                    ostei_general_vrr_I(5, 0, 8, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__g_s_l_s, PRIM_INT__f_s_l_s, NULL, PRIM_INT__g_s_k_s, NULL, PRIM_INT__h_s_l_s);


                    ostei_general_vrr1_K(11, 7,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_n_s, PRIM_INT__s_s_m_s, PRIM_INT__s_s_o_s);


                    ostei_general_vrr_I(1, 0, 11, 0, 5,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_o_s, NULL, NULL, PRIM_INT__s_s_n_s, NULL, PRIM_INT__p_s_o_s);


                    ostei_general_vrr_I(2, 0, 11, 0, 4,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__p_s_o_s, PRIM_INT__s_s_o_s, NULL, PRIM_INT__p_s_n_s, NULL, PRIM_INT__d_s_o_s);


                    ostei_general_vrr_I(3, 0, 11, 0, 3,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__d_s_o_s, PRIM_INT__p_s_o_s, NULL, PRIM_INT__d_s_n_s, NULL, PRIM_INT__f_s_o_s);


                    ostei_general_vrr_I(4, 0, 10, 0, 2,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__f_s_n_s, PRIM_INT__d_s_n_s, NULL, PRIM_INT__f_s_m_s, NULL, PRIM_INT__g_s_n_s);


                    ostei_general_vrr_I(5, 0, 9, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__g_s_m_s, PRIM_INT__f_s_m_s, NULL, PRIM_INT__g_s_l_s, NULL, PRIM_INT__h_s_m_s);


                    ostei_general_vrr1_K(12, 6,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_o_s, PRIM_INT__s_s_n_s, PRIM_INT__s_s_q_s);


                    ostei_general_vrr_I(1, 0, 12, 0, 5,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_q_s, NULL, NULL, PRIM_INT__s_s_o_s, NULL, PRIM_INT__p_s_q_s);


                    ostei_general_vrr_I(2, 0, 12, 0, 4,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__p_s_q_s, PRIM_INT__s_s_q_s, NULL, PRIM_INT__p_s_o_s, NULL, PRIM_INT__d_s_q_s);


                    ostei_general_vrr_I(3, 0, 12, 0, 3,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__d_s_q_s, PRIM_INT__p_s_q_s, NULL, PRIM_INT__d_s_o_s, NULL, PRIM_INT__f_s_q_s);


                    ostei_general_vrr_I(4, 0, 11, 0, 2,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__f_s_o_s, PRIM_INT__d_s_o_s, NULL, PRIM_INT__f_s_n_s, NULL, PRIM_INT__g_s_o_s);


                    ostei_general_vrr_I(5, 0, 10, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__g_s_n_s, PRIM_INT__f_s_n_s, NULL, PRIM_INT__g_s_m_s, NULL, PRIM_INT__h_s_n_s);


                    ostei_general_vrr_I(4, 0, 12, 0, 2,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__f_s_q_s, PRIM_INT__d_s_q_s, NULL, PRIM_INT__f_s_o_s, NULL, PRIM_INT__g_s_q_s);


                    ostei_general_vrr_I(5, 0, 11, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__g_s_o_s, PRIM_INT__f_s_o_s, NULL, PRIM_INT__g_s_n_s, NULL, PRIM_INT__h_s_o_s);


                    ostei_general_vrr_I(5, 0, 12, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__g_s_q_s, PRIM_INT__f_s_q_s, NULL, PRIM_INT__g_s_o_s, NULL, PRIM_INT__h_s_q_s);




                    ////////////////////////////////////
                    // Accumulate contracted integrals
                    ////////////////////////////////////
                    if(lastoffset == 0)
                    {
                        contract_all(280, PRIM_INT__f_s_i_s, PRIM_PTR_INT__f_s_i_s);
                        contract_all(360, PRIM_INT__f_s_k_s, PRIM_PTR_INT__f_s_k_s);
                        contract_all(450, PRIM_INT__f_s_l_s, PRIM_PTR_INT__f_s_l_s);
                        contract_all(550, PRIM_INT__f_s_m_s, PRIM_PTR_INT__f_s_m_s);
                        contract_all(660, PRIM_INT__f_s_n_s, PRIM_PTR_INT__f_s_n_s);
                        contract_all(780, PRIM_INT__f_s_o_s, PRIM_PTR_INT__f_s_o_s);
                        contract_all(910, PRIM_INT__f_s_q_s, PRIM_PTR_INT__f_s_q_s);
                        contract_all(420, PRIM_INT__g_s_i_s, PRIM_PTR_INT__g_s_i_s);
                        contract_all(540, PRIM_INT__g_s_k_s, PRIM_PTR_INT__g_s_k_s);
                        contract_all(675, PRIM_INT__g_s_l_s, PRIM_PTR_INT__g_s_l_s);
                        contract_all(825, PRIM_INT__g_s_m_s, PRIM_PTR_INT__g_s_m_s);
                        contract_all(990, PRIM_INT__g_s_n_s, PRIM_PTR_INT__g_s_n_s);
                        contract_all(1170, PRIM_INT__g_s_o_s, PRIM_PTR_INT__g_s_o_s);
                        contract_all(1365, PRIM_INT__g_s_q_s, PRIM_PTR_INT__g_s_q_s);
                        contract_all(588, PRIM_INT__h_s_i_s, PRIM_PTR_INT__h_s_i_s);
                        contract_all(756, PRIM_INT__h_s_k_s, PRIM_PTR_INT__h_s_k_s);
                        contract_all(945, PRIM_INT__h_s_l_s, PRIM_PTR_INT__h_s_l_s);
                        contract_all(1155, PRIM_INT__h_s_m_s, PRIM_PTR_INT__h_s_m_s);
                        contract_all(1386, PRIM_INT__h_s_n_s, PRIM_PTR_INT__h_s_n_s);
                        contract_all(1638, PRIM_INT__h_s_o_s, PRIM_PTR_INT__h_s_o_s);
                        contract_all(1911, PRIM_INT__h_s_q_s, PRIM_PTR_INT__h_s_q_s);
                    }
                    else
                    {
                        contract(280, shelloffsets, PRIM_INT__f_s_i_s, PRIM_PTR_INT__f_s_i_s);
                        contract(360, shelloffsets, PRIM_INT__f_s_k_s, PRIM_PTR_INT__f_s_k_s);
                        contract(450, shelloffsets, PRIM_INT__f_s_l_s, PRIM_PTR_INT__f_s_l_s);
                        contract(550, shelloffsets, PRIM_INT__f_s_m_s, PRIM_PTR_INT__f_s_m_s);
                        contract(660, shelloffsets, PRIM_INT__f_s_n_s, PRIM_PTR_INT__f_s_n_s);
                        contract(780, shelloffsets, PRIM_INT__f_s_o_s, PRIM_PTR_INT__f_s_o_s);
                        contract(910, shelloffsets, PRIM_INT__f_s_q_s, PRIM_PTR_INT__f_s_q_s);
                        contract(420, shelloffsets, PRIM_INT__g_s_i_s, PRIM_PTR_INT__g_s_i_s);
                        contract(540, shelloffsets, PRIM_INT__g_s_k_s, PRIM_PTR_INT__g_s_k_s);
                        contract(675, shelloffsets, PRIM_INT__g_s_l_s, PRIM_PTR_INT__g_s_l_s);
                        contract(825, shelloffsets, PRIM_INT__g_s_m_s, PRIM_PTR_INT__g_s_m_s);
                        contract(990, shelloffsets, PRIM_INT__g_s_n_s, PRIM_PTR_INT__g_s_n_s);
                        contract(1170, shelloffsets, PRIM_INT__g_s_o_s, PRIM_PTR_INT__g_s_o_s);
                        contract(1365, shelloffsets, PRIM_INT__g_s_q_s, PRIM_PTR_INT__g_s_q_s);
                        contract(588, shelloffsets, PRIM_INT__h_s_i_s, PRIM_PTR_INT__h_s_i_s);
                        contract(756, shelloffsets, PRIM_INT__h_s_k_s, PRIM_PTR_INT__h_s_k_s);
                        contract(945, shelloffsets, PRIM_INT__h_s_l_s, PRIM_PTR_INT__h_s_l_s);
                        contract(1155, shelloffsets, PRIM_INT__h_s_m_s, PRIM_PTR_INT__h_s_m_s);
                        contract(1386, shelloffsets, PRIM_INT__h_s_n_s, PRIM_PTR_INT__h_s_n_s);
                        contract(1638, shelloffsets, PRIM_INT__h_s_o_s, PRIM_PTR_INT__h_s_o_s);
                        contract(1911, shelloffsets, PRIM_INT__h_s_q_s, PRIM_PTR_INT__h_s_q_s);
                        PRIM_PTR_INT__f_s_i_s += lastoffset*280;
                        PRIM_PTR_INT__f_s_k_s += lastoffset*360;
                        PRIM_PTR_INT__f_s_l_s += lastoffset*450;
                        PRIM_PTR_INT__f_s_m_s += lastoffset*550;
                        PRIM_PTR_INT__f_s_n_s += lastoffset*660;
                        PRIM_PTR_INT__f_s_o_s += lastoffset*780;
                        PRIM_PTR_INT__f_s_q_s += lastoffset*910;
                        PRIM_PTR_INT__g_s_i_s += lastoffset*420;
                        PRIM_PTR_INT__g_s_k_s += lastoffset*540;
                        PRIM_PTR_INT__g_s_l_s += lastoffset*675;
                        PRIM_PTR_INT__g_s_m_s += lastoffset*825;
                        PRIM_PTR_INT__g_s_n_s += lastoffset*990;
                        PRIM_PTR_INT__g_s_o_s += lastoffset*1170;
                        PRIM_PTR_INT__g_s_q_s += lastoffset*1365;
                        PRIM_PTR_INT__h_s_i_s += lastoffset*588;
                        PRIM_PTR_INT__h_s_k_s += lastoffset*756;
                        PRIM_PTR_INT__h_s_l_s += lastoffset*945;
                        PRIM_PTR_INT__h_s_m_s += lastoffset*1155;
                        PRIM_PTR_INT__h_s_n_s += lastoffset*1386;
                        PRIM_PTR_INT__h_s_o_s += lastoffset*1638;
                        PRIM_PTR_INT__h_s_q_s += lastoffset*1911;
                    }

                }  // close loop over j
            }  // close loop over i
            
            //Advance to the next batch
            jstart = SIMINT_SIMD_ROUND(jend);
            
            //////////////////////////////////////////////
            // Contracted integrals: Horizontal recurrance
            //////////////////////////////////////////////


            const double hAB[3] = { P.AB_x[ab], P.AB_y[ab], P.AB_z[ab] };


            for(abcd = 0; abcd < nshellbatch; ++abcd, ++real_abcd)
            {
                const double hCD[3] = { Q.AB_x[cd+abcd], Q.AB_y[cd+abcd], Q.AB_z[cd+abcd] };

                // set up HRR pointers
                double const * restrict HRR_INT__f_s_i_s = INT__f_s_i_s + abcd * 280;
                double const * restrict HRR_INT__f_s_k_s = INT__f_s_k_s + abcd * 360;
                double const * restrict HRR_INT__f_s_l_s = INT__f_s_l_s + abcd * 450;
                double const * restrict HRR_INT__f_s_m_s = INT__f_s_m_s + abcd * 550;
                double const * restrict HRR_INT__f_s_n_s = INT__f_s_n_s + abcd * 660;
                double const * restrict HRR_INT__f_s_o_s = INT__f_s_o_s + abcd * 780;
                double const * restrict HRR_INT__f_s_q_s = INT__f_s_q_s + abcd * 910;
                double const * restrict HRR_INT__g_s_i_s = INT__g_s_i_s + abcd * 420;
                double const * restrict HRR_INT__g_s_k_s = INT__g_s_k_s + abcd * 540;
                double const * restrict HRR_INT__g_s_l_s = INT__g_s_l_s + abcd * 675;
                double const * restrict HRR_INT__g_s_m_s = INT__g_s_m_s + abcd * 825;
                double const * restrict HRR_INT__g_s_n_s = INT__g_s_n_s + abcd * 990;
                double const * restrict HRR_INT__g_s_o_s = INT__g_s_o_s + abcd * 1170;
                double const * restrict HRR_INT__g_s_q_s = INT__g_s_q_s + abcd * 1365;
                double const * restrict HRR_INT__h_s_i_s = INT__h_s_i_s + abcd * 588;
                double const * restrict HRR_INT__h_s_k_s = INT__h_s_k_s + abcd * 756;
                double const * restrict HRR_INT__h_s_l_s = INT__h_s_l_s + abcd * 945;
                double const * restrict HRR_INT__h_s_m_s = INT__h_s_m_s + abcd * 1155;
                double const * restrict HRR_INT__h_s_n_s = INT__h_s_n_s + abcd * 1386;
                double const * restrict HRR_INT__h_s_o_s = INT__h_s_o_s + abcd * 1638;
                double const * restrict HRR_INT__h_s_q_s = INT__h_s_q_s + abcd * 1911;
                double * restrict HRR_INT__f_d_i_i = INT__f_d_i_i + real_abcd * 47040;

                // form INT__f_p_i_s
                for(iket = 0; iket < 28; ++iket)
                {
                    HRR_INT__f_p_i_s[0 * 28 + iket] = HRR_INT__g_s_i_s[0 * 28 + iket] + ( hAB[0] * HRR_INT__f_s_i_s[0 * 28 + iket] );

                    HRR_INT__f_p_i_s[1 * 28 + iket] = HRR_INT__g_s_i_s[1 * 28 + iket] + ( hAB[1] * HRR_INT__f_s_i_s[0 * 28 + iket] );

                    HRR_INT__f_p_i_s[2 * 28 + iket] = HRR_INT__g_s_i_s[2 * 28 + iket] + ( hAB[2] * HRR_INT__f_s_i_s[0 * 28 + iket] );

                    HRR_INT__f_p_i_s[3 * 28 + iket] = HRR_INT__g_s_i_s[1 * 28 + iket] + ( hAB[0] * HRR_INT__f_s_i_s[1 * 28 + iket] );

                    HRR_INT__f_p_i_s[4 * 28 + iket] = HRR_INT__g_s_i_s[3 * 28 + iket] + ( hAB[1] * HRR_INT__f_s_i_s[1 * 28 + iket] );

                    HRR_INT__f_p_i_s[5 * 28 + iket] = HRR_INT__g_s_i_s[4 * 28 + iket] + ( hAB[2] * HRR_INT__f_s_i_s[1 * 28 + iket] );

                    HRR_INT__f_p_i_s[6 * 28 + iket] = HRR_INT__g_s_i_s[2 * 28 + iket] + ( hAB[0] * HRR_INT__f_s_i_s[2 * 28 + iket] );

                    HRR_INT__f_p_i_s[7 * 28 + iket] = HRR_INT__g_s_i_s[4 * 28 + iket] + ( hAB[1] * HRR_INT__f_s_i_s[2 * 28 + iket] );

                    HRR_INT__f_p_i_s[8 * 28 + iket] = HRR_INT__g_s_i_s[5 * 28 + iket] + ( hAB[2] * HRR_INT__f_s_i_s[2 * 28 + iket] );

                    HRR_INT__f_p_i_s[9 * 28 + iket] = HRR_INT__g_s_i_s[3 * 28 + iket] + ( hAB[0] * HRR_INT__f_s_i_s[3 * 28 + iket] );

                    HRR_INT__f_p_i_s[10 * 28 + iket] = HRR_INT__g_s_i_s[6 * 28 + iket] + ( hAB[1] * HRR_INT__f_s_i_s[3 * 28 + iket] );

                    HRR_INT__f_p_i_s[11 * 28 + iket] = HRR_INT__g_s_i_s[7 * 28 + iket] + ( hAB[2] * HRR_INT__f_s_i_s[3 * 28 + iket] );

                    HRR_INT__f_p_i_s[12 * 28 + iket] = HRR_INT__g_s_i_s[4 * 28 + iket] + ( hAB[0] * HRR_INT__f_s_i_s[4 * 28 + iket] );

                    HRR_INT__f_p_i_s[13 * 28 + iket] = HRR_INT__g_s_i_s[7 * 28 + iket] + ( hAB[1] * HRR_INT__f_s_i_s[4 * 28 + iket] );

                    HRR_INT__f_p_i_s[14 * 28 + iket] = HRR_INT__g_s_i_s[8 * 28 + iket] + ( hAB[2] * HRR_INT__f_s_i_s[4 * 28 + iket] );

                    HRR_INT__f_p_i_s[15 * 28 + iket] = HRR_INT__g_s_i_s[5 * 28 + iket] + ( hAB[0] * HRR_INT__f_s_i_s[5 * 28 + iket] );

                    HRR_INT__f_p_i_s[16 * 28 + iket] = HRR_INT__g_s_i_s[8 * 28 + iket] + ( hAB[1] * HRR_INT__f_s_i_s[5 * 28 + iket] );

                    HRR_INT__f_p_i_s[17 * 28 + iket] = HRR_INT__g_s_i_s[9 * 28 + iket] + ( hAB[2] * HRR_INT__f_s_i_s[5 * 28 + iket] );

                    HRR_INT__f_p_i_s[18 * 28 + iket] = HRR_INT__g_s_i_s[6 * 28 + iket] + ( hAB[0] * HRR_INT__f_s_i_s[6 * 28 + iket] );

                    HRR_INT__f_p_i_s[19 * 28 + iket] = HRR_INT__g_s_i_s[10 * 28 + iket] + ( hAB[1] * HRR_INT__f_s_i_s[6 * 28 + iket] );

                    HRR_INT__f_p_i_s[20 * 28 + iket] = HRR_INT__g_s_i_s[11 * 28 + iket] + ( hAB[2] * HRR_INT__f_s_i_s[6 * 28 + iket] );

                    HRR_INT__f_p_i_s[21 * 28 + iket] = HRR_INT__g_s_i_s[7 * 28 + iket] + ( hAB[0] * HRR_INT__f_s_i_s[7 * 28 + iket] );

                    HRR_INT__f_p_i_s[22 * 28 + iket] = HRR_INT__g_s_i_s[11 * 28 + iket] + ( hAB[1] * HRR_INT__f_s_i_s[7 * 28 + iket] );

                    HRR_INT__f_p_i_s[23 * 28 + iket] = HRR_INT__g_s_i_s[12 * 28 + iket] + ( hAB[2] * HRR_INT__f_s_i_s[7 * 28 + iket] );

                    HRR_INT__f_p_i_s[24 * 28 + iket] = HRR_INT__g_s_i_s[8 * 28 + iket] + ( hAB[0] * HRR_INT__f_s_i_s[8 * 28 + iket] );

                    HRR_INT__f_p_i_s[25 * 28 + iket] = HRR_INT__g_s_i_s[12 * 28 + iket] + ( hAB[1] * HRR_INT__f_s_i_s[8 * 28 + iket] );

                    HRR_INT__f_p_i_s[26 * 28 + iket] = HRR_INT__g_s_i_s[13 * 28 + iket] + ( hAB[2] * HRR_INT__f_s_i_s[8 * 28 + iket] );

                    HRR_INT__f_p_i_s[27 * 28 + iket] = HRR_INT__g_s_i_s[9 * 28 + iket] + ( hAB[0] * HRR_INT__f_s_i_s[9 * 28 + iket] );

                    HRR_INT__f_p_i_s[28 * 28 + iket] = HRR_INT__g_s_i_s[13 * 28 + iket] + ( hAB[1] * HRR_INT__f_s_i_s[9 * 28 + iket] );

                    HRR_INT__f_p_i_s[29 * 28 + iket] = HRR_INT__g_s_i_s[14 * 28 + iket] + ( hAB[2] * HRR_INT__f_s_i_s[9 * 28 + iket] );

                }


                // form INT__f_p_k_s
                for(iket = 0; iket < 36; ++iket)
                {
                    HRR_INT__f_p_k_s[0 * 36 + iket] = HRR_INT__g_s_k_s[0 * 36 + iket] + ( hAB[0] * HRR_INT__f_s_k_s[0 * 36 + iket] );

                    HRR_INT__f_p_k_s[1 * 36 + iket] = HRR_INT__g_s_k_s[1 * 36 + iket] + ( hAB[1] * HRR_INT__f_s_k_s[0 * 36 + iket] );

                    HRR_INT__f_p_k_s[2 * 36 + iket] = HRR_INT__g_s_k_s[2 * 36 + iket] + ( hAB[2] * HRR_INT__f_s_k_s[0 * 36 + iket] );

                    HRR_INT__f_p_k_s[3 * 36 + iket] = HRR_INT__g_s_k_s[1 * 36 + iket] + ( hAB[0] * HRR_INT__f_s_k_s[1 * 36 + iket] );

                    HRR_INT__f_p_k_s[4 * 36 + iket] = HRR_INT__g_s_k_s[3 * 36 + iket] + ( hAB[1] * HRR_INT__f_s_k_s[1 * 36 + iket] );

                    HRR_INT__f_p_k_s[5 * 36 + iket] = HRR_INT__g_s_k_s[4 * 36 + iket] + ( hAB[2] * HRR_INT__f_s_k_s[1 * 36 + iket] );

                    HRR_INT__f_p_k_s[6 * 36 + iket] = HRR_INT__g_s_k_s[2 * 36 + iket] + ( hAB[0] * HRR_INT__f_s_k_s[2 * 36 + iket] );

                    HRR_INT__f_p_k_s[7 * 36 + iket] = HRR_INT__g_s_k_s[4 * 36 + iket] + ( hAB[1] * HRR_INT__f_s_k_s[2 * 36 + iket] );

                    HRR_INT__f_p_k_s[8 * 36 + iket] = HRR_INT__g_s_k_s[5 * 36 + iket] + ( hAB[2] * HRR_INT__f_s_k_s[2 * 36 + iket] );

                    HRR_INT__f_p_k_s[9 * 36 + iket] = HRR_INT__g_s_k_s[3 * 36 + iket] + ( hAB[0] * HRR_INT__f_s_k_s[3 * 36 + iket] );

                    HRR_INT__f_p_k_s[10 * 36 + iket] = HRR_INT__g_s_k_s[6 * 36 + iket] + ( hAB[1] * HRR_INT__f_s_k_s[3 * 36 + iket] );

                    HRR_INT__f_p_k_s[11 * 36 + iket] = HRR_INT__g_s_k_s[7 * 36 + iket] + ( hAB[2] * HRR_INT__f_s_k_s[3 * 36 + iket] );

                    HRR_INT__f_p_k_s[12 * 36 + iket] = HRR_INT__g_s_k_s[4 * 36 + iket] + ( hAB[0] * HRR_INT__f_s_k_s[4 * 36 + iket] );

                    HRR_INT__f_p_k_s[13 * 36 + iket] = HRR_INT__g_s_k_s[7 * 36 + iket] + ( hAB[1] * HRR_INT__f_s_k_s[4 * 36 + iket] );

                    HRR_INT__f_p_k_s[14 * 36 + iket] = HRR_INT__g_s_k_s[8 * 36 + iket] + ( hAB[2] * HRR_INT__f_s_k_s[4 * 36 + iket] );

                    HRR_INT__f_p_k_s[15 * 36 + iket] = HRR_INT__g_s_k_s[5 * 36 + iket] + ( hAB[0] * HRR_INT__f_s_k_s[5 * 36 + iket] );

                    HRR_INT__f_p_k_s[16 * 36 + iket] = HRR_INT__g_s_k_s[8 * 36 + iket] + ( hAB[1] * HRR_INT__f_s_k_s[5 * 36 + iket] );

                    HRR_INT__f_p_k_s[17 * 36 + iket] = HRR_INT__g_s_k_s[9 * 36 + iket] + ( hAB[2] * HRR_INT__f_s_k_s[5 * 36 + iket] );

                    HRR_INT__f_p_k_s[18 * 36 + iket] = HRR_INT__g_s_k_s[6 * 36 + iket] + ( hAB[0] * HRR_INT__f_s_k_s[6 * 36 + iket] );

                    HRR_INT__f_p_k_s[19 * 36 + iket] = HRR_INT__g_s_k_s[10 * 36 + iket] + ( hAB[1] * HRR_INT__f_s_k_s[6 * 36 + iket] );

                    HRR_INT__f_p_k_s[20 * 36 + iket] = HRR_INT__g_s_k_s[11 * 36 + iket] + ( hAB[2] * HRR_INT__f_s_k_s[6 * 36 + iket] );

                    HRR_INT__f_p_k_s[21 * 36 + iket] = HRR_INT__g_s_k_s[7 * 36 + iket] + ( hAB[0] * HRR_INT__f_s_k_s[7 * 36 + iket] );

                    HRR_INT__f_p_k_s[22 * 36 + iket] = HRR_INT__g_s_k_s[11 * 36 + iket] + ( hAB[1] * HRR_INT__f_s_k_s[7 * 36 + iket] );

                    HRR_INT__f_p_k_s[23 * 36 + iket] = HRR_INT__g_s_k_s[12 * 36 + iket] + ( hAB[2] * HRR_INT__f_s_k_s[7 * 36 + iket] );

                    HRR_INT__f_p_k_s[24 * 36 + iket] = HRR_INT__g_s_k_s[8 * 36 + iket] + ( hAB[0] * HRR_INT__f_s_k_s[8 * 36 + iket] );

                    HRR_INT__f_p_k_s[25 * 36 + iket] = HRR_INT__g_s_k_s[12 * 36 + iket] + ( hAB[1] * HRR_INT__f_s_k_s[8 * 36 + iket] );

                    HRR_INT__f_p_k_s[26 * 36 + iket] = HRR_INT__g_s_k_s[13 * 36 + iket] + ( hAB[2] * HRR_INT__f_s_k_s[8 * 36 + iket] );

                    HRR_INT__f_p_k_s[27 * 36 + iket] = HRR_INT__g_s_k_s[9 * 36 + iket] + ( hAB[0] * HRR_INT__f_s_k_s[9 * 36 + iket] );

                    HRR_INT__f_p_k_s[28 * 36 + iket] = HRR_INT__g_s_k_s[13 * 36 + iket] + ( hAB[1] * HRR_INT__f_s_k_s[9 * 36 + iket] );

                    HRR_INT__f_p_k_s[29 * 36 + iket] = HRR_INT__g_s_k_s[14 * 36 + iket] + ( hAB[2] * HRR_INT__f_s_k_s[9 * 36 + iket] );

                }


                // form INT__f_p_l_s
                for(iket = 0; iket < 45; ++iket)
                {
                    HRR_INT__f_p_l_s[0 * 45 + iket] = HRR_INT__g_s_l_s[0 * 45 + iket] + ( hAB[0] * HRR_INT__f_s_l_s[0 * 45 + iket] );

                    HRR_INT__f_p_l_s[1 * 45 + iket] = HRR_INT__g_s_l_s[1 * 45 + iket] + ( hAB[1] * HRR_INT__f_s_l_s[0 * 45 + iket] );

                    HRR_INT__f_p_l_s[2 * 45 + iket] = HRR_INT__g_s_l_s[2 * 45 + iket] + ( hAB[2] * HRR_INT__f_s_l_s[0 * 45 + iket] );

                    HRR_INT__f_p_l_s[3 * 45 + iket] = HRR_INT__g_s_l_s[1 * 45 + iket] + ( hAB[0] * HRR_INT__f_s_l_s[1 * 45 + iket] );

                    HRR_INT__f_p_l_s[4 * 45 + iket] = HRR_INT__g_s_l_s[3 * 45 + iket] + ( hAB[1] * HRR_INT__f_s_l_s[1 * 45 + iket] );

                    HRR_INT__f_p_l_s[5 * 45 + iket] = HRR_INT__g_s_l_s[4 * 45 + iket] + ( hAB[2] * HRR_INT__f_s_l_s[1 * 45 + iket] );

                    HRR_INT__f_p_l_s[6 * 45 + iket] = HRR_INT__g_s_l_s[2 * 45 + iket] + ( hAB[0] * HRR_INT__f_s_l_s[2 * 45 + iket] );

                    HRR_INT__f_p_l_s[7 * 45 + iket] = HRR_INT__g_s_l_s[4 * 45 + iket] + ( hAB[1] * HRR_INT__f_s_l_s[2 * 45 + iket] );

                    HRR_INT__f_p_l_s[8 * 45 + iket] = HRR_INT__g_s_l_s[5 * 45 + iket] + ( hAB[2] * HRR_INT__f_s_l_s[2 * 45 + iket] );

                    HRR_INT__f_p_l_s[9 * 45 + iket] = HRR_INT__g_s_l_s[3 * 45 + iket] + ( hAB[0] * HRR_INT__f_s_l_s[3 * 45 + iket] );

                    HRR_INT__f_p_l_s[10 * 45 + iket] = HRR_INT__g_s_l_s[6 * 45 + iket] + ( hAB[1] * HRR_INT__f_s_l_s[3 * 45 + iket] );

                    HRR_INT__f_p_l_s[11 * 45 + iket] = HRR_INT__g_s_l_s[7 * 45 + iket] + ( hAB[2] * HRR_INT__f_s_l_s[3 * 45 + iket] );

                    HRR_INT__f_p_l_s[12 * 45 + iket] = HRR_INT__g_s_l_s[4 * 45 + iket] + ( hAB[0] * HRR_INT__f_s_l_s[4 * 45 + iket] );

                    HRR_INT__f_p_l_s[13 * 45 + iket] = HRR_INT__g_s_l_s[7 * 45 + iket] + ( hAB[1] * HRR_INT__f_s_l_s[4 * 45 + iket] );

                    HRR_INT__f_p_l_s[14 * 45 + iket] = HRR_INT__g_s_l_s[8 * 45 + iket] + ( hAB[2] * HRR_INT__f_s_l_s[4 * 45 + iket] );

                    HRR_INT__f_p_l_s[15 * 45 + iket] = HRR_INT__g_s_l_s[5 * 45 + iket] + ( hAB[0] * HRR_INT__f_s_l_s[5 * 45 + iket] );

                    HRR_INT__f_p_l_s[16 * 45 + iket] = HRR_INT__g_s_l_s[8 * 45 + iket] + ( hAB[1] * HRR_INT__f_s_l_s[5 * 45 + iket] );

                    HRR_INT__f_p_l_s[17 * 45 + iket] = HRR_INT__g_s_l_s[9 * 45 + iket] + ( hAB[2] * HRR_INT__f_s_l_s[5 * 45 + iket] );

                    HRR_INT__f_p_l_s[18 * 45 + iket] = HRR_INT__g_s_l_s[6 * 45 + iket] + ( hAB[0] * HRR_INT__f_s_l_s[6 * 45 + iket] );

                    HRR_INT__f_p_l_s[19 * 45 + iket] = HRR_INT__g_s_l_s[10 * 45 + iket] + ( hAB[1] * HRR_INT__f_s_l_s[6 * 45 + iket] );

                    HRR_INT__f_p_l_s[20 * 45 + iket] = HRR_INT__g_s_l_s[11 * 45 + iket] + ( hAB[2] * HRR_INT__f_s_l_s[6 * 45 + iket] );

                    HRR_INT__f_p_l_s[21 * 45 + iket] = HRR_INT__g_s_l_s[7 * 45 + iket] + ( hAB[0] * HRR_INT__f_s_l_s[7 * 45 + iket] );

                    HRR_INT__f_p_l_s[22 * 45 + iket] = HRR_INT__g_s_l_s[11 * 45 + iket] + ( hAB[1] * HRR_INT__f_s_l_s[7 * 45 + iket] );

                    HRR_INT__f_p_l_s[23 * 45 + iket] = HRR_INT__g_s_l_s[12 * 45 + iket] + ( hAB[2] * HRR_INT__f_s_l_s[7 * 45 + iket] );

                    HRR_INT__f_p_l_s[24 * 45 + iket] = HRR_INT__g_s_l_s[8 * 45 + iket] + ( hAB[0] * HRR_INT__f_s_l_s[8 * 45 + iket] );

                    HRR_INT__f_p_l_s[25 * 45 + iket] = HRR_INT__g_s_l_s[12 * 45 + iket] + ( hAB[1] * HRR_INT__f_s_l_s[8 * 45 + iket] );

                    HRR_INT__f_p_l_s[26 * 45 + iket] = HRR_INT__g_s_l_s[13 * 45 + iket] + ( hAB[2] * HRR_INT__f_s_l_s[8 * 45 + iket] );

                    HRR_INT__f_p_l_s[27 * 45 + iket] = HRR_INT__g_s_l_s[9 * 45 + iket] + ( hAB[0] * HRR_INT__f_s_l_s[9 * 45 + iket] );

                    HRR_INT__f_p_l_s[28 * 45 + iket] = HRR_INT__g_s_l_s[13 * 45 + iket] + ( hAB[1] * HRR_INT__f_s_l_s[9 * 45 + iket] );

                    HRR_INT__f_p_l_s[29 * 45 + iket] = HRR_INT__g_s_l_s[14 * 45 + iket] + ( hAB[2] * HRR_INT__f_s_l_s[9 * 45 + iket] );

                }


                // form INT__f_p_m_s
                for(iket = 0; iket < 55; ++iket)
                {
                    HRR_INT__f_p_m_s[0 * 55 + iket] = HRR_INT__g_s_m_s[0 * 55 + iket] + ( hAB[0] * HRR_INT__f_s_m_s[0 * 55 + iket] );

                    HRR_INT__f_p_m_s[1 * 55 + iket] = HRR_INT__g_s_m_s[1 * 55 + iket] + ( hAB[1] * HRR_INT__f_s_m_s[0 * 55 + iket] );

                    HRR_INT__f_p_m_s[2 * 55 + iket] = HRR_INT__g_s_m_s[2 * 55 + iket] + ( hAB[2] * HRR_INT__f_s_m_s[0 * 55 + iket] );

                    HRR_INT__f_p_m_s[3 * 55 + iket] = HRR_INT__g_s_m_s[1 * 55 + iket] + ( hAB[0] * HRR_INT__f_s_m_s[1 * 55 + iket] );

                    HRR_INT__f_p_m_s[4 * 55 + iket] = HRR_INT__g_s_m_s[3 * 55 + iket] + ( hAB[1] * HRR_INT__f_s_m_s[1 * 55 + iket] );

                    HRR_INT__f_p_m_s[5 * 55 + iket] = HRR_INT__g_s_m_s[4 * 55 + iket] + ( hAB[2] * HRR_INT__f_s_m_s[1 * 55 + iket] );

                    HRR_INT__f_p_m_s[6 * 55 + iket] = HRR_INT__g_s_m_s[2 * 55 + iket] + ( hAB[0] * HRR_INT__f_s_m_s[2 * 55 + iket] );

                    HRR_INT__f_p_m_s[7 * 55 + iket] = HRR_INT__g_s_m_s[4 * 55 + iket] + ( hAB[1] * HRR_INT__f_s_m_s[2 * 55 + iket] );

                    HRR_INT__f_p_m_s[8 * 55 + iket] = HRR_INT__g_s_m_s[5 * 55 + iket] + ( hAB[2] * HRR_INT__f_s_m_s[2 * 55 + iket] );

                    HRR_INT__f_p_m_s[9 * 55 + iket] = HRR_INT__g_s_m_s[3 * 55 + iket] + ( hAB[0] * HRR_INT__f_s_m_s[3 * 55 + iket] );

                    HRR_INT__f_p_m_s[10 * 55 + iket] = HRR_INT__g_s_m_s[6 * 55 + iket] + ( hAB[1] * HRR_INT__f_s_m_s[3 * 55 + iket] );

                    HRR_INT__f_p_m_s[11 * 55 + iket] = HRR_INT__g_s_m_s[7 * 55 + iket] + ( hAB[2] * HRR_INT__f_s_m_s[3 * 55 + iket] );

                    HRR_INT__f_p_m_s[12 * 55 + iket] = HRR_INT__g_s_m_s[4 * 55 + iket] + ( hAB[0] * HRR_INT__f_s_m_s[4 * 55 + iket] );

                    HRR_INT__f_p_m_s[13 * 55 + iket] = HRR_INT__g_s_m_s[7 * 55 + iket] + ( hAB[1] * HRR_INT__f_s_m_s[4 * 55 + iket] );

                    HRR_INT__f_p_m_s[14 * 55 + iket] = HRR_INT__g_s_m_s[8 * 55 + iket] + ( hAB[2] * HRR_INT__f_s_m_s[4 * 55 + iket] );

                    HRR_INT__f_p_m_s[15 * 55 + iket] = HRR_INT__g_s_m_s[5 * 55 + iket] + ( hAB[0] * HRR_INT__f_s_m_s[5 * 55 + iket] );

                    HRR_INT__f_p_m_s[16 * 55 + iket] = HRR_INT__g_s_m_s[8 * 55 + iket] + ( hAB[1] * HRR_INT__f_s_m_s[5 * 55 + iket] );

                    HRR_INT__f_p_m_s[17 * 55 + iket] = HRR_INT__g_s_m_s[9 * 55 + iket] + ( hAB[2] * HRR_INT__f_s_m_s[5 * 55 + iket] );

                    HRR_INT__f_p_m_s[18 * 55 + iket] = HRR_INT__g_s_m_s[6 * 55 + iket] + ( hAB[0] * HRR_INT__f_s_m_s[6 * 55 + iket] );

                    HRR_INT__f_p_m_s[19 * 55 + iket] = HRR_INT__g_s_m_s[10 * 55 + iket] + ( hAB[1] * HRR_INT__f_s_m_s[6 * 55 + iket] );

                    HRR_INT__f_p_m_s[20 * 55 + iket] = HRR_INT__g_s_m_s[11 * 55 + iket] + ( hAB[2] * HRR_INT__f_s_m_s[6 * 55 + iket] );

                    HRR_INT__f_p_m_s[21 * 55 + iket] = HRR_INT__g_s_m_s[7 * 55 + iket] + ( hAB[0] * HRR_INT__f_s_m_s[7 * 55 + iket] );

                    HRR_INT__f_p_m_s[22 * 55 + iket] = HRR_INT__g_s_m_s[11 * 55 + iket] + ( hAB[1] * HRR_INT__f_s_m_s[7 * 55 + iket] );

                    HRR_INT__f_p_m_s[23 * 55 + iket] = HRR_INT__g_s_m_s[12 * 55 + iket] + ( hAB[2] * HRR_INT__f_s_m_s[7 * 55 + iket] );

                    HRR_INT__f_p_m_s[24 * 55 + iket] = HRR_INT__g_s_m_s[8 * 55 + iket] + ( hAB[0] * HRR_INT__f_s_m_s[8 * 55 + iket] );

                    HRR_INT__f_p_m_s[25 * 55 + iket] = HRR_INT__g_s_m_s[12 * 55 + iket] + ( hAB[1] * HRR_INT__f_s_m_s[8 * 55 + iket] );

                    HRR_INT__f_p_m_s[26 * 55 + iket] = HRR_INT__g_s_m_s[13 * 55 + iket] + ( hAB[2] * HRR_INT__f_s_m_s[8 * 55 + iket] );

                    HRR_INT__f_p_m_s[27 * 55 + iket] = HRR_INT__g_s_m_s[9 * 55 + iket] + ( hAB[0] * HRR_INT__f_s_m_s[9 * 55 + iket] );

                    HRR_INT__f_p_m_s[28 * 55 + iket] = HRR_INT__g_s_m_s[13 * 55 + iket] + ( hAB[1] * HRR_INT__f_s_m_s[9 * 55 + iket] );

                    HRR_INT__f_p_m_s[29 * 55 + iket] = HRR_INT__g_s_m_s[14 * 55 + iket] + ( hAB[2] * HRR_INT__f_s_m_s[9 * 55 + iket] );

                }


                // form INT__f_p_n_s
                for(iket = 0; iket < 66; ++iket)
                {
                    HRR_INT__f_p_n_s[0 * 66 + iket] = HRR_INT__g_s_n_s[0 * 66 + iket] + ( hAB[0] * HRR_INT__f_s_n_s[0 * 66 + iket] );

                    HRR_INT__f_p_n_s[1 * 66 + iket] = HRR_INT__g_s_n_s[1 * 66 + iket] + ( hAB[1] * HRR_INT__f_s_n_s[0 * 66 + iket] );

                    HRR_INT__f_p_n_s[2 * 66 + iket] = HRR_INT__g_s_n_s[2 * 66 + iket] + ( hAB[2] * HRR_INT__f_s_n_s[0 * 66 + iket] );

                    HRR_INT__f_p_n_s[3 * 66 + iket] = HRR_INT__g_s_n_s[1 * 66 + iket] + ( hAB[0] * HRR_INT__f_s_n_s[1 * 66 + iket] );

                    HRR_INT__f_p_n_s[4 * 66 + iket] = HRR_INT__g_s_n_s[3 * 66 + iket] + ( hAB[1] * HRR_INT__f_s_n_s[1 * 66 + iket] );

                    HRR_INT__f_p_n_s[5 * 66 + iket] = HRR_INT__g_s_n_s[4 * 66 + iket] + ( hAB[2] * HRR_INT__f_s_n_s[1 * 66 + iket] );

                    HRR_INT__f_p_n_s[6 * 66 + iket] = HRR_INT__g_s_n_s[2 * 66 + iket] + ( hAB[0] * HRR_INT__f_s_n_s[2 * 66 + iket] );

                    HRR_INT__f_p_n_s[7 * 66 + iket] = HRR_INT__g_s_n_s[4 * 66 + iket] + ( hAB[1] * HRR_INT__f_s_n_s[2 * 66 + iket] );

                    HRR_INT__f_p_n_s[8 * 66 + iket] = HRR_INT__g_s_n_s[5 * 66 + iket] + ( hAB[2] * HRR_INT__f_s_n_s[2 * 66 + iket] );

                    HRR_INT__f_p_n_s[9 * 66 + iket] = HRR_INT__g_s_n_s[3 * 66 + iket] + ( hAB[0] * HRR_INT__f_s_n_s[3 * 66 + iket] );

                    HRR_INT__f_p_n_s[10 * 66 + iket] = HRR_INT__g_s_n_s[6 * 66 + iket] + ( hAB[1] * HRR_INT__f_s_n_s[3 * 66 + iket] );

                    HRR_INT__f_p_n_s[11 * 66 + iket] = HRR_INT__g_s_n_s[7 * 66 + iket] + ( hAB[2] * HRR_INT__f_s_n_s[3 * 66 + iket] );

                    HRR_INT__f_p_n_s[12 * 66 + iket] = HRR_INT__g_s_n_s[4 * 66 + iket] + ( hAB[0] * HRR_INT__f_s_n_s[4 * 66 + iket] );

                    HRR_INT__f_p_n_s[13 * 66 + iket] = HRR_INT__g_s_n_s[7 * 66 + iket] + ( hAB[1] * HRR_INT__f_s_n_s[4 * 66 + iket] );

                    HRR_INT__f_p_n_s[14 * 66 + iket] = HRR_INT__g_s_n_s[8 * 66 + iket] + ( hAB[2] * HRR_INT__f_s_n_s[4 * 66 + iket] );

                    HRR_INT__f_p_n_s[15 * 66 + iket] = HRR_INT__g_s_n_s[5 * 66 + iket] + ( hAB[0] * HRR_INT__f_s_n_s[5 * 66 + iket] );

                    HRR_INT__f_p_n_s[16 * 66 + iket] = HRR_INT__g_s_n_s[8 * 66 + iket] + ( hAB[1] * HRR_INT__f_s_n_s[5 * 66 + iket] );

                    HRR_INT__f_p_n_s[17 * 66 + iket] = HRR_INT__g_s_n_s[9 * 66 + iket] + ( hAB[2] * HRR_INT__f_s_n_s[5 * 66 + iket] );

                    HRR_INT__f_p_n_s[18 * 66 + iket] = HRR_INT__g_s_n_s[6 * 66 + iket] + ( hAB[0] * HRR_INT__f_s_n_s[6 * 66 + iket] );

                    HRR_INT__f_p_n_s[19 * 66 + iket] = HRR_INT__g_s_n_s[10 * 66 + iket] + ( hAB[1] * HRR_INT__f_s_n_s[6 * 66 + iket] );

                    HRR_INT__f_p_n_s[20 * 66 + iket] = HRR_INT__g_s_n_s[11 * 66 + iket] + ( hAB[2] * HRR_INT__f_s_n_s[6 * 66 + iket] );

                    HRR_INT__f_p_n_s[21 * 66 + iket] = HRR_INT__g_s_n_s[7 * 66 + iket] + ( hAB[0] * HRR_INT__f_s_n_s[7 * 66 + iket] );

                    HRR_INT__f_p_n_s[22 * 66 + iket] = HRR_INT__g_s_n_s[11 * 66 + iket] + ( hAB[1] * HRR_INT__f_s_n_s[7 * 66 + iket] );

                    HRR_INT__f_p_n_s[23 * 66 + iket] = HRR_INT__g_s_n_s[12 * 66 + iket] + ( hAB[2] * HRR_INT__f_s_n_s[7 * 66 + iket] );

                    HRR_INT__f_p_n_s[24 * 66 + iket] = HRR_INT__g_s_n_s[8 * 66 + iket] + ( hAB[0] * HRR_INT__f_s_n_s[8 * 66 + iket] );

                    HRR_INT__f_p_n_s[25 * 66 + iket] = HRR_INT__g_s_n_s[12 * 66 + iket] + ( hAB[1] * HRR_INT__f_s_n_s[8 * 66 + iket] );

                    HRR_INT__f_p_n_s[26 * 66 + iket] = HRR_INT__g_s_n_s[13 * 66 + iket] + ( hAB[2] * HRR_INT__f_s_n_s[8 * 66 + iket] );

                    HRR_INT__f_p_n_s[27 * 66 + iket] = HRR_INT__g_s_n_s[9 * 66 + iket] + ( hAB[0] * HRR_INT__f_s_n_s[9 * 66 + iket] );

                    HRR_INT__f_p_n_s[28 * 66 + iket] = HRR_INT__g_s_n_s[13 * 66 + iket] + ( hAB[1] * HRR_INT__f_s_n_s[9 * 66 + iket] );

                    HRR_INT__f_p_n_s[29 * 66 + iket] = HRR_INT__g_s_n_s[14 * 66 + iket] + ( hAB[2] * HRR_INT__f_s_n_s[9 * 66 + iket] );

                }


                // form INT__f_p_o_s
                for(iket = 0; iket < 78; ++iket)
                {
                    HRR_INT__f_p_o_s[0 * 78 + iket] = HRR_INT__g_s_o_s[0 * 78 + iket] + ( hAB[0] * HRR_INT__f_s_o_s[0 * 78 + iket] );

                    HRR_INT__f_p_o_s[1 * 78 + iket] = HRR_INT__g_s_o_s[1 * 78 + iket] + ( hAB[1] * HRR_INT__f_s_o_s[0 * 78 + iket] );

                    HRR_INT__f_p_o_s[2 * 78 + iket] = HRR_INT__g_s_o_s[2 * 78 + iket] + ( hAB[2] * HRR_INT__f_s_o_s[0 * 78 + iket] );

                    HRR_INT__f_p_o_s[3 * 78 + iket] = HRR_INT__g_s_o_s[1 * 78 + iket] + ( hAB[0] * HRR_INT__f_s_o_s[1 * 78 + iket] );

                    HRR_INT__f_p_o_s[4 * 78 + iket] = HRR_INT__g_s_o_s[3 * 78 + iket] + ( hAB[1] * HRR_INT__f_s_o_s[1 * 78 + iket] );

                    HRR_INT__f_p_o_s[5 * 78 + iket] = HRR_INT__g_s_o_s[4 * 78 + iket] + ( hAB[2] * HRR_INT__f_s_o_s[1 * 78 + iket] );

                    HRR_INT__f_p_o_s[6 * 78 + iket] = HRR_INT__g_s_o_s[2 * 78 + iket] + ( hAB[0] * HRR_INT__f_s_o_s[2 * 78 + iket] );

                    HRR_INT__f_p_o_s[7 * 78 + iket] = HRR_INT__g_s_o_s[4 * 78 + iket] + ( hAB[1] * HRR_INT__f_s_o_s[2 * 78 + iket] );

                    HRR_INT__f_p_o_s[8 * 78 + iket] = HRR_INT__g_s_o_s[5 * 78 + iket] + ( hAB[2] * HRR_INT__f_s_o_s[2 * 78 + iket] );

                    HRR_INT__f_p_o_s[9 * 78 + iket] = HRR_INT__g_s_o_s[3 * 78 + iket] + ( hAB[0] * HRR_INT__f_s_o_s[3 * 78 + iket] );

                    HRR_INT__f_p_o_s[10 * 78 + iket] = HRR_INT__g_s_o_s[6 * 78 + iket] + ( hAB[1] * HRR_INT__f_s_o_s[3 * 78 + iket] );

                    HRR_INT__f_p_o_s[11 * 78 + iket] = HRR_INT__g_s_o_s[7 * 78 + iket] + ( hAB[2] * HRR_INT__f_s_o_s[3 * 78 + iket] );

                    HRR_INT__f_p_o_s[12 * 78 + iket] = HRR_INT__g_s_o_s[4 * 78 + iket] + ( hAB[0] * HRR_INT__f_s_o_s[4 * 78 + iket] );

                    HRR_INT__f_p_o_s[13 * 78 + iket] = HRR_INT__g_s_o_s[7 * 78 + iket] + ( hAB[1] * HRR_INT__f_s_o_s[4 * 78 + iket] );

                    HRR_INT__f_p_o_s[14 * 78 + iket] = HRR_INT__g_s_o_s[8 * 78 + iket] + ( hAB[2] * HRR_INT__f_s_o_s[4 * 78 + iket] );

                    HRR_INT__f_p_o_s[15 * 78 + iket] = HRR_INT__g_s_o_s[5 * 78 + iket] + ( hAB[0] * HRR_INT__f_s_o_s[5 * 78 + iket] );

                    HRR_INT__f_p_o_s[16 * 78 + iket] = HRR_INT__g_s_o_s[8 * 78 + iket] + ( hAB[1] * HRR_INT__f_s_o_s[5 * 78 + iket] );

                    HRR_INT__f_p_o_s[17 * 78 + iket] = HRR_INT__g_s_o_s[9 * 78 + iket] + ( hAB[2] * HRR_INT__f_s_o_s[5 * 78 + iket] );

                    HRR_INT__f_p_o_s[18 * 78 + iket] = HRR_INT__g_s_o_s[6 * 78 + iket] + ( hAB[0] * HRR_INT__f_s_o_s[6 * 78 + iket] );

                    HRR_INT__f_p_o_s[19 * 78 + iket] = HRR_INT__g_s_o_s[10 * 78 + iket] + ( hAB[1] * HRR_INT__f_s_o_s[6 * 78 + iket] );

                    HRR_INT__f_p_o_s[20 * 78 + iket] = HRR_INT__g_s_o_s[11 * 78 + iket] + ( hAB[2] * HRR_INT__f_s_o_s[6 * 78 + iket] );

                    HRR_INT__f_p_o_s[21 * 78 + iket] = HRR_INT__g_s_o_s[7 * 78 + iket] + ( hAB[0] * HRR_INT__f_s_o_s[7 * 78 + iket] );

                    HRR_INT__f_p_o_s[22 * 78 + iket] = HRR_INT__g_s_o_s[11 * 78 + iket] + ( hAB[1] * HRR_INT__f_s_o_s[7 * 78 + iket] );

                    HRR_INT__f_p_o_s[23 * 78 + iket] = HRR_INT__g_s_o_s[12 * 78 + iket] + ( hAB[2] * HRR_INT__f_s_o_s[7 * 78 + iket] );

                    HRR_INT__f_p_o_s[24 * 78 + iket] = HRR_INT__g_s_o_s[8 * 78 + iket] + ( hAB[0] * HRR_INT__f_s_o_s[8 * 78 + iket] );

                    HRR_INT__f_p_o_s[25 * 78 + iket] = HRR_INT__g_s_o_s[12 * 78 + iket] + ( hAB[1] * HRR_INT__f_s_o_s[8 * 78 + iket] );

                    HRR_INT__f_p_o_s[26 * 78 + iket] = HRR_INT__g_s_o_s[13 * 78 + iket] + ( hAB[2] * HRR_INT__f_s_o_s[8 * 78 + iket] );

                    HRR_INT__f_p_o_s[27 * 78 + iket] = HRR_INT__g_s_o_s[9 * 78 + iket] + ( hAB[0] * HRR_INT__f_s_o_s[9 * 78 + iket] );

                    HRR_INT__f_p_o_s[28 * 78 + iket] = HRR_INT__g_s_o_s[13 * 78 + iket] + ( hAB[1] * HRR_INT__f_s_o_s[9 * 78 + iket] );

                    HRR_INT__f_p_o_s[29 * 78 + iket] = HRR_INT__g_s_o_s[14 * 78 + iket] + ( hAB[2] * HRR_INT__f_s_o_s[9 * 78 + iket] );

                }


                // form INT__f_p_q_s
                for(iket = 0; iket < 91; ++iket)
                {
                    HRR_INT__f_p_q_s[0 * 91 + iket] = HRR_INT__g_s_q_s[0 * 91 + iket] + ( hAB[0] * HRR_INT__f_s_q_s[0 * 91 + iket] );

                    HRR_INT__f_p_q_s[1 * 91 + iket] = HRR_INT__g_s_q_s[1 * 91 + iket] + ( hAB[1] * HRR_INT__f_s_q_s[0 * 91 + iket] );

                    HRR_INT__f_p_q_s[2 * 91 + iket] = HRR_INT__g_s_q_s[2 * 91 + iket] + ( hAB[2] * HRR_INT__f_s_q_s[0 * 91 + iket] );

                    HRR_INT__f_p_q_s[3 * 91 + iket] = HRR_INT__g_s_q_s[1 * 91 + iket] + ( hAB[0] * HRR_INT__f_s_q_s[1 * 91 + iket] );

                    HRR_INT__f_p_q_s[4 * 91 + iket] = HRR_INT__g_s_q_s[3 * 91 + iket] + ( hAB[1] * HRR_INT__f_s_q_s[1 * 91 + iket] );

                    HRR_INT__f_p_q_s[5 * 91 + iket] = HRR_INT__g_s_q_s[4 * 91 + iket] + ( hAB[2] * HRR_INT__f_s_q_s[1 * 91 + iket] );

                    HRR_INT__f_p_q_s[6 * 91 + iket] = HRR_INT__g_s_q_s[2 * 91 + iket] + ( hAB[0] * HRR_INT__f_s_q_s[2 * 91 + iket] );

                    HRR_INT__f_p_q_s[7 * 91 + iket] = HRR_INT__g_s_q_s[4 * 91 + iket] + ( hAB[1] * HRR_INT__f_s_q_s[2 * 91 + iket] );

                    HRR_INT__f_p_q_s[8 * 91 + iket] = HRR_INT__g_s_q_s[5 * 91 + iket] + ( hAB[2] * HRR_INT__f_s_q_s[2 * 91 + iket] );

                    HRR_INT__f_p_q_s[9 * 91 + iket] = HRR_INT__g_s_q_s[3 * 91 + iket] + ( hAB[0] * HRR_INT__f_s_q_s[3 * 91 + iket] );

                    HRR_INT__f_p_q_s[10 * 91 + iket] = HRR_INT__g_s_q_s[6 * 91 + iket] + ( hAB[1] * HRR_INT__f_s_q_s[3 * 91 + iket] );

                    HRR_INT__f_p_q_s[11 * 91 + iket] = HRR_INT__g_s_q_s[7 * 91 + iket] + ( hAB[2] * HRR_INT__f_s_q_s[3 * 91 + iket] );

                    HRR_INT__f_p_q_s[12 * 91 + iket] = HRR_INT__g_s_q_s[4 * 91 + iket] + ( hAB[0] * HRR_INT__f_s_q_s[4 * 91 + iket] );

                    HRR_INT__f_p_q_s[13 * 91 + iket] = HRR_INT__g_s_q_s[7 * 91 + iket] + ( hAB[1] * HRR_INT__f_s_q_s[4 * 91 + iket] );

                    HRR_INT__f_p_q_s[14 * 91 + iket] = HRR_INT__g_s_q_s[8 * 91 + iket] + ( hAB[2] * HRR_INT__f_s_q_s[4 * 91 + iket] );

                    HRR_INT__f_p_q_s[15 * 91 + iket] = HRR_INT__g_s_q_s[5 * 91 + iket] + ( hAB[0] * HRR_INT__f_s_q_s[5 * 91 + iket] );

                    HRR_INT__f_p_q_s[16 * 91 + iket] = HRR_INT__g_s_q_s[8 * 91 + iket] + ( hAB[1] * HRR_INT__f_s_q_s[5 * 91 + iket] );

                    HRR_INT__f_p_q_s[17 * 91 + iket] = HRR_INT__g_s_q_s[9 * 91 + iket] + ( hAB[2] * HRR_INT__f_s_q_s[5 * 91 + iket] );

                    HRR_INT__f_p_q_s[18 * 91 + iket] = HRR_INT__g_s_q_s[6 * 91 + iket] + ( hAB[0] * HRR_INT__f_s_q_s[6 * 91 + iket] );

                    HRR_INT__f_p_q_s[19 * 91 + iket] = HRR_INT__g_s_q_s[10 * 91 + iket] + ( hAB[1] * HRR_INT__f_s_q_s[6 * 91 + iket] );

                    HRR_INT__f_p_q_s[20 * 91 + iket] = HRR_INT__g_s_q_s[11 * 91 + iket] + ( hAB[2] * HRR_INT__f_s_q_s[6 * 91 + iket] );

                    HRR_INT__f_p_q_s[21 * 91 + iket] = HRR_INT__g_s_q_s[7 * 91 + iket] + ( hAB[0] * HRR_INT__f_s_q_s[7 * 91 + iket] );

                    HRR_INT__f_p_q_s[22 * 91 + iket] = HRR_INT__g_s_q_s[11 * 91 + iket] + ( hAB[1] * HRR_INT__f_s_q_s[7 * 91 + iket] );

                    HRR_INT__f_p_q_s[23 * 91 + iket] = HRR_INT__g_s_q_s[12 * 91 + iket] + ( hAB[2] * HRR_INT__f_s_q_s[7 * 91 + iket] );

                    HRR_INT__f_p_q_s[24 * 91 + iket] = HRR_INT__g_s_q_s[8 * 91 + iket] + ( hAB[0] * HRR_INT__f_s_q_s[8 * 91 + iket] );

                    HRR_INT__f_p_q_s[25 * 91 + iket] = HRR_INT__g_s_q_s[12 * 91 + iket] + ( hAB[1] * HRR_INT__f_s_q_s[8 * 91 + iket] );

                    HRR_INT__f_p_q_s[26 * 91 + iket] = HRR_INT__g_s_q_s[13 * 91 + iket] + ( hAB[2] * HRR_INT__f_s_q_s[8 * 91 + iket] );

                    HRR_INT__f_p_q_s[27 * 91 + iket] = HRR_INT__g_s_q_s[9 * 91 + iket] + ( hAB[0] * HRR_INT__f_s_q_s[9 * 91 + iket] );

                    HRR_INT__f_p_q_s[28 * 91 + iket] = HRR_INT__g_s_q_s[13 * 91 + iket] + ( hAB[1] * HRR_INT__f_s_q_s[9 * 91 + iket] );

                    HRR_INT__f_p_q_s[29 * 91 + iket] = HRR_INT__g_s_q_s[14 * 91 + iket] + ( hAB[2] * HRR_INT__f_s_q_s[9 * 91 + iket] );

                }


                // form INT__g_p_i_s
                HRR_J_g_p(
                    HRR_INT__g_p_i_s,
                    HRR_INT__g_s_i_s,
                    HRR_INT__h_s_i_s,
                    hAB, 28);

                // form INT__g_p_k_s
                HRR_J_g_p(
                    HRR_INT__g_p_k_s,
                    HRR_INT__g_s_k_s,
                    HRR_INT__h_s_k_s,
                    hAB, 36);

                // form INT__g_p_l_s
                HRR_J_g_p(
                    HRR_INT__g_p_l_s,
                    HRR_INT__g_s_l_s,
                    HRR_INT__h_s_l_s,
                    hAB, 45);

                // form INT__g_p_m_s
                HRR_J_g_p(
                    HRR_INT__g_p_m_s,
                    HRR_INT__g_s_m_s,
                    HRR_INT__h_s_m_s,
                    hAB, 55);

                // form INT__g_p_n_s
                HRR_J_g_p(
                    HRR_INT__g_p_n_s,
                    HRR_INT__g_s_n_s,
                    HRR_INT__h_s_n_s,
                    hAB, 66);

                // form INT__g_p_o_s
                HRR_J_g_p(
                    HRR_INT__g_p_o_s,
                    HRR_INT__g_s_o_s,
                    HRR_INT__h_s_o_s,
                    hAB, 78);

                // form INT__g_p_q_s
                HRR_J_g_p(
                    HRR_INT__g_p_q_s,
                    HRR_INT__g_s_q_s,
                    HRR_INT__h_s_q_s,
                    hAB, 91);

                // form INT__f_d_i_s
                HRR_J_f_d(
                    HRR_INT__f_d_i_s,
                    HRR_INT__f_p_i_s,
                    HRR_INT__g_p_i_s,
                    hAB, 28);

                // form INT__f_d_k_s
                HRR_J_f_d(
                    HRR_INT__f_d_k_s,
                    HRR_INT__f_p_k_s,
                    HRR_INT__g_p_k_s,
                    hAB, 36);

                // form INT__f_d_l_s
                HRR_J_f_d(
                    HRR_INT__f_d_l_s,
                    HRR_INT__f_p_l_s,
                    HRR_INT__g_p_l_s,
                    hAB, 45);

                // form INT__f_d_m_s
                HRR_J_f_d(
                    HRR_INT__f_d_m_s,
                    HRR_INT__f_p_m_s,
                    HRR_INT__g_p_m_s,
                    hAB, 55);

                // form INT__f_d_n_s
                HRR_J_f_d(
                    HRR_INT__f_d_n_s,
                    HRR_INT__f_p_n_s,
                    HRR_INT__g_p_n_s,
                    hAB, 66);

                // form INT__f_d_o_s
                HRR_J_f_d(
                    HRR_INT__f_d_o_s,
                    HRR_INT__f_p_o_s,
                    HRR_INT__g_p_o_s,
                    hAB, 78);

                // form INT__f_d_q_s
                HRR_J_f_d(
                    HRR_INT__f_d_q_s,
                    HRR_INT__f_p_q_s,
                    HRR_INT__g_p_q_s,
                    hAB, 91);

                // form INT__f_d_i_p
                HRR_L_i_p(
                    HRR_INT__f_d_i_p,
                    HRR_INT__f_d_i_s,
                    HRR_INT__f_d_k_s,
                    hCD, 60);

                // form INT__f_d_k_p
                HRR_L_k_p(
                    HRR_INT__f_d_k_p,
                    HRR_INT__f_d_k_s,
                    HRR_INT__f_d_l_s,
                    hCD, 60);

                // form INT__f_d_l_p
                HRR_L_l_p(
                    HRR_INT__f_d_l_p,
                    HRR_INT__f_d_l_s,
                    HRR_INT__f_d_m_s,
                    hCD, 60);

                // form INT__f_d_m_p
                ostei_general_hrr_L(3, 2, 9, 1, hCD, HRR_INT__f_d_n_s, HRR_INT__f_d_m_s, HRR_INT__f_d_m_p);

                // form INT__f_d_n_p
                ostei_general_hrr_L(3, 2, 10, 1, hCD, HRR_INT__f_d_o_s, HRR_INT__f_d_n_s, HRR_INT__f_d_n_p);

                // form INT__f_d_o_p
                ostei_general_hrr_L(3, 2, 11, 1, hCD, HRR_INT__f_d_q_s, HRR_INT__f_d_o_s, HRR_INT__f_d_o_p);

                // form INT__f_d_i_d
                HRR_L_i_d(
                    HRR_INT__f_d_i_d,
                    HRR_INT__f_d_i_p,
                    HRR_INT__f_d_k_p,
                    hCD, 60);

                // form INT__f_d_k_d
                HRR_L_k_d(
                    HRR_INT__f_d_k_d,
                    HRR_INT__f_d_k_p,
                    HRR_INT__f_d_l_p,
                    hCD, 60);

                // form INT__f_d_l_d
                ostei_general_hrr_L(3, 2, 8, 2, hCD, HRR_INT__f_d_m_p, HRR_INT__f_d_l_p, HRR_INT__f_d_l_d);

                // form INT__f_d_m_d
                ostei_general_hrr_L(3, 2, 9, 2, hCD, HRR_INT__f_d_n_p, HRR_INT__f_d_m_p, HRR_INT__f_d_m_d);

                // form INT__f_d_n_d
                ostei_general_hrr_L(3, 2, 10, 2, hCD, HRR_INT__f_d_o_p, HRR_INT__f_d_n_p, HRR_INT__f_d_n_d);

                // form INT__f_d_i_f
                HRR_L_i_f(
                    HRR_INT__f_d_i_f,
                    HRR_INT__f_d_i_d,
                    HRR_INT__f_d_k_d,
                    hCD, 60);

                // form INT__f_d_k_f
                ostei_general_hrr_L(3, 2, 7, 3, hCD, HRR_INT__f_d_l_d, HRR_INT__f_d_k_d, HRR_INT__f_d_k_f);

                // form INT__f_d_l_f
                ostei_general_hrr_L(3, 2, 8, 3, hCD, HRR_INT__f_d_m_d, HRR_INT__f_d_l_d, HRR_INT__f_d_l_f);

                // form INT__f_d_m_f
                ostei_general_hrr_L(3, 2, 9, 3, hCD, HRR_INT__f_d_n_d, HRR_INT__f_d_m_d, HRR_INT__f_d_m_f);

                // form INT__f_d_i_g
                ostei_general_hrr_L(3, 2, 6, 4, hCD, HRR_INT__f_d_k_f, HRR_INT__f_d_i_f, HRR_INT__f_d_i_g);

                // form INT__f_d_k_g
                ostei_general_hrr_L(3, 2, 7, 4, hCD, HRR_INT__f_d_l_f, HRR_INT__f_d_k_f, HRR_INT__f_d_k_g);

                // form INT__f_d_l_g
                ostei_general_hrr_L(3, 2, 8, 4, hCD, HRR_INT__f_d_m_f, HRR_INT__f_d_l_f, HRR_INT__f_d_l_g);

                // form INT__f_d_i_h
                ostei_general_hrr_L(3, 2, 6, 5, hCD, HRR_INT__f_d_k_g, HRR_INT__f_d_i_g, HRR_INT__f_d_i_h);

                // form INT__f_d_k_h
                ostei_general_hrr_L(3, 2, 7, 5, hCD, HRR_INT__f_d_l_g, HRR_INT__f_d_k_g, HRR_INT__f_d_k_h);

                // form INT__f_d_i_i
                ostei_general_hrr_L(3, 2, 6, 6, hCD, HRR_INT__f_d_k_h, HRR_INT__f_d_i_h, HRR_INT__f_d_i_i);


            }  // close HRR loop


        }   // close loop cdbatch

        istart = iend;
    }  // close loop over ab

    return P.nshell12_clip * Q.nshell12_clip;
}

int ostei_d_f_i_i(struct simint_multi_shellpair const P,
                  struct simint_multi_shellpair const Q,
                  double screen_tol,
                  double * const restrict work,
                  double * const restrict INT__d_f_i_i)
{
    double P_AB[3*P.nshell12];
    struct simint_multi_shellpair P_tmp = P;
    P_tmp.PA_x = P.PB_x;  P_tmp.PA_y = P.PB_y;  P_tmp.PA_z = P.PB_z;
    P_tmp.PB_x = P.PA_x;  P_tmp.PB_y = P.PA_y;  P_tmp.PB_z = P.PA_z;
    P_tmp.AB_x = P_AB;
    P_tmp.AB_y = P_AB + P.nshell12;
    P_tmp.AB_z = P_AB + 2*P.nshell12;

    for(int i = 0; i < P.nshell12; i++)
    {
        P_tmp.AB_x[i] = -P.AB_x[i];
        P_tmp.AB_y[i] = -P.AB_y[i];
        P_tmp.AB_z[i] = -P.AB_z[i];
    }

    int ret = ostei_f_d_i_i(P_tmp, Q, screen_tol, work, INT__d_f_i_i);
    double buffer[47040] SIMINT_ALIGN_ARRAY_DBL;

    for(int q = 0; q < ret; q++)
    {
        int idx = 0;
        for(int a = 0; a < 6; ++a)
        for(int b = 0; b < 10; ++b)
        for(int c = 0; c < 28; ++c)
        for(int d = 0; d < 28; ++d)
            buffer[idx++] = INT__d_f_i_i[q*47040+b*4704+a*784+c*28+d];

        memcpy(INT__d_f_i_i+q*47040, buffer, 47040*sizeof(double));
    }

    return ret;
}

