#include "simint/boys/boys.h"
#include "simint/ostei/gen/ostei_generated.h"
#include "simint/vectorization/vectorization.h"
#include <math.h>
#include <string.h>


int ostei_k_k_d_d(struct simint_multi_shellpair const P,
                  struct simint_multi_shellpair const Q,
                  double screen_tol,
                  double * const restrict work,
                  double * const restrict INT__k_k_d_d)
{

    SIMINT_ASSUME_ALIGN_DBL(work);
    SIMINT_ASSUME_ALIGN_DBL(INT__k_k_d_d);
    int ab, cd, abcd;
    int istart, jstart;
    int iprimcd, nprim_icd, icd;
    const int check_screen = (screen_tol > 0.0);
    int i, j;
    int n;
    int not_screened;
    int real_abcd;
    int iket;
    int ibra;

    // partition workspace
    double * const INT__k_s_d_s = work + (SIMINT_NSHELL_SIMD * 0);
    double * const INT__k_s_f_s = work + (SIMINT_NSHELL_SIMD * 216);
    double * const INT__k_s_g_s = work + (SIMINT_NSHELL_SIMD * 576);
    double * const INT__l_s_d_s = work + (SIMINT_NSHELL_SIMD * 1116);
    double * const INT__l_s_f_s = work + (SIMINT_NSHELL_SIMD * 1386);
    double * const INT__l_s_g_s = work + (SIMINT_NSHELL_SIMD * 1836);
    double * const INT__m_s_d_s = work + (SIMINT_NSHELL_SIMD * 2511);
    double * const INT__m_s_f_s = work + (SIMINT_NSHELL_SIMD * 2841);
    double * const INT__m_s_g_s = work + (SIMINT_NSHELL_SIMD * 3391);
    double * const INT__n_s_d_s = work + (SIMINT_NSHELL_SIMD * 4216);
    double * const INT__n_s_f_s = work + (SIMINT_NSHELL_SIMD * 4612);
    double * const INT__n_s_g_s = work + (SIMINT_NSHELL_SIMD * 5272);
    double * const INT__o_s_d_s = work + (SIMINT_NSHELL_SIMD * 6262);
    double * const INT__o_s_f_s = work + (SIMINT_NSHELL_SIMD * 6730);
    double * const INT__o_s_g_s = work + (SIMINT_NSHELL_SIMD * 7510);
    double * const INT__q_s_d_s = work + (SIMINT_NSHELL_SIMD * 8680);
    double * const INT__q_s_f_s = work + (SIMINT_NSHELL_SIMD * 9226);
    double * const INT__q_s_g_s = work + (SIMINT_NSHELL_SIMD * 10136);
    double * const INT__r_s_d_s = work + (SIMINT_NSHELL_SIMD * 11501);
    double * const INT__r_s_f_s = work + (SIMINT_NSHELL_SIMD * 12131);
    double * const INT__r_s_g_s = work + (SIMINT_NSHELL_SIMD * 13181);
    double * const INT__t_s_d_s = work + (SIMINT_NSHELL_SIMD * 14756);
    double * const INT__t_s_f_s = work + (SIMINT_NSHELL_SIMD * 15476);
    double * const INT__t_s_g_s = work + (SIMINT_NSHELL_SIMD * 16676);
    SIMINT_DBLTYPE * const primwork = (SIMINT_DBLTYPE *)(work + SIMINT_NSHELL_SIMD*18476);
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_s_s = primwork + 0;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_s_s = primwork + 19;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_s_s = primwork + 73;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_s_s = primwork + 175;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_s_s = primwork + 335;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_p_s = primwork + 560;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_s_s = primwork + 740;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_p_s = primwork + 1034;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_d_s = primwork + 1286;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_s_s = primwork + 1664;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_p_s = primwork + 2028;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_d_s = primwork + 2364;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_f_s = primwork + 2868;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_s_s = primwork + 3428;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_p_s = primwork + 3860;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_d_s = primwork + 4292;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_f_s = primwork + 4940;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_g_s = primwork + 5660;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_s_s = primwork + 6200;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_p_s = primwork + 6695;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_d_s = primwork + 7235;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_f_s = primwork + 8045;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_g_s = primwork + 8945;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_s_s = primwork + 9620;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_p_s = primwork + 10170;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_d_s = primwork + 10830;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_f_s = primwork + 11820;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_g_s = primwork + 12920;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_s_s = primwork + 13745;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_p_s = primwork + 14339;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_d_s = primwork + 15131;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_f_s = primwork + 16319;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_g_s = primwork + 17639;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_s_s = primwork + 18629;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_p_s = primwork + 19253;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_d_s = primwork + 20189;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_f_s = primwork + 21593;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_g_s = primwork + 23153;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_s_s = primwork + 24323;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_p_s = primwork + 24960;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_d_s = primwork + 26052;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_f_s = primwork + 27690;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_g_s = primwork + 29510;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_s_s = primwork + 30875;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_p_s = primwork + 31505;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_d_s = primwork + 32765;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_f_s = primwork + 34655;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_g_s = primwork + 36755;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_s_s = primwork + 38330;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_p_s = primwork + 38930;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_d_s = primwork + 40370;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_f_s = primwork + 42530;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_g_s = primwork + 44930;
    double * const hrrwork = (double *)(primwork + 46730);
    double * const HRR_INT__k_p_d_s = hrrwork + 0;
    double * const HRR_INT__k_p_f_s = hrrwork + 648;
    double * const HRR_INT__k_p_g_s = hrrwork + 1728;
    double * const HRR_INT__k_d_d_s = hrrwork + 3348;
    double * const HRR_INT__k_d_f_s = hrrwork + 4644;
    double * const HRR_INT__k_d_g_s = hrrwork + 6804;
    double * const HRR_INT__k_f_d_s = hrrwork + 10044;
    double * const HRR_INT__k_f_f_s = hrrwork + 12204;
    double * const HRR_INT__k_f_g_s = hrrwork + 15804;
    double * const HRR_INT__k_g_d_s = hrrwork + 21204;
    double * const HRR_INT__k_g_f_s = hrrwork + 24444;
    double * const HRR_INT__k_g_g_s = hrrwork + 29844;
    double * const HRR_INT__k_h_d_s = hrrwork + 37944;
    double * const HRR_INT__k_h_f_s = hrrwork + 42480;
    double * const HRR_INT__k_h_g_s = hrrwork + 50040;
    double * const HRR_INT__k_i_d_s = hrrwork + 61380;
    double * const HRR_INT__k_i_f_s = hrrwork + 67428;
    double * const HRR_INT__k_i_g_s = hrrwork + 77508;
    double * const HRR_INT__k_k_d_s = hrrwork + 92628;
    double * const HRR_INT__k_k_d_p = hrrwork + 100404;
    double * const HRR_INT__k_k_f_s = hrrwork + 123732;
    double * const HRR_INT__k_k_f_p = hrrwork + 136692;
    double * const HRR_INT__k_k_g_s = hrrwork + 175572;
    double * const HRR_INT__l_p_d_s = hrrwork + 195012;
    double * const HRR_INT__l_p_f_s = hrrwork + 195822;
    double * const HRR_INT__l_p_g_s = hrrwork + 197172;
    double * const HRR_INT__l_d_d_s = hrrwork + 199197;
    double * const HRR_INT__l_d_f_s = hrrwork + 200817;
    double * const HRR_INT__l_d_g_s = hrrwork + 203517;
    double * const HRR_INT__l_f_d_s = hrrwork + 207567;
    double * const HRR_INT__l_f_f_s = hrrwork + 210267;
    double * const HRR_INT__l_f_g_s = hrrwork + 214767;
    double * const HRR_INT__l_g_d_s = hrrwork + 221517;
    double * const HRR_INT__l_g_f_s = hrrwork + 225567;
    double * const HRR_INT__l_g_g_s = hrrwork + 232317;
    double * const HRR_INT__l_h_d_s = hrrwork + 242442;
    double * const HRR_INT__l_h_f_s = hrrwork + 248112;
    double * const HRR_INT__l_h_g_s = hrrwork + 257562;
    double * const HRR_INT__l_i_d_s = hrrwork + 271737;
    double * const HRR_INT__l_i_f_s = hrrwork + 279297;
    double * const HRR_INT__l_i_g_s = hrrwork + 291897;
    double * const HRR_INT__m_p_d_s = hrrwork + 310797;
    double * const HRR_INT__m_p_f_s = hrrwork + 311787;
    double * const HRR_INT__m_p_g_s = hrrwork + 313437;
    double * const HRR_INT__m_d_d_s = hrrwork + 315912;
    double * const HRR_INT__m_d_f_s = hrrwork + 317892;
    double * const HRR_INT__m_d_g_s = hrrwork + 321192;
    double * const HRR_INT__m_f_d_s = hrrwork + 326142;
    double * const HRR_INT__m_f_f_s = hrrwork + 329442;
    double * const HRR_INT__m_f_g_s = hrrwork + 334942;
    double * const HRR_INT__m_g_d_s = hrrwork + 343192;
    double * const HRR_INT__m_g_f_s = hrrwork + 348142;
    double * const HRR_INT__m_g_g_s = hrrwork + 356392;
    double * const HRR_INT__m_h_d_s = hrrwork + 368767;
    double * const HRR_INT__m_h_f_s = hrrwork + 375697;
    double * const HRR_INT__m_h_g_s = hrrwork + 387247;
    double * const HRR_INT__n_p_d_s = hrrwork + 404572;
    double * const HRR_INT__n_p_f_s = hrrwork + 405760;
    double * const HRR_INT__n_p_g_s = hrrwork + 407740;
    double * const HRR_INT__n_d_d_s = hrrwork + 410710;
    double * const HRR_INT__n_d_f_s = hrrwork + 413086;
    double * const HRR_INT__n_d_g_s = hrrwork + 417046;
    double * const HRR_INT__n_f_d_s = hrrwork + 422986;
    double * const HRR_INT__n_f_f_s = hrrwork + 426946;
    double * const HRR_INT__n_f_g_s = hrrwork + 433546;
    double * const HRR_INT__n_g_d_s = hrrwork + 443446;
    double * const HRR_INT__n_g_f_s = hrrwork + 449386;
    double * const HRR_INT__n_g_g_s = hrrwork + 459286;
    double * const HRR_INT__o_p_d_s = hrrwork + 474136;
    double * const HRR_INT__o_p_f_s = hrrwork + 475540;
    double * const HRR_INT__o_p_g_s = hrrwork + 477880;
    double * const HRR_INT__o_d_d_s = hrrwork + 481390;
    double * const HRR_INT__o_d_f_s = hrrwork + 484198;
    double * const HRR_INT__o_d_g_s = hrrwork + 488878;
    double * const HRR_INT__o_f_d_s = hrrwork + 495898;
    double * const HRR_INT__o_f_f_s = hrrwork + 500578;
    double * const HRR_INT__o_f_g_s = hrrwork + 508378;
    double * const HRR_INT__q_p_d_s = hrrwork + 520078;
    double * const HRR_INT__q_p_f_s = hrrwork + 521716;
    double * const HRR_INT__q_p_g_s = hrrwork + 524446;
    double * const HRR_INT__q_d_d_s = hrrwork + 528541;
    double * const HRR_INT__q_d_f_s = hrrwork + 531817;
    double * const HRR_INT__q_d_g_s = hrrwork + 537277;
    double * const HRR_INT__r_p_d_s = hrrwork + 545467;
    double * const HRR_INT__r_p_f_s = hrrwork + 547357;
    double * const HRR_INT__r_p_g_s = hrrwork + 550507;


    // Create constants
    const SIMINT_DBLTYPE const_1 = SIMINT_DBLSET1(1);
    const SIMINT_DBLTYPE const_10 = SIMINT_DBLSET1(10);
    const SIMINT_DBLTYPE const_11 = SIMINT_DBLSET1(11);
    const SIMINT_DBLTYPE const_12 = SIMINT_DBLSET1(12);
    const SIMINT_DBLTYPE const_13 = SIMINT_DBLSET1(13);
    const SIMINT_DBLTYPE const_14 = SIMINT_DBLSET1(14);
    const SIMINT_DBLTYPE const_2 = SIMINT_DBLSET1(2);
    const SIMINT_DBLTYPE const_3 = SIMINT_DBLSET1(3);
    const SIMINT_DBLTYPE const_4 = SIMINT_DBLSET1(4);
    const SIMINT_DBLTYPE const_5 = SIMINT_DBLSET1(5);
    const SIMINT_DBLTYPE const_6 = SIMINT_DBLSET1(6);
    const SIMINT_DBLTYPE const_7 = SIMINT_DBLSET1(7);
    const SIMINT_DBLTYPE const_8 = SIMINT_DBLSET1(8);
    const SIMINT_DBLTYPE const_9 = SIMINT_DBLSET1(9);
    const SIMINT_DBLTYPE one_half = SIMINT_DBLSET1(0.5);


    ////////////////////////////////////////
    // Loop over shells and primitives
    ////////////////////////////////////////

    real_abcd = 0;
    istart = 0;
    for(ab = 0; ab < P.nshell12_clip; ++ab)
    {
        const int iend = istart + P.nprim12[ab];

        cd = 0;
        jstart = 0;

        for(cd = 0; cd < Q.nshell12_clip; cd += SIMINT_NSHELL_SIMD)
        {
            const int nshellbatch = ((cd + SIMINT_NSHELL_SIMD) > Q.nshell12_clip) ? Q.nshell12_clip - cd : SIMINT_NSHELL_SIMD;
            int jend = jstart;
            for(i = 0; i < nshellbatch; i++)
                jend += Q.nprim12[cd+i];

            // Clear the beginning of the workspace (where we are accumulating integrals)
            memset(work, 0, SIMINT_NSHELL_SIMD * 18476 * sizeof(double));
            abcd = 0;


            for(i = istart; i < iend; ++i)
            {
                SIMINT_DBLTYPE bra_screen_max;  // only used if check_screen

                if(check_screen)
                {
                    // Skip this whole thing if always insignificant
                    if((P.screen[i] * Q.screen_max) < screen_tol)
                        continue;
                    bra_screen_max = SIMINT_DBLSET1(P.screen[i]);
                }

                icd = 0;
                iprimcd = 0;
                nprim_icd = Q.nprim12[cd];
                double * restrict PRIM_PTR_INT__k_s_d_s = INT__k_s_d_s + abcd * 216;
                double * restrict PRIM_PTR_INT__k_s_f_s = INT__k_s_f_s + abcd * 360;
                double * restrict PRIM_PTR_INT__k_s_g_s = INT__k_s_g_s + abcd * 540;
                double * restrict PRIM_PTR_INT__l_s_d_s = INT__l_s_d_s + abcd * 270;
                double * restrict PRIM_PTR_INT__l_s_f_s = INT__l_s_f_s + abcd * 450;
                double * restrict PRIM_PTR_INT__l_s_g_s = INT__l_s_g_s + abcd * 675;
                double * restrict PRIM_PTR_INT__m_s_d_s = INT__m_s_d_s + abcd * 330;
                double * restrict PRIM_PTR_INT__m_s_f_s = INT__m_s_f_s + abcd * 550;
                double * restrict PRIM_PTR_INT__m_s_g_s = INT__m_s_g_s + abcd * 825;
                double * restrict PRIM_PTR_INT__n_s_d_s = INT__n_s_d_s + abcd * 396;
                double * restrict PRIM_PTR_INT__n_s_f_s = INT__n_s_f_s + abcd * 660;
                double * restrict PRIM_PTR_INT__n_s_g_s = INT__n_s_g_s + abcd * 990;
                double * restrict PRIM_PTR_INT__o_s_d_s = INT__o_s_d_s + abcd * 468;
                double * restrict PRIM_PTR_INT__o_s_f_s = INT__o_s_f_s + abcd * 780;
                double * restrict PRIM_PTR_INT__o_s_g_s = INT__o_s_g_s + abcd * 1170;
                double * restrict PRIM_PTR_INT__q_s_d_s = INT__q_s_d_s + abcd * 546;
                double * restrict PRIM_PTR_INT__q_s_f_s = INT__q_s_f_s + abcd * 910;
                double * restrict PRIM_PTR_INT__q_s_g_s = INT__q_s_g_s + abcd * 1365;
                double * restrict PRIM_PTR_INT__r_s_d_s = INT__r_s_d_s + abcd * 630;
                double * restrict PRIM_PTR_INT__r_s_f_s = INT__r_s_f_s + abcd * 1050;
                double * restrict PRIM_PTR_INT__r_s_g_s = INT__r_s_g_s + abcd * 1575;
                double * restrict PRIM_PTR_INT__t_s_d_s = INT__t_s_d_s + abcd * 720;
                double * restrict PRIM_PTR_INT__t_s_f_s = INT__t_s_f_s + abcd * 1200;
                double * restrict PRIM_PTR_INT__t_s_g_s = INT__t_s_g_s + abcd * 1800;



                // Load these one per loop over i
                const SIMINT_DBLTYPE P_alpha = SIMINT_DBLSET1(P.alpha[i]);
                const SIMINT_DBLTYPE P_prefac = SIMINT_DBLSET1(P.prefac[i]);
                const SIMINT_DBLTYPE Pxyz[3] = { SIMINT_DBLSET1(P.x[i]), SIMINT_DBLSET1(P.y[i]), SIMINT_DBLSET1(P.z[i]) };

                const SIMINT_DBLTYPE P_PA[3] = { SIMINT_DBLSET1(P.PA_x[i]), SIMINT_DBLSET1(P.PA_y[i]), SIMINT_DBLSET1(P.PA_z[i]) };

                for(j = jstart; j < jend; j += SIMINT_SIMD_LEN)
                {
                    // calculate the shell offsets
                    // these are the offset from the shell pointed to by cd
                    // for each element
                    int shelloffsets[SIMINT_SIMD_LEN] = {0};
                    int lastoffset = 0;
                    const int nlane = ( ((j + SIMINT_SIMD_LEN) < jend) ? SIMINT_SIMD_LEN : (jend - j));

                    if((iprimcd + SIMINT_SIMD_LEN) >= nprim_icd)
                    {
                        // Handle if the first element of the vector is a new shell
                        if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                        {
                            nprim_icd += Q.nprim12[cd + (++icd)];
                            PRIM_PTR_INT__k_s_d_s += 216;
                            PRIM_PTR_INT__k_s_f_s += 360;
                            PRIM_PTR_INT__k_s_g_s += 540;
                            PRIM_PTR_INT__l_s_d_s += 270;
                            PRIM_PTR_INT__l_s_f_s += 450;
                            PRIM_PTR_INT__l_s_g_s += 675;
                            PRIM_PTR_INT__m_s_d_s += 330;
                            PRIM_PTR_INT__m_s_f_s += 550;
                            PRIM_PTR_INT__m_s_g_s += 825;
                            PRIM_PTR_INT__n_s_d_s += 396;
                            PRIM_PTR_INT__n_s_f_s += 660;
                            PRIM_PTR_INT__n_s_g_s += 990;
                            PRIM_PTR_INT__o_s_d_s += 468;
                            PRIM_PTR_INT__o_s_f_s += 780;
                            PRIM_PTR_INT__o_s_g_s += 1170;
                            PRIM_PTR_INT__q_s_d_s += 546;
                            PRIM_PTR_INT__q_s_f_s += 910;
                            PRIM_PTR_INT__q_s_g_s += 1365;
                            PRIM_PTR_INT__r_s_d_s += 630;
                            PRIM_PTR_INT__r_s_f_s += 1050;
                            PRIM_PTR_INT__r_s_g_s += 1575;
                            PRIM_PTR_INT__t_s_d_s += 720;
                            PRIM_PTR_INT__t_s_f_s += 1200;
                            PRIM_PTR_INT__t_s_g_s += 1800;
                        }
                        iprimcd++;
                        for(n = 1; n < SIMINT_SIMD_LEN; ++n)
                        {
                            if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                            {
                                shelloffsets[n] = shelloffsets[n-1] + 1;
                                lastoffset++;
                                nprim_icd += Q.nprim12[cd + (++icd)];
                            }
                            else
                                shelloffsets[n] = shelloffsets[n-1];
                            iprimcd++;
                        }
                    }
                    else
                        iprimcd += SIMINT_SIMD_LEN;

                    // Do we have to compute this vector (or has it been screened out)?
                    // (not_screened != 0 means we have to do this vector)
                    if(check_screen)
                    {
                        const double vmax = vector_max(SIMINT_MUL(bra_screen_max, SIMINT_DBLLOAD(Q.screen, j)));
                        if(vmax < screen_tol)
                        {
                            PRIM_PTR_INT__k_s_d_s += lastoffset*216;
                            PRIM_PTR_INT__k_s_f_s += lastoffset*360;
                            PRIM_PTR_INT__k_s_g_s += lastoffset*540;
                            PRIM_PTR_INT__l_s_d_s += lastoffset*270;
                            PRIM_PTR_INT__l_s_f_s += lastoffset*450;
                            PRIM_PTR_INT__l_s_g_s += lastoffset*675;
                            PRIM_PTR_INT__m_s_d_s += lastoffset*330;
                            PRIM_PTR_INT__m_s_f_s += lastoffset*550;
                            PRIM_PTR_INT__m_s_g_s += lastoffset*825;
                            PRIM_PTR_INT__n_s_d_s += lastoffset*396;
                            PRIM_PTR_INT__n_s_f_s += lastoffset*660;
                            PRIM_PTR_INT__n_s_g_s += lastoffset*990;
                            PRIM_PTR_INT__o_s_d_s += lastoffset*468;
                            PRIM_PTR_INT__o_s_f_s += lastoffset*780;
                            PRIM_PTR_INT__o_s_g_s += lastoffset*1170;
                            PRIM_PTR_INT__q_s_d_s += lastoffset*546;
                            PRIM_PTR_INT__q_s_f_s += lastoffset*910;
                            PRIM_PTR_INT__q_s_g_s += lastoffset*1365;
                            PRIM_PTR_INT__r_s_d_s += lastoffset*630;
                            PRIM_PTR_INT__r_s_f_s += lastoffset*1050;
                            PRIM_PTR_INT__r_s_g_s += lastoffset*1575;
                            PRIM_PTR_INT__t_s_d_s += lastoffset*720;
                            PRIM_PTR_INT__t_s_f_s += lastoffset*1200;
                            PRIM_PTR_INT__t_s_g_s += lastoffset*1800;
                            continue;
                        }
                    }

                    const SIMINT_DBLTYPE Q_alpha = SIMINT_DBLLOAD(Q.alpha, j);
                    const SIMINT_DBLTYPE PQalpha_mul = SIMINT_MUL(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE PQalpha_sum = SIMINT_ADD(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE one_over_PQalpha_sum = SIMINT_DIV(const_1, PQalpha_sum);


                    /* construct R2 = (Px - Qx)**2 + (Py - Qy)**2 + (Pz -Qz)**2 */
                    SIMINT_DBLTYPE PQ[3];
                    PQ[0] = SIMINT_SUB(Pxyz[0], SIMINT_DBLLOAD(Q.x, j));
                    PQ[1] = SIMINT_SUB(Pxyz[1], SIMINT_DBLLOAD(Q.y, j));
                    PQ[2] = SIMINT_SUB(Pxyz[2], SIMINT_DBLLOAD(Q.z, j));
                    SIMINT_DBLTYPE R2 = SIMINT_MUL(PQ[0], PQ[0]);
                    R2 = SIMINT_FMADD(PQ[1], PQ[1], R2);
                    R2 = SIMINT_FMADD(PQ[2], PQ[2], R2);

                    const SIMINT_DBLTYPE alpha = SIMINT_MUL(PQalpha_mul, one_over_PQalpha_sum); // alpha from MEST
                    const SIMINT_DBLTYPE one_over_p = SIMINT_DIV(const_1, P_alpha);
                    const SIMINT_DBLTYPE one_over_q = SIMINT_DIV(const_1, Q_alpha);
                    const SIMINT_DBLTYPE one_over_2p = SIMINT_MUL(one_half, one_over_p);
                    const SIMINT_DBLTYPE one_over_2q = SIMINT_MUL(one_half, one_over_q);
                    const SIMINT_DBLTYPE one_over_2pq = SIMINT_MUL(one_half, one_over_PQalpha_sum);
                    const SIMINT_DBLTYPE Q_PA[3] = { SIMINT_DBLLOAD(Q.PA_x, j), SIMINT_DBLLOAD(Q.PA_y, j), SIMINT_DBLLOAD(Q.PA_z, j) };

                    // NOTE: Minus sign!
                    const SIMINT_DBLTYPE a_over_p = SIMINT_MUL(SIMINT_NEG(alpha), one_over_p);
                    SIMINT_DBLTYPE aop_PQ[3];
                    aop_PQ[0] = SIMINT_MUL(a_over_p, PQ[0]);
                    aop_PQ[1] = SIMINT_MUL(a_over_p, PQ[1]);
                    aop_PQ[2] = SIMINT_MUL(a_over_p, PQ[2]);

                    SIMINT_DBLTYPE a_over_q = SIMINT_MUL(alpha, one_over_q);
                    SIMINT_DBLTYPE aoq_PQ[3];
                    aoq_PQ[0] = SIMINT_MUL(a_over_q, PQ[0]);
                    aoq_PQ[1] = SIMINT_MUL(a_over_q, PQ[1]);
                    aoq_PQ[2] = SIMINT_MUL(a_over_q, PQ[2]);
                    // Put a minus sign here so we don't have to in RR routines
                    a_over_q = SIMINT_NEG(a_over_q);


                    //////////////////////////////////////////////
                    // Fjt function section
                    // Maximum v value: 18
                    //////////////////////////////////////////////
                    // The parameter to the Fjt function
                    const SIMINT_DBLTYPE F_x = SIMINT_MUL(R2, alpha);


                    const SIMINT_DBLTYPE Q_prefac = mask_load(nlane, Q.prefac + j);


                    boys_F_split(PRIM_INT__s_s_s_s, F_x, 18);
                    SIMINT_DBLTYPE prefac = SIMINT_SQRT(one_over_PQalpha_sum);
                    prefac = SIMINT_MUL(SIMINT_MUL(P_prefac, Q_prefac), prefac);
                    for(n = 0; n <= 18; n++)
                        PRIM_INT__s_s_s_s[n] = SIMINT_MUL(PRIM_INT__s_s_s_s[n], prefac);

                    //////////////////////////////////////////////
                    // Primitive integrals: Vertical recurrance
                    //////////////////////////////////////////////

                    const SIMINT_DBLTYPE vrr_const_1_over_2p = one_over_2p;
                    const SIMINT_DBLTYPE vrr_const_2_over_2p = SIMINT_MUL(const_2, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_3_over_2p = SIMINT_MUL(const_3, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_4_over_2p = SIMINT_MUL(const_4, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_5_over_2p = SIMINT_MUL(const_5, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_6_over_2p = SIMINT_MUL(const_6, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_7_over_2p = SIMINT_MUL(const_7, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_8_over_2p = SIMINT_MUL(const_8, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_9_over_2p = SIMINT_MUL(const_9, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_10_over_2p = SIMINT_MUL(const_10, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_11_over_2p = SIMINT_MUL(const_11, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_12_over_2p = SIMINT_MUL(const_12, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_13_over_2p = SIMINT_MUL(const_13, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_1_over_2q = one_over_2q;
                    const SIMINT_DBLTYPE vrr_const_2_over_2q = SIMINT_MUL(const_2, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_3_over_2q = SIMINT_MUL(const_3, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_1_over_2pq = one_over_2pq;
                    const SIMINT_DBLTYPE vrr_const_2_over_2pq = SIMINT_MUL(const_2, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_3_over_2pq = SIMINT_MUL(const_3, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_4_over_2pq = SIMINT_MUL(const_4, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_5_over_2pq = SIMINT_MUL(const_5, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_6_over_2pq = SIMINT_MUL(const_6, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_7_over_2pq = SIMINT_MUL(const_7, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_8_over_2pq = SIMINT_MUL(const_8, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_9_over_2pq = SIMINT_MUL(const_9, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_10_over_2pq = SIMINT_MUL(const_10, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_11_over_2pq = SIMINT_MUL(const_11, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_12_over_2pq = SIMINT_MUL(const_12, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_13_over_2pq = SIMINT_MUL(const_13, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_14_over_2pq = SIMINT_MUL(const_14, one_over_2pq);



                    // Forming PRIM_INT__p_s_s_s[18 * 3];
                    for(n = 0; n < 18; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__p_s_s_s[n * 3 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__p_s_s_s[n * 3 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__p_s_s_s[n * 3 + 0]);

                        PRIM_INT__p_s_s_s[n * 3 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__p_s_s_s[n * 3 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__p_s_s_s[n * 3 + 1]);

                        PRIM_INT__p_s_s_s[n * 3 + 2] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__p_s_s_s[n * 3 + 2] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__p_s_s_s[n * 3 + 2]);

                    }



                    // Forming PRIM_INT__d_s_s_s[17 * 6];
                    for(n = 0; n < 17; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__d_s_s_s[n * 6 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__p_s_s_s[n * 3 + 0]);
                        PRIM_INT__d_s_s_s[n * 6 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__p_s_s_s[(n+1) * 3 + 0], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__d_s_s_s[n * 6 + 0] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__d_s_s_s[n * 6 + 0]);

                        PRIM_INT__d_s_s_s[n * 6 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__p_s_s_s[n * 3 + 0]);
                        PRIM_INT__d_s_s_s[n * 6 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__p_s_s_s[(n+1) * 3 + 0], PRIM_INT__d_s_s_s[n * 6 + 1]);

                        PRIM_INT__d_s_s_s[n * 6 + 3] = SIMINT_MUL(P_PA[1], PRIM_INT__p_s_s_s[n * 3 + 1]);
                        PRIM_INT__d_s_s_s[n * 6 + 3] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__p_s_s_s[(n+1) * 3 + 1], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__d_s_s_s[n * 6 + 3] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__d_s_s_s[n * 6 + 3]);

                        PRIM_INT__d_s_s_s[n * 6 + 5] = SIMINT_MUL(P_PA[2], PRIM_INT__p_s_s_s[n * 3 + 2]);
                        PRIM_INT__d_s_s_s[n * 6 + 5] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__p_s_s_s[(n+1) * 3 + 2], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__d_s_s_s[n * 6 + 5] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__d_s_s_s[n * 6 + 5]);

                    }



                    // Forming PRIM_INT__f_s_s_s[16 * 10];
                    for(n = 0; n < 16; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__f_s_s_s[n * 10 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 0] = SIMINT_FMADD( vrr_const_2_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__p_s_s_s[(n+1) * 3 + 0], PRIM_INT__p_s_s_s[n * 3 + 0]), PRIM_INT__f_s_s_s[n * 10 + 0]);

                        PRIM_INT__f_s_s_s[n * 10 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_s_s[n * 10 + 1]);

                        PRIM_INT__f_s_s_s[n * 10 + 2] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 2] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_s_s[n * 10 + 2]);

                        PRIM_INT__f_s_s_s[n * 10 + 3] = SIMINT_MUL(P_PA[0], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__f_s_s_s[n * 10 + 3] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_s_s[n * 10 + 3]);

                        PRIM_INT__f_s_s_s[n * 10 + 4] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 1]);
                        PRIM_INT__f_s_s_s[n * 10 + 4] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 1], PRIM_INT__f_s_s_s[n * 10 + 4]);

                        PRIM_INT__f_s_s_s[n * 10 + 5] = SIMINT_MUL(P_PA[0], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__f_s_s_s[n * 10 + 5] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__f_s_s_s[n * 10 + 5]);

                        PRIM_INT__f_s_s_s[n * 10 + 6] = SIMINT_MUL(P_PA[1], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__f_s_s_s[n * 10 + 6] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__f_s_s_s[n * 10 + 6] = SIMINT_FMADD( vrr_const_2_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__p_s_s_s[(n+1) * 3 + 1], PRIM_INT__p_s_s_s[n * 3 + 1]), PRIM_INT__f_s_s_s[n * 10 + 6]);

                        PRIM_INT__f_s_s_s[n * 10 + 7] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__f_s_s_s[n * 10 + 7] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_s_s[n * 10 + 7]);

                        PRIM_INT__f_s_s_s[n * 10 + 8] = SIMINT_MUL(P_PA[1], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__f_s_s_s[n * 10 + 8] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__f_s_s_s[n * 10 + 8]);

                        PRIM_INT__f_s_s_s[n * 10 + 9] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__f_s_s_s[n * 10 + 9] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__f_s_s_s[n * 10 + 9] = SIMINT_FMADD( vrr_const_2_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__p_s_s_s[(n+1) * 3 + 2], PRIM_INT__p_s_s_s[n * 3 + 2]), PRIM_INT__f_s_s_s[n * 10 + 9]);

                    }



                    // Forming PRIM_INT__g_s_s_s[15 * 15];
                    for(n = 0; n < 15; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__g_s_s_s[n * 15 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__g_s_s_s[n * 15 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 0], PRIM_INT__g_s_s_s[n * 15 + 0]);
                        PRIM_INT__g_s_s_s[n * 15 + 0] = SIMINT_FMADD( vrr_const_3_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__d_s_s_s[n * 6 + 0]), PRIM_INT__g_s_s_s[n * 15 + 0]);

                        PRIM_INT__g_s_s_s[n * 15 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__g_s_s_s[n * 15 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 0], PRIM_INT__g_s_s_s[n * 15 + 1]);

                        PRIM_INT__g_s_s_s[n * 15 + 2] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__g_s_s_s[n * 15 + 2] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 0], PRIM_INT__g_s_s_s[n * 15 + 2]);

                        PRIM_INT__g_s_s_s[n * 15 + 3] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 1]);
                        PRIM_INT__g_s_s_s[n * 15 + 3] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 1], PRIM_INT__g_s_s_s[n * 15 + 3]);
                        PRIM_INT__g_s_s_s[n * 15 + 3] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__d_s_s_s[n * 6 + 0]), PRIM_INT__g_s_s_s[n * 15 + 3]);

                        PRIM_INT__g_s_s_s[n * 15 + 4] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 1]);
                        PRIM_INT__g_s_s_s[n * 15 + 4] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 1], PRIM_INT__g_s_s_s[n * 15 + 4]);

                        PRIM_INT__g_s_s_s[n * 15 + 5] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 2]);
                        PRIM_INT__g_s_s_s[n * 15 + 5] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 2], PRIM_INT__g_s_s_s[n * 15 + 5]);
                        PRIM_INT__g_s_s_s[n * 15 + 5] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__d_s_s_s[n * 6 + 0]), PRIM_INT__g_s_s_s[n * 15 + 5]);

                        PRIM_INT__g_s_s_s[n * 15 + 6] = SIMINT_MUL(P_PA[0], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__g_s_s_s[n * 15 + 6] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 6], PRIM_INT__g_s_s_s[n * 15 + 6]);

                        PRIM_INT__g_s_s_s[n * 15 + 7] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 3]);
                        PRIM_INT__g_s_s_s[n * 15 + 7] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 3], PRIM_INT__g_s_s_s[n * 15 + 7]);

                        PRIM_INT__g_s_s_s[n * 15 + 8] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 5]);
                        PRIM_INT__g_s_s_s[n * 15 + 8] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 5], PRIM_INT__g_s_s_s[n * 15 + 8]);

                        PRIM_INT__g_s_s_s[n * 15 + 9] = SIMINT_MUL(P_PA[0], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__g_s_s_s[n * 15 + 9] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 9], PRIM_INT__g_s_s_s[n * 15 + 9]);

                        PRIM_INT__g_s_s_s[n * 15 + 10] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__g_s_s_s[n * 15 + 10] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 6], PRIM_INT__g_s_s_s[n * 15 + 10]);
                        PRIM_INT__g_s_s_s[n * 15 + 10] = SIMINT_FMADD( vrr_const_3_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__d_s_s_s[n * 6 + 3]), PRIM_INT__g_s_s_s[n * 15 + 10]);

                        PRIM_INT__g_s_s_s[n * 15 + 11] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__g_s_s_s[n * 15 + 11] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 6], PRIM_INT__g_s_s_s[n * 15 + 11]);

                        PRIM_INT__g_s_s_s[n * 15 + 12] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 7]);
                        PRIM_INT__g_s_s_s[n * 15 + 12] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 7], PRIM_INT__g_s_s_s[n * 15 + 12]);
                        PRIM_INT__g_s_s_s[n * 15 + 12] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__d_s_s_s[n * 6 + 3]), PRIM_INT__g_s_s_s[n * 15 + 12]);

                        PRIM_INT__g_s_s_s[n * 15 + 13] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__g_s_s_s[n * 15 + 13] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 9], PRIM_INT__g_s_s_s[n * 15 + 13]);

                        PRIM_INT__g_s_s_s[n * 15 + 14] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__g_s_s_s[n * 15 + 14] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 9], PRIM_INT__g_s_s_s[n * 15 + 14]);
                        PRIM_INT__g_s_s_s[n * 15 + 14] = SIMINT_FMADD( vrr_const_3_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__d_s_s_s[n * 6 + 5]), PRIM_INT__g_s_s_s[n * 15 + 14]);

                    }


                    VRR_I_h_s_s_s(
                            PRIM_INT__h_s_s_s,
                            PRIM_INT__g_s_s_s,
                            PRIM_INT__f_s_s_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            14);


                    VRR_I_i_s_s_s(
                            PRIM_INT__i_s_s_s,
                            PRIM_INT__h_s_s_s,
                            PRIM_INT__g_s_s_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            13);


                    VRR_I_k_s_s_s(
                            PRIM_INT__k_s_s_s,
                            PRIM_INT__i_s_s_s,
                            PRIM_INT__h_s_s_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            12);


                    ostei_general_vrr_K(7, 0, 1, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_s_s, NULL, NULL, PRIM_INT__i_s_s_s, NULL, PRIM_INT__k_s_p_s);


                    VRR_K_i_s_p_s(
                            PRIM_INT__i_s_p_s,
                            PRIM_INT__i_s_s_s,
                            PRIM_INT__h_s_s_s,
                            Q_PA,
                            aoq_PQ,
                            one_over_2pq,
                            4);


                    ostei_general_vrr_K(7, 0, 2, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_p_s, PRIM_INT__k_s_s_s, NULL, PRIM_INT__i_s_p_s, NULL, PRIM_INT__k_s_d_s);


                    VRR_K_h_s_p_s(
                            PRIM_INT__h_s_p_s,
                            PRIM_INT__h_s_s_s,
                            PRIM_INT__g_s_s_s,
                            Q_PA,
                            aoq_PQ,
                            one_over_2pq,
                            4);


                    ostei_general_vrr_K(6, 0, 2, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__i_s_p_s, PRIM_INT__i_s_s_s, NULL, PRIM_INT__h_s_p_s, NULL, PRIM_INT__i_s_d_s);


                    ostei_general_vrr_K(7, 0, 3, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_d_s, PRIM_INT__k_s_p_s, NULL, PRIM_INT__i_s_d_s, NULL, PRIM_INT__k_s_f_s);


                    ostei_general_vrr1_I(8, 11,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__k_s_s_s, PRIM_INT__i_s_s_s, PRIM_INT__l_s_s_s);


                    ostei_general_vrr_K(8, 0, 1, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_s_s, NULL, NULL, PRIM_INT__k_s_s_s, NULL, PRIM_INT__l_s_p_s);


                    ostei_general_vrr_K(8, 0, 2, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_p_s, PRIM_INT__l_s_s_s, NULL, PRIM_INT__k_s_p_s, NULL, PRIM_INT__l_s_d_s);


                    VRR_K_g_s_p_s(
                            PRIM_INT__g_s_p_s,
                            PRIM_INT__g_s_s_s,
                            PRIM_INT__f_s_s_s,
                            Q_PA,
                            aoq_PQ,
                            one_over_2pq,
                            4);


                    VRR_K_h_s_d_s(
                            PRIM_INT__h_s_d_s,
                            PRIM_INT__h_s_p_s,
                            PRIM_INT__h_s_s_s,
                            PRIM_INT__g_s_p_s,
                            Q_PA,
                            a_over_q,
                            aoq_PQ,
                            one_over_2pq,
                            one_over_2q,
                            3);


                    ostei_general_vrr_K(6, 0, 3, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__i_s_d_s, PRIM_INT__i_s_p_s, NULL, PRIM_INT__h_s_d_s, NULL, PRIM_INT__i_s_f_s);


                    ostei_general_vrr_K(7, 0, 4, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_f_s, PRIM_INT__k_s_d_s, NULL, PRIM_INT__i_s_f_s, NULL, PRIM_INT__k_s_g_s);


                    ostei_general_vrr_K(8, 0, 3, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_d_s, PRIM_INT__l_s_p_s, NULL, PRIM_INT__k_s_d_s, NULL, PRIM_INT__l_s_f_s);


                    ostei_general_vrr1_I(9, 10,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__l_s_s_s, PRIM_INT__k_s_s_s, PRIM_INT__m_s_s_s);


                    ostei_general_vrr_K(9, 0, 1, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_s_s, NULL, NULL, PRIM_INT__l_s_s_s, NULL, PRIM_INT__m_s_p_s);


                    ostei_general_vrr_K(9, 0, 2, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_p_s, PRIM_INT__m_s_s_s, NULL, PRIM_INT__l_s_p_s, NULL, PRIM_INT__m_s_d_s);


                    ostei_general_vrr_K(8, 0, 4, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_f_s, PRIM_INT__l_s_d_s, NULL, PRIM_INT__k_s_f_s, NULL, PRIM_INT__l_s_g_s);


                    ostei_general_vrr_K(9, 0, 3, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_d_s, PRIM_INT__m_s_p_s, NULL, PRIM_INT__l_s_d_s, NULL, PRIM_INT__m_s_f_s);


                    ostei_general_vrr1_I(10, 9,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__m_s_s_s, PRIM_INT__l_s_s_s, PRIM_INT__n_s_s_s);


                    ostei_general_vrr_K(10, 0, 1, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_s_s, NULL, NULL, PRIM_INT__m_s_s_s, NULL, PRIM_INT__n_s_p_s);


                    ostei_general_vrr_K(10, 0, 2, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_p_s, PRIM_INT__n_s_s_s, NULL, PRIM_INT__m_s_p_s, NULL, PRIM_INT__n_s_d_s);


                    ostei_general_vrr_K(9, 0, 4, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_f_s, PRIM_INT__m_s_d_s, NULL, PRIM_INT__l_s_f_s, NULL, PRIM_INT__m_s_g_s);


                    ostei_general_vrr_K(10, 0, 3, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_d_s, PRIM_INT__n_s_p_s, NULL, PRIM_INT__m_s_d_s, NULL, PRIM_INT__n_s_f_s);


                    ostei_general_vrr1_I(11, 8,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__n_s_s_s, PRIM_INT__m_s_s_s, PRIM_INT__o_s_s_s);


                    ostei_general_vrr_K(11, 0, 1, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_s_s, NULL, NULL, PRIM_INT__n_s_s_s, NULL, PRIM_INT__o_s_p_s);


                    ostei_general_vrr_K(11, 0, 2, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_p_s, PRIM_INT__o_s_s_s, NULL, PRIM_INT__n_s_p_s, NULL, PRIM_INT__o_s_d_s);


                    ostei_general_vrr_K(10, 0, 4, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_f_s, PRIM_INT__n_s_d_s, NULL, PRIM_INT__m_s_f_s, NULL, PRIM_INT__n_s_g_s);


                    ostei_general_vrr_K(11, 0, 3, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_d_s, PRIM_INT__o_s_p_s, NULL, PRIM_INT__n_s_d_s, NULL, PRIM_INT__o_s_f_s);


                    ostei_general_vrr1_I(12, 7,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__o_s_s_s, PRIM_INT__n_s_s_s, PRIM_INT__q_s_s_s);


                    ostei_general_vrr_K(12, 0, 1, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_s_s, NULL, NULL, PRIM_INT__o_s_s_s, NULL, PRIM_INT__q_s_p_s);


                    ostei_general_vrr_K(12, 0, 2, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_p_s, PRIM_INT__q_s_s_s, NULL, PRIM_INT__o_s_p_s, NULL, PRIM_INT__q_s_d_s);


                    ostei_general_vrr_K(11, 0, 4, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_f_s, PRIM_INT__o_s_d_s, NULL, PRIM_INT__n_s_f_s, NULL, PRIM_INT__o_s_g_s);


                    ostei_general_vrr_K(12, 0, 3, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_d_s, PRIM_INT__q_s_p_s, NULL, PRIM_INT__o_s_d_s, NULL, PRIM_INT__q_s_f_s);


                    ostei_general_vrr1_I(13, 6,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__q_s_s_s, PRIM_INT__o_s_s_s, PRIM_INT__r_s_s_s);


                    ostei_general_vrr_K(13, 0, 1, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__r_s_s_s, NULL, NULL, PRIM_INT__q_s_s_s, NULL, PRIM_INT__r_s_p_s);


                    ostei_general_vrr_K(13, 0, 2, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__r_s_p_s, PRIM_INT__r_s_s_s, NULL, PRIM_INT__q_s_p_s, NULL, PRIM_INT__r_s_d_s);


                    ostei_general_vrr_K(12, 0, 4, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_f_s, PRIM_INT__q_s_d_s, NULL, PRIM_INT__o_s_f_s, NULL, PRIM_INT__q_s_g_s);


                    ostei_general_vrr_K(13, 0, 3, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__r_s_d_s, PRIM_INT__r_s_p_s, NULL, PRIM_INT__q_s_d_s, NULL, PRIM_INT__r_s_f_s);


                    ostei_general_vrr1_I(14, 5,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__r_s_s_s, PRIM_INT__q_s_s_s, PRIM_INT__t_s_s_s);


                    ostei_general_vrr_K(14, 0, 1, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__t_s_s_s, NULL, NULL, PRIM_INT__r_s_s_s, NULL, PRIM_INT__t_s_p_s);


                    ostei_general_vrr_K(14, 0, 2, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__t_s_p_s, PRIM_INT__t_s_s_s, NULL, PRIM_INT__r_s_p_s, NULL, PRIM_INT__t_s_d_s);


                    ostei_general_vrr_K(13, 0, 4, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__r_s_f_s, PRIM_INT__r_s_d_s, NULL, PRIM_INT__q_s_f_s, NULL, PRIM_INT__r_s_g_s);


                    ostei_general_vrr_K(14, 0, 3, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__t_s_d_s, PRIM_INT__t_s_p_s, NULL, PRIM_INT__r_s_d_s, NULL, PRIM_INT__t_s_f_s);


                    ostei_general_vrr_K(14, 0, 4, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__t_s_f_s, PRIM_INT__t_s_d_s, NULL, PRIM_INT__r_s_f_s, NULL, PRIM_INT__t_s_g_s);




                    ////////////////////////////////////
                    // Accumulate contracted integrals
                    ////////////////////////////////////
                    if(lastoffset == 0)
                    {
                        contract_all(216, PRIM_INT__k_s_d_s, PRIM_PTR_INT__k_s_d_s);
                        contract_all(360, PRIM_INT__k_s_f_s, PRIM_PTR_INT__k_s_f_s);
                        contract_all(540, PRIM_INT__k_s_g_s, PRIM_PTR_INT__k_s_g_s);
                        contract_all(270, PRIM_INT__l_s_d_s, PRIM_PTR_INT__l_s_d_s);
                        contract_all(450, PRIM_INT__l_s_f_s, PRIM_PTR_INT__l_s_f_s);
                        contract_all(675, PRIM_INT__l_s_g_s, PRIM_PTR_INT__l_s_g_s);
                        contract_all(330, PRIM_INT__m_s_d_s, PRIM_PTR_INT__m_s_d_s);
                        contract_all(550, PRIM_INT__m_s_f_s, PRIM_PTR_INT__m_s_f_s);
                        contract_all(825, PRIM_INT__m_s_g_s, PRIM_PTR_INT__m_s_g_s);
                        contract_all(396, PRIM_INT__n_s_d_s, PRIM_PTR_INT__n_s_d_s);
                        contract_all(660, PRIM_INT__n_s_f_s, PRIM_PTR_INT__n_s_f_s);
                        contract_all(990, PRIM_INT__n_s_g_s, PRIM_PTR_INT__n_s_g_s);
                        contract_all(468, PRIM_INT__o_s_d_s, PRIM_PTR_INT__o_s_d_s);
                        contract_all(780, PRIM_INT__o_s_f_s, PRIM_PTR_INT__o_s_f_s);
                        contract_all(1170, PRIM_INT__o_s_g_s, PRIM_PTR_INT__o_s_g_s);
                        contract_all(546, PRIM_INT__q_s_d_s, PRIM_PTR_INT__q_s_d_s);
                        contract_all(910, PRIM_INT__q_s_f_s, PRIM_PTR_INT__q_s_f_s);
                        contract_all(1365, PRIM_INT__q_s_g_s, PRIM_PTR_INT__q_s_g_s);
                        contract_all(630, PRIM_INT__r_s_d_s, PRIM_PTR_INT__r_s_d_s);
                        contract_all(1050, PRIM_INT__r_s_f_s, PRIM_PTR_INT__r_s_f_s);
                        contract_all(1575, PRIM_INT__r_s_g_s, PRIM_PTR_INT__r_s_g_s);
                        contract_all(720, PRIM_INT__t_s_d_s, PRIM_PTR_INT__t_s_d_s);
                        contract_all(1200, PRIM_INT__t_s_f_s, PRIM_PTR_INT__t_s_f_s);
                        contract_all(1800, PRIM_INT__t_s_g_s, PRIM_PTR_INT__t_s_g_s);
                    }
                    else
                    {
                        contract(216, shelloffsets, PRIM_INT__k_s_d_s, PRIM_PTR_INT__k_s_d_s);
                        contract(360, shelloffsets, PRIM_INT__k_s_f_s, PRIM_PTR_INT__k_s_f_s);
                        contract(540, shelloffsets, PRIM_INT__k_s_g_s, PRIM_PTR_INT__k_s_g_s);
                        contract(270, shelloffsets, PRIM_INT__l_s_d_s, PRIM_PTR_INT__l_s_d_s);
                        contract(450, shelloffsets, PRIM_INT__l_s_f_s, PRIM_PTR_INT__l_s_f_s);
                        contract(675, shelloffsets, PRIM_INT__l_s_g_s, PRIM_PTR_INT__l_s_g_s);
                        contract(330, shelloffsets, PRIM_INT__m_s_d_s, PRIM_PTR_INT__m_s_d_s);
                        contract(550, shelloffsets, PRIM_INT__m_s_f_s, PRIM_PTR_INT__m_s_f_s);
                        contract(825, shelloffsets, PRIM_INT__m_s_g_s, PRIM_PTR_INT__m_s_g_s);
                        contract(396, shelloffsets, PRIM_INT__n_s_d_s, PRIM_PTR_INT__n_s_d_s);
                        contract(660, shelloffsets, PRIM_INT__n_s_f_s, PRIM_PTR_INT__n_s_f_s);
                        contract(990, shelloffsets, PRIM_INT__n_s_g_s, PRIM_PTR_INT__n_s_g_s);
                        contract(468, shelloffsets, PRIM_INT__o_s_d_s, PRIM_PTR_INT__o_s_d_s);
                        contract(780, shelloffsets, PRIM_INT__o_s_f_s, PRIM_PTR_INT__o_s_f_s);
                        contract(1170, shelloffsets, PRIM_INT__o_s_g_s, PRIM_PTR_INT__o_s_g_s);
                        contract(546, shelloffsets, PRIM_INT__q_s_d_s, PRIM_PTR_INT__q_s_d_s);
                        contract(910, shelloffsets, PRIM_INT__q_s_f_s, PRIM_PTR_INT__q_s_f_s);
                        contract(1365, shelloffsets, PRIM_INT__q_s_g_s, PRIM_PTR_INT__q_s_g_s);
                        contract(630, shelloffsets, PRIM_INT__r_s_d_s, PRIM_PTR_INT__r_s_d_s);
                        contract(1050, shelloffsets, PRIM_INT__r_s_f_s, PRIM_PTR_INT__r_s_f_s);
                        contract(1575, shelloffsets, PRIM_INT__r_s_g_s, PRIM_PTR_INT__r_s_g_s);
                        contract(720, shelloffsets, PRIM_INT__t_s_d_s, PRIM_PTR_INT__t_s_d_s);
                        contract(1200, shelloffsets, PRIM_INT__t_s_f_s, PRIM_PTR_INT__t_s_f_s);
                        contract(1800, shelloffsets, PRIM_INT__t_s_g_s, PRIM_PTR_INT__t_s_g_s);
                        PRIM_PTR_INT__k_s_d_s += lastoffset*216;
                        PRIM_PTR_INT__k_s_f_s += lastoffset*360;
                        PRIM_PTR_INT__k_s_g_s += lastoffset*540;
                        PRIM_PTR_INT__l_s_d_s += lastoffset*270;
                        PRIM_PTR_INT__l_s_f_s += lastoffset*450;
                        PRIM_PTR_INT__l_s_g_s += lastoffset*675;
                        PRIM_PTR_INT__m_s_d_s += lastoffset*330;
                        PRIM_PTR_INT__m_s_f_s += lastoffset*550;
                        PRIM_PTR_INT__m_s_g_s += lastoffset*825;
                        PRIM_PTR_INT__n_s_d_s += lastoffset*396;
                        PRIM_PTR_INT__n_s_f_s += lastoffset*660;
                        PRIM_PTR_INT__n_s_g_s += lastoffset*990;
                        PRIM_PTR_INT__o_s_d_s += lastoffset*468;
                        PRIM_PTR_INT__o_s_f_s += lastoffset*780;
                        PRIM_PTR_INT__o_s_g_s += lastoffset*1170;
                        PRIM_PTR_INT__q_s_d_s += lastoffset*546;
                        PRIM_PTR_INT__q_s_f_s += lastoffset*910;
                        PRIM_PTR_INT__q_s_g_s += lastoffset*1365;
                        PRIM_PTR_INT__r_s_d_s += lastoffset*630;
                        PRIM_PTR_INT__r_s_f_s += lastoffset*1050;
                        PRIM_PTR_INT__r_s_g_s += lastoffset*1575;
                        PRIM_PTR_INT__t_s_d_s += lastoffset*720;
                        PRIM_PTR_INT__t_s_f_s += lastoffset*1200;
                        PRIM_PTR_INT__t_s_g_s += lastoffset*1800;
                    }

                }  // close loop over j
            }  // close loop over i
            
            //Advance to the next batch
            jstart = SIMINT_SIMD_ROUND(jend);
            
            //////////////////////////////////////////////
            // Contracted integrals: Horizontal recurrance
            //////////////////////////////////////////////


            const double hAB[3] = { P.AB_x[ab], P.AB_y[ab], P.AB_z[ab] };


            for(abcd = 0; abcd < nshellbatch; ++abcd, ++real_abcd)
            {
                const double hCD[3] = { Q.AB_x[cd+abcd], Q.AB_y[cd+abcd], Q.AB_z[cd+abcd] };

                // set up HRR pointers
                double const * restrict HRR_INT__k_s_d_s = INT__k_s_d_s + abcd * 216;
                double const * restrict HRR_INT__k_s_f_s = INT__k_s_f_s + abcd * 360;
                double const * restrict HRR_INT__k_s_g_s = INT__k_s_g_s + abcd * 540;
                double const * restrict HRR_INT__l_s_d_s = INT__l_s_d_s + abcd * 270;
                double const * restrict HRR_INT__l_s_f_s = INT__l_s_f_s + abcd * 450;
                double const * restrict HRR_INT__l_s_g_s = INT__l_s_g_s + abcd * 675;
                double const * restrict HRR_INT__m_s_d_s = INT__m_s_d_s + abcd * 330;
                double const * restrict HRR_INT__m_s_f_s = INT__m_s_f_s + abcd * 550;
                double const * restrict HRR_INT__m_s_g_s = INT__m_s_g_s + abcd * 825;
                double const * restrict HRR_INT__n_s_d_s = INT__n_s_d_s + abcd * 396;
                double const * restrict HRR_INT__n_s_f_s = INT__n_s_f_s + abcd * 660;
                double const * restrict HRR_INT__n_s_g_s = INT__n_s_g_s + abcd * 990;
                double const * restrict HRR_INT__o_s_d_s = INT__o_s_d_s + abcd * 468;
                double const * restrict HRR_INT__o_s_f_s = INT__o_s_f_s + abcd * 780;
                double const * restrict HRR_INT__o_s_g_s = INT__o_s_g_s + abcd * 1170;
                double const * restrict HRR_INT__q_s_d_s = INT__q_s_d_s + abcd * 546;
                double const * restrict HRR_INT__q_s_f_s = INT__q_s_f_s + abcd * 910;
                double const * restrict HRR_INT__q_s_g_s = INT__q_s_g_s + abcd * 1365;
                double const * restrict HRR_INT__r_s_d_s = INT__r_s_d_s + abcd * 630;
                double const * restrict HRR_INT__r_s_f_s = INT__r_s_f_s + abcd * 1050;
                double const * restrict HRR_INT__r_s_g_s = INT__r_s_g_s + abcd * 1575;
                double const * restrict HRR_INT__t_s_d_s = INT__t_s_d_s + abcd * 720;
                double const * restrict HRR_INT__t_s_f_s = INT__t_s_f_s + abcd * 1200;
                double const * restrict HRR_INT__t_s_g_s = INT__t_s_g_s + abcd * 1800;
                double * restrict HRR_INT__k_k_d_d = INT__k_k_d_d + real_abcd * 46656;

                // form INT__k_p_d_s
                HRR_J_k_p(
                    HRR_INT__k_p_d_s,
                    HRR_INT__k_s_d_s,
                    HRR_INT__l_s_d_s,
                    hAB, 6);

                // form INT__k_p_f_s
                HRR_J_k_p(
                    HRR_INT__k_p_f_s,
                    HRR_INT__k_s_f_s,
                    HRR_INT__l_s_f_s,
                    hAB, 10);

                // form INT__k_p_g_s
                HRR_J_k_p(
                    HRR_INT__k_p_g_s,
                    HRR_INT__k_s_g_s,
                    HRR_INT__l_s_g_s,
                    hAB, 15);

                // form INT__l_p_d_s
                HRR_J_l_p(
                    HRR_INT__l_p_d_s,
                    HRR_INT__l_s_d_s,
                    HRR_INT__m_s_d_s,
                    hAB, 6);

                // form INT__l_p_f_s
                HRR_J_l_p(
                    HRR_INT__l_p_f_s,
                    HRR_INT__l_s_f_s,
                    HRR_INT__m_s_f_s,
                    hAB, 10);

                // form INT__l_p_g_s
                HRR_J_l_p(
                    HRR_INT__l_p_g_s,
                    HRR_INT__l_s_g_s,
                    HRR_INT__m_s_g_s,
                    hAB, 15);

                // form INT__m_p_d_s
                ostei_general_hrr_J(9, 1, 2, 0, hAB, HRR_INT__n_s_d_s, HRR_INT__m_s_d_s, HRR_INT__m_p_d_s);

                // form INT__m_p_f_s
                ostei_general_hrr_J(9, 1, 3, 0, hAB, HRR_INT__n_s_f_s, HRR_INT__m_s_f_s, HRR_INT__m_p_f_s);

                // form INT__m_p_g_s
                ostei_general_hrr_J(9, 1, 4, 0, hAB, HRR_INT__n_s_g_s, HRR_INT__m_s_g_s, HRR_INT__m_p_g_s);

                // form INT__n_p_d_s
                ostei_general_hrr_J(10, 1, 2, 0, hAB, HRR_INT__o_s_d_s, HRR_INT__n_s_d_s, HRR_INT__n_p_d_s);

                // form INT__n_p_f_s
                ostei_general_hrr_J(10, 1, 3, 0, hAB, HRR_INT__o_s_f_s, HRR_INT__n_s_f_s, HRR_INT__n_p_f_s);

                // form INT__n_p_g_s
                ostei_general_hrr_J(10, 1, 4, 0, hAB, HRR_INT__o_s_g_s, HRR_INT__n_s_g_s, HRR_INT__n_p_g_s);

                // form INT__o_p_d_s
                ostei_general_hrr_J(11, 1, 2, 0, hAB, HRR_INT__q_s_d_s, HRR_INT__o_s_d_s, HRR_INT__o_p_d_s);

                // form INT__o_p_f_s
                ostei_general_hrr_J(11, 1, 3, 0, hAB, HRR_INT__q_s_f_s, HRR_INT__o_s_f_s, HRR_INT__o_p_f_s);

                // form INT__o_p_g_s
                ostei_general_hrr_J(11, 1, 4, 0, hAB, HRR_INT__q_s_g_s, HRR_INT__o_s_g_s, HRR_INT__o_p_g_s);

                // form INT__q_p_d_s
                ostei_general_hrr_J(12, 1, 2, 0, hAB, HRR_INT__r_s_d_s, HRR_INT__q_s_d_s, HRR_INT__q_p_d_s);

                // form INT__q_p_f_s
                ostei_general_hrr_J(12, 1, 3, 0, hAB, HRR_INT__r_s_f_s, HRR_INT__q_s_f_s, HRR_INT__q_p_f_s);

                // form INT__q_p_g_s
                ostei_general_hrr_J(12, 1, 4, 0, hAB, HRR_INT__r_s_g_s, HRR_INT__q_s_g_s, HRR_INT__q_p_g_s);

                // form INT__r_p_d_s
                ostei_general_hrr_J(13, 1, 2, 0, hAB, HRR_INT__t_s_d_s, HRR_INT__r_s_d_s, HRR_INT__r_p_d_s);

                // form INT__r_p_f_s
                ostei_general_hrr_J(13, 1, 3, 0, hAB, HRR_INT__t_s_f_s, HRR_INT__r_s_f_s, HRR_INT__r_p_f_s);

                // form INT__r_p_g_s
                ostei_general_hrr_J(13, 1, 4, 0, hAB, HRR_INT__t_s_g_s, HRR_INT__r_s_g_s, HRR_INT__r_p_g_s);

                // form INT__k_d_d_s
                HRR_J_k_d(
                    HRR_INT__k_d_d_s,
                    HRR_INT__k_p_d_s,
                    HRR_INT__l_p_d_s,
                    hAB, 6);

                // form INT__k_d_f_s
                HRR_J_k_d(
                    HRR_INT__k_d_f_s,
                    HRR_INT__k_p_f_s,
                    HRR_INT__l_p_f_s,
                    hAB, 10);

                // form INT__k_d_g_s
                HRR_J_k_d(
                    HRR_INT__k_d_g_s,
                    HRR_INT__k_p_g_s,
                    HRR_INT__l_p_g_s,
                    hAB, 15);

                // form INT__l_d_d_s
                ostei_general_hrr_J(8, 2, 2, 0, hAB, HRR_INT__m_p_d_s, HRR_INT__l_p_d_s, HRR_INT__l_d_d_s);

                // form INT__l_d_f_s
                ostei_general_hrr_J(8, 2, 3, 0, hAB, HRR_INT__m_p_f_s, HRR_INT__l_p_f_s, HRR_INT__l_d_f_s);

                // form INT__l_d_g_s
                ostei_general_hrr_J(8, 2, 4, 0, hAB, HRR_INT__m_p_g_s, HRR_INT__l_p_g_s, HRR_INT__l_d_g_s);

                // form INT__m_d_d_s
                ostei_general_hrr_J(9, 2, 2, 0, hAB, HRR_INT__n_p_d_s, HRR_INT__m_p_d_s, HRR_INT__m_d_d_s);

                // form INT__m_d_f_s
                ostei_general_hrr_J(9, 2, 3, 0, hAB, HRR_INT__n_p_f_s, HRR_INT__m_p_f_s, HRR_INT__m_d_f_s);

                // form INT__m_d_g_s
                ostei_general_hrr_J(9, 2, 4, 0, hAB, HRR_INT__n_p_g_s, HRR_INT__m_p_g_s, HRR_INT__m_d_g_s);

                // form INT__n_d_d_s
                ostei_general_hrr_J(10, 2, 2, 0, hAB, HRR_INT__o_p_d_s, HRR_INT__n_p_d_s, HRR_INT__n_d_d_s);

                // form INT__n_d_f_s
                ostei_general_hrr_J(10, 2, 3, 0, hAB, HRR_INT__o_p_f_s, HRR_INT__n_p_f_s, HRR_INT__n_d_f_s);

                // form INT__n_d_g_s
                ostei_general_hrr_J(10, 2, 4, 0, hAB, HRR_INT__o_p_g_s, HRR_INT__n_p_g_s, HRR_INT__n_d_g_s);

                // form INT__o_d_d_s
                ostei_general_hrr_J(11, 2, 2, 0, hAB, HRR_INT__q_p_d_s, HRR_INT__o_p_d_s, HRR_INT__o_d_d_s);

                // form INT__o_d_f_s
                ostei_general_hrr_J(11, 2, 3, 0, hAB, HRR_INT__q_p_f_s, HRR_INT__o_p_f_s, HRR_INT__o_d_f_s);

                // form INT__o_d_g_s
                ostei_general_hrr_J(11, 2, 4, 0, hAB, HRR_INT__q_p_g_s, HRR_INT__o_p_g_s, HRR_INT__o_d_g_s);

                // form INT__q_d_d_s
                ostei_general_hrr_J(12, 2, 2, 0, hAB, HRR_INT__r_p_d_s, HRR_INT__q_p_d_s, HRR_INT__q_d_d_s);

                // form INT__q_d_f_s
                ostei_general_hrr_J(12, 2, 3, 0, hAB, HRR_INT__r_p_f_s, HRR_INT__q_p_f_s, HRR_INT__q_d_f_s);

                // form INT__q_d_g_s
                ostei_general_hrr_J(12, 2, 4, 0, hAB, HRR_INT__r_p_g_s, HRR_INT__q_p_g_s, HRR_INT__q_d_g_s);

                // form INT__k_f_d_s
                ostei_general_hrr_J(7, 3, 2, 0, hAB, HRR_INT__l_d_d_s, HRR_INT__k_d_d_s, HRR_INT__k_f_d_s);

                // form INT__k_f_f_s
                ostei_general_hrr_J(7, 3, 3, 0, hAB, HRR_INT__l_d_f_s, HRR_INT__k_d_f_s, HRR_INT__k_f_f_s);

                // form INT__k_f_g_s
                ostei_general_hrr_J(7, 3, 4, 0, hAB, HRR_INT__l_d_g_s, HRR_INT__k_d_g_s, HRR_INT__k_f_g_s);

                // form INT__l_f_d_s
                ostei_general_hrr_J(8, 3, 2, 0, hAB, HRR_INT__m_d_d_s, HRR_INT__l_d_d_s, HRR_INT__l_f_d_s);

                // form INT__l_f_f_s
                ostei_general_hrr_J(8, 3, 3, 0, hAB, HRR_INT__m_d_f_s, HRR_INT__l_d_f_s, HRR_INT__l_f_f_s);

                // form INT__l_f_g_s
                ostei_general_hrr_J(8, 3, 4, 0, hAB, HRR_INT__m_d_g_s, HRR_INT__l_d_g_s, HRR_INT__l_f_g_s);

                // form INT__m_f_d_s
                ostei_general_hrr_J(9, 3, 2, 0, hAB, HRR_INT__n_d_d_s, HRR_INT__m_d_d_s, HRR_INT__m_f_d_s);

                // form INT__m_f_f_s
                ostei_general_hrr_J(9, 3, 3, 0, hAB, HRR_INT__n_d_f_s, HRR_INT__m_d_f_s, HRR_INT__m_f_f_s);

                // form INT__m_f_g_s
                ostei_general_hrr_J(9, 3, 4, 0, hAB, HRR_INT__n_d_g_s, HRR_INT__m_d_g_s, HRR_INT__m_f_g_s);

                // form INT__n_f_d_s
                ostei_general_hrr_J(10, 3, 2, 0, hAB, HRR_INT__o_d_d_s, HRR_INT__n_d_d_s, HRR_INT__n_f_d_s);

                // form INT__n_f_f_s
                ostei_general_hrr_J(10, 3, 3, 0, hAB, HRR_INT__o_d_f_s, HRR_INT__n_d_f_s, HRR_INT__n_f_f_s);

                // form INT__n_f_g_s
                ostei_general_hrr_J(10, 3, 4, 0, hAB, HRR_INT__o_d_g_s, HRR_INT__n_d_g_s, HRR_INT__n_f_g_s);

                // form INT__o_f_d_s
                ostei_general_hrr_J(11, 3, 2, 0, hAB, HRR_INT__q_d_d_s, HRR_INT__o_d_d_s, HRR_INT__o_f_d_s);

                // form INT__o_f_f_s
                ostei_general_hrr_J(11, 3, 3, 0, hAB, HRR_INT__q_d_f_s, HRR_INT__o_d_f_s, HRR_INT__o_f_f_s);

                // form INT__o_f_g_s
                ostei_general_hrr_J(11, 3, 4, 0, hAB, HRR_INT__q_d_g_s, HRR_INT__o_d_g_s, HRR_INT__o_f_g_s);

                // form INT__k_g_d_s
                ostei_general_hrr_J(7, 4, 2, 0, hAB, HRR_INT__l_f_d_s, HRR_INT__k_f_d_s, HRR_INT__k_g_d_s);

                // form INT__k_g_f_s
                ostei_general_hrr_J(7, 4, 3, 0, hAB, HRR_INT__l_f_f_s, HRR_INT__k_f_f_s, HRR_INT__k_g_f_s);

                // form INT__k_g_g_s
                ostei_general_hrr_J(7, 4, 4, 0, hAB, HRR_INT__l_f_g_s, HRR_INT__k_f_g_s, HRR_INT__k_g_g_s);

                // form INT__l_g_d_s
                ostei_general_hrr_J(8, 4, 2, 0, hAB, HRR_INT__m_f_d_s, HRR_INT__l_f_d_s, HRR_INT__l_g_d_s);

                // form INT__l_g_f_s
                ostei_general_hrr_J(8, 4, 3, 0, hAB, HRR_INT__m_f_f_s, HRR_INT__l_f_f_s, HRR_INT__l_g_f_s);

                // form INT__l_g_g_s
                ostei_general_hrr_J(8, 4, 4, 0, hAB, HRR_INT__m_f_g_s, HRR_INT__l_f_g_s, HRR_INT__l_g_g_s);

                // form INT__m_g_d_s
                ostei_general_hrr_J(9, 4, 2, 0, hAB, HRR_INT__n_f_d_s, HRR_INT__m_f_d_s, HRR_INT__m_g_d_s);

                // form INT__m_g_f_s
                ostei_general_hrr_J(9, 4, 3, 0, hAB, HRR_INT__n_f_f_s, HRR_INT__m_f_f_s, HRR_INT__m_g_f_s);

                // form INT__m_g_g_s
                ostei_general_hrr_J(9, 4, 4, 0, hAB, HRR_INT__n_f_g_s, HRR_INT__m_f_g_s, HRR_INT__m_g_g_s);

                // form INT__n_g_d_s
                ostei_general_hrr_J(10, 4, 2, 0, hAB, HRR_INT__o_f_d_s, HRR_INT__n_f_d_s, HRR_INT__n_g_d_s);

                // form INT__n_g_f_s
                ostei_general_hrr_J(10, 4, 3, 0, hAB, HRR_INT__o_f_f_s, HRR_INT__n_f_f_s, HRR_INT__n_g_f_s);

                // form INT__n_g_g_s
                ostei_general_hrr_J(10, 4, 4, 0, hAB, HRR_INT__o_f_g_s, HRR_INT__n_f_g_s, HRR_INT__n_g_g_s);

                // form INT__k_h_d_s
                ostei_general_hrr_J(7, 5, 2, 0, hAB, HRR_INT__l_g_d_s, HRR_INT__k_g_d_s, HRR_INT__k_h_d_s);

                // form INT__k_h_f_s
                ostei_general_hrr_J(7, 5, 3, 0, hAB, HRR_INT__l_g_f_s, HRR_INT__k_g_f_s, HRR_INT__k_h_f_s);

                // form INT__k_h_g_s
                ostei_general_hrr_J(7, 5, 4, 0, hAB, HRR_INT__l_g_g_s, HRR_INT__k_g_g_s, HRR_INT__k_h_g_s);

                // form INT__l_h_d_s
                ostei_general_hrr_J(8, 5, 2, 0, hAB, HRR_INT__m_g_d_s, HRR_INT__l_g_d_s, HRR_INT__l_h_d_s);

                // form INT__l_h_f_s
                ostei_general_hrr_J(8, 5, 3, 0, hAB, HRR_INT__m_g_f_s, HRR_INT__l_g_f_s, HRR_INT__l_h_f_s);

                // form INT__l_h_g_s
                ostei_general_hrr_J(8, 5, 4, 0, hAB, HRR_INT__m_g_g_s, HRR_INT__l_g_g_s, HRR_INT__l_h_g_s);

                // form INT__m_h_d_s
                ostei_general_hrr_J(9, 5, 2, 0, hAB, HRR_INT__n_g_d_s, HRR_INT__m_g_d_s, HRR_INT__m_h_d_s);

                // form INT__m_h_f_s
                ostei_general_hrr_J(9, 5, 3, 0, hAB, HRR_INT__n_g_f_s, HRR_INT__m_g_f_s, HRR_INT__m_h_f_s);

                // form INT__m_h_g_s
                ostei_general_hrr_J(9, 5, 4, 0, hAB, HRR_INT__n_g_g_s, HRR_INT__m_g_g_s, HRR_INT__m_h_g_s);

                // form INT__k_i_d_s
                ostei_general_hrr_J(7, 6, 2, 0, hAB, HRR_INT__l_h_d_s, HRR_INT__k_h_d_s, HRR_INT__k_i_d_s);

                // form INT__k_i_f_s
                ostei_general_hrr_J(7, 6, 3, 0, hAB, HRR_INT__l_h_f_s, HRR_INT__k_h_f_s, HRR_INT__k_i_f_s);

                // form INT__k_i_g_s
                ostei_general_hrr_J(7, 6, 4, 0, hAB, HRR_INT__l_h_g_s, HRR_INT__k_h_g_s, HRR_INT__k_i_g_s);

                // form INT__l_i_d_s
                ostei_general_hrr_J(8, 6, 2, 0, hAB, HRR_INT__m_h_d_s, HRR_INT__l_h_d_s, HRR_INT__l_i_d_s);

                // form INT__l_i_f_s
                ostei_general_hrr_J(8, 6, 3, 0, hAB, HRR_INT__m_h_f_s, HRR_INT__l_h_f_s, HRR_INT__l_i_f_s);

                // form INT__l_i_g_s
                ostei_general_hrr_J(8, 6, 4, 0, hAB, HRR_INT__m_h_g_s, HRR_INT__l_h_g_s, HRR_INT__l_i_g_s);

                // form INT__k_k_d_s
                ostei_general_hrr_J(7, 7, 2, 0, hAB, HRR_INT__l_i_d_s, HRR_INT__k_i_d_s, HRR_INT__k_k_d_s);

                // form INT__k_k_f_s
                ostei_general_hrr_J(7, 7, 3, 0, hAB, HRR_INT__l_i_f_s, HRR_INT__k_i_f_s, HRR_INT__k_k_f_s);

                // form INT__k_k_g_s
                ostei_general_hrr_J(7, 7, 4, 0, hAB, HRR_INT__l_i_g_s, HRR_INT__k_i_g_s, HRR_INT__k_k_g_s);

                // form INT__k_k_d_p
                for(ibra = 0; ibra < 1296; ++ibra)
                {
                    HRR_INT__k_k_d_p[ibra * 18 + 0] = HRR_INT__k_k_f_s[ibra * 10 + 0] + ( hCD[0] * HRR_INT__k_k_d_s[ibra * 6 + 0] );

                    HRR_INT__k_k_d_p[ibra * 18 + 1] = HRR_INT__k_k_f_s[ibra * 10 + 1] + ( hCD[1] * HRR_INT__k_k_d_s[ibra * 6 + 0] );

                    HRR_INT__k_k_d_p[ibra * 18 + 2] = HRR_INT__k_k_f_s[ibra * 10 + 2] + ( hCD[2] * HRR_INT__k_k_d_s[ibra * 6 + 0] );

                    HRR_INT__k_k_d_p[ibra * 18 + 3] = HRR_INT__k_k_f_s[ibra * 10 + 1] + ( hCD[0] * HRR_INT__k_k_d_s[ibra * 6 + 1] );

                    HRR_INT__k_k_d_p[ibra * 18 + 4] = HRR_INT__k_k_f_s[ibra * 10 + 3] + ( hCD[1] * HRR_INT__k_k_d_s[ibra * 6 + 1] );

                    HRR_INT__k_k_d_p[ibra * 18 + 5] = HRR_INT__k_k_f_s[ibra * 10 + 4] + ( hCD[2] * HRR_INT__k_k_d_s[ibra * 6 + 1] );

                    HRR_INT__k_k_d_p[ibra * 18 + 6] = HRR_INT__k_k_f_s[ibra * 10 + 2] + ( hCD[0] * HRR_INT__k_k_d_s[ibra * 6 + 2] );

                    HRR_INT__k_k_d_p[ibra * 18 + 7] = HRR_INT__k_k_f_s[ibra * 10 + 4] + ( hCD[1] * HRR_INT__k_k_d_s[ibra * 6 + 2] );

                    HRR_INT__k_k_d_p[ibra * 18 + 8] = HRR_INT__k_k_f_s[ibra * 10 + 5] + ( hCD[2] * HRR_INT__k_k_d_s[ibra * 6 + 2] );

                    HRR_INT__k_k_d_p[ibra * 18 + 9] = HRR_INT__k_k_f_s[ibra * 10 + 3] + ( hCD[0] * HRR_INT__k_k_d_s[ibra * 6 + 3] );

                    HRR_INT__k_k_d_p[ibra * 18 + 10] = HRR_INT__k_k_f_s[ibra * 10 + 6] + ( hCD[1] * HRR_INT__k_k_d_s[ibra * 6 + 3] );

                    HRR_INT__k_k_d_p[ibra * 18 + 11] = HRR_INT__k_k_f_s[ibra * 10 + 7] + ( hCD[2] * HRR_INT__k_k_d_s[ibra * 6 + 3] );

                    HRR_INT__k_k_d_p[ibra * 18 + 12] = HRR_INT__k_k_f_s[ibra * 10 + 4] + ( hCD[0] * HRR_INT__k_k_d_s[ibra * 6 + 4] );

                    HRR_INT__k_k_d_p[ibra * 18 + 13] = HRR_INT__k_k_f_s[ibra * 10 + 7] + ( hCD[1] * HRR_INT__k_k_d_s[ibra * 6 + 4] );

                    HRR_INT__k_k_d_p[ibra * 18 + 14] = HRR_INT__k_k_f_s[ibra * 10 + 8] + ( hCD[2] * HRR_INT__k_k_d_s[ibra * 6 + 4] );

                    HRR_INT__k_k_d_p[ibra * 18 + 15] = HRR_INT__k_k_f_s[ibra * 10 + 5] + ( hCD[0] * HRR_INT__k_k_d_s[ibra * 6 + 5] );

                    HRR_INT__k_k_d_p[ibra * 18 + 16] = HRR_INT__k_k_f_s[ibra * 10 + 8] + ( hCD[1] * HRR_INT__k_k_d_s[ibra * 6 + 5] );

                    HRR_INT__k_k_d_p[ibra * 18 + 17] = HRR_INT__k_k_f_s[ibra * 10 + 9] + ( hCD[2] * HRR_INT__k_k_d_s[ibra * 6 + 5] );

                }

                // form INT__k_k_f_p
                for(ibra = 0; ibra < 1296; ++ibra)
                {
                    HRR_INT__k_k_f_p[ibra * 30 + 0] = HRR_INT__k_k_g_s[ibra * 15 + 0] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 0] );

                    HRR_INT__k_k_f_p[ibra * 30 + 3] = HRR_INT__k_k_g_s[ibra * 15 + 1] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 1] );

                    HRR_INT__k_k_f_p[ibra * 30 + 4] = HRR_INT__k_k_g_s[ibra * 15 + 3] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 1] );

                    HRR_INT__k_k_f_p[ibra * 30 + 6] = HRR_INT__k_k_g_s[ibra * 15 + 2] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 2] );

                    HRR_INT__k_k_f_p[ibra * 30 + 7] = HRR_INT__k_k_g_s[ibra * 15 + 4] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 2] );

                    HRR_INT__k_k_f_p[ibra * 30 + 8] = HRR_INT__k_k_g_s[ibra * 15 + 5] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 2] );

                    HRR_INT__k_k_f_p[ibra * 30 + 9] = HRR_INT__k_k_g_s[ibra * 15 + 3] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 3] );

                    HRR_INT__k_k_f_p[ibra * 30 + 10] = HRR_INT__k_k_g_s[ibra * 15 + 6] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 3] );

                    HRR_INT__k_k_f_p[ibra * 30 + 12] = HRR_INT__k_k_g_s[ibra * 15 + 4] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 4] );

                    HRR_INT__k_k_f_p[ibra * 30 + 13] = HRR_INT__k_k_g_s[ibra * 15 + 7] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 4] );

                    HRR_INT__k_k_f_p[ibra * 30 + 14] = HRR_INT__k_k_g_s[ibra * 15 + 8] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 4] );

                    HRR_INT__k_k_f_p[ibra * 30 + 15] = HRR_INT__k_k_g_s[ibra * 15 + 5] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 5] );

                    HRR_INT__k_k_f_p[ibra * 30 + 16] = HRR_INT__k_k_g_s[ibra * 15 + 8] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 5] );

                    HRR_INT__k_k_f_p[ibra * 30 + 17] = HRR_INT__k_k_g_s[ibra * 15 + 9] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 5] );

                    HRR_INT__k_k_f_p[ibra * 30 + 18] = HRR_INT__k_k_g_s[ibra * 15 + 6] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 6] );

                    HRR_INT__k_k_f_p[ibra * 30 + 19] = HRR_INT__k_k_g_s[ibra * 15 + 10] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 6] );

                    HRR_INT__k_k_f_p[ibra * 30 + 21] = HRR_INT__k_k_g_s[ibra * 15 + 7] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 7] );

                    HRR_INT__k_k_f_p[ibra * 30 + 22] = HRR_INT__k_k_g_s[ibra * 15 + 11] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 7] );

                    HRR_INT__k_k_f_p[ibra * 30 + 23] = HRR_INT__k_k_g_s[ibra * 15 + 12] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 7] );

                    HRR_INT__k_k_f_p[ibra * 30 + 24] = HRR_INT__k_k_g_s[ibra * 15 + 8] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 8] );

                    HRR_INT__k_k_f_p[ibra * 30 + 25] = HRR_INT__k_k_g_s[ibra * 15 + 12] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 8] );

                    HRR_INT__k_k_f_p[ibra * 30 + 26] = HRR_INT__k_k_g_s[ibra * 15 + 13] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 8] );

                    HRR_INT__k_k_f_p[ibra * 30 + 27] = HRR_INT__k_k_g_s[ibra * 15 + 9] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 9] );

                    HRR_INT__k_k_f_p[ibra * 30 + 28] = HRR_INT__k_k_g_s[ibra * 15 + 13] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 9] );

                    HRR_INT__k_k_f_p[ibra * 30 + 29] = HRR_INT__k_k_g_s[ibra * 15 + 14] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 9] );

                }

                // form INT__k_k_d_d
                for(ibra = 0; ibra < 1296; ++ibra)
                {
                    HRR_INT__k_k_d_d[ibra * 36 + 0] = HRR_INT__k_k_f_p[ibra * 30 + 0] + ( hCD[0] * HRR_INT__k_k_d_p[ibra * 18 + 0] );

                    HRR_INT__k_k_d_d[ibra * 36 + 1] = HRR_INT__k_k_f_p[ibra * 30 + 3] + ( hCD[1] * HRR_INT__k_k_d_p[ibra * 18 + 0] );

                    HRR_INT__k_k_d_d[ibra * 36 + 2] = HRR_INT__k_k_f_p[ibra * 30 + 6] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 0] );

                    HRR_INT__k_k_d_d[ibra * 36 + 3] = HRR_INT__k_k_f_p[ibra * 30 + 4] + ( hCD[1] * HRR_INT__k_k_d_p[ibra * 18 + 1] );

                    HRR_INT__k_k_d_d[ibra * 36 + 4] = HRR_INT__k_k_f_p[ibra * 30 + 7] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 1] );

                    HRR_INT__k_k_d_d[ibra * 36 + 5] = HRR_INT__k_k_f_p[ibra * 30 + 8] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 2] );

                    HRR_INT__k_k_d_d[ibra * 36 + 6] = HRR_INT__k_k_f_p[ibra * 30 + 3] + ( hCD[0] * HRR_INT__k_k_d_p[ibra * 18 + 3] );

                    HRR_INT__k_k_d_d[ibra * 36 + 7] = HRR_INT__k_k_f_p[ibra * 30 + 9] + ( hCD[1] * HRR_INT__k_k_d_p[ibra * 18 + 3] );

                    HRR_INT__k_k_d_d[ibra * 36 + 8] = HRR_INT__k_k_f_p[ibra * 30 + 12] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 3] );

                    HRR_INT__k_k_d_d[ibra * 36 + 9] = HRR_INT__k_k_f_p[ibra * 30 + 10] + ( hCD[1] * HRR_INT__k_k_d_p[ibra * 18 + 4] );

                    HRR_INT__k_k_d_d[ibra * 36 + 10] = HRR_INT__k_k_f_p[ibra * 30 + 13] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 4] );

                    HRR_INT__k_k_d_d[ibra * 36 + 11] = HRR_INT__k_k_f_p[ibra * 30 + 14] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 5] );

                    HRR_INT__k_k_d_d[ibra * 36 + 12] = HRR_INT__k_k_f_p[ibra * 30 + 6] + ( hCD[0] * HRR_INT__k_k_d_p[ibra * 18 + 6] );

                    HRR_INT__k_k_d_d[ibra * 36 + 13] = HRR_INT__k_k_f_p[ibra * 30 + 12] + ( hCD[1] * HRR_INT__k_k_d_p[ibra * 18 + 6] );

                    HRR_INT__k_k_d_d[ibra * 36 + 14] = HRR_INT__k_k_f_p[ibra * 30 + 15] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 6] );

                    HRR_INT__k_k_d_d[ibra * 36 + 15] = HRR_INT__k_k_f_p[ibra * 30 + 13] + ( hCD[1] * HRR_INT__k_k_d_p[ibra * 18 + 7] );

                    HRR_INT__k_k_d_d[ibra * 36 + 16] = HRR_INT__k_k_f_p[ibra * 30 + 16] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 7] );

                    HRR_INT__k_k_d_d[ibra * 36 + 17] = HRR_INT__k_k_f_p[ibra * 30 + 17] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 8] );

                    HRR_INT__k_k_d_d[ibra * 36 + 18] = HRR_INT__k_k_f_p[ibra * 30 + 9] + ( hCD[0] * HRR_INT__k_k_d_p[ibra * 18 + 9] );

                    HRR_INT__k_k_d_d[ibra * 36 + 19] = HRR_INT__k_k_f_p[ibra * 30 + 18] + ( hCD[1] * HRR_INT__k_k_d_p[ibra * 18 + 9] );

                    HRR_INT__k_k_d_d[ibra * 36 + 20] = HRR_INT__k_k_f_p[ibra * 30 + 21] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 9] );

                    HRR_INT__k_k_d_d[ibra * 36 + 21] = HRR_INT__k_k_f_p[ibra * 30 + 19] + ( hCD[1] * HRR_INT__k_k_d_p[ibra * 18 + 10] );

                    HRR_INT__k_k_d_d[ibra * 36 + 22] = HRR_INT__k_k_f_p[ibra * 30 + 22] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 10] );

                    HRR_INT__k_k_d_d[ibra * 36 + 23] = HRR_INT__k_k_f_p[ibra * 30 + 23] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 11] );

                    HRR_INT__k_k_d_d[ibra * 36 + 24] = HRR_INT__k_k_f_p[ibra * 30 + 12] + ( hCD[0] * HRR_INT__k_k_d_p[ibra * 18 + 12] );

                    HRR_INT__k_k_d_d[ibra * 36 + 25] = HRR_INT__k_k_f_p[ibra * 30 + 21] + ( hCD[1] * HRR_INT__k_k_d_p[ibra * 18 + 12] );

                    HRR_INT__k_k_d_d[ibra * 36 + 26] = HRR_INT__k_k_f_p[ibra * 30 + 24] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 12] );

                    HRR_INT__k_k_d_d[ibra * 36 + 27] = HRR_INT__k_k_f_p[ibra * 30 + 22] + ( hCD[1] * HRR_INT__k_k_d_p[ibra * 18 + 13] );

                    HRR_INT__k_k_d_d[ibra * 36 + 28] = HRR_INT__k_k_f_p[ibra * 30 + 25] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 13] );

                    HRR_INT__k_k_d_d[ibra * 36 + 29] = HRR_INT__k_k_f_p[ibra * 30 + 26] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 14] );

                    HRR_INT__k_k_d_d[ibra * 36 + 30] = HRR_INT__k_k_f_p[ibra * 30 + 15] + ( hCD[0] * HRR_INT__k_k_d_p[ibra * 18 + 15] );

                    HRR_INT__k_k_d_d[ibra * 36 + 31] = HRR_INT__k_k_f_p[ibra * 30 + 24] + ( hCD[1] * HRR_INT__k_k_d_p[ibra * 18 + 15] );

                    HRR_INT__k_k_d_d[ibra * 36 + 32] = HRR_INT__k_k_f_p[ibra * 30 + 27] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 15] );

                    HRR_INT__k_k_d_d[ibra * 36 + 33] = HRR_INT__k_k_f_p[ibra * 30 + 25] + ( hCD[1] * HRR_INT__k_k_d_p[ibra * 18 + 16] );

                    HRR_INT__k_k_d_d[ibra * 36 + 34] = HRR_INT__k_k_f_p[ibra * 30 + 28] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 16] );

                    HRR_INT__k_k_d_d[ibra * 36 + 35] = HRR_INT__k_k_f_p[ibra * 30 + 29] + ( hCD[2] * HRR_INT__k_k_d_p[ibra * 18 + 17] );

                }


            }  // close HRR loop


        }   // close loop cdbatch

        istart = iend;
    }  // close loop over ab

    return P.nshell12_clip * Q.nshell12_clip;
}

