#include "simint/boys/boys.h"
#include "simint/ostei/gen/ostei_generated.h"
#include "simint/vectorization/vectorization.h"
#include <math.h>
#include <string.h>


int ostei_k_k_d_s(struct simint_multi_shellpair const P,
                  struct simint_multi_shellpair const Q,
                  double screen_tol,
                  double * const restrict work,
                  double * const restrict INT__k_k_d_s)
{

    SIMINT_ASSUME_ALIGN_DBL(work);
    SIMINT_ASSUME_ALIGN_DBL(INT__k_k_d_s);
    int ab, cd, abcd;
    int istart, jstart;
    int iprimcd, nprim_icd, icd;
    const int check_screen = (screen_tol > 0.0);
    int i, j;
    int n;
    int not_screened;
    int real_abcd;
    int iket;

    // partition workspace
    double * const INT__k_s_d_s = work + (SIMINT_NSHELL_SIMD * 0);
    double * const INT__l_s_d_s = work + (SIMINT_NSHELL_SIMD * 216);
    double * const INT__m_s_d_s = work + (SIMINT_NSHELL_SIMD * 486);
    double * const INT__n_s_d_s = work + (SIMINT_NSHELL_SIMD * 816);
    double * const INT__o_s_d_s = work + (SIMINT_NSHELL_SIMD * 1212);
    double * const INT__q_s_d_s = work + (SIMINT_NSHELL_SIMD * 1680);
    double * const INT__r_s_d_s = work + (SIMINT_NSHELL_SIMD * 2226);
    double * const INT__t_s_d_s = work + (SIMINT_NSHELL_SIMD * 2856);
    SIMINT_DBLTYPE * const primwork = (SIMINT_DBLTYPE *)(work + SIMINT_NSHELL_SIMD*3576);
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_s_s = primwork + 0;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_s_s = primwork + 17;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_s_s = primwork + 65;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_s_s = primwork + 155;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_s_s = primwork + 295;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_s_s = primwork + 490;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_s_s = primwork + 742;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_p_s = primwork + 1050;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_s_s = primwork + 1218;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_p_s = primwork + 1578;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_d_s = primwork + 1794;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_s_s = primwork + 2010;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_p_s = primwork + 2415;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_d_s = primwork + 2685;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_s_s = primwork + 2955;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_p_s = primwork + 3395;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_d_s = primwork + 3725;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_s_s = primwork + 4055;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_p_s = primwork + 4517;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_d_s = primwork + 4913;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_s_s = primwork + 5309;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_p_s = primwork + 5777;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_d_s = primwork + 6245;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_s_s = primwork + 6713;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_p_s = primwork + 7168;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_d_s = primwork + 7714;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_s_s = primwork + 8260;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_p_s = primwork + 8680;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_d_s = primwork + 9310;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_s_s = primwork + 9940;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_p_s = primwork + 10300;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_d_s = primwork + 11020;
    double * const hrrwork = (double *)(primwork + 11740);
    double * const HRR_INT__k_p_d_s = hrrwork + 0;
    double * const HRR_INT__k_d_d_s = hrrwork + 648;
    double * const HRR_INT__k_f_d_s = hrrwork + 1944;
    double * const HRR_INT__k_g_d_s = hrrwork + 4104;
    double * const HRR_INT__k_h_d_s = hrrwork + 7344;
    double * const HRR_INT__k_i_d_s = hrrwork + 11880;
    double * const HRR_INT__l_p_d_s = hrrwork + 17928;
    double * const HRR_INT__l_d_d_s = hrrwork + 18738;
    double * const HRR_INT__l_f_d_s = hrrwork + 20358;
    double * const HRR_INT__l_g_d_s = hrrwork + 23058;
    double * const HRR_INT__l_h_d_s = hrrwork + 27108;
    double * const HRR_INT__l_i_d_s = hrrwork + 32778;
    double * const HRR_INT__m_p_d_s = hrrwork + 40338;
    double * const HRR_INT__m_d_d_s = hrrwork + 41328;
    double * const HRR_INT__m_f_d_s = hrrwork + 43308;
    double * const HRR_INT__m_g_d_s = hrrwork + 46608;
    double * const HRR_INT__m_h_d_s = hrrwork + 51558;
    double * const HRR_INT__n_p_d_s = hrrwork + 58488;
    double * const HRR_INT__n_d_d_s = hrrwork + 59676;
    double * const HRR_INT__n_f_d_s = hrrwork + 62052;
    double * const HRR_INT__n_g_d_s = hrrwork + 66012;
    double * const HRR_INT__o_p_d_s = hrrwork + 71952;
    double * const HRR_INT__o_d_d_s = hrrwork + 73356;
    double * const HRR_INT__o_f_d_s = hrrwork + 76164;
    double * const HRR_INT__q_p_d_s = hrrwork + 80844;
    double * const HRR_INT__q_d_d_s = hrrwork + 82482;
    double * const HRR_INT__r_p_d_s = hrrwork + 85758;


    // Create constants
    const SIMINT_DBLTYPE const_1 = SIMINT_DBLSET1(1);
    const SIMINT_DBLTYPE const_10 = SIMINT_DBLSET1(10);
    const SIMINT_DBLTYPE const_11 = SIMINT_DBLSET1(11);
    const SIMINT_DBLTYPE const_12 = SIMINT_DBLSET1(12);
    const SIMINT_DBLTYPE const_13 = SIMINT_DBLSET1(13);
    const SIMINT_DBLTYPE const_14 = SIMINT_DBLSET1(14);
    const SIMINT_DBLTYPE const_2 = SIMINT_DBLSET1(2);
    const SIMINT_DBLTYPE const_3 = SIMINT_DBLSET1(3);
    const SIMINT_DBLTYPE const_4 = SIMINT_DBLSET1(4);
    const SIMINT_DBLTYPE const_5 = SIMINT_DBLSET1(5);
    const SIMINT_DBLTYPE const_6 = SIMINT_DBLSET1(6);
    const SIMINT_DBLTYPE const_7 = SIMINT_DBLSET1(7);
    const SIMINT_DBLTYPE const_8 = SIMINT_DBLSET1(8);
    const SIMINT_DBLTYPE const_9 = SIMINT_DBLSET1(9);
    const SIMINT_DBLTYPE one_half = SIMINT_DBLSET1(0.5);


    ////////////////////////////////////////
    // Loop over shells and primitives
    ////////////////////////////////////////

    real_abcd = 0;
    istart = 0;
    for(ab = 0; ab < P.nshell12_clip; ++ab)
    {
        const int iend = istart + P.nprim12[ab];

        cd = 0;
        jstart = 0;

        for(cd = 0; cd < Q.nshell12_clip; cd += SIMINT_NSHELL_SIMD)
        {
            const int nshellbatch = ((cd + SIMINT_NSHELL_SIMD) > Q.nshell12_clip) ? Q.nshell12_clip - cd : SIMINT_NSHELL_SIMD;
            int jend = jstart;
            for(i = 0; i < nshellbatch; i++)
                jend += Q.nprim12[cd+i];

            // Clear the beginning of the workspace (where we are accumulating integrals)
            memset(work, 0, SIMINT_NSHELL_SIMD * 3576 * sizeof(double));
            abcd = 0;


            for(i = istart; i < iend; ++i)
            {
                SIMINT_DBLTYPE bra_screen_max;  // only used if check_screen

                if(check_screen)
                {
                    // Skip this whole thing if always insignificant
                    if((P.screen[i] * Q.screen_max) < screen_tol)
                        continue;
                    bra_screen_max = SIMINT_DBLSET1(P.screen[i]);
                }

                icd = 0;
                iprimcd = 0;
                nprim_icd = Q.nprim12[cd];
                double * restrict PRIM_PTR_INT__k_s_d_s = INT__k_s_d_s + abcd * 216;
                double * restrict PRIM_PTR_INT__l_s_d_s = INT__l_s_d_s + abcd * 270;
                double * restrict PRIM_PTR_INT__m_s_d_s = INT__m_s_d_s + abcd * 330;
                double * restrict PRIM_PTR_INT__n_s_d_s = INT__n_s_d_s + abcd * 396;
                double * restrict PRIM_PTR_INT__o_s_d_s = INT__o_s_d_s + abcd * 468;
                double * restrict PRIM_PTR_INT__q_s_d_s = INT__q_s_d_s + abcd * 546;
                double * restrict PRIM_PTR_INT__r_s_d_s = INT__r_s_d_s + abcd * 630;
                double * restrict PRIM_PTR_INT__t_s_d_s = INT__t_s_d_s + abcd * 720;



                // Load these one per loop over i
                const SIMINT_DBLTYPE P_alpha = SIMINT_DBLSET1(P.alpha[i]);
                const SIMINT_DBLTYPE P_prefac = SIMINT_DBLSET1(P.prefac[i]);
                const SIMINT_DBLTYPE Pxyz[3] = { SIMINT_DBLSET1(P.x[i]), SIMINT_DBLSET1(P.y[i]), SIMINT_DBLSET1(P.z[i]) };

                const SIMINT_DBLTYPE P_PA[3] = { SIMINT_DBLSET1(P.PA_x[i]), SIMINT_DBLSET1(P.PA_y[i]), SIMINT_DBLSET1(P.PA_z[i]) };

                for(j = jstart; j < jend; j += SIMINT_SIMD_LEN)
                {
                    // calculate the shell offsets
                    // these are the offset from the shell pointed to by cd
                    // for each element
                    int shelloffsets[SIMINT_SIMD_LEN] = {0};
                    int lastoffset = 0;
                    const int nlane = ( ((j + SIMINT_SIMD_LEN) < jend) ? SIMINT_SIMD_LEN : (jend - j));

                    if((iprimcd + SIMINT_SIMD_LEN) >= nprim_icd)
                    {
                        // Handle if the first element of the vector is a new shell
                        if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                        {
                            nprim_icd += Q.nprim12[cd + (++icd)];
                            PRIM_PTR_INT__k_s_d_s += 216;
                            PRIM_PTR_INT__l_s_d_s += 270;
                            PRIM_PTR_INT__m_s_d_s += 330;
                            PRIM_PTR_INT__n_s_d_s += 396;
                            PRIM_PTR_INT__o_s_d_s += 468;
                            PRIM_PTR_INT__q_s_d_s += 546;
                            PRIM_PTR_INT__r_s_d_s += 630;
                            PRIM_PTR_INT__t_s_d_s += 720;
                        }
                        iprimcd++;
                        for(n = 1; n < SIMINT_SIMD_LEN; ++n)
                        {
                            if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                            {
                                shelloffsets[n] = shelloffsets[n-1] + 1;
                                lastoffset++;
                                nprim_icd += Q.nprim12[cd + (++icd)];
                            }
                            else
                                shelloffsets[n] = shelloffsets[n-1];
                            iprimcd++;
                        }
                    }
                    else
                        iprimcd += SIMINT_SIMD_LEN;

                    // Do we have to compute this vector (or has it been screened out)?
                    // (not_screened != 0 means we have to do this vector)
                    if(check_screen)
                    {
                        const double vmax = vector_max(SIMINT_MUL(bra_screen_max, SIMINT_DBLLOAD(Q.screen, j)));
                        if(vmax < screen_tol)
                        {
                            PRIM_PTR_INT__k_s_d_s += lastoffset*216;
                            PRIM_PTR_INT__l_s_d_s += lastoffset*270;
                            PRIM_PTR_INT__m_s_d_s += lastoffset*330;
                            PRIM_PTR_INT__n_s_d_s += lastoffset*396;
                            PRIM_PTR_INT__o_s_d_s += lastoffset*468;
                            PRIM_PTR_INT__q_s_d_s += lastoffset*546;
                            PRIM_PTR_INT__r_s_d_s += lastoffset*630;
                            PRIM_PTR_INT__t_s_d_s += lastoffset*720;
                            continue;
                        }
                    }

                    const SIMINT_DBLTYPE Q_alpha = SIMINT_DBLLOAD(Q.alpha, j);
                    const SIMINT_DBLTYPE PQalpha_mul = SIMINT_MUL(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE PQalpha_sum = SIMINT_ADD(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE one_over_PQalpha_sum = SIMINT_DIV(const_1, PQalpha_sum);


                    /* construct R2 = (Px - Qx)**2 + (Py - Qy)**2 + (Pz -Qz)**2 */
                    SIMINT_DBLTYPE PQ[3];
                    PQ[0] = SIMINT_SUB(Pxyz[0], SIMINT_DBLLOAD(Q.x, j));
                    PQ[1] = SIMINT_SUB(Pxyz[1], SIMINT_DBLLOAD(Q.y, j));
                    PQ[2] = SIMINT_SUB(Pxyz[2], SIMINT_DBLLOAD(Q.z, j));
                    SIMINT_DBLTYPE R2 = SIMINT_MUL(PQ[0], PQ[0]);
                    R2 = SIMINT_FMADD(PQ[1], PQ[1], R2);
                    R2 = SIMINT_FMADD(PQ[2], PQ[2], R2);

                    const SIMINT_DBLTYPE alpha = SIMINT_MUL(PQalpha_mul, one_over_PQalpha_sum); // alpha from MEST
                    const SIMINT_DBLTYPE one_over_p = SIMINT_DIV(const_1, P_alpha);
                    const SIMINT_DBLTYPE one_over_q = SIMINT_DIV(const_1, Q_alpha);
                    const SIMINT_DBLTYPE one_over_2p = SIMINT_MUL(one_half, one_over_p);
                    const SIMINT_DBLTYPE one_over_2q = SIMINT_MUL(one_half, one_over_q);
                    const SIMINT_DBLTYPE one_over_2pq = SIMINT_MUL(one_half, one_over_PQalpha_sum);
                    const SIMINT_DBLTYPE Q_PA[3] = { SIMINT_DBLLOAD(Q.PA_x, j), SIMINT_DBLLOAD(Q.PA_y, j), SIMINT_DBLLOAD(Q.PA_z, j) };

                    // NOTE: Minus sign!
                    const SIMINT_DBLTYPE a_over_p = SIMINT_MUL(SIMINT_NEG(alpha), one_over_p);
                    SIMINT_DBLTYPE aop_PQ[3];
                    aop_PQ[0] = SIMINT_MUL(a_over_p, PQ[0]);
                    aop_PQ[1] = SIMINT_MUL(a_over_p, PQ[1]);
                    aop_PQ[2] = SIMINT_MUL(a_over_p, PQ[2]);

                    SIMINT_DBLTYPE a_over_q = SIMINT_MUL(alpha, one_over_q);
                    SIMINT_DBLTYPE aoq_PQ[3];
                    aoq_PQ[0] = SIMINT_MUL(a_over_q, PQ[0]);
                    aoq_PQ[1] = SIMINT_MUL(a_over_q, PQ[1]);
                    aoq_PQ[2] = SIMINT_MUL(a_over_q, PQ[2]);
                    // Put a minus sign here so we don't have to in RR routines
                    a_over_q = SIMINT_NEG(a_over_q);


                    //////////////////////////////////////////////
                    // Fjt function section
                    // Maximum v value: 16
                    //////////////////////////////////////////////
                    // The parameter to the Fjt function
                    const SIMINT_DBLTYPE F_x = SIMINT_MUL(R2, alpha);


                    const SIMINT_DBLTYPE Q_prefac = mask_load(nlane, Q.prefac + j);


                    boys_F_split(PRIM_INT__s_s_s_s, F_x, 16);
                    SIMINT_DBLTYPE prefac = SIMINT_SQRT(one_over_PQalpha_sum);
                    prefac = SIMINT_MUL(SIMINT_MUL(P_prefac, Q_prefac), prefac);
                    for(n = 0; n <= 16; n++)
                        PRIM_INT__s_s_s_s[n] = SIMINT_MUL(PRIM_INT__s_s_s_s[n], prefac);

                    //////////////////////////////////////////////
                    // Primitive integrals: Vertical recurrance
                    //////////////////////////////////////////////

                    const SIMINT_DBLTYPE vrr_const_1_over_2p = one_over_2p;
                    const SIMINT_DBLTYPE vrr_const_2_over_2p = SIMINT_MUL(const_2, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_3_over_2p = SIMINT_MUL(const_3, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_4_over_2p = SIMINT_MUL(const_4, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_5_over_2p = SIMINT_MUL(const_5, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_6_over_2p = SIMINT_MUL(const_6, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_7_over_2p = SIMINT_MUL(const_7, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_8_over_2p = SIMINT_MUL(const_8, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_9_over_2p = SIMINT_MUL(const_9, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_10_over_2p = SIMINT_MUL(const_10, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_11_over_2p = SIMINT_MUL(const_11, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_12_over_2p = SIMINT_MUL(const_12, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_13_over_2p = SIMINT_MUL(const_13, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_1_over_2q = one_over_2q;
                    const SIMINT_DBLTYPE vrr_const_1_over_2pq = one_over_2pq;
                    const SIMINT_DBLTYPE vrr_const_2_over_2pq = SIMINT_MUL(const_2, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_3_over_2pq = SIMINT_MUL(const_3, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_4_over_2pq = SIMINT_MUL(const_4, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_5_over_2pq = SIMINT_MUL(const_5, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_6_over_2pq = SIMINT_MUL(const_6, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_7_over_2pq = SIMINT_MUL(const_7, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_8_over_2pq = SIMINT_MUL(const_8, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_9_over_2pq = SIMINT_MUL(const_9, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_10_over_2pq = SIMINT_MUL(const_10, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_11_over_2pq = SIMINT_MUL(const_11, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_12_over_2pq = SIMINT_MUL(const_12, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_13_over_2pq = SIMINT_MUL(const_13, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_14_over_2pq = SIMINT_MUL(const_14, one_over_2pq);



                    // Forming PRIM_INT__p_s_s_s[16 * 3];
                    for(n = 0; n < 16; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__p_s_s_s[n * 3 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__p_s_s_s[n * 3 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__p_s_s_s[n * 3 + 0]);

                        PRIM_INT__p_s_s_s[n * 3 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__p_s_s_s[n * 3 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__p_s_s_s[n * 3 + 1]);

                        PRIM_INT__p_s_s_s[n * 3 + 2] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__p_s_s_s[n * 3 + 2] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__p_s_s_s[n * 3 + 2]);

                    }



                    // Forming PRIM_INT__d_s_s_s[15 * 6];
                    for(n = 0; n < 15; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__d_s_s_s[n * 6 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__p_s_s_s[n * 3 + 0]);
                        PRIM_INT__d_s_s_s[n * 6 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__p_s_s_s[(n+1) * 3 + 0], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__d_s_s_s[n * 6 + 0] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__d_s_s_s[n * 6 + 0]);

                        PRIM_INT__d_s_s_s[n * 6 + 3] = SIMINT_MUL(P_PA[1], PRIM_INT__p_s_s_s[n * 3 + 1]);
                        PRIM_INT__d_s_s_s[n * 6 + 3] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__p_s_s_s[(n+1) * 3 + 1], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__d_s_s_s[n * 6 + 3] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__d_s_s_s[n * 6 + 3]);

                        PRIM_INT__d_s_s_s[n * 6 + 5] = SIMINT_MUL(P_PA[2], PRIM_INT__p_s_s_s[n * 3 + 2]);
                        PRIM_INT__d_s_s_s[n * 6 + 5] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__p_s_s_s[(n+1) * 3 + 2], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__d_s_s_s[n * 6 + 5] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__d_s_s_s[n * 6 + 5]);

                    }



                    // Forming PRIM_INT__f_s_s_s[14 * 10];
                    for(n = 0; n < 14; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__f_s_s_s[n * 10 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 0] = SIMINT_FMADD( vrr_const_2_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__p_s_s_s[(n+1) * 3 + 0], PRIM_INT__p_s_s_s[n * 3 + 0]), PRIM_INT__f_s_s_s[n * 10 + 0]);

                        PRIM_INT__f_s_s_s[n * 10 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_s_s[n * 10 + 1]);

                        PRIM_INT__f_s_s_s[n * 10 + 2] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 2] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_s_s[n * 10 + 2]);

                        PRIM_INT__f_s_s_s[n * 10 + 6] = SIMINT_MUL(P_PA[1], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__f_s_s_s[n * 10 + 6] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__f_s_s_s[n * 10 + 6] = SIMINT_FMADD( vrr_const_2_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__p_s_s_s[(n+1) * 3 + 1], PRIM_INT__p_s_s_s[n * 3 + 1]), PRIM_INT__f_s_s_s[n * 10 + 6]);

                        PRIM_INT__f_s_s_s[n * 10 + 7] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__f_s_s_s[n * 10 + 7] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_s_s[n * 10 + 7]);

                        PRIM_INT__f_s_s_s[n * 10 + 9] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__f_s_s_s[n * 10 + 9] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__f_s_s_s[n * 10 + 9] = SIMINT_FMADD( vrr_const_2_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__p_s_s_s[(n+1) * 3 + 2], PRIM_INT__p_s_s_s[n * 3 + 2]), PRIM_INT__f_s_s_s[n * 10 + 9]);

                    }



                    // Forming PRIM_INT__g_s_s_s[13 * 15];
                    for(n = 0; n < 13; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__g_s_s_s[n * 15 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__g_s_s_s[n * 15 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 0], PRIM_INT__g_s_s_s[n * 15 + 0]);
                        PRIM_INT__g_s_s_s[n * 15 + 0] = SIMINT_FMADD( vrr_const_3_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__d_s_s_s[n * 6 + 0]), PRIM_INT__g_s_s_s[n * 15 + 0]);

                        PRIM_INT__g_s_s_s[n * 15 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__g_s_s_s[n * 15 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 0], PRIM_INT__g_s_s_s[n * 15 + 1]);

                        PRIM_INT__g_s_s_s[n * 15 + 2] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__g_s_s_s[n * 15 + 2] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 0], PRIM_INT__g_s_s_s[n * 15 + 2]);

                        PRIM_INT__g_s_s_s[n * 15 + 3] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 1]);
                        PRIM_INT__g_s_s_s[n * 15 + 3] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 1], PRIM_INT__g_s_s_s[n * 15 + 3]);
                        PRIM_INT__g_s_s_s[n * 15 + 3] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__d_s_s_s[n * 6 + 0]), PRIM_INT__g_s_s_s[n * 15 + 3]);

                        PRIM_INT__g_s_s_s[n * 15 + 5] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 2]);
                        PRIM_INT__g_s_s_s[n * 15 + 5] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 2], PRIM_INT__g_s_s_s[n * 15 + 5]);
                        PRIM_INT__g_s_s_s[n * 15 + 5] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__d_s_s_s[n * 6 + 0]), PRIM_INT__g_s_s_s[n * 15 + 5]);

                        PRIM_INT__g_s_s_s[n * 15 + 6] = SIMINT_MUL(P_PA[0], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__g_s_s_s[n * 15 + 6] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 6], PRIM_INT__g_s_s_s[n * 15 + 6]);

                        PRIM_INT__g_s_s_s[n * 15 + 9] = SIMINT_MUL(P_PA[0], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__g_s_s_s[n * 15 + 9] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 9], PRIM_INT__g_s_s_s[n * 15 + 9]);

                        PRIM_INT__g_s_s_s[n * 15 + 10] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__g_s_s_s[n * 15 + 10] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 6], PRIM_INT__g_s_s_s[n * 15 + 10]);
                        PRIM_INT__g_s_s_s[n * 15 + 10] = SIMINT_FMADD( vrr_const_3_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__d_s_s_s[n * 6 + 3]), PRIM_INT__g_s_s_s[n * 15 + 10]);

                        PRIM_INT__g_s_s_s[n * 15 + 11] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__g_s_s_s[n * 15 + 11] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 6], PRIM_INT__g_s_s_s[n * 15 + 11]);

                        PRIM_INT__g_s_s_s[n * 15 + 12] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 7]);
                        PRIM_INT__g_s_s_s[n * 15 + 12] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 7], PRIM_INT__g_s_s_s[n * 15 + 12]);
                        PRIM_INT__g_s_s_s[n * 15 + 12] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__d_s_s_s[n * 6 + 3]), PRIM_INT__g_s_s_s[n * 15 + 12]);

                        PRIM_INT__g_s_s_s[n * 15 + 13] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__g_s_s_s[n * 15 + 13] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 9], PRIM_INT__g_s_s_s[n * 15 + 13]);

                        PRIM_INT__g_s_s_s[n * 15 + 14] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__g_s_s_s[n * 15 + 14] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 9], PRIM_INT__g_s_s_s[n * 15 + 14]);
                        PRIM_INT__g_s_s_s[n * 15 + 14] = SIMINT_FMADD( vrr_const_3_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__d_s_s_s[n * 6 + 5]), PRIM_INT__g_s_s_s[n * 15 + 14]);

                    }


                    VRR_I_h_s_s_s(
                            PRIM_INT__h_s_s_s,
                            PRIM_INT__g_s_s_s,
                            PRIM_INT__f_s_s_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            12);


                    VRR_I_i_s_s_s(
                            PRIM_INT__i_s_s_s,
                            PRIM_INT__h_s_s_s,
                            PRIM_INT__g_s_s_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            11);


                    VRR_I_k_s_s_s(
                            PRIM_INT__k_s_s_s,
                            PRIM_INT__i_s_s_s,
                            PRIM_INT__h_s_s_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            10);


                    ostei_general_vrr_K(7, 0, 1, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_s_s, NULL, NULL, PRIM_INT__i_s_s_s, NULL, PRIM_INT__k_s_p_s);


                    VRR_K_i_s_p_s(
                            PRIM_INT__i_s_p_s,
                            PRIM_INT__i_s_s_s,
                            PRIM_INT__h_s_s_s,
                            Q_PA,
                            aoq_PQ,
                            one_over_2pq,
                            2);


                    ostei_general_vrr_K(7, 0, 2, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_p_s, PRIM_INT__k_s_s_s, NULL, PRIM_INT__i_s_p_s, NULL, PRIM_INT__k_s_d_s);


                    ostei_general_vrr1_I(8, 9,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__k_s_s_s, PRIM_INT__i_s_s_s, PRIM_INT__l_s_s_s);


                    ostei_general_vrr_K(8, 0, 1, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_s_s, NULL, NULL, PRIM_INT__k_s_s_s, NULL, PRIM_INT__l_s_p_s);


                    ostei_general_vrr_K(8, 0, 2, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_p_s, PRIM_INT__l_s_s_s, NULL, PRIM_INT__k_s_p_s, NULL, PRIM_INT__l_s_d_s);


                    ostei_general_vrr1_I(9, 8,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__l_s_s_s, PRIM_INT__k_s_s_s, PRIM_INT__m_s_s_s);


                    ostei_general_vrr_K(9, 0, 1, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_s_s, NULL, NULL, PRIM_INT__l_s_s_s, NULL, PRIM_INT__m_s_p_s);


                    ostei_general_vrr_K(9, 0, 2, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_p_s, PRIM_INT__m_s_s_s, NULL, PRIM_INT__l_s_p_s, NULL, PRIM_INT__m_s_d_s);


                    ostei_general_vrr1_I(10, 7,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__m_s_s_s, PRIM_INT__l_s_s_s, PRIM_INT__n_s_s_s);


                    ostei_general_vrr_K(10, 0, 1, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_s_s, NULL, NULL, PRIM_INT__m_s_s_s, NULL, PRIM_INT__n_s_p_s);


                    ostei_general_vrr_K(10, 0, 2, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_p_s, PRIM_INT__n_s_s_s, NULL, PRIM_INT__m_s_p_s, NULL, PRIM_INT__n_s_d_s);


                    ostei_general_vrr1_I(11, 6,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__n_s_s_s, PRIM_INT__m_s_s_s, PRIM_INT__o_s_s_s);


                    ostei_general_vrr_K(11, 0, 1, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_s_s, NULL, NULL, PRIM_INT__n_s_s_s, NULL, PRIM_INT__o_s_p_s);


                    ostei_general_vrr_K(11, 0, 2, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_p_s, PRIM_INT__o_s_s_s, NULL, PRIM_INT__n_s_p_s, NULL, PRIM_INT__o_s_d_s);


                    ostei_general_vrr1_I(12, 5,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__o_s_s_s, PRIM_INT__n_s_s_s, PRIM_INT__q_s_s_s);


                    ostei_general_vrr_K(12, 0, 1, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_s_s, NULL, NULL, PRIM_INT__o_s_s_s, NULL, PRIM_INT__q_s_p_s);


                    ostei_general_vrr_K(12, 0, 2, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_p_s, PRIM_INT__q_s_s_s, NULL, PRIM_INT__o_s_p_s, NULL, PRIM_INT__q_s_d_s);


                    ostei_general_vrr1_I(13, 4,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__q_s_s_s, PRIM_INT__o_s_s_s, PRIM_INT__r_s_s_s);


                    ostei_general_vrr_K(13, 0, 1, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__r_s_s_s, NULL, NULL, PRIM_INT__q_s_s_s, NULL, PRIM_INT__r_s_p_s);


                    ostei_general_vrr_K(13, 0, 2, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__r_s_p_s, PRIM_INT__r_s_s_s, NULL, PRIM_INT__q_s_p_s, NULL, PRIM_INT__r_s_d_s);


                    ostei_general_vrr1_I(14, 3,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__r_s_s_s, PRIM_INT__q_s_s_s, PRIM_INT__t_s_s_s);


                    ostei_general_vrr_K(14, 0, 1, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__t_s_s_s, NULL, NULL, PRIM_INT__r_s_s_s, NULL, PRIM_INT__t_s_p_s);


                    ostei_general_vrr_K(14, 0, 2, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__t_s_p_s, PRIM_INT__t_s_s_s, NULL, PRIM_INT__r_s_p_s, NULL, PRIM_INT__t_s_d_s);




                    ////////////////////////////////////
                    // Accumulate contracted integrals
                    ////////////////////////////////////
                    if(lastoffset == 0)
                    {
                        contract_all(216, PRIM_INT__k_s_d_s, PRIM_PTR_INT__k_s_d_s);
                        contract_all(270, PRIM_INT__l_s_d_s, PRIM_PTR_INT__l_s_d_s);
                        contract_all(330, PRIM_INT__m_s_d_s, PRIM_PTR_INT__m_s_d_s);
                        contract_all(396, PRIM_INT__n_s_d_s, PRIM_PTR_INT__n_s_d_s);
                        contract_all(468, PRIM_INT__o_s_d_s, PRIM_PTR_INT__o_s_d_s);
                        contract_all(546, PRIM_INT__q_s_d_s, PRIM_PTR_INT__q_s_d_s);
                        contract_all(630, PRIM_INT__r_s_d_s, PRIM_PTR_INT__r_s_d_s);
                        contract_all(720, PRIM_INT__t_s_d_s, PRIM_PTR_INT__t_s_d_s);
                    }
                    else
                    {
                        contract(216, shelloffsets, PRIM_INT__k_s_d_s, PRIM_PTR_INT__k_s_d_s);
                        contract(270, shelloffsets, PRIM_INT__l_s_d_s, PRIM_PTR_INT__l_s_d_s);
                        contract(330, shelloffsets, PRIM_INT__m_s_d_s, PRIM_PTR_INT__m_s_d_s);
                        contract(396, shelloffsets, PRIM_INT__n_s_d_s, PRIM_PTR_INT__n_s_d_s);
                        contract(468, shelloffsets, PRIM_INT__o_s_d_s, PRIM_PTR_INT__o_s_d_s);
                        contract(546, shelloffsets, PRIM_INT__q_s_d_s, PRIM_PTR_INT__q_s_d_s);
                        contract(630, shelloffsets, PRIM_INT__r_s_d_s, PRIM_PTR_INT__r_s_d_s);
                        contract(720, shelloffsets, PRIM_INT__t_s_d_s, PRIM_PTR_INT__t_s_d_s);
                        PRIM_PTR_INT__k_s_d_s += lastoffset*216;
                        PRIM_PTR_INT__l_s_d_s += lastoffset*270;
                        PRIM_PTR_INT__m_s_d_s += lastoffset*330;
                        PRIM_PTR_INT__n_s_d_s += lastoffset*396;
                        PRIM_PTR_INT__o_s_d_s += lastoffset*468;
                        PRIM_PTR_INT__q_s_d_s += lastoffset*546;
                        PRIM_PTR_INT__r_s_d_s += lastoffset*630;
                        PRIM_PTR_INT__t_s_d_s += lastoffset*720;
                    }

                }  // close loop over j
            }  // close loop over i
            
            //Advance to the next batch
            jstart = SIMINT_SIMD_ROUND(jend);
            
            //////////////////////////////////////////////
            // Contracted integrals: Horizontal recurrance
            //////////////////////////////////////////////


            const double hAB[3] = { P.AB_x[ab], P.AB_y[ab], P.AB_z[ab] };


            for(abcd = 0; abcd < nshellbatch; ++abcd, ++real_abcd)
            {

                // set up HRR pointers
                double const * restrict HRR_INT__k_s_d_s = INT__k_s_d_s + abcd * 216;
                double const * restrict HRR_INT__l_s_d_s = INT__l_s_d_s + abcd * 270;
                double const * restrict HRR_INT__m_s_d_s = INT__m_s_d_s + abcd * 330;
                double const * restrict HRR_INT__n_s_d_s = INT__n_s_d_s + abcd * 396;
                double const * restrict HRR_INT__o_s_d_s = INT__o_s_d_s + abcd * 468;
                double const * restrict HRR_INT__q_s_d_s = INT__q_s_d_s + abcd * 546;
                double const * restrict HRR_INT__r_s_d_s = INT__r_s_d_s + abcd * 630;
                double const * restrict HRR_INT__t_s_d_s = INT__t_s_d_s + abcd * 720;
                double * restrict HRR_INT__k_k_d_s = INT__k_k_d_s + real_abcd * 7776;

                // form INT__k_p_d_s
                HRR_J_k_p(
                    HRR_INT__k_p_d_s,
                    HRR_INT__k_s_d_s,
                    HRR_INT__l_s_d_s,
                    hAB, 6);

                // form INT__l_p_d_s
                HRR_J_l_p(
                    HRR_INT__l_p_d_s,
                    HRR_INT__l_s_d_s,
                    HRR_INT__m_s_d_s,
                    hAB, 6);

                // form INT__m_p_d_s
                ostei_general_hrr_J(9, 1, 2, 0, hAB, HRR_INT__n_s_d_s, HRR_INT__m_s_d_s, HRR_INT__m_p_d_s);

                // form INT__n_p_d_s
                ostei_general_hrr_J(10, 1, 2, 0, hAB, HRR_INT__o_s_d_s, HRR_INT__n_s_d_s, HRR_INT__n_p_d_s);

                // form INT__o_p_d_s
                ostei_general_hrr_J(11, 1, 2, 0, hAB, HRR_INT__q_s_d_s, HRR_INT__o_s_d_s, HRR_INT__o_p_d_s);

                // form INT__q_p_d_s
                ostei_general_hrr_J(12, 1, 2, 0, hAB, HRR_INT__r_s_d_s, HRR_INT__q_s_d_s, HRR_INT__q_p_d_s);

                // form INT__r_p_d_s
                ostei_general_hrr_J(13, 1, 2, 0, hAB, HRR_INT__t_s_d_s, HRR_INT__r_s_d_s, HRR_INT__r_p_d_s);

                // form INT__k_d_d_s
                HRR_J_k_d(
                    HRR_INT__k_d_d_s,
                    HRR_INT__k_p_d_s,
                    HRR_INT__l_p_d_s,
                    hAB, 6);

                // form INT__l_d_d_s
                ostei_general_hrr_J(8, 2, 2, 0, hAB, HRR_INT__m_p_d_s, HRR_INT__l_p_d_s, HRR_INT__l_d_d_s);

                // form INT__m_d_d_s
                ostei_general_hrr_J(9, 2, 2, 0, hAB, HRR_INT__n_p_d_s, HRR_INT__m_p_d_s, HRR_INT__m_d_d_s);

                // form INT__n_d_d_s
                ostei_general_hrr_J(10, 2, 2, 0, hAB, HRR_INT__o_p_d_s, HRR_INT__n_p_d_s, HRR_INT__n_d_d_s);

                // form INT__o_d_d_s
                ostei_general_hrr_J(11, 2, 2, 0, hAB, HRR_INT__q_p_d_s, HRR_INT__o_p_d_s, HRR_INT__o_d_d_s);

                // form INT__q_d_d_s
                ostei_general_hrr_J(12, 2, 2, 0, hAB, HRR_INT__r_p_d_s, HRR_INT__q_p_d_s, HRR_INT__q_d_d_s);

                // form INT__k_f_d_s
                ostei_general_hrr_J(7, 3, 2, 0, hAB, HRR_INT__l_d_d_s, HRR_INT__k_d_d_s, HRR_INT__k_f_d_s);

                // form INT__l_f_d_s
                ostei_general_hrr_J(8, 3, 2, 0, hAB, HRR_INT__m_d_d_s, HRR_INT__l_d_d_s, HRR_INT__l_f_d_s);

                // form INT__m_f_d_s
                ostei_general_hrr_J(9, 3, 2, 0, hAB, HRR_INT__n_d_d_s, HRR_INT__m_d_d_s, HRR_INT__m_f_d_s);

                // form INT__n_f_d_s
                ostei_general_hrr_J(10, 3, 2, 0, hAB, HRR_INT__o_d_d_s, HRR_INT__n_d_d_s, HRR_INT__n_f_d_s);

                // form INT__o_f_d_s
                ostei_general_hrr_J(11, 3, 2, 0, hAB, HRR_INT__q_d_d_s, HRR_INT__o_d_d_s, HRR_INT__o_f_d_s);

                // form INT__k_g_d_s
                ostei_general_hrr_J(7, 4, 2, 0, hAB, HRR_INT__l_f_d_s, HRR_INT__k_f_d_s, HRR_INT__k_g_d_s);

                // form INT__l_g_d_s
                ostei_general_hrr_J(8, 4, 2, 0, hAB, HRR_INT__m_f_d_s, HRR_INT__l_f_d_s, HRR_INT__l_g_d_s);

                // form INT__m_g_d_s
                ostei_general_hrr_J(9, 4, 2, 0, hAB, HRR_INT__n_f_d_s, HRR_INT__m_f_d_s, HRR_INT__m_g_d_s);

                // form INT__n_g_d_s
                ostei_general_hrr_J(10, 4, 2, 0, hAB, HRR_INT__o_f_d_s, HRR_INT__n_f_d_s, HRR_INT__n_g_d_s);

                // form INT__k_h_d_s
                ostei_general_hrr_J(7, 5, 2, 0, hAB, HRR_INT__l_g_d_s, HRR_INT__k_g_d_s, HRR_INT__k_h_d_s);

                // form INT__l_h_d_s
                ostei_general_hrr_J(8, 5, 2, 0, hAB, HRR_INT__m_g_d_s, HRR_INT__l_g_d_s, HRR_INT__l_h_d_s);

                // form INT__m_h_d_s
                ostei_general_hrr_J(9, 5, 2, 0, hAB, HRR_INT__n_g_d_s, HRR_INT__m_g_d_s, HRR_INT__m_h_d_s);

                // form INT__k_i_d_s
                ostei_general_hrr_J(7, 6, 2, 0, hAB, HRR_INT__l_h_d_s, HRR_INT__k_h_d_s, HRR_INT__k_i_d_s);

                // form INT__l_i_d_s
                ostei_general_hrr_J(8, 6, 2, 0, hAB, HRR_INT__m_h_d_s, HRR_INT__l_h_d_s, HRR_INT__l_i_d_s);

                // form INT__k_k_d_s
                ostei_general_hrr_J(7, 7, 2, 0, hAB, HRR_INT__l_i_d_s, HRR_INT__k_i_d_s, HRR_INT__k_k_d_s);


            }  // close HRR loop


        }   // close loop cdbatch

        istart = iend;
    }  // close loop over ab

    return P.nshell12_clip * Q.nshell12_clip;
}

int ostei_k_k_s_d(struct simint_multi_shellpair const P,
                  struct simint_multi_shellpair const Q,
                  double screen_tol,
                  double * const restrict work,
                  double * const restrict INT__k_k_s_d)
{
    double Q_AB[3*Q.nshell12];
    struct simint_multi_shellpair Q_tmp = Q;
    Q_tmp.PA_x = Q.PB_x;  Q_tmp.PA_y = Q.PB_y;  Q_tmp.PA_z = Q.PB_z;
    Q_tmp.PB_x = Q.PA_x;  Q_tmp.PB_y = Q.PA_y;  Q_tmp.PB_z = Q.PA_z;
    Q_tmp.AB_x = Q_AB;
    Q_tmp.AB_y = Q_AB + Q.nshell12;
    Q_tmp.AB_z = Q_AB + 2*Q.nshell12;

    for(int i = 0; i < Q.nshell12; i++)
    {
        Q_tmp.AB_x[i] = -Q.AB_x[i];
        Q_tmp.AB_y[i] = -Q.AB_y[i];
        Q_tmp.AB_z[i] = -Q.AB_z[i];
    }

    int ret = ostei_k_k_d_s(P, Q_tmp, screen_tol, work, INT__k_k_s_d);
    double buffer[7776] SIMINT_ALIGN_ARRAY_DBL;

    for(int q = 0; q < ret; q++)
    {
        int idx = 0;
        for(int a = 0; a < 36; ++a)
        for(int b = 0; b < 36; ++b)
        for(int c = 0; c < 1; ++c)
        for(int d = 0; d < 6; ++d)
            buffer[idx++] = INT__k_k_s_d[q*7776+a*216+b*6+d*1+c];

        memcpy(INT__k_k_s_d+q*7776, buffer, 7776*sizeof(double));
    }

    return ret;
}

