#include "simint/boys/boys.h"
#include "simint/ostei/gen/ostei_generated.h"
#include "simint/vectorization/vectorization.h"
#include <math.h>
#include <string.h>


int ostei_k_k_f_d(struct simint_multi_shellpair const P,
                  struct simint_multi_shellpair const Q,
                  double screen_tol,
                  double * const restrict work,
                  double * const restrict INT__k_k_f_d)
{

    SIMINT_ASSUME_ALIGN_DBL(work);
    SIMINT_ASSUME_ALIGN_DBL(INT__k_k_f_d);
    int ab, cd, abcd;
    int istart, jstart;
    int iprimcd, nprim_icd, icd;
    const int check_screen = (screen_tol > 0.0);
    int i, j;
    int n;
    int not_screened;
    int real_abcd;
    int iket;
    int ibra;

    // partition workspace
    double * const INT__k_s_f_s = work + (SIMINT_NSHELL_SIMD * 0);
    double * const INT__k_s_g_s = work + (SIMINT_NSHELL_SIMD * 360);
    double * const INT__k_s_h_s = work + (SIMINT_NSHELL_SIMD * 900);
    double * const INT__l_s_f_s = work + (SIMINT_NSHELL_SIMD * 1656);
    double * const INT__l_s_g_s = work + (SIMINT_NSHELL_SIMD * 2106);
    double * const INT__l_s_h_s = work + (SIMINT_NSHELL_SIMD * 2781);
    double * const INT__m_s_f_s = work + (SIMINT_NSHELL_SIMD * 3726);
    double * const INT__m_s_g_s = work + (SIMINT_NSHELL_SIMD * 4276);
    double * const INT__m_s_h_s = work + (SIMINT_NSHELL_SIMD * 5101);
    double * const INT__n_s_f_s = work + (SIMINT_NSHELL_SIMD * 6256);
    double * const INT__n_s_g_s = work + (SIMINT_NSHELL_SIMD * 6916);
    double * const INT__n_s_h_s = work + (SIMINT_NSHELL_SIMD * 7906);
    double * const INT__o_s_f_s = work + (SIMINT_NSHELL_SIMD * 9292);
    double * const INT__o_s_g_s = work + (SIMINT_NSHELL_SIMD * 10072);
    double * const INT__o_s_h_s = work + (SIMINT_NSHELL_SIMD * 11242);
    double * const INT__q_s_f_s = work + (SIMINT_NSHELL_SIMD * 12880);
    double * const INT__q_s_g_s = work + (SIMINT_NSHELL_SIMD * 13790);
    double * const INT__q_s_h_s = work + (SIMINT_NSHELL_SIMD * 15155);
    double * const INT__r_s_f_s = work + (SIMINT_NSHELL_SIMD * 17066);
    double * const INT__r_s_g_s = work + (SIMINT_NSHELL_SIMD * 18116);
    double * const INT__r_s_h_s = work + (SIMINT_NSHELL_SIMD * 19691);
    double * const INT__t_s_f_s = work + (SIMINT_NSHELL_SIMD * 21896);
    double * const INT__t_s_g_s = work + (SIMINT_NSHELL_SIMD * 23096);
    double * const INT__t_s_h_s = work + (SIMINT_NSHELL_SIMD * 24896);
    SIMINT_DBLTYPE * const primwork = (SIMINT_DBLTYPE *)(work + SIMINT_NSHELL_SIMD*27416);
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_s_s = primwork + 0;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_s_s = primwork + 20;
    SIMINT_DBLTYPE * const restrict PRIM_INT__d_s_s_s = primwork + 77;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_s_s = primwork + 185;
    SIMINT_DBLTYPE * const restrict PRIM_INT__f_s_p_s = primwork + 355;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_s_s = primwork + 505;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_p_s = primwork + 745;
    SIMINT_DBLTYPE * const restrict PRIM_INT__g_s_d_s = primwork + 970;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_s_s = primwork + 1330;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_p_s = primwork + 1645;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_d_s = primwork + 1960;
    SIMINT_DBLTYPE * const restrict PRIM_INT__h_s_f_s = primwork + 2464;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_s_s = primwork + 3094;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_p_s = primwork + 3486;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_d_s = primwork + 3906;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_f_s = primwork + 4578;
    SIMINT_DBLTYPE * const restrict PRIM_INT__i_s_g_s = primwork + 5418;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_s_s = primwork + 6258;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_p_s = primwork + 6726;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_d_s = primwork + 7266;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_f_s = primwork + 8130;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_g_s = primwork + 9210;
    SIMINT_DBLTYPE * const restrict PRIM_INT__k_s_h_s = primwork + 10290;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_s_s = primwork + 11046;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_p_s = primwork + 11586;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_d_s = primwork + 12261;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_f_s = primwork + 13341;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_g_s = primwork + 14691;
    SIMINT_DBLTYPE * const restrict PRIM_INT__l_s_h_s = primwork + 16041;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_s_s = primwork + 16986;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_p_s = primwork + 17591;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_d_s = primwork + 18416;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_f_s = primwork + 19736;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_g_s = primwork + 21386;
    SIMINT_DBLTYPE * const restrict PRIM_INT__m_s_h_s = primwork + 23036;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_s_s = primwork + 24191;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_p_s = primwork + 24851;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_d_s = primwork + 25841;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_f_s = primwork + 27425;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_g_s = primwork + 29405;
    SIMINT_DBLTYPE * const restrict PRIM_INT__n_s_h_s = primwork + 31385;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_s_s = primwork + 32771;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_p_s = primwork + 33473;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_d_s = primwork + 34643;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_f_s = primwork + 36515;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_g_s = primwork + 38855;
    SIMINT_DBLTYPE * const restrict PRIM_INT__o_s_h_s = primwork + 41195;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_s_s = primwork + 42833;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_p_s = primwork + 43561;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_d_s = primwork + 44926;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_f_s = primwork + 47110;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_g_s = primwork + 49840;
    SIMINT_DBLTYPE * const restrict PRIM_INT__q_s_h_s = primwork + 52570;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_s_s = primwork + 54481;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_p_s = primwork + 55216;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_d_s = primwork + 56791;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_f_s = primwork + 59311;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_g_s = primwork + 62461;
    SIMINT_DBLTYPE * const restrict PRIM_INT__r_s_h_s = primwork + 65611;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_s_s = primwork + 67816;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_p_s = primwork + 68536;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_d_s = primwork + 70336;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_f_s = primwork + 73216;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_g_s = primwork + 76816;
    SIMINT_DBLTYPE * const restrict PRIM_INT__t_s_h_s = primwork + 80416;
    double * const hrrwork = (double *)(primwork + 82936);
    double * const HRR_INT__k_p_f_s = hrrwork + 0;
    double * const HRR_INT__k_p_g_s = hrrwork + 1080;
    double * const HRR_INT__k_p_h_s = hrrwork + 2700;
    double * const HRR_INT__k_d_f_s = hrrwork + 4968;
    double * const HRR_INT__k_d_g_s = hrrwork + 7128;
    double * const HRR_INT__k_d_h_s = hrrwork + 10368;
    double * const HRR_INT__k_f_f_s = hrrwork + 14904;
    double * const HRR_INT__k_f_g_s = hrrwork + 18504;
    double * const HRR_INT__k_f_h_s = hrrwork + 23904;
    double * const HRR_INT__k_g_f_s = hrrwork + 31464;
    double * const HRR_INT__k_g_g_s = hrrwork + 36864;
    double * const HRR_INT__k_g_h_s = hrrwork + 44964;
    double * const HRR_INT__k_h_f_s = hrrwork + 56304;
    double * const HRR_INT__k_h_g_s = hrrwork + 63864;
    double * const HRR_INT__k_h_h_s = hrrwork + 75204;
    double * const HRR_INT__k_i_f_s = hrrwork + 91080;
    double * const HRR_INT__k_i_g_s = hrrwork + 101160;
    double * const HRR_INT__k_i_h_s = hrrwork + 116280;
    double * const HRR_INT__k_k_f_s = hrrwork + 137448;
    double * const HRR_INT__k_k_f_p = hrrwork + 150408;
    double * const HRR_INT__k_k_g_s = hrrwork + 189288;
    double * const HRR_INT__k_k_g_p = hrrwork + 208728;
    double * const HRR_INT__k_k_h_s = hrrwork + 267048;
    double * const HRR_INT__l_p_f_s = hrrwork + 294264;
    double * const HRR_INT__l_p_g_s = hrrwork + 295614;
    double * const HRR_INT__l_p_h_s = hrrwork + 297639;
    double * const HRR_INT__l_d_f_s = hrrwork + 300474;
    double * const HRR_INT__l_d_g_s = hrrwork + 303174;
    double * const HRR_INT__l_d_h_s = hrrwork + 307224;
    double * const HRR_INT__l_f_f_s = hrrwork + 312894;
    double * const HRR_INT__l_f_g_s = hrrwork + 317394;
    double * const HRR_INT__l_f_h_s = hrrwork + 324144;
    double * const HRR_INT__l_g_f_s = hrrwork + 333594;
    double * const HRR_INT__l_g_g_s = hrrwork + 340344;
    double * const HRR_INT__l_g_h_s = hrrwork + 350469;
    double * const HRR_INT__l_h_f_s = hrrwork + 364644;
    double * const HRR_INT__l_h_g_s = hrrwork + 374094;
    double * const HRR_INT__l_h_h_s = hrrwork + 388269;
    double * const HRR_INT__l_i_f_s = hrrwork + 408114;
    double * const HRR_INT__l_i_g_s = hrrwork + 420714;
    double * const HRR_INT__l_i_h_s = hrrwork + 439614;
    double * const HRR_INT__m_p_f_s = hrrwork + 466074;
    double * const HRR_INT__m_p_g_s = hrrwork + 467724;
    double * const HRR_INT__m_p_h_s = hrrwork + 470199;
    double * const HRR_INT__m_d_f_s = hrrwork + 473664;
    double * const HRR_INT__m_d_g_s = hrrwork + 476964;
    double * const HRR_INT__m_d_h_s = hrrwork + 481914;
    double * const HRR_INT__m_f_f_s = hrrwork + 488844;
    double * const HRR_INT__m_f_g_s = hrrwork + 494344;
    double * const HRR_INT__m_f_h_s = hrrwork + 502594;
    double * const HRR_INT__m_g_f_s = hrrwork + 514144;
    double * const HRR_INT__m_g_g_s = hrrwork + 522394;
    double * const HRR_INT__m_g_h_s = hrrwork + 534769;
    double * const HRR_INT__m_h_f_s = hrrwork + 552094;
    double * const HRR_INT__m_h_g_s = hrrwork + 563644;
    double * const HRR_INT__m_h_h_s = hrrwork + 580969;
    double * const HRR_INT__n_p_f_s = hrrwork + 605224;
    double * const HRR_INT__n_p_g_s = hrrwork + 607204;
    double * const HRR_INT__n_p_h_s = hrrwork + 610174;
    double * const HRR_INT__n_d_f_s = hrrwork + 614332;
    double * const HRR_INT__n_d_g_s = hrrwork + 618292;
    double * const HRR_INT__n_d_h_s = hrrwork + 624232;
    double * const HRR_INT__n_f_f_s = hrrwork + 632548;
    double * const HRR_INT__n_f_g_s = hrrwork + 639148;
    double * const HRR_INT__n_f_h_s = hrrwork + 649048;
    double * const HRR_INT__n_g_f_s = hrrwork + 662908;
    double * const HRR_INT__n_g_g_s = hrrwork + 672808;
    double * const HRR_INT__n_g_h_s = hrrwork + 687658;
    double * const HRR_INT__o_p_f_s = hrrwork + 708448;
    double * const HRR_INT__o_p_g_s = hrrwork + 710788;
    double * const HRR_INT__o_p_h_s = hrrwork + 714298;
    double * const HRR_INT__o_d_f_s = hrrwork + 719212;
    double * const HRR_INT__o_d_g_s = hrrwork + 723892;
    double * const HRR_INT__o_d_h_s = hrrwork + 730912;
    double * const HRR_INT__o_f_f_s = hrrwork + 740740;
    double * const HRR_INT__o_f_g_s = hrrwork + 748540;
    double * const HRR_INT__o_f_h_s = hrrwork + 760240;
    double * const HRR_INT__q_p_f_s = hrrwork + 776620;
    double * const HRR_INT__q_p_g_s = hrrwork + 779350;
    double * const HRR_INT__q_p_h_s = hrrwork + 783445;
    double * const HRR_INT__q_d_f_s = hrrwork + 789178;
    double * const HRR_INT__q_d_g_s = hrrwork + 794638;
    double * const HRR_INT__q_d_h_s = hrrwork + 802828;
    double * const HRR_INT__r_p_f_s = hrrwork + 814294;
    double * const HRR_INT__r_p_g_s = hrrwork + 817444;
    double * const HRR_INT__r_p_h_s = hrrwork + 822169;


    // Create constants
    const SIMINT_DBLTYPE const_1 = SIMINT_DBLSET1(1);
    const SIMINT_DBLTYPE const_10 = SIMINT_DBLSET1(10);
    const SIMINT_DBLTYPE const_11 = SIMINT_DBLSET1(11);
    const SIMINT_DBLTYPE const_12 = SIMINT_DBLSET1(12);
    const SIMINT_DBLTYPE const_13 = SIMINT_DBLSET1(13);
    const SIMINT_DBLTYPE const_14 = SIMINT_DBLSET1(14);
    const SIMINT_DBLTYPE const_2 = SIMINT_DBLSET1(2);
    const SIMINT_DBLTYPE const_3 = SIMINT_DBLSET1(3);
    const SIMINT_DBLTYPE const_4 = SIMINT_DBLSET1(4);
    const SIMINT_DBLTYPE const_5 = SIMINT_DBLSET1(5);
    const SIMINT_DBLTYPE const_6 = SIMINT_DBLSET1(6);
    const SIMINT_DBLTYPE const_7 = SIMINT_DBLSET1(7);
    const SIMINT_DBLTYPE const_8 = SIMINT_DBLSET1(8);
    const SIMINT_DBLTYPE const_9 = SIMINT_DBLSET1(9);
    const SIMINT_DBLTYPE one_half = SIMINT_DBLSET1(0.5);


    ////////////////////////////////////////
    // Loop over shells and primitives
    ////////////////////////////////////////

    real_abcd = 0;
    istart = 0;
    for(ab = 0; ab < P.nshell12_clip; ++ab)
    {
        const int iend = istart + P.nprim12[ab];

        cd = 0;
        jstart = 0;

        for(cd = 0; cd < Q.nshell12_clip; cd += SIMINT_NSHELL_SIMD)
        {
            const int nshellbatch = ((cd + SIMINT_NSHELL_SIMD) > Q.nshell12_clip) ? Q.nshell12_clip - cd : SIMINT_NSHELL_SIMD;
            int jend = jstart;
            for(i = 0; i < nshellbatch; i++)
                jend += Q.nprim12[cd+i];

            // Clear the beginning of the workspace (where we are accumulating integrals)
            memset(work, 0, SIMINT_NSHELL_SIMD * 27416 * sizeof(double));
            abcd = 0;


            for(i = istart; i < iend; ++i)
            {
                SIMINT_DBLTYPE bra_screen_max;  // only used if check_screen

                if(check_screen)
                {
                    // Skip this whole thing if always insignificant
                    if((P.screen[i] * Q.screen_max) < screen_tol)
                        continue;
                    bra_screen_max = SIMINT_DBLSET1(P.screen[i]);
                }

                icd = 0;
                iprimcd = 0;
                nprim_icd = Q.nprim12[cd];
                double * restrict PRIM_PTR_INT__k_s_f_s = INT__k_s_f_s + abcd * 360;
                double * restrict PRIM_PTR_INT__k_s_g_s = INT__k_s_g_s + abcd * 540;
                double * restrict PRIM_PTR_INT__k_s_h_s = INT__k_s_h_s + abcd * 756;
                double * restrict PRIM_PTR_INT__l_s_f_s = INT__l_s_f_s + abcd * 450;
                double * restrict PRIM_PTR_INT__l_s_g_s = INT__l_s_g_s + abcd * 675;
                double * restrict PRIM_PTR_INT__l_s_h_s = INT__l_s_h_s + abcd * 945;
                double * restrict PRIM_PTR_INT__m_s_f_s = INT__m_s_f_s + abcd * 550;
                double * restrict PRIM_PTR_INT__m_s_g_s = INT__m_s_g_s + abcd * 825;
                double * restrict PRIM_PTR_INT__m_s_h_s = INT__m_s_h_s + abcd * 1155;
                double * restrict PRIM_PTR_INT__n_s_f_s = INT__n_s_f_s + abcd * 660;
                double * restrict PRIM_PTR_INT__n_s_g_s = INT__n_s_g_s + abcd * 990;
                double * restrict PRIM_PTR_INT__n_s_h_s = INT__n_s_h_s + abcd * 1386;
                double * restrict PRIM_PTR_INT__o_s_f_s = INT__o_s_f_s + abcd * 780;
                double * restrict PRIM_PTR_INT__o_s_g_s = INT__o_s_g_s + abcd * 1170;
                double * restrict PRIM_PTR_INT__o_s_h_s = INT__o_s_h_s + abcd * 1638;
                double * restrict PRIM_PTR_INT__q_s_f_s = INT__q_s_f_s + abcd * 910;
                double * restrict PRIM_PTR_INT__q_s_g_s = INT__q_s_g_s + abcd * 1365;
                double * restrict PRIM_PTR_INT__q_s_h_s = INT__q_s_h_s + abcd * 1911;
                double * restrict PRIM_PTR_INT__r_s_f_s = INT__r_s_f_s + abcd * 1050;
                double * restrict PRIM_PTR_INT__r_s_g_s = INT__r_s_g_s + abcd * 1575;
                double * restrict PRIM_PTR_INT__r_s_h_s = INT__r_s_h_s + abcd * 2205;
                double * restrict PRIM_PTR_INT__t_s_f_s = INT__t_s_f_s + abcd * 1200;
                double * restrict PRIM_PTR_INT__t_s_g_s = INT__t_s_g_s + abcd * 1800;
                double * restrict PRIM_PTR_INT__t_s_h_s = INT__t_s_h_s + abcd * 2520;



                // Load these one per loop over i
                const SIMINT_DBLTYPE P_alpha = SIMINT_DBLSET1(P.alpha[i]);
                const SIMINT_DBLTYPE P_prefac = SIMINT_DBLSET1(P.prefac[i]);
                const SIMINT_DBLTYPE Pxyz[3] = { SIMINT_DBLSET1(P.x[i]), SIMINT_DBLSET1(P.y[i]), SIMINT_DBLSET1(P.z[i]) };

                const SIMINT_DBLTYPE P_PA[3] = { SIMINT_DBLSET1(P.PA_x[i]), SIMINT_DBLSET1(P.PA_y[i]), SIMINT_DBLSET1(P.PA_z[i]) };

                for(j = jstart; j < jend; j += SIMINT_SIMD_LEN)
                {
                    // calculate the shell offsets
                    // these are the offset from the shell pointed to by cd
                    // for each element
                    int shelloffsets[SIMINT_SIMD_LEN] = {0};
                    int lastoffset = 0;
                    const int nlane = ( ((j + SIMINT_SIMD_LEN) < jend) ? SIMINT_SIMD_LEN : (jend - j));

                    if((iprimcd + SIMINT_SIMD_LEN) >= nprim_icd)
                    {
                        // Handle if the first element of the vector is a new shell
                        if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                        {
                            nprim_icd += Q.nprim12[cd + (++icd)];
                            PRIM_PTR_INT__k_s_f_s += 360;
                            PRIM_PTR_INT__k_s_g_s += 540;
                            PRIM_PTR_INT__k_s_h_s += 756;
                            PRIM_PTR_INT__l_s_f_s += 450;
                            PRIM_PTR_INT__l_s_g_s += 675;
                            PRIM_PTR_INT__l_s_h_s += 945;
                            PRIM_PTR_INT__m_s_f_s += 550;
                            PRIM_PTR_INT__m_s_g_s += 825;
                            PRIM_PTR_INT__m_s_h_s += 1155;
                            PRIM_PTR_INT__n_s_f_s += 660;
                            PRIM_PTR_INT__n_s_g_s += 990;
                            PRIM_PTR_INT__n_s_h_s += 1386;
                            PRIM_PTR_INT__o_s_f_s += 780;
                            PRIM_PTR_INT__o_s_g_s += 1170;
                            PRIM_PTR_INT__o_s_h_s += 1638;
                            PRIM_PTR_INT__q_s_f_s += 910;
                            PRIM_PTR_INT__q_s_g_s += 1365;
                            PRIM_PTR_INT__q_s_h_s += 1911;
                            PRIM_PTR_INT__r_s_f_s += 1050;
                            PRIM_PTR_INT__r_s_g_s += 1575;
                            PRIM_PTR_INT__r_s_h_s += 2205;
                            PRIM_PTR_INT__t_s_f_s += 1200;
                            PRIM_PTR_INT__t_s_g_s += 1800;
                            PRIM_PTR_INT__t_s_h_s += 2520;
                        }
                        iprimcd++;
                        for(n = 1; n < SIMINT_SIMD_LEN; ++n)
                        {
                            if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                            {
                                shelloffsets[n] = shelloffsets[n-1] + 1;
                                lastoffset++;
                                nprim_icd += Q.nprim12[cd + (++icd)];
                            }
                            else
                                shelloffsets[n] = shelloffsets[n-1];
                            iprimcd++;
                        }
                    }
                    else
                        iprimcd += SIMINT_SIMD_LEN;

                    // Do we have to compute this vector (or has it been screened out)?
                    // (not_screened != 0 means we have to do this vector)
                    if(check_screen)
                    {
                        const double vmax = vector_max(SIMINT_MUL(bra_screen_max, SIMINT_DBLLOAD(Q.screen, j)));
                        if(vmax < screen_tol)
                        {
                            PRIM_PTR_INT__k_s_f_s += lastoffset*360;
                            PRIM_PTR_INT__k_s_g_s += lastoffset*540;
                            PRIM_PTR_INT__k_s_h_s += lastoffset*756;
                            PRIM_PTR_INT__l_s_f_s += lastoffset*450;
                            PRIM_PTR_INT__l_s_g_s += lastoffset*675;
                            PRIM_PTR_INT__l_s_h_s += lastoffset*945;
                            PRIM_PTR_INT__m_s_f_s += lastoffset*550;
                            PRIM_PTR_INT__m_s_g_s += lastoffset*825;
                            PRIM_PTR_INT__m_s_h_s += lastoffset*1155;
                            PRIM_PTR_INT__n_s_f_s += lastoffset*660;
                            PRIM_PTR_INT__n_s_g_s += lastoffset*990;
                            PRIM_PTR_INT__n_s_h_s += lastoffset*1386;
                            PRIM_PTR_INT__o_s_f_s += lastoffset*780;
                            PRIM_PTR_INT__o_s_g_s += lastoffset*1170;
                            PRIM_PTR_INT__o_s_h_s += lastoffset*1638;
                            PRIM_PTR_INT__q_s_f_s += lastoffset*910;
                            PRIM_PTR_INT__q_s_g_s += lastoffset*1365;
                            PRIM_PTR_INT__q_s_h_s += lastoffset*1911;
                            PRIM_PTR_INT__r_s_f_s += lastoffset*1050;
                            PRIM_PTR_INT__r_s_g_s += lastoffset*1575;
                            PRIM_PTR_INT__r_s_h_s += lastoffset*2205;
                            PRIM_PTR_INT__t_s_f_s += lastoffset*1200;
                            PRIM_PTR_INT__t_s_g_s += lastoffset*1800;
                            PRIM_PTR_INT__t_s_h_s += lastoffset*2520;
                            continue;
                        }
                    }

                    const SIMINT_DBLTYPE Q_alpha = SIMINT_DBLLOAD(Q.alpha, j);
                    const SIMINT_DBLTYPE PQalpha_mul = SIMINT_MUL(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE PQalpha_sum = SIMINT_ADD(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE one_over_PQalpha_sum = SIMINT_DIV(const_1, PQalpha_sum);


                    /* construct R2 = (Px - Qx)**2 + (Py - Qy)**2 + (Pz -Qz)**2 */
                    SIMINT_DBLTYPE PQ[3];
                    PQ[0] = SIMINT_SUB(Pxyz[0], SIMINT_DBLLOAD(Q.x, j));
                    PQ[1] = SIMINT_SUB(Pxyz[1], SIMINT_DBLLOAD(Q.y, j));
                    PQ[2] = SIMINT_SUB(Pxyz[2], SIMINT_DBLLOAD(Q.z, j));
                    SIMINT_DBLTYPE R2 = SIMINT_MUL(PQ[0], PQ[0]);
                    R2 = SIMINT_FMADD(PQ[1], PQ[1], R2);
                    R2 = SIMINT_FMADD(PQ[2], PQ[2], R2);

                    const SIMINT_DBLTYPE alpha = SIMINT_MUL(PQalpha_mul, one_over_PQalpha_sum); // alpha from MEST
                    const SIMINT_DBLTYPE one_over_p = SIMINT_DIV(const_1, P_alpha);
                    const SIMINT_DBLTYPE one_over_q = SIMINT_DIV(const_1, Q_alpha);
                    const SIMINT_DBLTYPE one_over_2p = SIMINT_MUL(one_half, one_over_p);
                    const SIMINT_DBLTYPE one_over_2q = SIMINT_MUL(one_half, one_over_q);
                    const SIMINT_DBLTYPE one_over_2pq = SIMINT_MUL(one_half, one_over_PQalpha_sum);
                    const SIMINT_DBLTYPE Q_PA[3] = { SIMINT_DBLLOAD(Q.PA_x, j), SIMINT_DBLLOAD(Q.PA_y, j), SIMINT_DBLLOAD(Q.PA_z, j) };

                    // NOTE: Minus sign!
                    const SIMINT_DBLTYPE a_over_p = SIMINT_MUL(SIMINT_NEG(alpha), one_over_p);
                    SIMINT_DBLTYPE aop_PQ[3];
                    aop_PQ[0] = SIMINT_MUL(a_over_p, PQ[0]);
                    aop_PQ[1] = SIMINT_MUL(a_over_p, PQ[1]);
                    aop_PQ[2] = SIMINT_MUL(a_over_p, PQ[2]);

                    SIMINT_DBLTYPE a_over_q = SIMINT_MUL(alpha, one_over_q);
                    SIMINT_DBLTYPE aoq_PQ[3];
                    aoq_PQ[0] = SIMINT_MUL(a_over_q, PQ[0]);
                    aoq_PQ[1] = SIMINT_MUL(a_over_q, PQ[1]);
                    aoq_PQ[2] = SIMINT_MUL(a_over_q, PQ[2]);
                    // Put a minus sign here so we don't have to in RR routines
                    a_over_q = SIMINT_NEG(a_over_q);


                    //////////////////////////////////////////////
                    // Fjt function section
                    // Maximum v value: 19
                    //////////////////////////////////////////////
                    // The parameter to the Fjt function
                    const SIMINT_DBLTYPE F_x = SIMINT_MUL(R2, alpha);


                    const SIMINT_DBLTYPE Q_prefac = mask_load(nlane, Q.prefac + j);


                    boys_F_split(PRIM_INT__s_s_s_s, F_x, 19);
                    SIMINT_DBLTYPE prefac = SIMINT_SQRT(one_over_PQalpha_sum);
                    prefac = SIMINT_MUL(SIMINT_MUL(P_prefac, Q_prefac), prefac);
                    for(n = 0; n <= 19; n++)
                        PRIM_INT__s_s_s_s[n] = SIMINT_MUL(PRIM_INT__s_s_s_s[n], prefac);

                    //////////////////////////////////////////////
                    // Primitive integrals: Vertical recurrance
                    //////////////////////////////////////////////

                    const SIMINT_DBLTYPE vrr_const_1_over_2p = one_over_2p;
                    const SIMINT_DBLTYPE vrr_const_2_over_2p = SIMINT_MUL(const_2, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_3_over_2p = SIMINT_MUL(const_3, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_4_over_2p = SIMINT_MUL(const_4, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_5_over_2p = SIMINT_MUL(const_5, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_6_over_2p = SIMINT_MUL(const_6, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_7_over_2p = SIMINT_MUL(const_7, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_8_over_2p = SIMINT_MUL(const_8, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_9_over_2p = SIMINT_MUL(const_9, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_10_over_2p = SIMINT_MUL(const_10, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_11_over_2p = SIMINT_MUL(const_11, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_12_over_2p = SIMINT_MUL(const_12, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_13_over_2p = SIMINT_MUL(const_13, one_over_2p);
                    const SIMINT_DBLTYPE vrr_const_1_over_2q = one_over_2q;
                    const SIMINT_DBLTYPE vrr_const_2_over_2q = SIMINT_MUL(const_2, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_3_over_2q = SIMINT_MUL(const_3, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_4_over_2q = SIMINT_MUL(const_4, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_1_over_2pq = one_over_2pq;
                    const SIMINT_DBLTYPE vrr_const_2_over_2pq = SIMINT_MUL(const_2, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_3_over_2pq = SIMINT_MUL(const_3, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_4_over_2pq = SIMINT_MUL(const_4, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_5_over_2pq = SIMINT_MUL(const_5, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_6_over_2pq = SIMINT_MUL(const_6, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_7_over_2pq = SIMINT_MUL(const_7, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_8_over_2pq = SIMINT_MUL(const_8, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_9_over_2pq = SIMINT_MUL(const_9, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_10_over_2pq = SIMINT_MUL(const_10, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_11_over_2pq = SIMINT_MUL(const_11, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_12_over_2pq = SIMINT_MUL(const_12, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_13_over_2pq = SIMINT_MUL(const_13, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_14_over_2pq = SIMINT_MUL(const_14, one_over_2pq);



                    // Forming PRIM_INT__p_s_s_s[19 * 3];
                    for(n = 0; n < 19; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__p_s_s_s[n * 3 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__p_s_s_s[n * 3 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__p_s_s_s[n * 3 + 0]);

                        PRIM_INT__p_s_s_s[n * 3 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__p_s_s_s[n * 3 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__p_s_s_s[n * 3 + 1]);

                        PRIM_INT__p_s_s_s[n * 3 + 2] = SIMINT_MUL(P_PA[2], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__p_s_s_s[n * 3 + 2] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__p_s_s_s[n * 3 + 2]);

                    }



                    // Forming PRIM_INT__d_s_s_s[18 * 6];
                    for(n = 0; n < 18; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__d_s_s_s[n * 6 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__p_s_s_s[n * 3 + 0]);
                        PRIM_INT__d_s_s_s[n * 6 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__p_s_s_s[(n+1) * 3 + 0], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__d_s_s_s[n * 6 + 0] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__d_s_s_s[n * 6 + 0]);

                        PRIM_INT__d_s_s_s[n * 6 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__p_s_s_s[n * 3 + 0]);
                        PRIM_INT__d_s_s_s[n * 6 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__p_s_s_s[(n+1) * 3 + 0], PRIM_INT__d_s_s_s[n * 6 + 1]);

                        PRIM_INT__d_s_s_s[n * 6 + 2] = SIMINT_MUL(P_PA[2], PRIM_INT__p_s_s_s[n * 3 + 0]);
                        PRIM_INT__d_s_s_s[n * 6 + 2] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__p_s_s_s[(n+1) * 3 + 0], PRIM_INT__d_s_s_s[n * 6 + 2]);

                        PRIM_INT__d_s_s_s[n * 6 + 3] = SIMINT_MUL(P_PA[1], PRIM_INT__p_s_s_s[n * 3 + 1]);
                        PRIM_INT__d_s_s_s[n * 6 + 3] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__p_s_s_s[(n+1) * 3 + 1], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__d_s_s_s[n * 6 + 3] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__d_s_s_s[n * 6 + 3]);

                        PRIM_INT__d_s_s_s[n * 6 + 4] = SIMINT_MUL(P_PA[2], PRIM_INT__p_s_s_s[n * 3 + 1]);
                        PRIM_INT__d_s_s_s[n * 6 + 4] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__p_s_s_s[(n+1) * 3 + 1], PRIM_INT__d_s_s_s[n * 6 + 4]);

                        PRIM_INT__d_s_s_s[n * 6 + 5] = SIMINT_MUL(P_PA[2], PRIM_INT__p_s_s_s[n * 3 + 2]);
                        PRIM_INT__d_s_s_s[n * 6 + 5] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__p_s_s_s[(n+1) * 3 + 2], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__d_s_s_s[n * 6 + 5] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__d_s_s_s[n * 6 + 5]);

                    }



                    // Forming PRIM_INT__f_s_s_s[17 * 10];
                    for(n = 0; n < 17; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__f_s_s_s[n * 10 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 0] = SIMINT_FMADD( vrr_const_2_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__p_s_s_s[(n+1) * 3 + 0], PRIM_INT__p_s_s_s[n * 3 + 0]), PRIM_INT__f_s_s_s[n * 10 + 0]);

                        PRIM_INT__f_s_s_s[n * 10 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_s_s[n * 10 + 1]);

                        PRIM_INT__f_s_s_s[n * 10 + 2] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 0]);
                        PRIM_INT__f_s_s_s[n * 10 + 2] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_s_s[n * 10 + 2]);

                        PRIM_INT__f_s_s_s[n * 10 + 3] = SIMINT_MUL(P_PA[0], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__f_s_s_s[n * 10 + 3] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_s_s[n * 10 + 3]);

                        PRIM_INT__f_s_s_s[n * 10 + 4] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 1]);
                        PRIM_INT__f_s_s_s[n * 10 + 4] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 1], PRIM_INT__f_s_s_s[n * 10 + 4]);

                        PRIM_INT__f_s_s_s[n * 10 + 5] = SIMINT_MUL(P_PA[0], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__f_s_s_s[n * 10 + 5] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__f_s_s_s[n * 10 + 5]);

                        PRIM_INT__f_s_s_s[n * 10 + 6] = SIMINT_MUL(P_PA[1], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__f_s_s_s[n * 10 + 6] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__f_s_s_s[n * 10 + 6] = SIMINT_FMADD( vrr_const_2_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__p_s_s_s[(n+1) * 3 + 1], PRIM_INT__p_s_s_s[n * 3 + 1]), PRIM_INT__f_s_s_s[n * 10 + 6]);

                        PRIM_INT__f_s_s_s[n * 10 + 7] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 3]);
                        PRIM_INT__f_s_s_s[n * 10 + 7] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_s_s[n * 10 + 7]);

                        PRIM_INT__f_s_s_s[n * 10 + 8] = SIMINT_MUL(P_PA[1], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__f_s_s_s[n * 10 + 8] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__f_s_s_s[n * 10 + 8]);

                        PRIM_INT__f_s_s_s[n * 10 + 9] = SIMINT_MUL(P_PA[2], PRIM_INT__d_s_s_s[n * 6 + 5]);
                        PRIM_INT__f_s_s_s[n * 10 + 9] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__f_s_s_s[n * 10 + 9] = SIMINT_FMADD( vrr_const_2_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__p_s_s_s[(n+1) * 3 + 2], PRIM_INT__p_s_s_s[n * 3 + 2]), PRIM_INT__f_s_s_s[n * 10 + 9]);

                    }



                    // Forming PRIM_INT__g_s_s_s[16 * 15];
                    for(n = 0; n < 16; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__g_s_s_s[n * 15 + 0] = SIMINT_MUL(P_PA[0], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__g_s_s_s[n * 15 + 0] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 0], PRIM_INT__g_s_s_s[n * 15 + 0]);
                        PRIM_INT__g_s_s_s[n * 15 + 0] = SIMINT_FMADD( vrr_const_3_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__d_s_s_s[n * 6 + 0]), PRIM_INT__g_s_s_s[n * 15 + 0]);

                        PRIM_INT__g_s_s_s[n * 15 + 1] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__g_s_s_s[n * 15 + 1] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 0], PRIM_INT__g_s_s_s[n * 15 + 1]);

                        PRIM_INT__g_s_s_s[n * 15 + 2] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__g_s_s_s[n * 15 + 2] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 0], PRIM_INT__g_s_s_s[n * 15 + 2]);

                        PRIM_INT__g_s_s_s[n * 15 + 3] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 1]);
                        PRIM_INT__g_s_s_s[n * 15 + 3] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 1], PRIM_INT__g_s_s_s[n * 15 + 3]);
                        PRIM_INT__g_s_s_s[n * 15 + 3] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__d_s_s_s[n * 6 + 0]), PRIM_INT__g_s_s_s[n * 15 + 3]);

                        PRIM_INT__g_s_s_s[n * 15 + 4] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 1]);
                        PRIM_INT__g_s_s_s[n * 15 + 4] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 1], PRIM_INT__g_s_s_s[n * 15 + 4]);

                        PRIM_INT__g_s_s_s[n * 15 + 5] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 2]);
                        PRIM_INT__g_s_s_s[n * 15 + 5] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 2], PRIM_INT__g_s_s_s[n * 15 + 5]);
                        PRIM_INT__g_s_s_s[n * 15 + 5] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__d_s_s_s[n * 6 + 0]), PRIM_INT__g_s_s_s[n * 15 + 5]);

                        PRIM_INT__g_s_s_s[n * 15 + 6] = SIMINT_MUL(P_PA[0], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__g_s_s_s[n * 15 + 6] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 6], PRIM_INT__g_s_s_s[n * 15 + 6]);

                        PRIM_INT__g_s_s_s[n * 15 + 7] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 3]);
                        PRIM_INT__g_s_s_s[n * 15 + 7] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 3], PRIM_INT__g_s_s_s[n * 15 + 7]);

                        PRIM_INT__g_s_s_s[n * 15 + 8] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 5]);
                        PRIM_INT__g_s_s_s[n * 15 + 8] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 5], PRIM_INT__g_s_s_s[n * 15 + 8]);

                        PRIM_INT__g_s_s_s[n * 15 + 9] = SIMINT_MUL(P_PA[0], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__g_s_s_s[n * 15 + 9] = SIMINT_FMADD( aop_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 9], PRIM_INT__g_s_s_s[n * 15 + 9]);

                        PRIM_INT__g_s_s_s[n * 15 + 10] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__g_s_s_s[n * 15 + 10] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 6], PRIM_INT__g_s_s_s[n * 15 + 10]);
                        PRIM_INT__g_s_s_s[n * 15 + 10] = SIMINT_FMADD( vrr_const_3_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__d_s_s_s[n * 6 + 3]), PRIM_INT__g_s_s_s[n * 15 + 10]);

                        PRIM_INT__g_s_s_s[n * 15 + 11] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__g_s_s_s[n * 15 + 11] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 6], PRIM_INT__g_s_s_s[n * 15 + 11]);

                        PRIM_INT__g_s_s_s[n * 15 + 12] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 7]);
                        PRIM_INT__g_s_s_s[n * 15 + 12] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 7], PRIM_INT__g_s_s_s[n * 15 + 12]);
                        PRIM_INT__g_s_s_s[n * 15 + 12] = SIMINT_FMADD( vrr_const_1_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__d_s_s_s[n * 6 + 3]), PRIM_INT__g_s_s_s[n * 15 + 12]);

                        PRIM_INT__g_s_s_s[n * 15 + 13] = SIMINT_MUL(P_PA[1], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__g_s_s_s[n * 15 + 13] = SIMINT_FMADD( aop_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 9], PRIM_INT__g_s_s_s[n * 15 + 13]);

                        PRIM_INT__g_s_s_s[n * 15 + 14] = SIMINT_MUL(P_PA[2], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__g_s_s_s[n * 15 + 14] = SIMINT_FMADD( aop_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 9], PRIM_INT__g_s_s_s[n * 15 + 14]);
                        PRIM_INT__g_s_s_s[n * 15 + 14] = SIMINT_FMADD( vrr_const_3_over_2p, SIMINT_FMADD(a_over_p, PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__d_s_s_s[n * 6 + 5]), PRIM_INT__g_s_s_s[n * 15 + 14]);

                    }


                    VRR_I_h_s_s_s(
                            PRIM_INT__h_s_s_s,
                            PRIM_INT__g_s_s_s,
                            PRIM_INT__f_s_s_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            15);


                    VRR_I_i_s_s_s(
                            PRIM_INT__i_s_s_s,
                            PRIM_INT__h_s_s_s,
                            PRIM_INT__g_s_s_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            14);


                    VRR_I_k_s_s_s(
                            PRIM_INT__k_s_s_s,
                            PRIM_INT__i_s_s_s,
                            PRIM_INT__h_s_s_s,
                            P_PA,
                            a_over_p,
                            aop_PQ,
                            one_over_2p,
                            13);


                    ostei_general_vrr_K(7, 0, 1, 0, 5,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_s_s, NULL, NULL, PRIM_INT__i_s_s_s, NULL, PRIM_INT__k_s_p_s);


                    VRR_K_i_s_p_s(
                            PRIM_INT__i_s_p_s,
                            PRIM_INT__i_s_s_s,
                            PRIM_INT__h_s_s_s,
                            Q_PA,
                            aoq_PQ,
                            one_over_2pq,
                            5);


                    ostei_general_vrr_K(7, 0, 2, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_p_s, PRIM_INT__k_s_s_s, NULL, PRIM_INT__i_s_p_s, NULL, PRIM_INT__k_s_d_s);


                    VRR_K_h_s_p_s(
                            PRIM_INT__h_s_p_s,
                            PRIM_INT__h_s_s_s,
                            PRIM_INT__g_s_s_s,
                            Q_PA,
                            aoq_PQ,
                            one_over_2pq,
                            5);


                    ostei_general_vrr_K(6, 0, 2, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__i_s_p_s, PRIM_INT__i_s_s_s, NULL, PRIM_INT__h_s_p_s, NULL, PRIM_INT__i_s_d_s);


                    ostei_general_vrr_K(7, 0, 3, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_d_s, PRIM_INT__k_s_p_s, NULL, PRIM_INT__i_s_d_s, NULL, PRIM_INT__k_s_f_s);


                    VRR_K_g_s_p_s(
                            PRIM_INT__g_s_p_s,
                            PRIM_INT__g_s_s_s,
                            PRIM_INT__f_s_s_s,
                            Q_PA,
                            aoq_PQ,
                            one_over_2pq,
                            5);


                    VRR_K_h_s_d_s(
                            PRIM_INT__h_s_d_s,
                            PRIM_INT__h_s_p_s,
                            PRIM_INT__h_s_s_s,
                            PRIM_INT__g_s_p_s,
                            Q_PA,
                            a_over_q,
                            aoq_PQ,
                            one_over_2pq,
                            one_over_2q,
                            4);


                    ostei_general_vrr_K(6, 0, 3, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__i_s_d_s, PRIM_INT__i_s_p_s, NULL, PRIM_INT__h_s_d_s, NULL, PRIM_INT__i_s_f_s);


                    ostei_general_vrr_K(7, 0, 4, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_f_s, PRIM_INT__k_s_d_s, NULL, PRIM_INT__i_s_f_s, NULL, PRIM_INT__k_s_g_s);


                    ostei_general_vrr1_I(8, 12,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__k_s_s_s, PRIM_INT__i_s_s_s, PRIM_INT__l_s_s_s);


                    ostei_general_vrr_K(8, 0, 1, 0, 5,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_s_s, NULL, NULL, PRIM_INT__k_s_s_s, NULL, PRIM_INT__l_s_p_s);


                    ostei_general_vrr_K(8, 0, 2, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_p_s, PRIM_INT__l_s_s_s, NULL, PRIM_INT__k_s_p_s, NULL, PRIM_INT__l_s_d_s);


                    ostei_general_vrr_K(8, 0, 3, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_d_s, PRIM_INT__l_s_p_s, NULL, PRIM_INT__k_s_d_s, NULL, PRIM_INT__l_s_f_s);



                    // Forming PRIM_INT__f_s_p_s[5 * 30];
                    for(n = 0; n < 5; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__f_s_p_s[n * 30 + 0] = SIMINT_MUL(Q_PA[0], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__f_s_p_s[n * 30 + 0] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 0], PRIM_INT__f_s_p_s[n * 30 + 0]);
                        PRIM_INT__f_s_p_s[n * 30 + 0] = SIMINT_FMADD( vrr_const_3_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_p_s[n * 30 + 0]);

                        PRIM_INT__f_s_p_s[n * 30 + 1] = SIMINT_MUL(Q_PA[1], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__f_s_p_s[n * 30 + 1] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 0], PRIM_INT__f_s_p_s[n * 30 + 1]);

                        PRIM_INT__f_s_p_s[n * 30 + 2] = SIMINT_MUL(Q_PA[2], PRIM_INT__f_s_s_s[n * 10 + 0]);
                        PRIM_INT__f_s_p_s[n * 30 + 2] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 0], PRIM_INT__f_s_p_s[n * 30 + 2]);

                        PRIM_INT__f_s_p_s[n * 30 + 3] = SIMINT_MUL(Q_PA[0], PRIM_INT__f_s_s_s[n * 10 + 1]);
                        PRIM_INT__f_s_p_s[n * 30 + 3] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 1], PRIM_INT__f_s_p_s[n * 30 + 3]);
                        PRIM_INT__f_s_p_s[n * 30 + 3] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 1], PRIM_INT__f_s_p_s[n * 30 + 3]);

                        PRIM_INT__f_s_p_s[n * 30 + 4] = SIMINT_MUL(Q_PA[1], PRIM_INT__f_s_s_s[n * 10 + 1]);
                        PRIM_INT__f_s_p_s[n * 30 + 4] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 1], PRIM_INT__f_s_p_s[n * 30 + 4]);
                        PRIM_INT__f_s_p_s[n * 30 + 4] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_p_s[n * 30 + 4]);

                        PRIM_INT__f_s_p_s[n * 30 + 5] = SIMINT_MUL(Q_PA[2], PRIM_INT__f_s_s_s[n * 10 + 1]);
                        PRIM_INT__f_s_p_s[n * 30 + 5] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 1], PRIM_INT__f_s_p_s[n * 30 + 5]);

                        PRIM_INT__f_s_p_s[n * 30 + 6] = SIMINT_MUL(Q_PA[0], PRIM_INT__f_s_s_s[n * 10 + 2]);
                        PRIM_INT__f_s_p_s[n * 30 + 6] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 2], PRIM_INT__f_s_p_s[n * 30 + 6]);
                        PRIM_INT__f_s_p_s[n * 30 + 6] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 2], PRIM_INT__f_s_p_s[n * 30 + 6]);

                        PRIM_INT__f_s_p_s[n * 30 + 7] = SIMINT_MUL(Q_PA[1], PRIM_INT__f_s_s_s[n * 10 + 2]);
                        PRIM_INT__f_s_p_s[n * 30 + 7] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 2], PRIM_INT__f_s_p_s[n * 30 + 7]);

                        PRIM_INT__f_s_p_s[n * 30 + 8] = SIMINT_MUL(Q_PA[2], PRIM_INT__f_s_s_s[n * 10 + 2]);
                        PRIM_INT__f_s_p_s[n * 30 + 8] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 2], PRIM_INT__f_s_p_s[n * 30 + 8]);
                        PRIM_INT__f_s_p_s[n * 30 + 8] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 0], PRIM_INT__f_s_p_s[n * 30 + 8]);

                        PRIM_INT__f_s_p_s[n * 30 + 9] = SIMINT_MUL(Q_PA[0], PRIM_INT__f_s_s_s[n * 10 + 3]);
                        PRIM_INT__f_s_p_s[n * 30 + 9] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 3], PRIM_INT__f_s_p_s[n * 30 + 9]);
                        PRIM_INT__f_s_p_s[n * 30 + 9] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_p_s[n * 30 + 9]);

                        PRIM_INT__f_s_p_s[n * 30 + 10] = SIMINT_MUL(Q_PA[1], PRIM_INT__f_s_s_s[n * 10 + 3]);
                        PRIM_INT__f_s_p_s[n * 30 + 10] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 3], PRIM_INT__f_s_p_s[n * 30 + 10]);
                        PRIM_INT__f_s_p_s[n * 30 + 10] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 1], PRIM_INT__f_s_p_s[n * 30 + 10]);

                        PRIM_INT__f_s_p_s[n * 30 + 11] = SIMINT_MUL(Q_PA[2], PRIM_INT__f_s_s_s[n * 10 + 3]);
                        PRIM_INT__f_s_p_s[n * 30 + 11] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 3], PRIM_INT__f_s_p_s[n * 30 + 11]);

                        PRIM_INT__f_s_p_s[n * 30 + 12] = SIMINT_MUL(Q_PA[0], PRIM_INT__f_s_s_s[n * 10 + 4]);
                        PRIM_INT__f_s_p_s[n * 30 + 12] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 4], PRIM_INT__f_s_p_s[n * 30 + 12]);
                        PRIM_INT__f_s_p_s[n * 30 + 12] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 4], PRIM_INT__f_s_p_s[n * 30 + 12]);

                        PRIM_INT__f_s_p_s[n * 30 + 13] = SIMINT_MUL(Q_PA[1], PRIM_INT__f_s_s_s[n * 10 + 4]);
                        PRIM_INT__f_s_p_s[n * 30 + 13] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 4], PRIM_INT__f_s_p_s[n * 30 + 13]);
                        PRIM_INT__f_s_p_s[n * 30 + 13] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 2], PRIM_INT__f_s_p_s[n * 30 + 13]);

                        PRIM_INT__f_s_p_s[n * 30 + 14] = SIMINT_MUL(Q_PA[2], PRIM_INT__f_s_s_s[n * 10 + 4]);
                        PRIM_INT__f_s_p_s[n * 30 + 14] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 4], PRIM_INT__f_s_p_s[n * 30 + 14]);
                        PRIM_INT__f_s_p_s[n * 30 + 14] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 1], PRIM_INT__f_s_p_s[n * 30 + 14]);

                        PRIM_INT__f_s_p_s[n * 30 + 15] = SIMINT_MUL(Q_PA[0], PRIM_INT__f_s_s_s[n * 10 + 5]);
                        PRIM_INT__f_s_p_s[n * 30 + 15] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 5], PRIM_INT__f_s_p_s[n * 30 + 15]);
                        PRIM_INT__f_s_p_s[n * 30 + 15] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__f_s_p_s[n * 30 + 15]);

                        PRIM_INT__f_s_p_s[n * 30 + 16] = SIMINT_MUL(Q_PA[1], PRIM_INT__f_s_s_s[n * 10 + 5]);
                        PRIM_INT__f_s_p_s[n * 30 + 16] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 5], PRIM_INT__f_s_p_s[n * 30 + 16]);

                        PRIM_INT__f_s_p_s[n * 30 + 17] = SIMINT_MUL(Q_PA[2], PRIM_INT__f_s_s_s[n * 10 + 5]);
                        PRIM_INT__f_s_p_s[n * 30 + 17] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 5], PRIM_INT__f_s_p_s[n * 30 + 17]);
                        PRIM_INT__f_s_p_s[n * 30 + 17] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 2], PRIM_INT__f_s_p_s[n * 30 + 17]);

                        PRIM_INT__f_s_p_s[n * 30 + 18] = SIMINT_MUL(Q_PA[0], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__f_s_p_s[n * 30 + 18] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 6], PRIM_INT__f_s_p_s[n * 30 + 18]);

                        PRIM_INT__f_s_p_s[n * 30 + 19] = SIMINT_MUL(Q_PA[1], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__f_s_p_s[n * 30 + 19] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 6], PRIM_INT__f_s_p_s[n * 30 + 19]);
                        PRIM_INT__f_s_p_s[n * 30 + 19] = SIMINT_FMADD( vrr_const_3_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_p_s[n * 30 + 19]);

                        PRIM_INT__f_s_p_s[n * 30 + 20] = SIMINT_MUL(Q_PA[2], PRIM_INT__f_s_s_s[n * 10 + 6]);
                        PRIM_INT__f_s_p_s[n * 30 + 20] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 6], PRIM_INT__f_s_p_s[n * 30 + 20]);

                        PRIM_INT__f_s_p_s[n * 30 + 21] = SIMINT_MUL(Q_PA[0], PRIM_INT__f_s_s_s[n * 10 + 7]);
                        PRIM_INT__f_s_p_s[n * 30 + 21] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 7], PRIM_INT__f_s_p_s[n * 30 + 21]);

                        PRIM_INT__f_s_p_s[n * 30 + 22] = SIMINT_MUL(Q_PA[1], PRIM_INT__f_s_s_s[n * 10 + 7]);
                        PRIM_INT__f_s_p_s[n * 30 + 22] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 7], PRIM_INT__f_s_p_s[n * 30 + 22]);
                        PRIM_INT__f_s_p_s[n * 30 + 22] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 4], PRIM_INT__f_s_p_s[n * 30 + 22]);

                        PRIM_INT__f_s_p_s[n * 30 + 23] = SIMINT_MUL(Q_PA[2], PRIM_INT__f_s_s_s[n * 10 + 7]);
                        PRIM_INT__f_s_p_s[n * 30 + 23] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 7], PRIM_INT__f_s_p_s[n * 30 + 23]);
                        PRIM_INT__f_s_p_s[n * 30 + 23] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 3], PRIM_INT__f_s_p_s[n * 30 + 23]);

                        PRIM_INT__f_s_p_s[n * 30 + 24] = SIMINT_MUL(Q_PA[0], PRIM_INT__f_s_s_s[n * 10 + 8]);
                        PRIM_INT__f_s_p_s[n * 30 + 24] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 8], PRIM_INT__f_s_p_s[n * 30 + 24]);

                        PRIM_INT__f_s_p_s[n * 30 + 25] = SIMINT_MUL(Q_PA[1], PRIM_INT__f_s_s_s[n * 10 + 8]);
                        PRIM_INT__f_s_p_s[n * 30 + 25] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 8], PRIM_INT__f_s_p_s[n * 30 + 25]);
                        PRIM_INT__f_s_p_s[n * 30 + 25] = SIMINT_FMADD( vrr_const_1_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__f_s_p_s[n * 30 + 25]);

                        PRIM_INT__f_s_p_s[n * 30 + 26] = SIMINT_MUL(Q_PA[2], PRIM_INT__f_s_s_s[n * 10 + 8]);
                        PRIM_INT__f_s_p_s[n * 30 + 26] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 8], PRIM_INT__f_s_p_s[n * 30 + 26]);
                        PRIM_INT__f_s_p_s[n * 30 + 26] = SIMINT_FMADD( vrr_const_2_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 4], PRIM_INT__f_s_p_s[n * 30 + 26]);

                        PRIM_INT__f_s_p_s[n * 30 + 27] = SIMINT_MUL(Q_PA[0], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__f_s_p_s[n * 30 + 27] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__f_s_s_s[(n+1) * 10 + 9], PRIM_INT__f_s_p_s[n * 30 + 27]);

                        PRIM_INT__f_s_p_s[n * 30 + 28] = SIMINT_MUL(Q_PA[1], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__f_s_p_s[n * 30 + 28] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__f_s_s_s[(n+1) * 10 + 9], PRIM_INT__f_s_p_s[n * 30 + 28]);

                        PRIM_INT__f_s_p_s[n * 30 + 29] = SIMINT_MUL(Q_PA[2], PRIM_INT__f_s_s_s[n * 10 + 9]);
                        PRIM_INT__f_s_p_s[n * 30 + 29] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__f_s_s_s[(n+1) * 10 + 9], PRIM_INT__f_s_p_s[n * 30 + 29]);
                        PRIM_INT__f_s_p_s[n * 30 + 29] = SIMINT_FMADD( vrr_const_3_over_2pq, PRIM_INT__d_s_s_s[(n+1) * 6 + 5], PRIM_INT__f_s_p_s[n * 30 + 29]);

                    }


                    VRR_K_g_s_d_s(
                            PRIM_INT__g_s_d_s,
                            PRIM_INT__g_s_p_s,
                            PRIM_INT__g_s_s_s,
                            PRIM_INT__f_s_p_s,
                            Q_PA,
                            a_over_q,
                            aoq_PQ,
                            one_over_2pq,
                            one_over_2q,
                            4);


                    ostei_general_vrr_K(5, 0, 3, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__h_s_d_s, PRIM_INT__h_s_p_s, NULL, PRIM_INT__g_s_d_s, NULL, PRIM_INT__h_s_f_s);


                    ostei_general_vrr_K(6, 0, 4, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__i_s_f_s, PRIM_INT__i_s_d_s, NULL, PRIM_INT__h_s_f_s, NULL, PRIM_INT__i_s_g_s);


                    ostei_general_vrr_K(7, 0, 5, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__k_s_g_s, PRIM_INT__k_s_f_s, NULL, PRIM_INT__i_s_g_s, NULL, PRIM_INT__k_s_h_s);


                    ostei_general_vrr_K(8, 0, 4, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_f_s, PRIM_INT__l_s_d_s, NULL, PRIM_INT__k_s_f_s, NULL, PRIM_INT__l_s_g_s);


                    ostei_general_vrr1_I(9, 11,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__l_s_s_s, PRIM_INT__k_s_s_s, PRIM_INT__m_s_s_s);


                    ostei_general_vrr_K(9, 0, 1, 0, 5,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_s_s, NULL, NULL, PRIM_INT__l_s_s_s, NULL, PRIM_INT__m_s_p_s);


                    ostei_general_vrr_K(9, 0, 2, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_p_s, PRIM_INT__m_s_s_s, NULL, PRIM_INT__l_s_p_s, NULL, PRIM_INT__m_s_d_s);


                    ostei_general_vrr_K(9, 0, 3, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_d_s, PRIM_INT__m_s_p_s, NULL, PRIM_INT__l_s_d_s, NULL, PRIM_INT__m_s_f_s);


                    ostei_general_vrr_K(8, 0, 5, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__l_s_g_s, PRIM_INT__l_s_f_s, NULL, PRIM_INT__k_s_g_s, NULL, PRIM_INT__l_s_h_s);


                    ostei_general_vrr_K(9, 0, 4, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_f_s, PRIM_INT__m_s_d_s, NULL, PRIM_INT__l_s_f_s, NULL, PRIM_INT__m_s_g_s);


                    ostei_general_vrr1_I(10, 10,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__m_s_s_s, PRIM_INT__l_s_s_s, PRIM_INT__n_s_s_s);


                    ostei_general_vrr_K(10, 0, 1, 0, 5,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_s_s, NULL, NULL, PRIM_INT__m_s_s_s, NULL, PRIM_INT__n_s_p_s);


                    ostei_general_vrr_K(10, 0, 2, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_p_s, PRIM_INT__n_s_s_s, NULL, PRIM_INT__m_s_p_s, NULL, PRIM_INT__n_s_d_s);


                    ostei_general_vrr_K(10, 0, 3, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_d_s, PRIM_INT__n_s_p_s, NULL, PRIM_INT__m_s_d_s, NULL, PRIM_INT__n_s_f_s);


                    ostei_general_vrr_K(9, 0, 5, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__m_s_g_s, PRIM_INT__m_s_f_s, NULL, PRIM_INT__l_s_g_s, NULL, PRIM_INT__m_s_h_s);


                    ostei_general_vrr_K(10, 0, 4, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_f_s, PRIM_INT__n_s_d_s, NULL, PRIM_INT__m_s_f_s, NULL, PRIM_INT__n_s_g_s);


                    ostei_general_vrr1_I(11, 9,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__n_s_s_s, PRIM_INT__m_s_s_s, PRIM_INT__o_s_s_s);


                    ostei_general_vrr_K(11, 0, 1, 0, 5,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_s_s, NULL, NULL, PRIM_INT__n_s_s_s, NULL, PRIM_INT__o_s_p_s);


                    ostei_general_vrr_K(11, 0, 2, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_p_s, PRIM_INT__o_s_s_s, NULL, PRIM_INT__n_s_p_s, NULL, PRIM_INT__o_s_d_s);


                    ostei_general_vrr_K(11, 0, 3, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_d_s, PRIM_INT__o_s_p_s, NULL, PRIM_INT__n_s_d_s, NULL, PRIM_INT__o_s_f_s);


                    ostei_general_vrr_K(10, 0, 5, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__n_s_g_s, PRIM_INT__n_s_f_s, NULL, PRIM_INT__m_s_g_s, NULL, PRIM_INT__n_s_h_s);


                    ostei_general_vrr_K(11, 0, 4, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_f_s, PRIM_INT__o_s_d_s, NULL, PRIM_INT__n_s_f_s, NULL, PRIM_INT__o_s_g_s);


                    ostei_general_vrr1_I(12, 8,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__o_s_s_s, PRIM_INT__n_s_s_s, PRIM_INT__q_s_s_s);


                    ostei_general_vrr_K(12, 0, 1, 0, 5,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_s_s, NULL, NULL, PRIM_INT__o_s_s_s, NULL, PRIM_INT__q_s_p_s);


                    ostei_general_vrr_K(12, 0, 2, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_p_s, PRIM_INT__q_s_s_s, NULL, PRIM_INT__o_s_p_s, NULL, PRIM_INT__q_s_d_s);


                    ostei_general_vrr_K(12, 0, 3, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_d_s, PRIM_INT__q_s_p_s, NULL, PRIM_INT__o_s_d_s, NULL, PRIM_INT__q_s_f_s);


                    ostei_general_vrr_K(11, 0, 5, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__o_s_g_s, PRIM_INT__o_s_f_s, NULL, PRIM_INT__n_s_g_s, NULL, PRIM_INT__o_s_h_s);


                    ostei_general_vrr_K(12, 0, 4, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_f_s, PRIM_INT__q_s_d_s, NULL, PRIM_INT__o_s_f_s, NULL, PRIM_INT__q_s_g_s);


                    ostei_general_vrr1_I(13, 7,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__q_s_s_s, PRIM_INT__o_s_s_s, PRIM_INT__r_s_s_s);


                    ostei_general_vrr_K(13, 0, 1, 0, 5,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__r_s_s_s, NULL, NULL, PRIM_INT__q_s_s_s, NULL, PRIM_INT__r_s_p_s);


                    ostei_general_vrr_K(13, 0, 2, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__r_s_p_s, PRIM_INT__r_s_s_s, NULL, PRIM_INT__q_s_p_s, NULL, PRIM_INT__r_s_d_s);


                    ostei_general_vrr_K(13, 0, 3, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__r_s_d_s, PRIM_INT__r_s_p_s, NULL, PRIM_INT__q_s_d_s, NULL, PRIM_INT__r_s_f_s);


                    ostei_general_vrr_K(12, 0, 5, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__q_s_g_s, PRIM_INT__q_s_f_s, NULL, PRIM_INT__o_s_g_s, NULL, PRIM_INT__q_s_h_s);


                    ostei_general_vrr_K(13, 0, 4, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__r_s_f_s, PRIM_INT__r_s_d_s, NULL, PRIM_INT__q_s_f_s, NULL, PRIM_INT__r_s_g_s);


                    ostei_general_vrr1_I(14, 6,
                            one_over_2p, a_over_p, aop_PQ, P_PA,
                            PRIM_INT__r_s_s_s, PRIM_INT__q_s_s_s, PRIM_INT__t_s_s_s);


                    ostei_general_vrr_K(14, 0, 1, 0, 5,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__t_s_s_s, NULL, NULL, PRIM_INT__r_s_s_s, NULL, PRIM_INT__t_s_p_s);


                    ostei_general_vrr_K(14, 0, 2, 0, 4,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__t_s_p_s, PRIM_INT__t_s_s_s, NULL, PRIM_INT__r_s_p_s, NULL, PRIM_INT__t_s_d_s);


                    ostei_general_vrr_K(14, 0, 3, 0, 3,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__t_s_d_s, PRIM_INT__t_s_p_s, NULL, PRIM_INT__r_s_d_s, NULL, PRIM_INT__t_s_f_s);


                    ostei_general_vrr_K(13, 0, 5, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__r_s_g_s, PRIM_INT__r_s_f_s, NULL, PRIM_INT__q_s_g_s, NULL, PRIM_INT__r_s_h_s);


                    ostei_general_vrr_K(14, 0, 4, 0, 2,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__t_s_f_s, PRIM_INT__t_s_d_s, NULL, PRIM_INT__r_s_f_s, NULL, PRIM_INT__t_s_g_s);


                    ostei_general_vrr_K(14, 0, 5, 0, 1,
                            one_over_2q, a_over_q, one_over_2pq, aoq_PQ, Q_PA,
                            PRIM_INT__t_s_g_s, PRIM_INT__t_s_f_s, NULL, PRIM_INT__r_s_g_s, NULL, PRIM_INT__t_s_h_s);




                    ////////////////////////////////////
                    // Accumulate contracted integrals
                    ////////////////////////////////////
                    if(lastoffset == 0)
                    {
                        contract_all(360, PRIM_INT__k_s_f_s, PRIM_PTR_INT__k_s_f_s);
                        contract_all(540, PRIM_INT__k_s_g_s, PRIM_PTR_INT__k_s_g_s);
                        contract_all(756, PRIM_INT__k_s_h_s, PRIM_PTR_INT__k_s_h_s);
                        contract_all(450, PRIM_INT__l_s_f_s, PRIM_PTR_INT__l_s_f_s);
                        contract_all(675, PRIM_INT__l_s_g_s, PRIM_PTR_INT__l_s_g_s);
                        contract_all(945, PRIM_INT__l_s_h_s, PRIM_PTR_INT__l_s_h_s);
                        contract_all(550, PRIM_INT__m_s_f_s, PRIM_PTR_INT__m_s_f_s);
                        contract_all(825, PRIM_INT__m_s_g_s, PRIM_PTR_INT__m_s_g_s);
                        contract_all(1155, PRIM_INT__m_s_h_s, PRIM_PTR_INT__m_s_h_s);
                        contract_all(660, PRIM_INT__n_s_f_s, PRIM_PTR_INT__n_s_f_s);
                        contract_all(990, PRIM_INT__n_s_g_s, PRIM_PTR_INT__n_s_g_s);
                        contract_all(1386, PRIM_INT__n_s_h_s, PRIM_PTR_INT__n_s_h_s);
                        contract_all(780, PRIM_INT__o_s_f_s, PRIM_PTR_INT__o_s_f_s);
                        contract_all(1170, PRIM_INT__o_s_g_s, PRIM_PTR_INT__o_s_g_s);
                        contract_all(1638, PRIM_INT__o_s_h_s, PRIM_PTR_INT__o_s_h_s);
                        contract_all(910, PRIM_INT__q_s_f_s, PRIM_PTR_INT__q_s_f_s);
                        contract_all(1365, PRIM_INT__q_s_g_s, PRIM_PTR_INT__q_s_g_s);
                        contract_all(1911, PRIM_INT__q_s_h_s, PRIM_PTR_INT__q_s_h_s);
                        contract_all(1050, PRIM_INT__r_s_f_s, PRIM_PTR_INT__r_s_f_s);
                        contract_all(1575, PRIM_INT__r_s_g_s, PRIM_PTR_INT__r_s_g_s);
                        contract_all(2205, PRIM_INT__r_s_h_s, PRIM_PTR_INT__r_s_h_s);
                        contract_all(1200, PRIM_INT__t_s_f_s, PRIM_PTR_INT__t_s_f_s);
                        contract_all(1800, PRIM_INT__t_s_g_s, PRIM_PTR_INT__t_s_g_s);
                        contract_all(2520, PRIM_INT__t_s_h_s, PRIM_PTR_INT__t_s_h_s);
                    }
                    else
                    {
                        contract(360, shelloffsets, PRIM_INT__k_s_f_s, PRIM_PTR_INT__k_s_f_s);
                        contract(540, shelloffsets, PRIM_INT__k_s_g_s, PRIM_PTR_INT__k_s_g_s);
                        contract(756, shelloffsets, PRIM_INT__k_s_h_s, PRIM_PTR_INT__k_s_h_s);
                        contract(450, shelloffsets, PRIM_INT__l_s_f_s, PRIM_PTR_INT__l_s_f_s);
                        contract(675, shelloffsets, PRIM_INT__l_s_g_s, PRIM_PTR_INT__l_s_g_s);
                        contract(945, shelloffsets, PRIM_INT__l_s_h_s, PRIM_PTR_INT__l_s_h_s);
                        contract(550, shelloffsets, PRIM_INT__m_s_f_s, PRIM_PTR_INT__m_s_f_s);
                        contract(825, shelloffsets, PRIM_INT__m_s_g_s, PRIM_PTR_INT__m_s_g_s);
                        contract(1155, shelloffsets, PRIM_INT__m_s_h_s, PRIM_PTR_INT__m_s_h_s);
                        contract(660, shelloffsets, PRIM_INT__n_s_f_s, PRIM_PTR_INT__n_s_f_s);
                        contract(990, shelloffsets, PRIM_INT__n_s_g_s, PRIM_PTR_INT__n_s_g_s);
                        contract(1386, shelloffsets, PRIM_INT__n_s_h_s, PRIM_PTR_INT__n_s_h_s);
                        contract(780, shelloffsets, PRIM_INT__o_s_f_s, PRIM_PTR_INT__o_s_f_s);
                        contract(1170, shelloffsets, PRIM_INT__o_s_g_s, PRIM_PTR_INT__o_s_g_s);
                        contract(1638, shelloffsets, PRIM_INT__o_s_h_s, PRIM_PTR_INT__o_s_h_s);
                        contract(910, shelloffsets, PRIM_INT__q_s_f_s, PRIM_PTR_INT__q_s_f_s);
                        contract(1365, shelloffsets, PRIM_INT__q_s_g_s, PRIM_PTR_INT__q_s_g_s);
                        contract(1911, shelloffsets, PRIM_INT__q_s_h_s, PRIM_PTR_INT__q_s_h_s);
                        contract(1050, shelloffsets, PRIM_INT__r_s_f_s, PRIM_PTR_INT__r_s_f_s);
                        contract(1575, shelloffsets, PRIM_INT__r_s_g_s, PRIM_PTR_INT__r_s_g_s);
                        contract(2205, shelloffsets, PRIM_INT__r_s_h_s, PRIM_PTR_INT__r_s_h_s);
                        contract(1200, shelloffsets, PRIM_INT__t_s_f_s, PRIM_PTR_INT__t_s_f_s);
                        contract(1800, shelloffsets, PRIM_INT__t_s_g_s, PRIM_PTR_INT__t_s_g_s);
                        contract(2520, shelloffsets, PRIM_INT__t_s_h_s, PRIM_PTR_INT__t_s_h_s);
                        PRIM_PTR_INT__k_s_f_s += lastoffset*360;
                        PRIM_PTR_INT__k_s_g_s += lastoffset*540;
                        PRIM_PTR_INT__k_s_h_s += lastoffset*756;
                        PRIM_PTR_INT__l_s_f_s += lastoffset*450;
                        PRIM_PTR_INT__l_s_g_s += lastoffset*675;
                        PRIM_PTR_INT__l_s_h_s += lastoffset*945;
                        PRIM_PTR_INT__m_s_f_s += lastoffset*550;
                        PRIM_PTR_INT__m_s_g_s += lastoffset*825;
                        PRIM_PTR_INT__m_s_h_s += lastoffset*1155;
                        PRIM_PTR_INT__n_s_f_s += lastoffset*660;
                        PRIM_PTR_INT__n_s_g_s += lastoffset*990;
                        PRIM_PTR_INT__n_s_h_s += lastoffset*1386;
                        PRIM_PTR_INT__o_s_f_s += lastoffset*780;
                        PRIM_PTR_INT__o_s_g_s += lastoffset*1170;
                        PRIM_PTR_INT__o_s_h_s += lastoffset*1638;
                        PRIM_PTR_INT__q_s_f_s += lastoffset*910;
                        PRIM_PTR_INT__q_s_g_s += lastoffset*1365;
                        PRIM_PTR_INT__q_s_h_s += lastoffset*1911;
                        PRIM_PTR_INT__r_s_f_s += lastoffset*1050;
                        PRIM_PTR_INT__r_s_g_s += lastoffset*1575;
                        PRIM_PTR_INT__r_s_h_s += lastoffset*2205;
                        PRIM_PTR_INT__t_s_f_s += lastoffset*1200;
                        PRIM_PTR_INT__t_s_g_s += lastoffset*1800;
                        PRIM_PTR_INT__t_s_h_s += lastoffset*2520;
                    }

                }  // close loop over j
            }  // close loop over i
            
            //Advance to the next batch
            jstart = SIMINT_SIMD_ROUND(jend);
            
            //////////////////////////////////////////////
            // Contracted integrals: Horizontal recurrance
            //////////////////////////////////////////////


            const double hAB[3] = { P.AB_x[ab], P.AB_y[ab], P.AB_z[ab] };


            for(abcd = 0; abcd < nshellbatch; ++abcd, ++real_abcd)
            {
                const double hCD[3] = { Q.AB_x[cd+abcd], Q.AB_y[cd+abcd], Q.AB_z[cd+abcd] };

                // set up HRR pointers
                double const * restrict HRR_INT__k_s_f_s = INT__k_s_f_s + abcd * 360;
                double const * restrict HRR_INT__k_s_g_s = INT__k_s_g_s + abcd * 540;
                double const * restrict HRR_INT__k_s_h_s = INT__k_s_h_s + abcd * 756;
                double const * restrict HRR_INT__l_s_f_s = INT__l_s_f_s + abcd * 450;
                double const * restrict HRR_INT__l_s_g_s = INT__l_s_g_s + abcd * 675;
                double const * restrict HRR_INT__l_s_h_s = INT__l_s_h_s + abcd * 945;
                double const * restrict HRR_INT__m_s_f_s = INT__m_s_f_s + abcd * 550;
                double const * restrict HRR_INT__m_s_g_s = INT__m_s_g_s + abcd * 825;
                double const * restrict HRR_INT__m_s_h_s = INT__m_s_h_s + abcd * 1155;
                double const * restrict HRR_INT__n_s_f_s = INT__n_s_f_s + abcd * 660;
                double const * restrict HRR_INT__n_s_g_s = INT__n_s_g_s + abcd * 990;
                double const * restrict HRR_INT__n_s_h_s = INT__n_s_h_s + abcd * 1386;
                double const * restrict HRR_INT__o_s_f_s = INT__o_s_f_s + abcd * 780;
                double const * restrict HRR_INT__o_s_g_s = INT__o_s_g_s + abcd * 1170;
                double const * restrict HRR_INT__o_s_h_s = INT__o_s_h_s + abcd * 1638;
                double const * restrict HRR_INT__q_s_f_s = INT__q_s_f_s + abcd * 910;
                double const * restrict HRR_INT__q_s_g_s = INT__q_s_g_s + abcd * 1365;
                double const * restrict HRR_INT__q_s_h_s = INT__q_s_h_s + abcd * 1911;
                double const * restrict HRR_INT__r_s_f_s = INT__r_s_f_s + abcd * 1050;
                double const * restrict HRR_INT__r_s_g_s = INT__r_s_g_s + abcd * 1575;
                double const * restrict HRR_INT__r_s_h_s = INT__r_s_h_s + abcd * 2205;
                double const * restrict HRR_INT__t_s_f_s = INT__t_s_f_s + abcd * 1200;
                double const * restrict HRR_INT__t_s_g_s = INT__t_s_g_s + abcd * 1800;
                double const * restrict HRR_INT__t_s_h_s = INT__t_s_h_s + abcd * 2520;
                double * restrict HRR_INT__k_k_f_d = INT__k_k_f_d + real_abcd * 77760;

                // form INT__k_p_f_s
                HRR_J_k_p(
                    HRR_INT__k_p_f_s,
                    HRR_INT__k_s_f_s,
                    HRR_INT__l_s_f_s,
                    hAB, 10);

                // form INT__k_p_g_s
                HRR_J_k_p(
                    HRR_INT__k_p_g_s,
                    HRR_INT__k_s_g_s,
                    HRR_INT__l_s_g_s,
                    hAB, 15);

                // form INT__k_p_h_s
                HRR_J_k_p(
                    HRR_INT__k_p_h_s,
                    HRR_INT__k_s_h_s,
                    HRR_INT__l_s_h_s,
                    hAB, 21);

                // form INT__l_p_f_s
                HRR_J_l_p(
                    HRR_INT__l_p_f_s,
                    HRR_INT__l_s_f_s,
                    HRR_INT__m_s_f_s,
                    hAB, 10);

                // form INT__l_p_g_s
                HRR_J_l_p(
                    HRR_INT__l_p_g_s,
                    HRR_INT__l_s_g_s,
                    HRR_INT__m_s_g_s,
                    hAB, 15);

                // form INT__l_p_h_s
                HRR_J_l_p(
                    HRR_INT__l_p_h_s,
                    HRR_INT__l_s_h_s,
                    HRR_INT__m_s_h_s,
                    hAB, 21);

                // form INT__m_p_f_s
                ostei_general_hrr_J(9, 1, 3, 0, hAB, HRR_INT__n_s_f_s, HRR_INT__m_s_f_s, HRR_INT__m_p_f_s);

                // form INT__m_p_g_s
                ostei_general_hrr_J(9, 1, 4, 0, hAB, HRR_INT__n_s_g_s, HRR_INT__m_s_g_s, HRR_INT__m_p_g_s);

                // form INT__m_p_h_s
                ostei_general_hrr_J(9, 1, 5, 0, hAB, HRR_INT__n_s_h_s, HRR_INT__m_s_h_s, HRR_INT__m_p_h_s);

                // form INT__n_p_f_s
                ostei_general_hrr_J(10, 1, 3, 0, hAB, HRR_INT__o_s_f_s, HRR_INT__n_s_f_s, HRR_INT__n_p_f_s);

                // form INT__n_p_g_s
                ostei_general_hrr_J(10, 1, 4, 0, hAB, HRR_INT__o_s_g_s, HRR_INT__n_s_g_s, HRR_INT__n_p_g_s);

                // form INT__n_p_h_s
                ostei_general_hrr_J(10, 1, 5, 0, hAB, HRR_INT__o_s_h_s, HRR_INT__n_s_h_s, HRR_INT__n_p_h_s);

                // form INT__o_p_f_s
                ostei_general_hrr_J(11, 1, 3, 0, hAB, HRR_INT__q_s_f_s, HRR_INT__o_s_f_s, HRR_INT__o_p_f_s);

                // form INT__o_p_g_s
                ostei_general_hrr_J(11, 1, 4, 0, hAB, HRR_INT__q_s_g_s, HRR_INT__o_s_g_s, HRR_INT__o_p_g_s);

                // form INT__o_p_h_s
                ostei_general_hrr_J(11, 1, 5, 0, hAB, HRR_INT__q_s_h_s, HRR_INT__o_s_h_s, HRR_INT__o_p_h_s);

                // form INT__q_p_f_s
                ostei_general_hrr_J(12, 1, 3, 0, hAB, HRR_INT__r_s_f_s, HRR_INT__q_s_f_s, HRR_INT__q_p_f_s);

                // form INT__q_p_g_s
                ostei_general_hrr_J(12, 1, 4, 0, hAB, HRR_INT__r_s_g_s, HRR_INT__q_s_g_s, HRR_INT__q_p_g_s);

                // form INT__q_p_h_s
                ostei_general_hrr_J(12, 1, 5, 0, hAB, HRR_INT__r_s_h_s, HRR_INT__q_s_h_s, HRR_INT__q_p_h_s);

                // form INT__r_p_f_s
                ostei_general_hrr_J(13, 1, 3, 0, hAB, HRR_INT__t_s_f_s, HRR_INT__r_s_f_s, HRR_INT__r_p_f_s);

                // form INT__r_p_g_s
                ostei_general_hrr_J(13, 1, 4, 0, hAB, HRR_INT__t_s_g_s, HRR_INT__r_s_g_s, HRR_INT__r_p_g_s);

                // form INT__r_p_h_s
                ostei_general_hrr_J(13, 1, 5, 0, hAB, HRR_INT__t_s_h_s, HRR_INT__r_s_h_s, HRR_INT__r_p_h_s);

                // form INT__k_d_f_s
                HRR_J_k_d(
                    HRR_INT__k_d_f_s,
                    HRR_INT__k_p_f_s,
                    HRR_INT__l_p_f_s,
                    hAB, 10);

                // form INT__k_d_g_s
                HRR_J_k_d(
                    HRR_INT__k_d_g_s,
                    HRR_INT__k_p_g_s,
                    HRR_INT__l_p_g_s,
                    hAB, 15);

                // form INT__k_d_h_s
                HRR_J_k_d(
                    HRR_INT__k_d_h_s,
                    HRR_INT__k_p_h_s,
                    HRR_INT__l_p_h_s,
                    hAB, 21);

                // form INT__l_d_f_s
                ostei_general_hrr_J(8, 2, 3, 0, hAB, HRR_INT__m_p_f_s, HRR_INT__l_p_f_s, HRR_INT__l_d_f_s);

                // form INT__l_d_g_s
                ostei_general_hrr_J(8, 2, 4, 0, hAB, HRR_INT__m_p_g_s, HRR_INT__l_p_g_s, HRR_INT__l_d_g_s);

                // form INT__l_d_h_s
                ostei_general_hrr_J(8, 2, 5, 0, hAB, HRR_INT__m_p_h_s, HRR_INT__l_p_h_s, HRR_INT__l_d_h_s);

                // form INT__m_d_f_s
                ostei_general_hrr_J(9, 2, 3, 0, hAB, HRR_INT__n_p_f_s, HRR_INT__m_p_f_s, HRR_INT__m_d_f_s);

                // form INT__m_d_g_s
                ostei_general_hrr_J(9, 2, 4, 0, hAB, HRR_INT__n_p_g_s, HRR_INT__m_p_g_s, HRR_INT__m_d_g_s);

                // form INT__m_d_h_s
                ostei_general_hrr_J(9, 2, 5, 0, hAB, HRR_INT__n_p_h_s, HRR_INT__m_p_h_s, HRR_INT__m_d_h_s);

                // form INT__n_d_f_s
                ostei_general_hrr_J(10, 2, 3, 0, hAB, HRR_INT__o_p_f_s, HRR_INT__n_p_f_s, HRR_INT__n_d_f_s);

                // form INT__n_d_g_s
                ostei_general_hrr_J(10, 2, 4, 0, hAB, HRR_INT__o_p_g_s, HRR_INT__n_p_g_s, HRR_INT__n_d_g_s);

                // form INT__n_d_h_s
                ostei_general_hrr_J(10, 2, 5, 0, hAB, HRR_INT__o_p_h_s, HRR_INT__n_p_h_s, HRR_INT__n_d_h_s);

                // form INT__o_d_f_s
                ostei_general_hrr_J(11, 2, 3, 0, hAB, HRR_INT__q_p_f_s, HRR_INT__o_p_f_s, HRR_INT__o_d_f_s);

                // form INT__o_d_g_s
                ostei_general_hrr_J(11, 2, 4, 0, hAB, HRR_INT__q_p_g_s, HRR_INT__o_p_g_s, HRR_INT__o_d_g_s);

                // form INT__o_d_h_s
                ostei_general_hrr_J(11, 2, 5, 0, hAB, HRR_INT__q_p_h_s, HRR_INT__o_p_h_s, HRR_INT__o_d_h_s);

                // form INT__q_d_f_s
                ostei_general_hrr_J(12, 2, 3, 0, hAB, HRR_INT__r_p_f_s, HRR_INT__q_p_f_s, HRR_INT__q_d_f_s);

                // form INT__q_d_g_s
                ostei_general_hrr_J(12, 2, 4, 0, hAB, HRR_INT__r_p_g_s, HRR_INT__q_p_g_s, HRR_INT__q_d_g_s);

                // form INT__q_d_h_s
                ostei_general_hrr_J(12, 2, 5, 0, hAB, HRR_INT__r_p_h_s, HRR_INT__q_p_h_s, HRR_INT__q_d_h_s);

                // form INT__k_f_f_s
                ostei_general_hrr_J(7, 3, 3, 0, hAB, HRR_INT__l_d_f_s, HRR_INT__k_d_f_s, HRR_INT__k_f_f_s);

                // form INT__k_f_g_s
                ostei_general_hrr_J(7, 3, 4, 0, hAB, HRR_INT__l_d_g_s, HRR_INT__k_d_g_s, HRR_INT__k_f_g_s);

                // form INT__k_f_h_s
                ostei_general_hrr_J(7, 3, 5, 0, hAB, HRR_INT__l_d_h_s, HRR_INT__k_d_h_s, HRR_INT__k_f_h_s);

                // form INT__l_f_f_s
                ostei_general_hrr_J(8, 3, 3, 0, hAB, HRR_INT__m_d_f_s, HRR_INT__l_d_f_s, HRR_INT__l_f_f_s);

                // form INT__l_f_g_s
                ostei_general_hrr_J(8, 3, 4, 0, hAB, HRR_INT__m_d_g_s, HRR_INT__l_d_g_s, HRR_INT__l_f_g_s);

                // form INT__l_f_h_s
                ostei_general_hrr_J(8, 3, 5, 0, hAB, HRR_INT__m_d_h_s, HRR_INT__l_d_h_s, HRR_INT__l_f_h_s);

                // form INT__m_f_f_s
                ostei_general_hrr_J(9, 3, 3, 0, hAB, HRR_INT__n_d_f_s, HRR_INT__m_d_f_s, HRR_INT__m_f_f_s);

                // form INT__m_f_g_s
                ostei_general_hrr_J(9, 3, 4, 0, hAB, HRR_INT__n_d_g_s, HRR_INT__m_d_g_s, HRR_INT__m_f_g_s);

                // form INT__m_f_h_s
                ostei_general_hrr_J(9, 3, 5, 0, hAB, HRR_INT__n_d_h_s, HRR_INT__m_d_h_s, HRR_INT__m_f_h_s);

                // form INT__n_f_f_s
                ostei_general_hrr_J(10, 3, 3, 0, hAB, HRR_INT__o_d_f_s, HRR_INT__n_d_f_s, HRR_INT__n_f_f_s);

                // form INT__n_f_g_s
                ostei_general_hrr_J(10, 3, 4, 0, hAB, HRR_INT__o_d_g_s, HRR_INT__n_d_g_s, HRR_INT__n_f_g_s);

                // form INT__n_f_h_s
                ostei_general_hrr_J(10, 3, 5, 0, hAB, HRR_INT__o_d_h_s, HRR_INT__n_d_h_s, HRR_INT__n_f_h_s);

                // form INT__o_f_f_s
                ostei_general_hrr_J(11, 3, 3, 0, hAB, HRR_INT__q_d_f_s, HRR_INT__o_d_f_s, HRR_INT__o_f_f_s);

                // form INT__o_f_g_s
                ostei_general_hrr_J(11, 3, 4, 0, hAB, HRR_INT__q_d_g_s, HRR_INT__o_d_g_s, HRR_INT__o_f_g_s);

                // form INT__o_f_h_s
                ostei_general_hrr_J(11, 3, 5, 0, hAB, HRR_INT__q_d_h_s, HRR_INT__o_d_h_s, HRR_INT__o_f_h_s);

                // form INT__k_g_f_s
                ostei_general_hrr_J(7, 4, 3, 0, hAB, HRR_INT__l_f_f_s, HRR_INT__k_f_f_s, HRR_INT__k_g_f_s);

                // form INT__k_g_g_s
                ostei_general_hrr_J(7, 4, 4, 0, hAB, HRR_INT__l_f_g_s, HRR_INT__k_f_g_s, HRR_INT__k_g_g_s);

                // form INT__k_g_h_s
                ostei_general_hrr_J(7, 4, 5, 0, hAB, HRR_INT__l_f_h_s, HRR_INT__k_f_h_s, HRR_INT__k_g_h_s);

                // form INT__l_g_f_s
                ostei_general_hrr_J(8, 4, 3, 0, hAB, HRR_INT__m_f_f_s, HRR_INT__l_f_f_s, HRR_INT__l_g_f_s);

                // form INT__l_g_g_s
                ostei_general_hrr_J(8, 4, 4, 0, hAB, HRR_INT__m_f_g_s, HRR_INT__l_f_g_s, HRR_INT__l_g_g_s);

                // form INT__l_g_h_s
                ostei_general_hrr_J(8, 4, 5, 0, hAB, HRR_INT__m_f_h_s, HRR_INT__l_f_h_s, HRR_INT__l_g_h_s);

                // form INT__m_g_f_s
                ostei_general_hrr_J(9, 4, 3, 0, hAB, HRR_INT__n_f_f_s, HRR_INT__m_f_f_s, HRR_INT__m_g_f_s);

                // form INT__m_g_g_s
                ostei_general_hrr_J(9, 4, 4, 0, hAB, HRR_INT__n_f_g_s, HRR_INT__m_f_g_s, HRR_INT__m_g_g_s);

                // form INT__m_g_h_s
                ostei_general_hrr_J(9, 4, 5, 0, hAB, HRR_INT__n_f_h_s, HRR_INT__m_f_h_s, HRR_INT__m_g_h_s);

                // form INT__n_g_f_s
                ostei_general_hrr_J(10, 4, 3, 0, hAB, HRR_INT__o_f_f_s, HRR_INT__n_f_f_s, HRR_INT__n_g_f_s);

                // form INT__n_g_g_s
                ostei_general_hrr_J(10, 4, 4, 0, hAB, HRR_INT__o_f_g_s, HRR_INT__n_f_g_s, HRR_INT__n_g_g_s);

                // form INT__n_g_h_s
                ostei_general_hrr_J(10, 4, 5, 0, hAB, HRR_INT__o_f_h_s, HRR_INT__n_f_h_s, HRR_INT__n_g_h_s);

                // form INT__k_h_f_s
                ostei_general_hrr_J(7, 5, 3, 0, hAB, HRR_INT__l_g_f_s, HRR_INT__k_g_f_s, HRR_INT__k_h_f_s);

                // form INT__k_h_g_s
                ostei_general_hrr_J(7, 5, 4, 0, hAB, HRR_INT__l_g_g_s, HRR_INT__k_g_g_s, HRR_INT__k_h_g_s);

                // form INT__k_h_h_s
                ostei_general_hrr_J(7, 5, 5, 0, hAB, HRR_INT__l_g_h_s, HRR_INT__k_g_h_s, HRR_INT__k_h_h_s);

                // form INT__l_h_f_s
                ostei_general_hrr_J(8, 5, 3, 0, hAB, HRR_INT__m_g_f_s, HRR_INT__l_g_f_s, HRR_INT__l_h_f_s);

                // form INT__l_h_g_s
                ostei_general_hrr_J(8, 5, 4, 0, hAB, HRR_INT__m_g_g_s, HRR_INT__l_g_g_s, HRR_INT__l_h_g_s);

                // form INT__l_h_h_s
                ostei_general_hrr_J(8, 5, 5, 0, hAB, HRR_INT__m_g_h_s, HRR_INT__l_g_h_s, HRR_INT__l_h_h_s);

                // form INT__m_h_f_s
                ostei_general_hrr_J(9, 5, 3, 0, hAB, HRR_INT__n_g_f_s, HRR_INT__m_g_f_s, HRR_INT__m_h_f_s);

                // form INT__m_h_g_s
                ostei_general_hrr_J(9, 5, 4, 0, hAB, HRR_INT__n_g_g_s, HRR_INT__m_g_g_s, HRR_INT__m_h_g_s);

                // form INT__m_h_h_s
                ostei_general_hrr_J(9, 5, 5, 0, hAB, HRR_INT__n_g_h_s, HRR_INT__m_g_h_s, HRR_INT__m_h_h_s);

                // form INT__k_i_f_s
                ostei_general_hrr_J(7, 6, 3, 0, hAB, HRR_INT__l_h_f_s, HRR_INT__k_h_f_s, HRR_INT__k_i_f_s);

                // form INT__k_i_g_s
                ostei_general_hrr_J(7, 6, 4, 0, hAB, HRR_INT__l_h_g_s, HRR_INT__k_h_g_s, HRR_INT__k_i_g_s);

                // form INT__k_i_h_s
                ostei_general_hrr_J(7, 6, 5, 0, hAB, HRR_INT__l_h_h_s, HRR_INT__k_h_h_s, HRR_INT__k_i_h_s);

                // form INT__l_i_f_s
                ostei_general_hrr_J(8, 6, 3, 0, hAB, HRR_INT__m_h_f_s, HRR_INT__l_h_f_s, HRR_INT__l_i_f_s);

                // form INT__l_i_g_s
                ostei_general_hrr_J(8, 6, 4, 0, hAB, HRR_INT__m_h_g_s, HRR_INT__l_h_g_s, HRR_INT__l_i_g_s);

                // form INT__l_i_h_s
                ostei_general_hrr_J(8, 6, 5, 0, hAB, HRR_INT__m_h_h_s, HRR_INT__l_h_h_s, HRR_INT__l_i_h_s);

                // form INT__k_k_f_s
                ostei_general_hrr_J(7, 7, 3, 0, hAB, HRR_INT__l_i_f_s, HRR_INT__k_i_f_s, HRR_INT__k_k_f_s);

                // form INT__k_k_g_s
                ostei_general_hrr_J(7, 7, 4, 0, hAB, HRR_INT__l_i_g_s, HRR_INT__k_i_g_s, HRR_INT__k_k_g_s);

                // form INT__k_k_h_s
                ostei_general_hrr_J(7, 7, 5, 0, hAB, HRR_INT__l_i_h_s, HRR_INT__k_i_h_s, HRR_INT__k_k_h_s);

                // form INT__k_k_f_p
                for(ibra = 0; ibra < 1296; ++ibra)
                {
                    HRR_INT__k_k_f_p[ibra * 30 + 0] = HRR_INT__k_k_g_s[ibra * 15 + 0] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 0] );

                    HRR_INT__k_k_f_p[ibra * 30 + 1] = HRR_INT__k_k_g_s[ibra * 15 + 1] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 0] );

                    HRR_INT__k_k_f_p[ibra * 30 + 2] = HRR_INT__k_k_g_s[ibra * 15 + 2] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 0] );

                    HRR_INT__k_k_f_p[ibra * 30 + 3] = HRR_INT__k_k_g_s[ibra * 15 + 1] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 1] );

                    HRR_INT__k_k_f_p[ibra * 30 + 4] = HRR_INT__k_k_g_s[ibra * 15 + 3] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 1] );

                    HRR_INT__k_k_f_p[ibra * 30 + 5] = HRR_INT__k_k_g_s[ibra * 15 + 4] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 1] );

                    HRR_INT__k_k_f_p[ibra * 30 + 6] = HRR_INT__k_k_g_s[ibra * 15 + 2] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 2] );

                    HRR_INT__k_k_f_p[ibra * 30 + 7] = HRR_INT__k_k_g_s[ibra * 15 + 4] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 2] );

                    HRR_INT__k_k_f_p[ibra * 30 + 8] = HRR_INT__k_k_g_s[ibra * 15 + 5] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 2] );

                    HRR_INT__k_k_f_p[ibra * 30 + 9] = HRR_INT__k_k_g_s[ibra * 15 + 3] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 3] );

                    HRR_INT__k_k_f_p[ibra * 30 + 10] = HRR_INT__k_k_g_s[ibra * 15 + 6] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 3] );

                    HRR_INT__k_k_f_p[ibra * 30 + 11] = HRR_INT__k_k_g_s[ibra * 15 + 7] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 3] );

                    HRR_INT__k_k_f_p[ibra * 30 + 12] = HRR_INT__k_k_g_s[ibra * 15 + 4] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 4] );

                    HRR_INT__k_k_f_p[ibra * 30 + 13] = HRR_INT__k_k_g_s[ibra * 15 + 7] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 4] );

                    HRR_INT__k_k_f_p[ibra * 30 + 14] = HRR_INT__k_k_g_s[ibra * 15 + 8] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 4] );

                    HRR_INT__k_k_f_p[ibra * 30 + 15] = HRR_INT__k_k_g_s[ibra * 15 + 5] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 5] );

                    HRR_INT__k_k_f_p[ibra * 30 + 16] = HRR_INT__k_k_g_s[ibra * 15 + 8] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 5] );

                    HRR_INT__k_k_f_p[ibra * 30 + 17] = HRR_INT__k_k_g_s[ibra * 15 + 9] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 5] );

                    HRR_INT__k_k_f_p[ibra * 30 + 18] = HRR_INT__k_k_g_s[ibra * 15 + 6] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 6] );

                    HRR_INT__k_k_f_p[ibra * 30 + 19] = HRR_INT__k_k_g_s[ibra * 15 + 10] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 6] );

                    HRR_INT__k_k_f_p[ibra * 30 + 20] = HRR_INT__k_k_g_s[ibra * 15 + 11] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 6] );

                    HRR_INT__k_k_f_p[ibra * 30 + 21] = HRR_INT__k_k_g_s[ibra * 15 + 7] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 7] );

                    HRR_INT__k_k_f_p[ibra * 30 + 22] = HRR_INT__k_k_g_s[ibra * 15 + 11] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 7] );

                    HRR_INT__k_k_f_p[ibra * 30 + 23] = HRR_INT__k_k_g_s[ibra * 15 + 12] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 7] );

                    HRR_INT__k_k_f_p[ibra * 30 + 24] = HRR_INT__k_k_g_s[ibra * 15 + 8] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 8] );

                    HRR_INT__k_k_f_p[ibra * 30 + 25] = HRR_INT__k_k_g_s[ibra * 15 + 12] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 8] );

                    HRR_INT__k_k_f_p[ibra * 30 + 26] = HRR_INT__k_k_g_s[ibra * 15 + 13] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 8] );

                    HRR_INT__k_k_f_p[ibra * 30 + 27] = HRR_INT__k_k_g_s[ibra * 15 + 9] + ( hCD[0] * HRR_INT__k_k_f_s[ibra * 10 + 9] );

                    HRR_INT__k_k_f_p[ibra * 30 + 28] = HRR_INT__k_k_g_s[ibra * 15 + 13] + ( hCD[1] * HRR_INT__k_k_f_s[ibra * 10 + 9] );

                    HRR_INT__k_k_f_p[ibra * 30 + 29] = HRR_INT__k_k_g_s[ibra * 15 + 14] + ( hCD[2] * HRR_INT__k_k_f_s[ibra * 10 + 9] );

                }

                // form INT__k_k_g_p
                HRR_L_g_p(
                    HRR_INT__k_k_g_p,
                    HRR_INT__k_k_g_s,
                    HRR_INT__k_k_h_s,
                    hCD, 1296);

                // form INT__k_k_f_d
                HRR_L_f_d(
                    HRR_INT__k_k_f_d,
                    HRR_INT__k_k_f_p,
                    HRR_INT__k_k_g_p,
                    hCD, 1296);


            }  // close HRR loop


        }   // close loop cdbatch

        istart = iend;
    }  // close loop over ab

    return P.nshell12_clip * Q.nshell12_clip;
}

int ostei_k_k_d_f(struct simint_multi_shellpair const P,
                  struct simint_multi_shellpair const Q,
                  double screen_tol,
                  double * const restrict work,
                  double * const restrict INT__k_k_d_f)
{
    double Q_AB[3*Q.nshell12];
    struct simint_multi_shellpair Q_tmp = Q;
    Q_tmp.PA_x = Q.PB_x;  Q_tmp.PA_y = Q.PB_y;  Q_tmp.PA_z = Q.PB_z;
    Q_tmp.PB_x = Q.PA_x;  Q_tmp.PB_y = Q.PA_y;  Q_tmp.PB_z = Q.PA_z;
    Q_tmp.AB_x = Q_AB;
    Q_tmp.AB_y = Q_AB + Q.nshell12;
    Q_tmp.AB_z = Q_AB + 2*Q.nshell12;

    for(int i = 0; i < Q.nshell12; i++)
    {
        Q_tmp.AB_x[i] = -Q.AB_x[i];
        Q_tmp.AB_y[i] = -Q.AB_y[i];
        Q_tmp.AB_z[i] = -Q.AB_z[i];
    }

    int ret = ostei_k_k_f_d(P, Q_tmp, screen_tol, work, INT__k_k_d_f);
    double buffer[77760] SIMINT_ALIGN_ARRAY_DBL;

    for(int q = 0; q < ret; q++)
    {
        int idx = 0;
        for(int a = 0; a < 36; ++a)
        for(int b = 0; b < 36; ++b)
        for(int c = 0; c < 6; ++c)
        for(int d = 0; d < 10; ++d)
            buffer[idx++] = INT__k_k_d_f[q*77760+a*2160+b*60+d*6+c];

        memcpy(INT__k_k_d_f+q*77760, buffer, 77760*sizeof(double));
    }

    return ret;
}

