#include "simint/boys/boys.h"
#include "simint/ostei/gen/ostei_generated.h"
#include "simint/vectorization/vectorization.h"
#include <math.h>
#include <string.h>


int ostei_p_s_k_k(struct simint_multi_shellpair const P,
                  struct simint_multi_shellpair const Q,
                  double screen_tol,
                  double * const restrict work,
                  double * const restrict INT__p_s_k_k)
{

    SIMINT_ASSUME_ALIGN_DBL(work);
    SIMINT_ASSUME_ALIGN_DBL(INT__p_s_k_k);
    int ab, cd, abcd;
    int istart, jstart;
    int iprimcd, nprim_icd, icd;
    const int check_screen = (screen_tol > 0.0);
    int i, j;
    int n;
    int not_screened;
    int real_abcd;
    int ibra;

    // partition workspace
    double * const INT__p_s_k_s = work + (SIMINT_NSHELL_SIMD * 0);
    double * const INT__p_s_l_s = work + (SIMINT_NSHELL_SIMD * 108);
    double * const INT__p_s_m_s = work + (SIMINT_NSHELL_SIMD * 243);
    double * const INT__p_s_n_s = work + (SIMINT_NSHELL_SIMD * 408);
    double * const INT__p_s_o_s = work + (SIMINT_NSHELL_SIMD * 606);
    double * const INT__p_s_q_s = work + (SIMINT_NSHELL_SIMD * 840);
    double * const INT__p_s_r_s = work + (SIMINT_NSHELL_SIMD * 1113);
    double * const INT__p_s_t_s = work + (SIMINT_NSHELL_SIMD * 1428);
    SIMINT_DBLTYPE * const primwork = (SIMINT_DBLTYPE *)(work + SIMINT_NSHELL_SIMD*1788);
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_s_s = primwork + 0;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_p_s = primwork + 16;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_d_s = primwork + 61;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_f_s = primwork + 145;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_g_s = primwork + 275;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_h_s = primwork + 455;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_i_s = primwork + 686;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_k_s = primwork + 966;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_l_s = primwork + 1290;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_m_s = primwork + 1650;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_n_s = primwork + 2035;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_o_s = primwork + 2431;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_q_s = primwork + 2821;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_r_s = primwork + 3185;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_t_s = primwork + 3500;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_k_s = primwork + 3740;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_l_s = primwork + 3848;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_m_s = primwork + 3983;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_n_s = primwork + 4148;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_o_s = primwork + 4346;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_q_s = primwork + 4580;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_r_s = primwork + 4853;
    SIMINT_DBLTYPE * const restrict PRIM_INT__p_s_t_s = primwork + 5168;
    double * const hrrwork = (double *)(primwork + 5528);
    double * const HRR_INT__p_s_k_p = hrrwork + 0;
    double * const HRR_INT__p_s_k_d = hrrwork + 324;
    double * const HRR_INT__p_s_k_f = hrrwork + 972;
    double * const HRR_INT__p_s_k_g = hrrwork + 2052;
    double * const HRR_INT__p_s_k_h = hrrwork + 3672;
    double * const HRR_INT__p_s_k_i = hrrwork + 5940;
    double * const HRR_INT__p_s_l_p = hrrwork + 8964;
    double * const HRR_INT__p_s_l_d = hrrwork + 9369;
    double * const HRR_INT__p_s_l_f = hrrwork + 10179;
    double * const HRR_INT__p_s_l_g = hrrwork + 11529;
    double * const HRR_INT__p_s_l_h = hrrwork + 13554;
    double * const HRR_INT__p_s_l_i = hrrwork + 16389;
    double * const HRR_INT__p_s_m_p = hrrwork + 20169;
    double * const HRR_INT__p_s_m_d = hrrwork + 20664;
    double * const HRR_INT__p_s_m_f = hrrwork + 21654;
    double * const HRR_INT__p_s_m_g = hrrwork + 23304;
    double * const HRR_INT__p_s_m_h = hrrwork + 25779;
    double * const HRR_INT__p_s_n_p = hrrwork + 29244;
    double * const HRR_INT__p_s_n_d = hrrwork + 29838;
    double * const HRR_INT__p_s_n_f = hrrwork + 31026;
    double * const HRR_INT__p_s_n_g = hrrwork + 33006;
    double * const HRR_INT__p_s_o_p = hrrwork + 35976;
    double * const HRR_INT__p_s_o_d = hrrwork + 36678;
    double * const HRR_INT__p_s_o_f = hrrwork + 38082;
    double * const HRR_INT__p_s_q_p = hrrwork + 40422;
    double * const HRR_INT__p_s_q_d = hrrwork + 41241;
    double * const HRR_INT__p_s_r_p = hrrwork + 42879;


    // Create constants
    const SIMINT_DBLTYPE const_1 = SIMINT_DBLSET1(1);
    const SIMINT_DBLTYPE const_10 = SIMINT_DBLSET1(10);
    const SIMINT_DBLTYPE const_11 = SIMINT_DBLSET1(11);
    const SIMINT_DBLTYPE const_12 = SIMINT_DBLSET1(12);
    const SIMINT_DBLTYPE const_13 = SIMINT_DBLSET1(13);
    const SIMINT_DBLTYPE const_14 = SIMINT_DBLSET1(14);
    const SIMINT_DBLTYPE const_2 = SIMINT_DBLSET1(2);
    const SIMINT_DBLTYPE const_3 = SIMINT_DBLSET1(3);
    const SIMINT_DBLTYPE const_4 = SIMINT_DBLSET1(4);
    const SIMINT_DBLTYPE const_5 = SIMINT_DBLSET1(5);
    const SIMINT_DBLTYPE const_6 = SIMINT_DBLSET1(6);
    const SIMINT_DBLTYPE const_7 = SIMINT_DBLSET1(7);
    const SIMINT_DBLTYPE const_8 = SIMINT_DBLSET1(8);
    const SIMINT_DBLTYPE const_9 = SIMINT_DBLSET1(9);
    const SIMINT_DBLTYPE one_half = SIMINT_DBLSET1(0.5);


    ////////////////////////////////////////
    // Loop over shells and primitives
    ////////////////////////////////////////

    real_abcd = 0;
    istart = 0;
    for(ab = 0; ab < P.nshell12_clip; ++ab)
    {
        const int iend = istart + P.nprim12[ab];

        cd = 0;
        jstart = 0;

        for(cd = 0; cd < Q.nshell12_clip; cd += SIMINT_NSHELL_SIMD)
        {
            const int nshellbatch = ((cd + SIMINT_NSHELL_SIMD) > Q.nshell12_clip) ? Q.nshell12_clip - cd : SIMINT_NSHELL_SIMD;
            int jend = jstart;
            for(i = 0; i < nshellbatch; i++)
                jend += Q.nprim12[cd+i];

            // Clear the beginning of the workspace (where we are accumulating integrals)
            memset(work, 0, SIMINT_NSHELL_SIMD * 1788 * sizeof(double));
            abcd = 0;


            for(i = istart; i < iend; ++i)
            {
                SIMINT_DBLTYPE bra_screen_max;  // only used if check_screen

                if(check_screen)
                {
                    // Skip this whole thing if always insignificant
                    if((P.screen[i] * Q.screen_max) < screen_tol)
                        continue;
                    bra_screen_max = SIMINT_DBLSET1(P.screen[i]);
                }

                icd = 0;
                iprimcd = 0;
                nprim_icd = Q.nprim12[cd];
                double * restrict PRIM_PTR_INT__p_s_k_s = INT__p_s_k_s + abcd * 108;
                double * restrict PRIM_PTR_INT__p_s_l_s = INT__p_s_l_s + abcd * 135;
                double * restrict PRIM_PTR_INT__p_s_m_s = INT__p_s_m_s + abcd * 165;
                double * restrict PRIM_PTR_INT__p_s_n_s = INT__p_s_n_s + abcd * 198;
                double * restrict PRIM_PTR_INT__p_s_o_s = INT__p_s_o_s + abcd * 234;
                double * restrict PRIM_PTR_INT__p_s_q_s = INT__p_s_q_s + abcd * 273;
                double * restrict PRIM_PTR_INT__p_s_r_s = INT__p_s_r_s + abcd * 315;
                double * restrict PRIM_PTR_INT__p_s_t_s = INT__p_s_t_s + abcd * 360;



                // Load these one per loop over i
                const SIMINT_DBLTYPE P_alpha = SIMINT_DBLSET1(P.alpha[i]);
                const SIMINT_DBLTYPE P_prefac = SIMINT_DBLSET1(P.prefac[i]);
                const SIMINT_DBLTYPE Pxyz[3] = { SIMINT_DBLSET1(P.x[i]), SIMINT_DBLSET1(P.y[i]), SIMINT_DBLSET1(P.z[i]) };

                const SIMINT_DBLTYPE P_PA[3] = { SIMINT_DBLSET1(P.PA_x[i]), SIMINT_DBLSET1(P.PA_y[i]), SIMINT_DBLSET1(P.PA_z[i]) };

                for(j = jstart; j < jend; j += SIMINT_SIMD_LEN)
                {
                    // calculate the shell offsets
                    // these are the offset from the shell pointed to by cd
                    // for each element
                    int shelloffsets[SIMINT_SIMD_LEN] = {0};
                    int lastoffset = 0;
                    const int nlane = ( ((j + SIMINT_SIMD_LEN) < jend) ? SIMINT_SIMD_LEN : (jend - j));

                    if((iprimcd + SIMINT_SIMD_LEN) >= nprim_icd)
                    {
                        // Handle if the first element of the vector is a new shell
                        if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                        {
                            nprim_icd += Q.nprim12[cd + (++icd)];
                            PRIM_PTR_INT__p_s_k_s += 108;
                            PRIM_PTR_INT__p_s_l_s += 135;
                            PRIM_PTR_INT__p_s_m_s += 165;
                            PRIM_PTR_INT__p_s_n_s += 198;
                            PRIM_PTR_INT__p_s_o_s += 234;
                            PRIM_PTR_INT__p_s_q_s += 273;
                            PRIM_PTR_INT__p_s_r_s += 315;
                            PRIM_PTR_INT__p_s_t_s += 360;
                        }
                        iprimcd++;
                        for(n = 1; n < SIMINT_SIMD_LEN; ++n)
                        {
                            if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                            {
                                shelloffsets[n] = shelloffsets[n-1] + 1;
                                lastoffset++;
                                nprim_icd += Q.nprim12[cd + (++icd)];
                            }
                            else
                                shelloffsets[n] = shelloffsets[n-1];
                            iprimcd++;
                        }
                    }
                    else
                        iprimcd += SIMINT_SIMD_LEN;

                    // Do we have to compute this vector (or has it been screened out)?
                    // (not_screened != 0 means we have to do this vector)
                    if(check_screen)
                    {
                        const double vmax = vector_max(SIMINT_MUL(bra_screen_max, SIMINT_DBLLOAD(Q.screen, j)));
                        if(vmax < screen_tol)
                        {
                            PRIM_PTR_INT__p_s_k_s += lastoffset*108;
                            PRIM_PTR_INT__p_s_l_s += lastoffset*135;
                            PRIM_PTR_INT__p_s_m_s += lastoffset*165;
                            PRIM_PTR_INT__p_s_n_s += lastoffset*198;
                            PRIM_PTR_INT__p_s_o_s += lastoffset*234;
                            PRIM_PTR_INT__p_s_q_s += lastoffset*273;
                            PRIM_PTR_INT__p_s_r_s += lastoffset*315;
                            PRIM_PTR_INT__p_s_t_s += lastoffset*360;
                            continue;
                        }
                    }

                    const SIMINT_DBLTYPE Q_alpha = SIMINT_DBLLOAD(Q.alpha, j);
                    const SIMINT_DBLTYPE PQalpha_mul = SIMINT_MUL(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE PQalpha_sum = SIMINT_ADD(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE one_over_PQalpha_sum = SIMINT_DIV(const_1, PQalpha_sum);


                    /* construct R2 = (Px - Qx)**2 + (Py - Qy)**2 + (Pz -Qz)**2 */
                    SIMINT_DBLTYPE PQ[3];
                    PQ[0] = SIMINT_SUB(Pxyz[0], SIMINT_DBLLOAD(Q.x, j));
                    PQ[1] = SIMINT_SUB(Pxyz[1], SIMINT_DBLLOAD(Q.y, j));
                    PQ[2] = SIMINT_SUB(Pxyz[2], SIMINT_DBLLOAD(Q.z, j));
                    SIMINT_DBLTYPE R2 = SIMINT_MUL(PQ[0], PQ[0]);
                    R2 = SIMINT_FMADD(PQ[1], PQ[1], R2);
                    R2 = SIMINT_FMADD(PQ[2], PQ[2], R2);

                    const SIMINT_DBLTYPE alpha = SIMINT_MUL(PQalpha_mul, one_over_PQalpha_sum); // alpha from MEST
                    const SIMINT_DBLTYPE one_over_p = SIMINT_DIV(const_1, P_alpha);
                    const SIMINT_DBLTYPE one_over_q = SIMINT_DIV(const_1, Q_alpha);
                    const SIMINT_DBLTYPE one_over_2p = SIMINT_MUL(one_half, one_over_p);
                    const SIMINT_DBLTYPE one_over_2q = SIMINT_MUL(one_half, one_over_q);
                    const SIMINT_DBLTYPE one_over_2pq = SIMINT_MUL(one_half, one_over_PQalpha_sum);
                    const SIMINT_DBLTYPE Q_PA[3] = { SIMINT_DBLLOAD(Q.PA_x, j), SIMINT_DBLLOAD(Q.PA_y, j), SIMINT_DBLLOAD(Q.PA_z, j) };

                    // NOTE: Minus sign!
                    const SIMINT_DBLTYPE a_over_p = SIMINT_MUL(SIMINT_NEG(alpha), one_over_p);
                    SIMINT_DBLTYPE aop_PQ[3];
                    aop_PQ[0] = SIMINT_MUL(a_over_p, PQ[0]);
                    aop_PQ[1] = SIMINT_MUL(a_over_p, PQ[1]);
                    aop_PQ[2] = SIMINT_MUL(a_over_p, PQ[2]);

                    SIMINT_DBLTYPE a_over_q = SIMINT_MUL(alpha, one_over_q);
                    SIMINT_DBLTYPE aoq_PQ[3];
                    aoq_PQ[0] = SIMINT_MUL(a_over_q, PQ[0]);
                    aoq_PQ[1] = SIMINT_MUL(a_over_q, PQ[1]);
                    aoq_PQ[2] = SIMINT_MUL(a_over_q, PQ[2]);
                    // Put a minus sign here so we don't have to in RR routines
                    a_over_q = SIMINT_NEG(a_over_q);


                    //////////////////////////////////////////////
                    // Fjt function section
                    // Maximum v value: 15
                    //////////////////////////////////////////////
                    // The parameter to the Fjt function
                    const SIMINT_DBLTYPE F_x = SIMINT_MUL(R2, alpha);


                    const SIMINT_DBLTYPE Q_prefac = mask_load(nlane, Q.prefac + j);


                    boys_F_split(PRIM_INT__s_s_s_s, F_x, 15);
                    SIMINT_DBLTYPE prefac = SIMINT_SQRT(one_over_PQalpha_sum);
                    prefac = SIMINT_MUL(SIMINT_MUL(P_prefac, Q_prefac), prefac);
                    for(n = 0; n <= 15; n++)
                        PRIM_INT__s_s_s_s[n] = SIMINT_MUL(PRIM_INT__s_s_s_s[n], prefac);

                    //////////////////////////////////////////////
                    // Primitive integrals: Vertical recurrance
                    //////////////////////////////////////////////

                    const SIMINT_DBLTYPE vrr_const_1_over_2q = one_over_2q;
                    const SIMINT_DBLTYPE vrr_const_2_over_2q = SIMINT_MUL(const_2, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_3_over_2q = SIMINT_MUL(const_3, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_4_over_2q = SIMINT_MUL(const_4, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_5_over_2q = SIMINT_MUL(const_5, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_6_over_2q = SIMINT_MUL(const_6, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_7_over_2q = SIMINT_MUL(const_7, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_8_over_2q = SIMINT_MUL(const_8, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_9_over_2q = SIMINT_MUL(const_9, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_10_over_2q = SIMINT_MUL(const_10, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_11_over_2q = SIMINT_MUL(const_11, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_12_over_2q = SIMINT_MUL(const_12, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_13_over_2q = SIMINT_MUL(const_13, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_1_over_2pq = one_over_2pq;
                    const SIMINT_DBLTYPE vrr_const_2_over_2pq = SIMINT_MUL(const_2, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_3_over_2pq = SIMINT_MUL(const_3, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_4_over_2pq = SIMINT_MUL(const_4, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_5_over_2pq = SIMINT_MUL(const_5, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_6_over_2pq = SIMINT_MUL(const_6, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_7_over_2pq = SIMINT_MUL(const_7, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_8_over_2pq = SIMINT_MUL(const_8, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_9_over_2pq = SIMINT_MUL(const_9, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_10_over_2pq = SIMINT_MUL(const_10, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_11_over_2pq = SIMINT_MUL(const_11, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_12_over_2pq = SIMINT_MUL(const_12, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_13_over_2pq = SIMINT_MUL(const_13, one_over_2pq);
                    const SIMINT_DBLTYPE vrr_const_14_over_2pq = SIMINT_MUL(const_14, one_over_2pq);



                    // Forming PRIM_INT__s_s_p_s[15 * 3];
                    for(n = 0; n < 15; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__s_s_p_s[n * 3 + 0] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__s_s_p_s[n * 3 + 0] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_p_s[n * 3 + 0]);

                        PRIM_INT__s_s_p_s[n * 3 + 1] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__s_s_p_s[n * 3 + 1] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_p_s[n * 3 + 1]);

                        PRIM_INT__s_s_p_s[n * 3 + 2] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__s_s_p_s[n * 3 + 2] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_p_s[n * 3 + 2]);

                    }



                    // Forming PRIM_INT__s_s_d_s[14 * 6];
                    for(n = 0; n < 14; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__s_s_d_s[n * 6 + 0] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_p_s[n * 3 + 0]);
                        PRIM_INT__s_s_d_s[n * 6 + 0] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_p_s[(n+1) * 3 + 0], PRIM_INT__s_s_d_s[n * 6 + 0]);
                        PRIM_INT__s_s_d_s[n * 6 + 0] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__s_s_d_s[n * 6 + 0]);

                        PRIM_INT__s_s_d_s[n * 6 + 3] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_p_s[n * 3 + 1]);
                        PRIM_INT__s_s_d_s[n * 6 + 3] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_p_s[(n+1) * 3 + 1], PRIM_INT__s_s_d_s[n * 6 + 3]);
                        PRIM_INT__s_s_d_s[n * 6 + 3] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__s_s_d_s[n * 6 + 3]);

                        PRIM_INT__s_s_d_s[n * 6 + 5] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_p_s[n * 3 + 2]);
                        PRIM_INT__s_s_d_s[n * 6 + 5] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_p_s[(n+1) * 3 + 2], PRIM_INT__s_s_d_s[n * 6 + 5]);
                        PRIM_INT__s_s_d_s[n * 6 + 5] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__s_s_d_s[n * 6 + 5]);

                    }



                    // Forming PRIM_INT__s_s_f_s[13 * 10];
                    for(n = 0; n < 13; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__s_s_f_s[n * 10 + 0] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_d_s[n * 6 + 0]);
                        PRIM_INT__s_s_f_s[n * 10 + 0] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__s_s_f_s[n * 10 + 0] = SIMINT_FMADD( vrr_const_2_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_p_s[(n+1) * 3 + 0], PRIM_INT__s_s_p_s[n * 3 + 0]), PRIM_INT__s_s_f_s[n * 10 + 0]);

                        PRIM_INT__s_s_f_s[n * 10 + 1] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_d_s[n * 6 + 0]);
                        PRIM_INT__s_s_f_s[n * 10 + 1] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_f_s[n * 10 + 1]);

                        PRIM_INT__s_s_f_s[n * 10 + 6] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_d_s[n * 6 + 3]);
                        PRIM_INT__s_s_f_s[n * 10 + 6] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__s_s_f_s[n * 10 + 6] = SIMINT_FMADD( vrr_const_2_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_p_s[(n+1) * 3 + 1], PRIM_INT__s_s_p_s[n * 3 + 1]), PRIM_INT__s_s_f_s[n * 10 + 6]);

                        PRIM_INT__s_s_f_s[n * 10 + 9] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_d_s[n * 6 + 5]);
                        PRIM_INT__s_s_f_s[n * 10 + 9] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__s_s_f_s[n * 10 + 9] = SIMINT_FMADD( vrr_const_2_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_p_s[(n+1) * 3 + 2], PRIM_INT__s_s_p_s[n * 3 + 2]), PRIM_INT__s_s_f_s[n * 10 + 9]);

                    }



                    // Forming PRIM_INT__s_s_g_s[12 * 15];
                    for(n = 0; n < 12; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__s_s_g_s[n * 15 + 0] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__s_s_g_s[n * 15 + 0] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 0], PRIM_INT__s_s_g_s[n * 15 + 0]);
                        PRIM_INT__s_s_g_s[n * 15 + 0] = SIMINT_FMADD( vrr_const_3_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_d_s[n * 6 + 0]), PRIM_INT__s_s_g_s[n * 15 + 0]);

                        PRIM_INT__s_s_g_s[n * 15 + 1] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__s_s_g_s[n * 15 + 1] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 0], PRIM_INT__s_s_g_s[n * 15 + 1]);

                        PRIM_INT__s_s_g_s[n * 15 + 2] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__s_s_g_s[n * 15 + 2] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 0], PRIM_INT__s_s_g_s[n * 15 + 2]);

                        PRIM_INT__s_s_g_s[n * 15 + 3] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_f_s[n * 10 + 1]);
                        PRIM_INT__s_s_g_s[n * 15 + 3] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 1], PRIM_INT__s_s_g_s[n * 15 + 3]);
                        PRIM_INT__s_s_g_s[n * 15 + 3] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_d_s[n * 6 + 0]), PRIM_INT__s_s_g_s[n * 15 + 3]);

                        PRIM_INT__s_s_g_s[n * 15 + 6] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__s_s_g_s[n * 15 + 6] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 6], PRIM_INT__s_s_g_s[n * 15 + 6]);

                        PRIM_INT__s_s_g_s[n * 15 + 9] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__s_s_g_s[n * 15 + 9] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 9], PRIM_INT__s_s_g_s[n * 15 + 9]);

                        PRIM_INT__s_s_g_s[n * 15 + 10] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__s_s_g_s[n * 15 + 10] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 6], PRIM_INT__s_s_g_s[n * 15 + 10]);
                        PRIM_INT__s_s_g_s[n * 15 + 10] = SIMINT_FMADD( vrr_const_3_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__s_s_d_s[n * 6 + 3]), PRIM_INT__s_s_g_s[n * 15 + 10]);

                        PRIM_INT__s_s_g_s[n * 15 + 11] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__s_s_g_s[n * 15 + 11] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 6], PRIM_INT__s_s_g_s[n * 15 + 11]);

                        PRIM_INT__s_s_g_s[n * 15 + 13] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__s_s_g_s[n * 15 + 13] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 9], PRIM_INT__s_s_g_s[n * 15 + 13]);

                        PRIM_INT__s_s_g_s[n * 15 + 14] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__s_s_g_s[n * 15 + 14] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 9], PRIM_INT__s_s_g_s[n * 15 + 14]);
                        PRIM_INT__s_s_g_s[n * 15 + 14] = SIMINT_FMADD( vrr_const_3_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__s_s_d_s[n * 6 + 5]), PRIM_INT__s_s_g_s[n * 15 + 14]);

                    }


                    VRR_K_s_s_h_s(
                            PRIM_INT__s_s_h_s,
                            PRIM_INT__s_s_g_s,
                            PRIM_INT__s_s_f_s,
                            Q_PA,
                            a_over_q,
                            aoq_PQ,
                            one_over_2q,
                            11);


                    VRR_K_s_s_i_s(
                            PRIM_INT__s_s_i_s,
                            PRIM_INT__s_s_h_s,
                            PRIM_INT__s_s_g_s,
                            Q_PA,
                            a_over_q,
                            aoq_PQ,
                            one_over_2q,
                            10);


                    VRR_K_s_s_k_s(
                            PRIM_INT__s_s_k_s,
                            PRIM_INT__s_s_i_s,
                            PRIM_INT__s_s_h_s,
                            Q_PA,
                            a_over_q,
                            aoq_PQ,
                            one_over_2q,
                            9);


                    ostei_general_vrr_I(1, 0, 7, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_k_s, NULL, NULL, PRIM_INT__s_s_i_s, NULL, PRIM_INT__p_s_k_s);


                    ostei_general_vrr1_K(8, 8,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_k_s, PRIM_INT__s_s_i_s, PRIM_INT__s_s_l_s);


                    ostei_general_vrr_I(1, 0, 8, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_l_s, NULL, NULL, PRIM_INT__s_s_k_s, NULL, PRIM_INT__p_s_l_s);


                    ostei_general_vrr1_K(9, 7,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_l_s, PRIM_INT__s_s_k_s, PRIM_INT__s_s_m_s);


                    ostei_general_vrr_I(1, 0, 9, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_m_s, NULL, NULL, PRIM_INT__s_s_l_s, NULL, PRIM_INT__p_s_m_s);


                    ostei_general_vrr1_K(10, 6,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_m_s, PRIM_INT__s_s_l_s, PRIM_INT__s_s_n_s);


                    ostei_general_vrr_I(1, 0, 10, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_n_s, NULL, NULL, PRIM_INT__s_s_m_s, NULL, PRIM_INT__p_s_n_s);


                    ostei_general_vrr1_K(11, 5,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_n_s, PRIM_INT__s_s_m_s, PRIM_INT__s_s_o_s);


                    ostei_general_vrr_I(1, 0, 11, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_o_s, NULL, NULL, PRIM_INT__s_s_n_s, NULL, PRIM_INT__p_s_o_s);


                    ostei_general_vrr1_K(12, 4,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_o_s, PRIM_INT__s_s_n_s, PRIM_INT__s_s_q_s);


                    ostei_general_vrr_I(1, 0, 12, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_q_s, NULL, NULL, PRIM_INT__s_s_o_s, NULL, PRIM_INT__p_s_q_s);


                    ostei_general_vrr1_K(13, 3,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_q_s, PRIM_INT__s_s_o_s, PRIM_INT__s_s_r_s);


                    ostei_general_vrr_I(1, 0, 13, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_r_s, NULL, NULL, PRIM_INT__s_s_q_s, NULL, PRIM_INT__p_s_r_s);


                    ostei_general_vrr1_K(14, 2,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_r_s, PRIM_INT__s_s_q_s, PRIM_INT__s_s_t_s);


                    ostei_general_vrr_I(1, 0, 14, 0, 1,
                            one_over_2p, a_over_p, one_over_2pq, aop_PQ, P_PA,
                            PRIM_INT__s_s_t_s, NULL, NULL, PRIM_INT__s_s_r_s, NULL, PRIM_INT__p_s_t_s);




                    ////////////////////////////////////
                    // Accumulate contracted integrals
                    ////////////////////////////////////
                    if(lastoffset == 0)
                    {
                        contract_all(108, PRIM_INT__p_s_k_s, PRIM_PTR_INT__p_s_k_s);
                        contract_all(135, PRIM_INT__p_s_l_s, PRIM_PTR_INT__p_s_l_s);
                        contract_all(165, PRIM_INT__p_s_m_s, PRIM_PTR_INT__p_s_m_s);
                        contract_all(198, PRIM_INT__p_s_n_s, PRIM_PTR_INT__p_s_n_s);
                        contract_all(234, PRIM_INT__p_s_o_s, PRIM_PTR_INT__p_s_o_s);
                        contract_all(273, PRIM_INT__p_s_q_s, PRIM_PTR_INT__p_s_q_s);
                        contract_all(315, PRIM_INT__p_s_r_s, PRIM_PTR_INT__p_s_r_s);
                        contract_all(360, PRIM_INT__p_s_t_s, PRIM_PTR_INT__p_s_t_s);
                    }
                    else
                    {
                        contract(108, shelloffsets, PRIM_INT__p_s_k_s, PRIM_PTR_INT__p_s_k_s);
                        contract(135, shelloffsets, PRIM_INT__p_s_l_s, PRIM_PTR_INT__p_s_l_s);
                        contract(165, shelloffsets, PRIM_INT__p_s_m_s, PRIM_PTR_INT__p_s_m_s);
                        contract(198, shelloffsets, PRIM_INT__p_s_n_s, PRIM_PTR_INT__p_s_n_s);
                        contract(234, shelloffsets, PRIM_INT__p_s_o_s, PRIM_PTR_INT__p_s_o_s);
                        contract(273, shelloffsets, PRIM_INT__p_s_q_s, PRIM_PTR_INT__p_s_q_s);
                        contract(315, shelloffsets, PRIM_INT__p_s_r_s, PRIM_PTR_INT__p_s_r_s);
                        contract(360, shelloffsets, PRIM_INT__p_s_t_s, PRIM_PTR_INT__p_s_t_s);
                        PRIM_PTR_INT__p_s_k_s += lastoffset*108;
                        PRIM_PTR_INT__p_s_l_s += lastoffset*135;
                        PRIM_PTR_INT__p_s_m_s += lastoffset*165;
                        PRIM_PTR_INT__p_s_n_s += lastoffset*198;
                        PRIM_PTR_INT__p_s_o_s += lastoffset*234;
                        PRIM_PTR_INT__p_s_q_s += lastoffset*273;
                        PRIM_PTR_INT__p_s_r_s += lastoffset*315;
                        PRIM_PTR_INT__p_s_t_s += lastoffset*360;
                    }

                }  // close loop over j
            }  // close loop over i
            
            //Advance to the next batch
            jstart = SIMINT_SIMD_ROUND(jend);
            
            //////////////////////////////////////////////
            // Contracted integrals: Horizontal recurrance
            //////////////////////////////////////////////




            for(abcd = 0; abcd < nshellbatch; ++abcd, ++real_abcd)
            {
                const double hCD[3] = { Q.AB_x[cd+abcd], Q.AB_y[cd+abcd], Q.AB_z[cd+abcd] };

                // set up HRR pointers
                double const * restrict HRR_INT__p_s_k_s = INT__p_s_k_s + abcd * 108;
                double const * restrict HRR_INT__p_s_l_s = INT__p_s_l_s + abcd * 135;
                double const * restrict HRR_INT__p_s_m_s = INT__p_s_m_s + abcd * 165;
                double const * restrict HRR_INT__p_s_n_s = INT__p_s_n_s + abcd * 198;
                double const * restrict HRR_INT__p_s_o_s = INT__p_s_o_s + abcd * 234;
                double const * restrict HRR_INT__p_s_q_s = INT__p_s_q_s + abcd * 273;
                double const * restrict HRR_INT__p_s_r_s = INT__p_s_r_s + abcd * 315;
                double const * restrict HRR_INT__p_s_t_s = INT__p_s_t_s + abcd * 360;
                double * restrict HRR_INT__p_s_k_k = INT__p_s_k_k + real_abcd * 3888;

                // form INT__p_s_k_p
                HRR_L_k_p(
                    HRR_INT__p_s_k_p,
                    HRR_INT__p_s_k_s,
                    HRR_INT__p_s_l_s,
                    hCD, 3);

                // form INT__p_s_l_p
                HRR_L_l_p(
                    HRR_INT__p_s_l_p,
                    HRR_INT__p_s_l_s,
                    HRR_INT__p_s_m_s,
                    hCD, 3);

                // form INT__p_s_m_p
                ostei_general_hrr_L(1, 0, 9, 1, hCD, HRR_INT__p_s_n_s, HRR_INT__p_s_m_s, HRR_INT__p_s_m_p);

                // form INT__p_s_n_p
                ostei_general_hrr_L(1, 0, 10, 1, hCD, HRR_INT__p_s_o_s, HRR_INT__p_s_n_s, HRR_INT__p_s_n_p);

                // form INT__p_s_o_p
                ostei_general_hrr_L(1, 0, 11, 1, hCD, HRR_INT__p_s_q_s, HRR_INT__p_s_o_s, HRR_INT__p_s_o_p);

                // form INT__p_s_q_p
                ostei_general_hrr_L(1, 0, 12, 1, hCD, HRR_INT__p_s_r_s, HRR_INT__p_s_q_s, HRR_INT__p_s_q_p);

                // form INT__p_s_r_p
                ostei_general_hrr_L(1, 0, 13, 1, hCD, HRR_INT__p_s_t_s, HRR_INT__p_s_r_s, HRR_INT__p_s_r_p);

                // form INT__p_s_k_d
                HRR_L_k_d(
                    HRR_INT__p_s_k_d,
                    HRR_INT__p_s_k_p,
                    HRR_INT__p_s_l_p,
                    hCD, 3);

                // form INT__p_s_l_d
                ostei_general_hrr_L(1, 0, 8, 2, hCD, HRR_INT__p_s_m_p, HRR_INT__p_s_l_p, HRR_INT__p_s_l_d);

                // form INT__p_s_m_d
                ostei_general_hrr_L(1, 0, 9, 2, hCD, HRR_INT__p_s_n_p, HRR_INT__p_s_m_p, HRR_INT__p_s_m_d);

                // form INT__p_s_n_d
                ostei_general_hrr_L(1, 0, 10, 2, hCD, HRR_INT__p_s_o_p, HRR_INT__p_s_n_p, HRR_INT__p_s_n_d);

                // form INT__p_s_o_d
                ostei_general_hrr_L(1, 0, 11, 2, hCD, HRR_INT__p_s_q_p, HRR_INT__p_s_o_p, HRR_INT__p_s_o_d);

                // form INT__p_s_q_d
                ostei_general_hrr_L(1, 0, 12, 2, hCD, HRR_INT__p_s_r_p, HRR_INT__p_s_q_p, HRR_INT__p_s_q_d);

                // form INT__p_s_k_f
                ostei_general_hrr_L(1, 0, 7, 3, hCD, HRR_INT__p_s_l_d, HRR_INT__p_s_k_d, HRR_INT__p_s_k_f);

                // form INT__p_s_l_f
                ostei_general_hrr_L(1, 0, 8, 3, hCD, HRR_INT__p_s_m_d, HRR_INT__p_s_l_d, HRR_INT__p_s_l_f);

                // form INT__p_s_m_f
                ostei_general_hrr_L(1, 0, 9, 3, hCD, HRR_INT__p_s_n_d, HRR_INT__p_s_m_d, HRR_INT__p_s_m_f);

                // form INT__p_s_n_f
                ostei_general_hrr_L(1, 0, 10, 3, hCD, HRR_INT__p_s_o_d, HRR_INT__p_s_n_d, HRR_INT__p_s_n_f);

                // form INT__p_s_o_f
                ostei_general_hrr_L(1, 0, 11, 3, hCD, HRR_INT__p_s_q_d, HRR_INT__p_s_o_d, HRR_INT__p_s_o_f);

                // form INT__p_s_k_g
                ostei_general_hrr_L(1, 0, 7, 4, hCD, HRR_INT__p_s_l_f, HRR_INT__p_s_k_f, HRR_INT__p_s_k_g);

                // form INT__p_s_l_g
                ostei_general_hrr_L(1, 0, 8, 4, hCD, HRR_INT__p_s_m_f, HRR_INT__p_s_l_f, HRR_INT__p_s_l_g);

                // form INT__p_s_m_g
                ostei_general_hrr_L(1, 0, 9, 4, hCD, HRR_INT__p_s_n_f, HRR_INT__p_s_m_f, HRR_INT__p_s_m_g);

                // form INT__p_s_n_g
                ostei_general_hrr_L(1, 0, 10, 4, hCD, HRR_INT__p_s_o_f, HRR_INT__p_s_n_f, HRR_INT__p_s_n_g);

                // form INT__p_s_k_h
                ostei_general_hrr_L(1, 0, 7, 5, hCD, HRR_INT__p_s_l_g, HRR_INT__p_s_k_g, HRR_INT__p_s_k_h);

                // form INT__p_s_l_h
                ostei_general_hrr_L(1, 0, 8, 5, hCD, HRR_INT__p_s_m_g, HRR_INT__p_s_l_g, HRR_INT__p_s_l_h);

                // form INT__p_s_m_h
                ostei_general_hrr_L(1, 0, 9, 5, hCD, HRR_INT__p_s_n_g, HRR_INT__p_s_m_g, HRR_INT__p_s_m_h);

                // form INT__p_s_k_i
                ostei_general_hrr_L(1, 0, 7, 6, hCD, HRR_INT__p_s_l_h, HRR_INT__p_s_k_h, HRR_INT__p_s_k_i);

                // form INT__p_s_l_i
                ostei_general_hrr_L(1, 0, 8, 6, hCD, HRR_INT__p_s_m_h, HRR_INT__p_s_l_h, HRR_INT__p_s_l_i);

                // form INT__p_s_k_k
                ostei_general_hrr_L(1, 0, 7, 7, hCD, HRR_INT__p_s_l_i, HRR_INT__p_s_k_i, HRR_INT__p_s_k_k);


            }  // close HRR loop


        }   // close loop cdbatch

        istart = iend;
    }  // close loop over ab

    return P.nshell12_clip * Q.nshell12_clip;
}

int ostei_s_p_k_k(struct simint_multi_shellpair const P,
                  struct simint_multi_shellpair const Q,
                  double screen_tol,
                  double * const restrict work,
                  double * const restrict INT__s_p_k_k)
{
    double P_AB[3*P.nshell12];
    struct simint_multi_shellpair P_tmp = P;
    P_tmp.PA_x = P.PB_x;  P_tmp.PA_y = P.PB_y;  P_tmp.PA_z = P.PB_z;
    P_tmp.PB_x = P.PA_x;  P_tmp.PB_y = P.PA_y;  P_tmp.PB_z = P.PA_z;
    P_tmp.AB_x = P_AB;
    P_tmp.AB_y = P_AB + P.nshell12;
    P_tmp.AB_z = P_AB + 2*P.nshell12;

    for(int i = 0; i < P.nshell12; i++)
    {
        P_tmp.AB_x[i] = -P.AB_x[i];
        P_tmp.AB_y[i] = -P.AB_y[i];
        P_tmp.AB_z[i] = -P.AB_z[i];
    }

    int ret = ostei_p_s_k_k(P_tmp, Q, screen_tol, work, INT__s_p_k_k);
    double buffer[3888] SIMINT_ALIGN_ARRAY_DBL;

    for(int q = 0; q < ret; q++)
    {
        int idx = 0;
        for(int a = 0; a < 1; ++a)
        for(int b = 0; b < 3; ++b)
        for(int c = 0; c < 36; ++c)
        for(int d = 0; d < 36; ++d)
            buffer[idx++] = INT__s_p_k_k[q*3888+b*1296+a*1296+c*36+d];

        memcpy(INT__s_p_k_k+q*3888, buffer, 3888*sizeof(double));
    }

    return ret;
}

