#include "simint/boys/boys.h"
#include "simint/ostei/gen/ostei_generated.h"
#include "simint/vectorization/vectorization.h"
#include <math.h>
#include <string.h>


int ostei_s_s_i_i(struct simint_multi_shellpair const P,
                  struct simint_multi_shellpair const Q,
                  double screen_tol,
                  double * const restrict work,
                  double * const restrict INT__s_s_i_i)
{

    SIMINT_ASSUME_ALIGN_DBL(work);
    SIMINT_ASSUME_ALIGN_DBL(INT__s_s_i_i);
    int ab, cd, abcd;
    int istart, jstart;
    int iprimcd, nprim_icd, icd;
    const int check_screen = (screen_tol > 0.0);
    int i, j;
    int n;
    int not_screened;
    int real_abcd;
    int ibra;

    // partition workspace
    double * const INT__s_s_i_s = work + (SIMINT_NSHELL_SIMD * 0);
    double * const INT__s_s_k_s = work + (SIMINT_NSHELL_SIMD * 28);
    double * const INT__s_s_l_s = work + (SIMINT_NSHELL_SIMD * 64);
    double * const INT__s_s_m_s = work + (SIMINT_NSHELL_SIMD * 109);
    double * const INT__s_s_n_s = work + (SIMINT_NSHELL_SIMD * 164);
    double * const INT__s_s_o_s = work + (SIMINT_NSHELL_SIMD * 230);
    double * const INT__s_s_q_s = work + (SIMINT_NSHELL_SIMD * 308);
    SIMINT_DBLTYPE * const primwork = (SIMINT_DBLTYPE *)(work + SIMINT_NSHELL_SIMD*399);
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_s_s = primwork + 0;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_p_s = primwork + 13;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_d_s = primwork + 49;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_f_s = primwork + 115;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_g_s = primwork + 215;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_h_s = primwork + 350;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_i_s = primwork + 518;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_k_s = primwork + 714;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_l_s = primwork + 930;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_m_s = primwork + 1155;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_n_s = primwork + 1375;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_o_s = primwork + 1573;
    SIMINT_DBLTYPE * const restrict PRIM_INT__s_s_q_s = primwork + 1729;
    double * const hrrwork = (double *)(primwork + 1820);
    double * const HRR_INT__s_s_i_p = hrrwork + 0;
    double * const HRR_INT__s_s_i_d = hrrwork + 84;
    double * const HRR_INT__s_s_i_f = hrrwork + 252;
    double * const HRR_INT__s_s_i_g = hrrwork + 532;
    double * const HRR_INT__s_s_i_h = hrrwork + 952;
    double * const HRR_INT__s_s_k_p = hrrwork + 1540;
    double * const HRR_INT__s_s_k_d = hrrwork + 1648;
    double * const HRR_INT__s_s_k_f = hrrwork + 1864;
    double * const HRR_INT__s_s_k_g = hrrwork + 2224;
    double * const HRR_INT__s_s_k_h = hrrwork + 2764;
    double * const HRR_INT__s_s_l_p = hrrwork + 3520;
    double * const HRR_INT__s_s_l_d = hrrwork + 3655;
    double * const HRR_INT__s_s_l_f = hrrwork + 3925;
    double * const HRR_INT__s_s_l_g = hrrwork + 4375;
    double * const HRR_INT__s_s_m_p = hrrwork + 5050;
    double * const HRR_INT__s_s_m_d = hrrwork + 5215;
    double * const HRR_INT__s_s_m_f = hrrwork + 5545;
    double * const HRR_INT__s_s_n_p = hrrwork + 6095;
    double * const HRR_INT__s_s_n_d = hrrwork + 6293;
    double * const HRR_INT__s_s_o_p = hrrwork + 6689;


    // Create constants
    const SIMINT_DBLTYPE const_1 = SIMINT_DBLSET1(1);
    const SIMINT_DBLTYPE const_10 = SIMINT_DBLSET1(10);
    const SIMINT_DBLTYPE const_11 = SIMINT_DBLSET1(11);
    const SIMINT_DBLTYPE const_2 = SIMINT_DBLSET1(2);
    const SIMINT_DBLTYPE const_3 = SIMINT_DBLSET1(3);
    const SIMINT_DBLTYPE const_4 = SIMINT_DBLSET1(4);
    const SIMINT_DBLTYPE const_5 = SIMINT_DBLSET1(5);
    const SIMINT_DBLTYPE const_6 = SIMINT_DBLSET1(6);
    const SIMINT_DBLTYPE const_7 = SIMINT_DBLSET1(7);
    const SIMINT_DBLTYPE const_8 = SIMINT_DBLSET1(8);
    const SIMINT_DBLTYPE const_9 = SIMINT_DBLSET1(9);
    const SIMINT_DBLTYPE one_half = SIMINT_DBLSET1(0.5);


    ////////////////////////////////////////
    // Loop over shells and primitives
    ////////////////////////////////////////

    real_abcd = 0;
    istart = 0;
    for(ab = 0; ab < P.nshell12_clip; ++ab)
    {
        const int iend = istart + P.nprim12[ab];

        cd = 0;
        jstart = 0;

        for(cd = 0; cd < Q.nshell12_clip; cd += SIMINT_NSHELL_SIMD)
        {
            const int nshellbatch = ((cd + SIMINT_NSHELL_SIMD) > Q.nshell12_clip) ? Q.nshell12_clip - cd : SIMINT_NSHELL_SIMD;
            int jend = jstart;
            for(i = 0; i < nshellbatch; i++)
                jend += Q.nprim12[cd+i];

            // Clear the beginning of the workspace (where we are accumulating integrals)
            memset(work, 0, SIMINT_NSHELL_SIMD * 399 * sizeof(double));
            abcd = 0;


            for(i = istart; i < iend; ++i)
            {
                SIMINT_DBLTYPE bra_screen_max;  // only used if check_screen

                if(check_screen)
                {
                    // Skip this whole thing if always insignificant
                    if((P.screen[i] * Q.screen_max) < screen_tol)
                        continue;
                    bra_screen_max = SIMINT_DBLSET1(P.screen[i]);
                }

                icd = 0;
                iprimcd = 0;
                nprim_icd = Q.nprim12[cd];
                double * restrict PRIM_PTR_INT__s_s_i_s = INT__s_s_i_s + abcd * 28;
                double * restrict PRIM_PTR_INT__s_s_k_s = INT__s_s_k_s + abcd * 36;
                double * restrict PRIM_PTR_INT__s_s_l_s = INT__s_s_l_s + abcd * 45;
                double * restrict PRIM_PTR_INT__s_s_m_s = INT__s_s_m_s + abcd * 55;
                double * restrict PRIM_PTR_INT__s_s_n_s = INT__s_s_n_s + abcd * 66;
                double * restrict PRIM_PTR_INT__s_s_o_s = INT__s_s_o_s + abcd * 78;
                double * restrict PRIM_PTR_INT__s_s_q_s = INT__s_s_q_s + abcd * 91;



                // Load these one per loop over i
                const SIMINT_DBLTYPE P_alpha = SIMINT_DBLSET1(P.alpha[i]);
                const SIMINT_DBLTYPE P_prefac = SIMINT_DBLSET1(P.prefac[i]);
                const SIMINT_DBLTYPE Pxyz[3] = { SIMINT_DBLSET1(P.x[i]), SIMINT_DBLSET1(P.y[i]), SIMINT_DBLSET1(P.z[i]) };


                for(j = jstart; j < jend; j += SIMINT_SIMD_LEN)
                {
                    // calculate the shell offsets
                    // these are the offset from the shell pointed to by cd
                    // for each element
                    int shelloffsets[SIMINT_SIMD_LEN] = {0};
                    int lastoffset = 0;
                    const int nlane = ( ((j + SIMINT_SIMD_LEN) < jend) ? SIMINT_SIMD_LEN : (jend - j));

                    if((iprimcd + SIMINT_SIMD_LEN) >= nprim_icd)
                    {
                        // Handle if the first element of the vector is a new shell
                        if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                        {
                            nprim_icd += Q.nprim12[cd + (++icd)];
                            PRIM_PTR_INT__s_s_i_s += 28;
                            PRIM_PTR_INT__s_s_k_s += 36;
                            PRIM_PTR_INT__s_s_l_s += 45;
                            PRIM_PTR_INT__s_s_m_s += 55;
                            PRIM_PTR_INT__s_s_n_s += 66;
                            PRIM_PTR_INT__s_s_o_s += 78;
                            PRIM_PTR_INT__s_s_q_s += 91;
                        }
                        iprimcd++;
                        for(n = 1; n < SIMINT_SIMD_LEN; ++n)
                        {
                            if(iprimcd >= nprim_icd && ((icd+1) < nshellbatch))
                            {
                                shelloffsets[n] = shelloffsets[n-1] + 1;
                                lastoffset++;
                                nprim_icd += Q.nprim12[cd + (++icd)];
                            }
                            else
                                shelloffsets[n] = shelloffsets[n-1];
                            iprimcd++;
                        }
                    }
                    else
                        iprimcd += SIMINT_SIMD_LEN;

                    // Do we have to compute this vector (or has it been screened out)?
                    // (not_screened != 0 means we have to do this vector)
                    if(check_screen)
                    {
                        const double vmax = vector_max(SIMINT_MUL(bra_screen_max, SIMINT_DBLLOAD(Q.screen, j)));
                        if(vmax < screen_tol)
                        {
                            PRIM_PTR_INT__s_s_i_s += lastoffset*28;
                            PRIM_PTR_INT__s_s_k_s += lastoffset*36;
                            PRIM_PTR_INT__s_s_l_s += lastoffset*45;
                            PRIM_PTR_INT__s_s_m_s += lastoffset*55;
                            PRIM_PTR_INT__s_s_n_s += lastoffset*66;
                            PRIM_PTR_INT__s_s_o_s += lastoffset*78;
                            PRIM_PTR_INT__s_s_q_s += lastoffset*91;
                            continue;
                        }
                    }

                    const SIMINT_DBLTYPE Q_alpha = SIMINT_DBLLOAD(Q.alpha, j);
                    const SIMINT_DBLTYPE PQalpha_mul = SIMINT_MUL(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE PQalpha_sum = SIMINT_ADD(P_alpha, Q_alpha);
                    const SIMINT_DBLTYPE one_over_PQalpha_sum = SIMINT_DIV(const_1, PQalpha_sum);


                    /* construct R2 = (Px - Qx)**2 + (Py - Qy)**2 + (Pz -Qz)**2 */
                    SIMINT_DBLTYPE PQ[3];
                    PQ[0] = SIMINT_SUB(Pxyz[0], SIMINT_DBLLOAD(Q.x, j));
                    PQ[1] = SIMINT_SUB(Pxyz[1], SIMINT_DBLLOAD(Q.y, j));
                    PQ[2] = SIMINT_SUB(Pxyz[2], SIMINT_DBLLOAD(Q.z, j));
                    SIMINT_DBLTYPE R2 = SIMINT_MUL(PQ[0], PQ[0]);
                    R2 = SIMINT_FMADD(PQ[1], PQ[1], R2);
                    R2 = SIMINT_FMADD(PQ[2], PQ[2], R2);

                    const SIMINT_DBLTYPE alpha = SIMINT_MUL(PQalpha_mul, one_over_PQalpha_sum); // alpha from MEST
                    const SIMINT_DBLTYPE one_over_p = SIMINT_DIV(const_1, P_alpha);
                    const SIMINT_DBLTYPE one_over_q = SIMINT_DIV(const_1, Q_alpha);
                    const SIMINT_DBLTYPE one_over_2p = SIMINT_MUL(one_half, one_over_p);
                    const SIMINT_DBLTYPE one_over_2q = SIMINT_MUL(one_half, one_over_q);
                    const SIMINT_DBLTYPE one_over_2pq = SIMINT_MUL(one_half, one_over_PQalpha_sum);
                    const SIMINT_DBLTYPE Q_PA[3] = { SIMINT_DBLLOAD(Q.PA_x, j), SIMINT_DBLLOAD(Q.PA_y, j), SIMINT_DBLLOAD(Q.PA_z, j) };

                    SIMINT_DBLTYPE a_over_q = SIMINT_MUL(alpha, one_over_q);
                    SIMINT_DBLTYPE aoq_PQ[3];
                    aoq_PQ[0] = SIMINT_MUL(a_over_q, PQ[0]);
                    aoq_PQ[1] = SIMINT_MUL(a_over_q, PQ[1]);
                    aoq_PQ[2] = SIMINT_MUL(a_over_q, PQ[2]);
                    // Put a minus sign here so we don't have to in RR routines
                    a_over_q = SIMINT_NEG(a_over_q);


                    //////////////////////////////////////////////
                    // Fjt function section
                    // Maximum v value: 12
                    //////////////////////////////////////////////
                    // The parameter to the Fjt function
                    const SIMINT_DBLTYPE F_x = SIMINT_MUL(R2, alpha);


                    const SIMINT_DBLTYPE Q_prefac = mask_load(nlane, Q.prefac + j);


                    boys_F_split(PRIM_INT__s_s_s_s, F_x, 12);
                    SIMINT_DBLTYPE prefac = SIMINT_SQRT(one_over_PQalpha_sum);
                    prefac = SIMINT_MUL(SIMINT_MUL(P_prefac, Q_prefac), prefac);
                    for(n = 0; n <= 12; n++)
                        PRIM_INT__s_s_s_s[n] = SIMINT_MUL(PRIM_INT__s_s_s_s[n], prefac);

                    //////////////////////////////////////////////
                    // Primitive integrals: Vertical recurrance
                    //////////////////////////////////////////////

                    const SIMINT_DBLTYPE vrr_const_1_over_2q = one_over_2q;
                    const SIMINT_DBLTYPE vrr_const_2_over_2q = SIMINT_MUL(const_2, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_3_over_2q = SIMINT_MUL(const_3, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_4_over_2q = SIMINT_MUL(const_4, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_5_over_2q = SIMINT_MUL(const_5, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_6_over_2q = SIMINT_MUL(const_6, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_7_over_2q = SIMINT_MUL(const_7, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_8_over_2q = SIMINT_MUL(const_8, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_9_over_2q = SIMINT_MUL(const_9, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_10_over_2q = SIMINT_MUL(const_10, one_over_2q);
                    const SIMINT_DBLTYPE vrr_const_11_over_2q = SIMINT_MUL(const_11, one_over_2q);



                    // Forming PRIM_INT__s_s_p_s[12 * 3];
                    for(n = 0; n < 12; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__s_s_p_s[n * 3 + 0] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__s_s_p_s[n * 3 + 0] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_p_s[n * 3 + 0]);

                        PRIM_INT__s_s_p_s[n * 3 + 1] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__s_s_p_s[n * 3 + 1] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_p_s[n * 3 + 1]);

                        PRIM_INT__s_s_p_s[n * 3 + 2] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_s_s[n * 1 + 0]);
                        PRIM_INT__s_s_p_s[n * 3 + 2] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_p_s[n * 3 + 2]);

                    }



                    // Forming PRIM_INT__s_s_d_s[11 * 6];
                    for(n = 0; n < 11; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__s_s_d_s[n * 6 + 0] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_p_s[n * 3 + 0]);
                        PRIM_INT__s_s_d_s[n * 6 + 0] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_p_s[(n+1) * 3 + 0], PRIM_INT__s_s_d_s[n * 6 + 0]);
                        PRIM_INT__s_s_d_s[n * 6 + 0] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__s_s_d_s[n * 6 + 0]);

                        PRIM_INT__s_s_d_s[n * 6 + 3] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_p_s[n * 3 + 1]);
                        PRIM_INT__s_s_d_s[n * 6 + 3] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_p_s[(n+1) * 3 + 1], PRIM_INT__s_s_d_s[n * 6 + 3]);
                        PRIM_INT__s_s_d_s[n * 6 + 3] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__s_s_d_s[n * 6 + 3]);

                        PRIM_INT__s_s_d_s[n * 6 + 5] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_p_s[n * 3 + 2]);
                        PRIM_INT__s_s_d_s[n * 6 + 5] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_p_s[(n+1) * 3 + 2], PRIM_INT__s_s_d_s[n * 6 + 5]);
                        PRIM_INT__s_s_d_s[n * 6 + 5] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_s_s[(n+1) * 1 + 0], PRIM_INT__s_s_s_s[n * 1 + 0]), PRIM_INT__s_s_d_s[n * 6 + 5]);

                    }



                    // Forming PRIM_INT__s_s_f_s[10 * 10];
                    for(n = 0; n < 10; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__s_s_f_s[n * 10 + 0] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_d_s[n * 6 + 0]);
                        PRIM_INT__s_s_f_s[n * 10 + 0] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__s_s_f_s[n * 10 + 0] = SIMINT_FMADD( vrr_const_2_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_p_s[(n+1) * 3 + 0], PRIM_INT__s_s_p_s[n * 3 + 0]), PRIM_INT__s_s_f_s[n * 10 + 0]);

                        PRIM_INT__s_s_f_s[n * 10 + 1] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_d_s[n * 6 + 0]);
                        PRIM_INT__s_s_f_s[n * 10 + 1] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_f_s[n * 10 + 1]);

                        PRIM_INT__s_s_f_s[n * 10 + 6] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_d_s[n * 6 + 3]);
                        PRIM_INT__s_s_f_s[n * 10 + 6] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__s_s_f_s[n * 10 + 6] = SIMINT_FMADD( vrr_const_2_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_p_s[(n+1) * 3 + 1], PRIM_INT__s_s_p_s[n * 3 + 1]), PRIM_INT__s_s_f_s[n * 10 + 6]);

                        PRIM_INT__s_s_f_s[n * 10 + 9] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_d_s[n * 6 + 5]);
                        PRIM_INT__s_s_f_s[n * 10 + 9] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__s_s_f_s[n * 10 + 9] = SIMINT_FMADD( vrr_const_2_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_p_s[(n+1) * 3 + 2], PRIM_INT__s_s_p_s[n * 3 + 2]), PRIM_INT__s_s_f_s[n * 10 + 9]);

                    }



                    // Forming PRIM_INT__s_s_g_s[9 * 15];
                    for(n = 0; n < 9; ++n)  // loop over orders of auxiliary function
                    {

                        PRIM_INT__s_s_g_s[n * 15 + 0] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__s_s_g_s[n * 15 + 0] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 0], PRIM_INT__s_s_g_s[n * 15 + 0]);
                        PRIM_INT__s_s_g_s[n * 15 + 0] = SIMINT_FMADD( vrr_const_3_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_d_s[n * 6 + 0]), PRIM_INT__s_s_g_s[n * 15 + 0]);

                        PRIM_INT__s_s_g_s[n * 15 + 1] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__s_s_g_s[n * 15 + 1] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 0], PRIM_INT__s_s_g_s[n * 15 + 1]);

                        PRIM_INT__s_s_g_s[n * 15 + 2] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_f_s[n * 10 + 0]);
                        PRIM_INT__s_s_g_s[n * 15 + 2] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 0], PRIM_INT__s_s_g_s[n * 15 + 2]);

                        PRIM_INT__s_s_g_s[n * 15 + 3] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_f_s[n * 10 + 1]);
                        PRIM_INT__s_s_g_s[n * 15 + 3] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 1], PRIM_INT__s_s_g_s[n * 15 + 3]);
                        PRIM_INT__s_s_g_s[n * 15 + 3] = SIMINT_FMADD( vrr_const_1_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 0], PRIM_INT__s_s_d_s[n * 6 + 0]), PRIM_INT__s_s_g_s[n * 15 + 3]);

                        PRIM_INT__s_s_g_s[n * 15 + 6] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__s_s_g_s[n * 15 + 6] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 6], PRIM_INT__s_s_g_s[n * 15 + 6]);

                        PRIM_INT__s_s_g_s[n * 15 + 9] = SIMINT_MUL(Q_PA[0], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__s_s_g_s[n * 15 + 9] = SIMINT_FMADD( aoq_PQ[0], PRIM_INT__s_s_f_s[(n+1) * 10 + 9], PRIM_INT__s_s_g_s[n * 15 + 9]);

                        PRIM_INT__s_s_g_s[n * 15 + 10] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__s_s_g_s[n * 15 + 10] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 6], PRIM_INT__s_s_g_s[n * 15 + 10]);
                        PRIM_INT__s_s_g_s[n * 15 + 10] = SIMINT_FMADD( vrr_const_3_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 3], PRIM_INT__s_s_d_s[n * 6 + 3]), PRIM_INT__s_s_g_s[n * 15 + 10]);

                        PRIM_INT__s_s_g_s[n * 15 + 11] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_f_s[n * 10 + 6]);
                        PRIM_INT__s_s_g_s[n * 15 + 11] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 6], PRIM_INT__s_s_g_s[n * 15 + 11]);

                        PRIM_INT__s_s_g_s[n * 15 + 13] = SIMINT_MUL(Q_PA[1], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__s_s_g_s[n * 15 + 13] = SIMINT_FMADD( aoq_PQ[1], PRIM_INT__s_s_f_s[(n+1) * 10 + 9], PRIM_INT__s_s_g_s[n * 15 + 13]);

                        PRIM_INT__s_s_g_s[n * 15 + 14] = SIMINT_MUL(Q_PA[2], PRIM_INT__s_s_f_s[n * 10 + 9]);
                        PRIM_INT__s_s_g_s[n * 15 + 14] = SIMINT_FMADD( aoq_PQ[2], PRIM_INT__s_s_f_s[(n+1) * 10 + 9], PRIM_INT__s_s_g_s[n * 15 + 14]);
                        PRIM_INT__s_s_g_s[n * 15 + 14] = SIMINT_FMADD( vrr_const_3_over_2q, SIMINT_FMADD(a_over_q, PRIM_INT__s_s_d_s[(n+1) * 6 + 5], PRIM_INT__s_s_d_s[n * 6 + 5]), PRIM_INT__s_s_g_s[n * 15 + 14]);

                    }


                    VRR_K_s_s_h_s(
                            PRIM_INT__s_s_h_s,
                            PRIM_INT__s_s_g_s,
                            PRIM_INT__s_s_f_s,
                            Q_PA,
                            a_over_q,
                            aoq_PQ,
                            one_over_2q,
                            8);


                    VRR_K_s_s_i_s(
                            PRIM_INT__s_s_i_s,
                            PRIM_INT__s_s_h_s,
                            PRIM_INT__s_s_g_s,
                            Q_PA,
                            a_over_q,
                            aoq_PQ,
                            one_over_2q,
                            7);


                    VRR_K_s_s_k_s(
                            PRIM_INT__s_s_k_s,
                            PRIM_INT__s_s_i_s,
                            PRIM_INT__s_s_h_s,
                            Q_PA,
                            a_over_q,
                            aoq_PQ,
                            one_over_2q,
                            6);


                    ostei_general_vrr1_K(8, 5,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_k_s, PRIM_INT__s_s_i_s, PRIM_INT__s_s_l_s);


                    ostei_general_vrr1_K(9, 4,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_l_s, PRIM_INT__s_s_k_s, PRIM_INT__s_s_m_s);


                    ostei_general_vrr1_K(10, 3,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_m_s, PRIM_INT__s_s_l_s, PRIM_INT__s_s_n_s);


                    ostei_general_vrr1_K(11, 2,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_n_s, PRIM_INT__s_s_m_s, PRIM_INT__s_s_o_s);


                    ostei_general_vrr1_K(12, 1,
                            one_over_2q, a_over_q, aoq_PQ, Q_PA,
                            PRIM_INT__s_s_o_s, PRIM_INT__s_s_n_s, PRIM_INT__s_s_q_s);




                    ////////////////////////////////////
                    // Accumulate contracted integrals
                    ////////////////////////////////////
                    if(lastoffset == 0)
                    {
                        contract_all(28, PRIM_INT__s_s_i_s, PRIM_PTR_INT__s_s_i_s);
                        contract_all(36, PRIM_INT__s_s_k_s, PRIM_PTR_INT__s_s_k_s);
                        contract_all(45, PRIM_INT__s_s_l_s, PRIM_PTR_INT__s_s_l_s);
                        contract_all(55, PRIM_INT__s_s_m_s, PRIM_PTR_INT__s_s_m_s);
                        contract_all(66, PRIM_INT__s_s_n_s, PRIM_PTR_INT__s_s_n_s);
                        contract_all(78, PRIM_INT__s_s_o_s, PRIM_PTR_INT__s_s_o_s);
                        contract_all(91, PRIM_INT__s_s_q_s, PRIM_PTR_INT__s_s_q_s);
                    }
                    else
                    {
                        contract(28, shelloffsets, PRIM_INT__s_s_i_s, PRIM_PTR_INT__s_s_i_s);
                        contract(36, shelloffsets, PRIM_INT__s_s_k_s, PRIM_PTR_INT__s_s_k_s);
                        contract(45, shelloffsets, PRIM_INT__s_s_l_s, PRIM_PTR_INT__s_s_l_s);
                        contract(55, shelloffsets, PRIM_INT__s_s_m_s, PRIM_PTR_INT__s_s_m_s);
                        contract(66, shelloffsets, PRIM_INT__s_s_n_s, PRIM_PTR_INT__s_s_n_s);
                        contract(78, shelloffsets, PRIM_INT__s_s_o_s, PRIM_PTR_INT__s_s_o_s);
                        contract(91, shelloffsets, PRIM_INT__s_s_q_s, PRIM_PTR_INT__s_s_q_s);
                        PRIM_PTR_INT__s_s_i_s += lastoffset*28;
                        PRIM_PTR_INT__s_s_k_s += lastoffset*36;
                        PRIM_PTR_INT__s_s_l_s += lastoffset*45;
                        PRIM_PTR_INT__s_s_m_s += lastoffset*55;
                        PRIM_PTR_INT__s_s_n_s += lastoffset*66;
                        PRIM_PTR_INT__s_s_o_s += lastoffset*78;
                        PRIM_PTR_INT__s_s_q_s += lastoffset*91;
                    }

                }  // close loop over j
            }  // close loop over i
            
            //Advance to the next batch
            jstart = SIMINT_SIMD_ROUND(jend);
            
            //////////////////////////////////////////////
            // Contracted integrals: Horizontal recurrance
            //////////////////////////////////////////////




            for(abcd = 0; abcd < nshellbatch; ++abcd, ++real_abcd)
            {
                const double hCD[3] = { Q.AB_x[cd+abcd], Q.AB_y[cd+abcd], Q.AB_z[cd+abcd] };

                // set up HRR pointers
                double const * restrict HRR_INT__s_s_i_s = INT__s_s_i_s + abcd * 28;
                double const * restrict HRR_INT__s_s_k_s = INT__s_s_k_s + abcd * 36;
                double const * restrict HRR_INT__s_s_l_s = INT__s_s_l_s + abcd * 45;
                double const * restrict HRR_INT__s_s_m_s = INT__s_s_m_s + abcd * 55;
                double const * restrict HRR_INT__s_s_n_s = INT__s_s_n_s + abcd * 66;
                double const * restrict HRR_INT__s_s_o_s = INT__s_s_o_s + abcd * 78;
                double const * restrict HRR_INT__s_s_q_s = INT__s_s_q_s + abcd * 91;
                double * restrict HRR_INT__s_s_i_i = INT__s_s_i_i + real_abcd * 784;

                // form INT__s_s_i_p
                HRR_L_i_p(
                    HRR_INT__s_s_i_p,
                    HRR_INT__s_s_i_s,
                    HRR_INT__s_s_k_s,
                    hCD, 1);

                // form INT__s_s_k_p
                HRR_L_k_p(
                    HRR_INT__s_s_k_p,
                    HRR_INT__s_s_k_s,
                    HRR_INT__s_s_l_s,
                    hCD, 1);

                // form INT__s_s_l_p
                HRR_L_l_p(
                    HRR_INT__s_s_l_p,
                    HRR_INT__s_s_l_s,
                    HRR_INT__s_s_m_s,
                    hCD, 1);

                // form INT__s_s_m_p
                ostei_general_hrr_L(0, 0, 9, 1, hCD, HRR_INT__s_s_n_s, HRR_INT__s_s_m_s, HRR_INT__s_s_m_p);

                // form INT__s_s_n_p
                ostei_general_hrr_L(0, 0, 10, 1, hCD, HRR_INT__s_s_o_s, HRR_INT__s_s_n_s, HRR_INT__s_s_n_p);

                // form INT__s_s_o_p
                ostei_general_hrr_L(0, 0, 11, 1, hCD, HRR_INT__s_s_q_s, HRR_INT__s_s_o_s, HRR_INT__s_s_o_p);

                // form INT__s_s_i_d
                HRR_L_i_d(
                    HRR_INT__s_s_i_d,
                    HRR_INT__s_s_i_p,
                    HRR_INT__s_s_k_p,
                    hCD, 1);

                // form INT__s_s_k_d
                HRR_L_k_d(
                    HRR_INT__s_s_k_d,
                    HRR_INT__s_s_k_p,
                    HRR_INT__s_s_l_p,
                    hCD, 1);

                // form INT__s_s_l_d
                ostei_general_hrr_L(0, 0, 8, 2, hCD, HRR_INT__s_s_m_p, HRR_INT__s_s_l_p, HRR_INT__s_s_l_d);

                // form INT__s_s_m_d
                ostei_general_hrr_L(0, 0, 9, 2, hCD, HRR_INT__s_s_n_p, HRR_INT__s_s_m_p, HRR_INT__s_s_m_d);

                // form INT__s_s_n_d
                ostei_general_hrr_L(0, 0, 10, 2, hCD, HRR_INT__s_s_o_p, HRR_INT__s_s_n_p, HRR_INT__s_s_n_d);

                // form INT__s_s_i_f
                HRR_L_i_f(
                    HRR_INT__s_s_i_f,
                    HRR_INT__s_s_i_d,
                    HRR_INT__s_s_k_d,
                    hCD, 1);

                // form INT__s_s_k_f
                ostei_general_hrr_L(0, 0, 7, 3, hCD, HRR_INT__s_s_l_d, HRR_INT__s_s_k_d, HRR_INT__s_s_k_f);

                // form INT__s_s_l_f
                ostei_general_hrr_L(0, 0, 8, 3, hCD, HRR_INT__s_s_m_d, HRR_INT__s_s_l_d, HRR_INT__s_s_l_f);

                // form INT__s_s_m_f
                ostei_general_hrr_L(0, 0, 9, 3, hCD, HRR_INT__s_s_n_d, HRR_INT__s_s_m_d, HRR_INT__s_s_m_f);

                // form INT__s_s_i_g
                ostei_general_hrr_L(0, 0, 6, 4, hCD, HRR_INT__s_s_k_f, HRR_INT__s_s_i_f, HRR_INT__s_s_i_g);

                // form INT__s_s_k_g
                ostei_general_hrr_L(0, 0, 7, 4, hCD, HRR_INT__s_s_l_f, HRR_INT__s_s_k_f, HRR_INT__s_s_k_g);

                // form INT__s_s_l_g
                ostei_general_hrr_L(0, 0, 8, 4, hCD, HRR_INT__s_s_m_f, HRR_INT__s_s_l_f, HRR_INT__s_s_l_g);

                // form INT__s_s_i_h
                ostei_general_hrr_L(0, 0, 6, 5, hCD, HRR_INT__s_s_k_g, HRR_INT__s_s_i_g, HRR_INT__s_s_i_h);

                // form INT__s_s_k_h
                ostei_general_hrr_L(0, 0, 7, 5, hCD, HRR_INT__s_s_l_g, HRR_INT__s_s_k_g, HRR_INT__s_s_k_h);

                // form INT__s_s_i_i
                ostei_general_hrr_L(0, 0, 6, 6, hCD, HRR_INT__s_s_k_h, HRR_INT__s_s_i_h, HRR_INT__s_s_i_i);


            }  // close HRR loop


        }   // close loop cdbatch

        istart = iend;
    }  // close loop over ab

    return P.nshell12_clip * Q.nshell12_clip;
}

